unit SOMIRIMP.SOM;

{$WARN UNSAFE_TYPE OFF}

{$IF CompilerVersion >= 17.0}
  {$DEFINE DELPHI_HAS_INLINE}
{$IFEND}

{$IF CompilerVersion >= 23.0}
  {$DEFINE DELPHI_HAS_INTPTR}
{$IFEND}

interface

uses
  SysUtils;

type
  { Hardwired definitions }
  CORBAString = PAnsiChar;
  CORBABoolean = ByteBool;
  TypeCode = class;
  any = packed record
    _type: TypeCode;
    _value: Pointer;
  end;
  TAnyResult = type Int64; { returned in edx:eax by vanilla IBM SOM, but passed via hidden pointer by Delphi when record }
  PEnvironment = ^Environment;
  {$IFNDEF DELPHI_HAS_INTPTR}
  IntPtr = type LongInt;
  UIntPtr = type LongWord;
  {$ENDIF}

  { Forward definitions }
  SOMObject = class;
  Contained = class;
  AttributeDef = class;
  BOA = class;
  SOMEEvent = class;
  SOMEClientEvent = class;
  Context = class;
  ConstantDef = class;
  Container = class;
  SOMEEMan = class;
  SOMEEMRegisterData = class;
  ExceptionDef = class;
  ImplementationDef = class;
  ImplRepository = class;
  InterfaceDef = class;
  ModuleDef = class;
  NVList = class;
  ObjectMgr = class;
  OperationDef = class;
  ORB = class;
  ParameterDef = class;
  Principal = class;
  Repository = class;
  Request = class;
  SOMTEntryC = class;
  SOMTAttributeEntryC = class;
  SOMTBaseClassEntryC = class;
  SOMTClassEntryC = class;
  SOMTCommonEntryC = class;
  SOMTConstEntryC = class;
  SOMTDataEntryC = class;
  SOMTEmitC = class;
  SOMTEnumEntryC = class;
  SOMTEnumNameEntryC = class;
  SOMTMetaClassEntryC = class;
  SOMTMethodEntryC = class;
  SOMTModuleEntryC = class;
  SOMTParameterEntryC = class;
  SOMTPassthruEntryC = class;
  SOMTSequenceEntryC = class;
  SOMTStringEntryC = class;
  SOMTStructEntryC = class;
  SOMTTypedefEntryC = class;
  SOMTTemplateOutputC = class;
  SOMTUnionEntryC = class;
  SOMTUserDefinedTypeEntryC = class;
  SOMDServerMgr = class;
  SOMESinkEvent = class;
  SOMClass = class;
  SOMMSingleInstance = class;
  SOMMBeforeAfter = class;
  SOMClassMgr = class;
  SOMDObject = class;
  SOMDClientProxy = class;
  SOMDMetaproxy = class;
  SOMDObjectMgr = class;
  SOMDServer = class;
  SOMUTId = class;
  SOMOA = class;
  Sockets = class;
  SOMStringTableC = class;
  SOMMTraced = class;
  SOMETimerEvent = class;
  TSIdentification = class;
  TypeDef = class;
  SOMEWorkProcEvent = class;

  { Foreign types }
  somId = Pointer { WARNING: foreign type, size may be different than SizeOf(Pointer) };
  va_list = Pointer { WARNING: foreign type, size may be different than SizeOf(Pointer) };
  Sockets_in_addr = Pointer { WARNING: foreign type, size may be different than SizeOf(Pointer) };

  { Data types }
  int = LongInt;
  uchar_t = Byte;
  size_t = LongWord;
  SOMFOREIGN = Pointer;
  somToken = Pointer;
  TCKind = type LongWord;
  integer1 = ShortInt;
  integer2 = SmallInt;
  uinteger2 = Word;
  integer4 = LongInt;
  uinteger4 = LongWord;
  float4 = Single;
  float8 = Double;
  zString = CORBAString;
  fString = CORBAString;
  somMethodProc = Pointer;
  somMethodPtr = Pointer;
  somMToken = Pointer;
  somMLocator = Pointer;
  somDToken = Pointer;
  somDLocator = Pointer;
  somClassInfo = Pointer;
  SOMTokBuf = Pointer;
  somInitCtrl = Pointer;
  somInitInfo = Pointer;
  somDestructCtrl = Pointer;
  somDestructInfo = Pointer;
  somAssignCtrl = Pointer;
  somAssignInfo = Pointer;
  somRdAppType = LongWord;
  PsomClassList = ^somClassList;
  somClasses = ^somClassList;
  somObjects = Pointer;
  PsomMethodTab = ^somMethodTab;
  PsomMethodTabList = ^somMethodTabList;
  somMethodTabs = ^somMethodTabList;
  somParentMtabStructPtr = ^somMethodTabList;
  _IDL_Array1Of_Pointer = array[0 .. 0] of Pointer;
  somCClassDataStructurePtr = ^somCClassDataStructure;
  somBooleanVector = ^Byte;
  exception_type = type LongWord;
  Identifier = CORBAString;
  RepositoryId = CORBAString;
  P_IDL_ArrayOf_SOMObject = ^_IDL_ArrayOf_SOMObject;
  _IDL_Sequence_SOMObject = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_SOMObject;
  end;
  SOMObject_SOMObjectSequence = _IDL_Sequence_SOMObject;
  P_IDL_ArrayOf_Byte = ^_IDL_ArrayOf_Byte;
  _IDL_Sequence_Byte = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_Byte;
  end;
  SOMObject_BooleanSequence = _IDL_Sequence_Byte;
  P_IDL_ArrayOf_SOMObject_somObjectOffset = ^_IDL_ArrayOf_SOMObject_somObjectOffset;
  _IDL_Sequence_SOMObject_somObjectOffset = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_SOMObject_somObjectOffset;
  end;
  SOMObject_somObjectOffsets = _IDL_Sequence_SOMObject_somObjectOffset;
  Contained_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  Contained_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  Contained_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  AttributeDef_AttributeMode = type LongWord;
  AttributeDef_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  AttributeDef_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  AttributeDef_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  completion_status = type LongWord;
  ORBStatus = LongWord;
  ReferenceData = _IDL_Sequence_Byte;
  Flags = LongWord;
  ImplId = CORBAString;
  BOA_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  BOA_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  BOA_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMEEvent_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMEEvent_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMEEvent_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMEClientEvent_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMEClientEvent_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMEClientEvent_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  Context_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  Context_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  Context_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  ConstantDef_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  ConstantDef_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  ConstantDef_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  Container_InterfaceName = CORBAString;
  Container_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  Container_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  Container_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  EMRegProc = Pointer;
  EMMethodProc = Pointer;
  EMMethodProcEv = Pointer;
  SOMEEMan_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMEEMan_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMEEMan_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMEEMRegisterData_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMEEMRegisterData_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMEEMRegisterData_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  ExceptionDef_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  ExceptionDef_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  ExceptionDef_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  ImplementationDef_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  ImplementationDef_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  ImplementationDef_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  ImplRepository_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  ImplRepository_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  ImplRepository_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  ContextIdentifier = CORBAString;
  InterfaceDef_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  InterfaceDef_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  InterfaceDef_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  InterfaceDef_InterfaceName = { inherited } Container_InterfaceName;
  ModuleDef_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  ModuleDef_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  ModuleDef_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  ModuleDef_InterfaceName = { inherited } Container_InterfaceName;
  NVList_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  NVList_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  NVList_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  ObjectMgr_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  ObjectMgr_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  ObjectMgr_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  OperationDef_OperationMode = type LongWord;
  OperationDef_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  OperationDef_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  OperationDef_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  OperationDef_InterfaceName = { inherited } Container_InterfaceName;
  ORB_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  ORB_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  ORB_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  ParameterDef_ParameterMode = type LongWord;
  ParameterDef_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  ParameterDef_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  ParameterDef_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  Principal_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  Principal_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  Principal_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  Repository_irOpenErrorCodes = type LongWord;
  Repository_InterfaceName = { inherited } Container_InterfaceName;
  Repository_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  Repository_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  Repository_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  Request_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  Request_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  Request_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  Entry = Pointer;
  Mlist = Pointer;
  AttList = Pointer;
  NumberList = Pointer;
  SwitchBody = Pointer;
  SOMTTargetTypeT = type LongWord;
  SOMTTypes = LongWord;
  SOMTEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTAttributeEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTAttributeEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTAttributeEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTBaseClassEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTBaseClassEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTBaseClassEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTClassEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTClassEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTClassEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  somtVisibilityT = type LongWord;
  SOMTCommonEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTCommonEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTCommonEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTConstEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTConstEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTConstEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTDataEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTDataEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTDataEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  somtCommentStyleT = type LongWord;
  SOMTEmitC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTEmitC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTEmitC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTEnumEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTEnumEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTEnumEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTEnumNameEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTEnumNameEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTEnumNameEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTMetaClassEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTMetaClassEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTMetaClassEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTMethodEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTMethodEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTMethodEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTModuleEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTModuleEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTModuleEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  somtParameterDirectionT = type LongWord;
  SOMTParameterEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTParameterEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTParameterEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTPassthruEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTPassthruEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTPassthruEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTSequenceEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTSequenceEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTSequenceEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTStringEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTStringEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTStringEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTStructEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTStructEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTStructEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTTypedefEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTTypedefEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTTypedefEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTTemplateOutputC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTTemplateOutputC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTTemplateOutputC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTUnionEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTUnionEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTUnionEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMTUserDefinedTypeEntryC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMTUserDefinedTypeEntryC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMTUserDefinedTypeEntryC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMDServerMgr_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMDServerMgr_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMDServerMgr_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMESinkEvent_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMESinkEvent_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMESinkEvent_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  P_IDL_ArrayOf_Pointer = ^_IDL_ArrayOf_Pointer;
  _IDL_Sequence_Pointer = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_Pointer;
  end;
  SOMClass_somTokenSequence = _IDL_Sequence_Pointer;
  P_IDL_ArrayOf_SOMClass = ^_IDL_ArrayOf_SOMClass;
  _IDL_Sequence_SOMClass = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_SOMClass;
  end;
  SOMClass_SOMClassSequence = _IDL_Sequence_SOMClass;
  P_IDL_ArrayOf_SOMClass_somOffsetInfo = ^_IDL_ArrayOf_SOMClass_somOffsetInfo;
  _IDL_Sequence_SOMClass_somOffsetInfo = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_SOMClass_somOffsetInfo;
  end;
  SOMClass_somOffsets = _IDL_Sequence_SOMClass_somOffsetInfo;
  P_IDL_ArrayOf_somId = ^_IDL_ArrayOf_somId;
  _IDL_Sequence_somId = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_somId;
  end;
  SOMClass_somIdSequence = _IDL_Sequence_somId;
  SOMClass_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMClass_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMClass_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMMSingleInstance_somTokenSequence = { inherited } SOMClass_somTokenSequence;
  SOMMSingleInstance_SOMClassSequence = { inherited } SOMClass_SOMClassSequence;
  SOMMSingleInstance_somOffsets = { inherited } SOMClass_somOffsets;
  SOMMSingleInstance_somIdSequence = { inherited } SOMClass_somIdSequence;
  SOMMSingleInstance_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMMSingleInstance_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMMSingleInstance_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMMBeforeAfter_somTokenSequence = { inherited } SOMClass_somTokenSequence;
  SOMMBeforeAfter_SOMClassSequence = { inherited } SOMClass_SOMClassSequence;
  SOMMBeforeAfter_somOffsets = { inherited } SOMClass_somOffsets;
  SOMMBeforeAfter_somIdSequence = { inherited } SOMClass_somIdSequence;
  SOMMBeforeAfter_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMMBeforeAfter_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMMBeforeAfter_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMClassMgr_SOMClassArray = ^SOMClass;
  SOMClassMgr_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMClassMgr_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMClassMgr_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMDObject_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMDObject_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMDObject_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMDClientProxy_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMDClientProxy_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMDClientProxy_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMDMetaproxy_somTokenSequence = { inherited } SOMClass_somTokenSequence;
  SOMDMetaproxy_SOMClassSequence = { inherited } SOMClass_SOMClassSequence;
  SOMDMetaproxy_somOffsets = { inherited } SOMClass_somOffsets;
  SOMDMetaproxy_somIdSequence = { inherited } SOMClass_somIdSequence;
  SOMDMetaproxy_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMDMetaproxy_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMDMetaproxy_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMDObjectMgr_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMDObjectMgr_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMDObjectMgr_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMDServer_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMDServer_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMDServer_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMUTId_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMUTId_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMUTId_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMOA_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMOA_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMOA_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  Sockets_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  Sockets_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  Sockets_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  PentryT = ^entryT;
  PPentryT = ^PentryT;
  tablePT = ^PPentryT;
  SOMStringTableC_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMStringTableC_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMStringTableC_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMMTraced_somTokenSequence = { inherited } SOMClass_somTokenSequence;
  SOMMTraced_SOMClassSequence = { inherited } SOMClass_SOMClassSequence;
  SOMMTraced_somOffsets = { inherited } SOMClass_somOffsets;
  SOMMTraced_somIdSequence = { inherited } SOMClass_somIdSequence;
  SOMMTraced_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMMTraced_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMMTraced_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMETimerEvent_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMETimerEvent_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMETimerEvent_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  TSIdentification_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  TSIdentification_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  TSIdentification_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  TypeDef_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  TypeDef_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  TypeDef_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;
  SOMEWorkProcEvent_SOMObjectSequence = { inherited } SOMObject_SOMObjectSequence;
  SOMEWorkProcEvent_BooleanSequence = { inherited } SOMObject_BooleanSequence;
  SOMEWorkProcEvent_somObjectOffsets = { inherited } SOMObject_somObjectOffsets;

  { Records }
  StExcep = packed record
    minor: LongWord;
    completed: completion_status;
  end;
  PStExcep = ^StExcep;

  Environment = packed record
    _major: exception_type;
    exception_exception_name: PAnsiChar;
    exception_params: Pointer;
    _somdAnchor: Pointer;
  end;

  somMethodTab = packed record
    SOM_classObject: SOMClass;
  end;

  SOMAny = packed record
    mtab: PsomMethodTab;
  end;

  somMethodInfo = packed record
    callType: LongWord;
    va_listSize: LongInt;
    float_map: PLongWord;
  end;

  somMethodDataStruct = packed record
    id: somId;
    SOM_type: LongInt;
    descriptor: somId;
    mToken: Pointer;
    method: Pointer;
    shared: PPointer;
  end;

  somMethodData = packed record
    id: somId;
    SOM_type: LongInt;
    descriptor: somId;
    mToken: Pointer;
    method: Pointer;
    shared: PPointer;
  end;

  somClassList = packed record
    cls: SOMClass;
    next: PsomClassList;
  end;

  somMethodTabList = packed record
    mtab: PsomMethodTab;
    next: PsomMethodTabList;
  end;

  somClassDataStructure = packed record
    SOM_classObject: SOMClass;
    tokens: _IDL_Array1Of_Pointer;
  end;

  somCClassDataStructure = packed record
    parentMtab: PsomMethodTabList;
    instanceDataToken: Pointer;
    ptrs: _IDL_Array1Of_Pointer;
  end;

  somModifier = packed record
    name: CORBAString;
    value: CORBAString;
  end;

  SOMObject_somObjectOffset = packed record
    obj: SOMObject;
    offset: LongInt;
  end;

  Contained_Description = packed record
    name: CORBAString;
    value: any;
  end;
  Contained_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  AttributeDef_AttributeDescription = packed record
    name: CORBAString;
    id: CORBAString;
    defined_in: CORBAString;
    SOM_type: TypeCode;
    mode: AttributeDef_AttributeMode;
  end;
  AttributeDef_Description = { inherited } Contained_Description;
  AttributeDef_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  NamedValue = packed record
    name: CORBAString;
    argument: any;
    len: LongInt;
    arg_modes: LongWord;
  end;
  BOA_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMEEvent_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMEClientEvent_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  Context_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  ConstantDef_ConstantDescription = packed record
    name: CORBAString;
    id: CORBAString;
    defined_in: CORBAString;
    SOM_type: TypeCode;
    value: any;
  end;
  ConstantDef_Description = { inherited } Contained_Description;
  ConstantDef_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  Container_ContainerDescription = packed record
    contained_object: Contained;
    name: CORBAString;
    value: any;
  end;
  Container_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMEEMan_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMEEMRegisterData_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  ExceptionDef_ExceptionDescription = packed record
    name: CORBAString;
    id: CORBAString;
    defined_in: CORBAString;
    SOM_type: TypeCode;
  end;
  ExceptionDef_Description = { inherited } Contained_Description;
  ExceptionDef_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  ImplementationDef_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  ImplRepository_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  P_IDL_ArrayOf_CORBAString = ^_IDL_ArrayOf_CORBAString;
  _IDL_Sequence_CORBAString = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_CORBAString;
  end;
  P_IDL_ArrayOf_ParameterDef_ParameterDescription = ^_IDL_ArrayOf_ParameterDef_ParameterDescription;
  _IDL_Sequence_ParameterDef_ParameterDescription = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_ParameterDef_ParameterDescription;
  end;
  P_IDL_ArrayOf_ExceptionDef_ExceptionDescription = ^_IDL_ArrayOf_ExceptionDef_ExceptionDescription;
  _IDL_Sequence_ExceptionDef_ExceptionDescription = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_ExceptionDef_ExceptionDescription;
  end;
  P_IDL_ArrayOf_OperationDef_OperationDescription = ^_IDL_ArrayOf_OperationDef_OperationDescription;
  _IDL_Sequence_OperationDef_OperationDescription = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_OperationDef_OperationDescription;
  end;
  P_IDL_ArrayOf_AttributeDef_AttributeDescription = ^_IDL_ArrayOf_AttributeDef_AttributeDescription;
  _IDL_Sequence_AttributeDef_AttributeDescription = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_AttributeDef_AttributeDescription;
  end;
  InterfaceDef_FullInterfaceDescription = packed record
    name: CORBAString;
    id: CORBAString;
    defined_in: CORBAString;
    operation: _IDL_Sequence_OperationDef_OperationDescription;
    attributes: _IDL_Sequence_AttributeDef_AttributeDescription;
  end;

  InterfaceDef_InterfaceDescription = packed record
    name: CORBAString;
    id: CORBAString;
    defined_in: CORBAString;
  end;
  InterfaceDef_Description = { inherited } Contained_Description;
  InterfaceDef_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  InterfaceDef_ContainerDescription = { inherited } Container_ContainerDescription;

  ModuleDef_ModuleDescription = packed record
    name: CORBAString;
    id: CORBAString;
    defined_in: CORBAString;
  end;
  ModuleDef_Description = { inherited } Contained_Description;
  ModuleDef_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  ModuleDef_ContainerDescription = { inherited } Container_ContainerDescription;
  NVList_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  ObjectMgr_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  OperationDef_OperationDescription = packed record
    name: CORBAString;
    id: CORBAString;
    defined_in: CORBAString;
    SOM_result: TypeCode;
    mode: OperationDef_OperationMode;
    contexts: _IDL_Sequence_CORBAString;
    parameter: _IDL_Sequence_ParameterDef_ParameterDescription;
    exceptions: _IDL_Sequence_ExceptionDef_ExceptionDescription;
  end;
  OperationDef_Description = { inherited } Contained_Description;
  OperationDef_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  OperationDef_ContainerDescription = { inherited } Container_ContainerDescription;
  ORB_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  ParameterDef_ParameterDescription = packed record
    name: CORBAString;
    id: CORBAString;
    defined_in: CORBAString;
    SOM_type: TypeCode;
    mode: ParameterDef_ParameterMode;
  end;
  ParameterDef_Description = { inherited } Contained_Description;
  ParameterDef_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  Principal_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  Repository_RepositoryDescription = packed record
    name: CORBAString;
    id: CORBAString;
    defined_in: CORBAString;
  end;

  Repository_irOpenError = { user exception } packed record
    errorCode: Repository_irOpenErrorCodes;
    fileName: CORBAString;
  end;
  Repository_ContainerDescription = { inherited } Container_ContainerDescription;
  Repository_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  Request_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTAttributeEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTBaseClassEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTClassEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTCommonEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTConstEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTDataEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTEmitC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTEnumEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTEnumNameEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTMetaClassEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTMethodEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTModuleEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTParameterEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTPassthruEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTSequenceEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTStringEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTStructEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTTypedefEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTTemplateOutputC_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  PSOMTUnionEntryC_somtLabelList = ^SOMTUnionEntryC_somtLabelList;
  SOMTUnionEntryC_somtLabelList = packed record
    SOM_label: CORBAString;
    nextLabel: PSOMTUnionEntryC_somtLabelList;
  end;

  SOMTUnionEntryC_somtCaseEntry = packed record
    caseLabels: PSOMTUnionEntryC_somtLabelList;
    memberType: SOMTEntryC;
    memberDeclarator: SOMTDataEntryC;
  end;
  SOMTUnionEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMTUserDefinedTypeEntryC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMDServerMgr_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMESinkEvent_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  SOMClass_somOffsetInfo = packed record
    cls: SOMClass;
    offset: LongInt;
  end;
  SOMClass_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMMSingleInstance_somOffsetInfo = { inherited } SOMClass_somOffsetInfo;
  SOMMSingleInstance_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMMBeforeAfter_somOffsetInfo = { inherited } SOMClass_somOffsetInfo;
  SOMMBeforeAfter_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMClassMgr_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMDObject_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMDClientProxy_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMDMetaproxy_somOffsetInfo = { inherited } SOMClass_somOffsetInfo;
  SOMDMetaproxy_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMDObjectMgr_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMDServer_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMUTId_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMOA_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  Sockets_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  entryT = packed record
    key: CORBAString;
    value: CORBAString;
    next: PentryT;
  end;
  SOMStringTableC_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMMTraced_somOffsetInfo = { inherited } SOMClass_somOffsetInfo;
  SOMMTraced_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  StExcep_UNKNOWN = { system exception } StExcep;
  StExcep_BAD_PARAM = { system exception } StExcep;
  StExcep_NO_MEMORY = { system exception } StExcep;
  StExcep_IMP_LIMIT = { system exception } StExcep;
  StExcep_COMM_FAILURE = { system exception } StExcep;
  StExcep_INV_OBJREF = { system exception } StExcep;
  StExcep_NO_PERMISSION = { system exception } StExcep;
  StExcep_INTERNAL = { system exception } StExcep;
  StExcep_MARSHAL = { system exception } StExcep;
  StExcep_INITIALIZE = { system exception } StExcep;
  StExcep_NO_IMPLEMENT = { system exception } StExcep;
  StExcep_BAD_TYPECODE = { system exception } StExcep;
  StExcep_BAD_OPERATION = { system exception } StExcep;
  StExcep_NO_RESOURCES = { system exception } StExcep;
  StExcep_NO_RESPONSE = { system exception } StExcep;
  StExcep_PERSIST_STORE = { system exception } StExcep;
  StExcep_BAD_INV_ORDER = { system exception } StExcep;
  StExcep_TRANSIENT = { system exception } StExcep;
  StExcep_FREE_MEM = { system exception } StExcep;
  StExcep_INV_IDENT = { system exception } StExcep;
  StExcep_INV_FLAG = { system exception } StExcep;
  StExcep_INTF_REPOS = { system exception } StExcep;
  StExcep_CONTEXT = { system exception } StExcep;
  StExcep_OBJ_ADAPTER = { system exception } StExcep;
  StExcep_DATA_CONVERSION = { system exception } StExcep;
  StExcep_OPSYS = { system exception } StExcep;
  StExcep_WMQUIT = { system exception } StExcep;
  StExcep_DISPATCH = { system exception } StExcep;
  StExcep_TransactionRequired = { system exception } StExcep;
  StExcep_TransactionRolledBack = { system exception } StExcep;
  StExcep_InvalidTransaction = { system exception } StExcep;
  StExcep_WrongTransaction = { system exception } StExcep;
  SOMETimerEvent_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  TSIdentification_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  TypeDef_TypeDescription = packed record
    name: CORBAString;
    id: CORBAString;
    defined_in: CORBAString;
    SOM_type: TypeCode;
  end;
  TypeDef_Description = { inherited } Contained_Description;
  TypeDef_somObjectOffset = { inherited } SOMObject_somObjectOffset;
  SOMEWorkProcEvent_somObjectOffset = { inherited } SOMObject_somObjectOffset;

  { Classes }
  SOMObjectBase = class
    { hide or reimplement TObject methods }
  protected
    class procedure Create; reintroduce;
  public
    procedure Free; reintroduce;
  protected
    class procedure InitInstance; reintroduce;
  public
    procedure CleanupInstance; reintroduce;
    function ClassType: SOMClass; reintroduce;
  protected
    class procedure ClassName; reintroduce;
    class procedure ClassNameIs; reintroduce;
    class procedure ClassParent; reintroduce;
    class procedure ClassInfo; reintroduce;
    class procedure InstanceSize; reintroduce;
    class procedure InheritsFrom; reintroduce;
    class procedure MethodAddress; reintroduce;
    class procedure MethodName; reintroduce;
    procedure FieldAddress; reintroduce;
    procedure GetInterface; reintroduce;
    class procedure GetInterfaceEntry; reintroduce;
    class procedure GetInterfaceTable; reintroduce;
    procedure SafeCallException; reintroduce;
  public
    procedure AfterConstruction; reintroduce;
    procedure BeforeDestruction; reintroduce;
  protected
    procedure Dispatch; reintroduce;
    procedure DefaultHandler; reintroduce;
    class procedure NewInstance; reintroduce;
  public
    procedure FreeInstance; reintroduce;
    procedure Destroy; reintroduce;

    { Upcasting }
    function As_SOMObject: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  end;

  TypeCode = class
    { hide or reimplement TObject methods }
  public
    procedure Free; reintroduce;
  protected
    class procedure InitInstance; reintroduce;
  public
    procedure CleanupInstance; reintroduce;
  protected
    procedure ClassType; reintroduce;
  public
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
  protected
    class procedure ClassParent; reintroduce;
    class procedure ClassInfo; reintroduce;
    class procedure InstanceSize; reintroduce;
    class procedure InheritsFrom; reintroduce;
    class procedure MethodAddress; reintroduce;
    class procedure MethodName; reintroduce;
    procedure FieldAddress; reintroduce;
    procedure GetInterface; reintroduce;
    class procedure GetInterfaceEntry; reintroduce;
    class procedure GetInterfaceTable; reintroduce;
    procedure SafeCallException; reintroduce;
  public
    procedure AfterConstruction; reintroduce;
    procedure BeforeDestruction; reintroduce;
  protected
    procedure Dispatch; reintroduce;
    procedure DefaultHandler; reintroduce;
    class procedure NewInstance; reintroduce;
  public
    procedure FreeInstance; reintroduce;
    procedure Destroy; reintroduce;
  protected
    function GetKind: TCKind;
    function GetParamCount: LongInt;
    function GetParameter(Index: LongInt): any;
    function GetAlignment: SmallInt;
    procedure SetAlignment(a: SmallInt);
    function GetSize: LongInt;
  public
    class function TC_null: TypeCode;
    class function TC_void: TypeCode;
    class function TC_short: TypeCode;
    class function TC_long: TypeCode;
    class function TC_ushort: TypeCode;
    class function TC_ulong: TypeCode;
    class function TC_float: TypeCode;
    class function TC_double: TypeCode;
    class function TC_boolean: TypeCode;
    class function TC_char: TypeCode;
    class function TC_octet: TypeCode;
    class function TC_any: TypeCode;
    class function TC_TypeCode: TypeCode;
    class function TC_Principal: TypeCode;
    class function TC_Object: TypeCode;
    class function TC_string: TypeCode;
    class function TC_NamedValue: TypeCode;
    class function TC_InterfaceDescription: TypeCode;
    class function TC_OperationDescription: TypeCode;
    class function TC_AttributeDescription: TypeCode;
    class function TC_ParameterDescription: TypeCode;
    class function TC_RepositoryDescription: TypeCode;
    class function TC_ModuleDescription: TypeCode;
    class function TC_ConstDescription: TypeCode;
    class function TC_ConstantDescription: TypeCode;
    class function TC_ExceptionDescription: TypeCode;
    class function TC_TypeDescription: TypeCode;
    class function TC_FullInterfaceDescription: TypeCode;
    function Equal(y: TypeCode): CORBABoolean;
    function Copy: TypeCode;
    procedure Print;
    class function Create(tag: TCKind): TypeCode; overload;
    class function Create(tag: TCKind; const Arguments: array of const): TypeCode; overload;
    class function Create(tag: TCKind; ap: va_list): TypeCode; overload;
    property Kind: TCKind read GetKind;
    property ParamCount: LongInt read GetParamCount;
    property Parameter[Index: LongInt]: any read GetParameter; default;
    property Alignment: SmallInt read GetAlignment write SetAlignment;
    property Size: LongInt read GetSize;
  end;

  ESOMException = class(Exception)
  protected
    FMajor: exception_type;
    FExceptionId: string;
    FExceptionValue: Pointer;
    FNestedEnvironment: Environment;
    function GetNestedEnvironment: PEnvironment; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    constructor Create(ev: PEnvironment); overload; // copies ev inside and clears ev argument
    constructor Create(AMajor: exception_type; const AExceptionId: string; AExceptionValue: Pointer); overload; // from user code
    destructor Destroy; override;
    procedure ResetNestedEnvironment; // clears the internal env and thus won't destroy it
    property Major: exception_type read FMajor;
    property ExceptionId: string read FExceptionId;
    property ExceptionValue: Pointer read FExceptionValue;
    property NestedEnvironment: PEnvironment read GetNestedEnvironment;
  end;

  SOMObject = class(SOMObjectBase)
  public
    class function Create: SOMObject; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMObject; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMObject; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMObject; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMObject): Boolean; overload;

  end;

  P_IDL_ArrayOf_somModifier = ^_IDL_ArrayOf_somModifier;
  _IDL_Sequence_somModifier = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_somModifier;
  end;
  P_IDL_ArrayOf_Container = ^_IDL_ArrayOf_Container;
  _IDL_Sequence_Container = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_Container;
  end;
  Contained = class(SOMObjectBase)
  private
    function _get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: Contained; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): Contained; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: Contained; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: Contained; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: Contained); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: Contained): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Contained); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: Contained); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Contained); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: Contained): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: Contained): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: Contained): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: Contained): Boolean; overload;

    property name: CORBAString read _get_name write _set_name;
    property id: CORBAString read _get_id write _set_id;
    property defined_in: CORBAString read _get_defined_in write _set_defined_in;
    property somModifiers: _IDL_Sequence_somModifier read _get_somModifiers write _set_somModifiers;
  end;

  AttributeDef = class(SOMObjectBase)
  private
    function _get_type: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_type(SOM_type: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_mode: AttributeDef_AttributeMode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_mode(mode: AttributeDef_AttributeMode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: AttributeDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): AttributeDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: AttributeDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: AttributeDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: AttributeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: AttributeDef): AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: AttributeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: AttributeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: AttributeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: AttributeDef): AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: AttributeDef): AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: AttributeDef): AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_AttributeDef: AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: AttributeDef): Boolean; overload;

    property SOM_type: TypeCode read _get_type write _set_type;
    property mode: AttributeDef_AttributeMode read _get_mode write _set_mode;
    property name: CORBAString read _get_name write _set_name;
    property id: CORBAString read _get_id write _set_id;
    property defined_in: CORBAString read _get_defined_in write _set_defined_in;
    property somModifiers: _IDL_Sequence_somModifier read _get_somModifiers write _set_somModifiers;
  end;

  _IDL_Array12Of_Byte = array[0 .. 11] of Byte;
  BOA = class(SOMObjectBase)
  public
    class function Create: BOA; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): BOA; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: BOA; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: BOA; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function SOM_create(const id: _IDL_Sequence_Byte; intf: InterfaceDef; impl: ImplementationDef): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure dispose(obj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_id(obj: SOMDObject): _IDL_Sequence_Byte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_principal(obj: SOMDObject; const req_ev: Environment): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure set_exception(major: exception_type; userid: CORBAString; param: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure impl_is_ready(impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure deactivate_impl(impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure change_implementation(obj: SOMDObject; impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure obj_is_ready(obj: SOMDObject; impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure deactivate_obj(obj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: BOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: BOA): BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: BOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: BOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: BOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: BOA): BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: BOA): BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: BOA): BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMMSingleInstance; // (not really new every time, but autocreated)

    { Upcasting }
    function As_BOA: BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: BOA): Boolean; overload;

  end;

  SOMEEvent = class(SOMObjectBase)
  public
    class function Create: SOMEEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMEEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMEEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMEEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventTime: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventTime(time: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventType(SOM_type: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMEEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMEEvent): SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMEEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMEEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMEEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMEEvent): SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMEEvent): SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMEEvent): SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMEEvent: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMEEvent): Boolean; overload;

  end;

  SOMEClientEvent = class(SOMObjectBase)
  public
    class function Create: SOMEClientEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMEClientEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMEClientEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMEClientEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventClientData: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventClientType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventClientData(clientData: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventClientType(clientType: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventTime: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventTime(time: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventType(SOM_type: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMEClientEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMEClientEvent): SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMEClientEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMEClientEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMEClientEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMEClientEvent): SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMEClientEvent): SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMEClientEvent): SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMEEvent: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMEClientEvent: SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMEClientEvent): Boolean; overload;

  end;

  Context = class(SOMObjectBase)
  public
    class function Create: Context; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): Context; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: Context; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: Context; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function set_one_value(prop_name: CORBAString; value: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function set_values(values: NVList): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_values(start_scope: CORBAString; op_flags: LongWord; prop_name: CORBAString; out values: NVList): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function delete_values(prop_name: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function create_child(ctx_name: CORBAString; out child_ctx: Context): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function SOM_destroy(flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: Context); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: Context): Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Context); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: Context); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Context); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: Context): Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: Context): Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: Context): Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Context: Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: Context): Boolean; overload;

  end;

  ConstantDef = class(SOMObjectBase)
  private
    function _get_type: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_type(SOM_type: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_value: any; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_value(const value: {caller_owns} any); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: ConstantDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): ConstantDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: ConstantDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: ConstantDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: ConstantDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: ConstantDef): ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ConstantDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: ConstantDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ConstantDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: ConstantDef): ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: ConstantDef): ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: ConstantDef): ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_ConstantDef: ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: ConstantDef): Boolean; overload;

    property SOM_type: TypeCode read _get_type write _set_type;
    property value: any read _get_value write _set_value;
    property name: CORBAString read _get_name write _set_name;
    property id: CORBAString read _get_id write _set_id;
    property defined_in: CORBAString read _get_defined_in write _set_defined_in;
    property somModifiers: _IDL_Sequence_somModifier read _get_somModifiers write _set_somModifiers;
  end;

  P_IDL_ArrayOf_Contained = ^_IDL_ArrayOf_Contained;
  _IDL_Sequence_Contained = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_Contained;
  end;
  P_IDL_ArrayOf_Container_ContainerDescription = ^_IDL_ArrayOf_Container_ContainerDescription;
  _IDL_Sequence_Container_ContainerDescription = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_Container_ContainerDescription;
  end;
  Container = class(SOMObjectBase)
  public
    class function Create: Container; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): Container; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: Container; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: Container; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function contents(limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function lookup_name(search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe_contents(limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: Container); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: Container): Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Container); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: Container); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Container); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: Container): Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: Container): Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: Container): Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Container: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: Container): Boolean; overload;

  end;

  SOMEEMan = class(SOMObjectBase)
  public
    class function Create: SOMEEMan; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMEEMan; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMEEMan; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMEEMan; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someGetEManSem; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someReleaseEManSem; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someChangeRegData(registrationId: LongInt; registerData: SOMEEMRegisterData); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someProcessEvent(mask: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someProcessEvents; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someQueueEvent(event: SOMEClientEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function someRegister(registerData: SOMEEMRegisterData; targetObject: SOMObject; targetMethod: CORBAString; targetData: Pointer): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function someRegisterEv(registerData: SOMEEMRegisterData; targetObject: SOMObject; var callbackEv: Environment; targetMethod: CORBAString; targetData: Pointer): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function someRegisterProc(registerData: SOMEEMRegisterData; targetProcedure: PPointer; targetData: Pointer): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someShutdown; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someUnRegister(registrationId: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMEEMan); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMEEMan): SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMEEMan); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMEEMan); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMEEMan); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMEEMan): SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMEEMan): SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMEEMan): SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMMSingleInstance; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMEEMan: SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMEEMan): Boolean; overload;

  end;

  SOMEEMRegisterData = class(SOMObjectBase)
  public
    class function Create: SOMEEMRegisterData; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMEEMRegisterData; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMEEMRegisterData; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMEEMRegisterData; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someClearRegData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someSetRegDataClientType(clientType: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someSetRegDataEventMask(eventType: LongInt; ap: va_list); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someSetRegDataSink(sink: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someSetRegDataSinkMask(sinkMask: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someSetRegDataTimerCount(count: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure someSetRegDataTimerInterval(interval: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMEEMRegisterData); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMEEMRegisterData): SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMEEMRegisterData); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMEEMRegisterData); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMEEMRegisterData); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMEEMRegisterData): SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMEEMRegisterData): SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMEEMRegisterData): SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMEEMRegisterData: SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMEEMRegisterData): Boolean; overload;

  end;

  ExceptionDef = class(SOMObjectBase)
  private
    function _get_type: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_type(SOM_type: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: ExceptionDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): ExceptionDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: ExceptionDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: ExceptionDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: ExceptionDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: ExceptionDef): ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ExceptionDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: ExceptionDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ExceptionDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: ExceptionDef): ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: ExceptionDef): ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: ExceptionDef): ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_ExceptionDef: ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: ExceptionDef): Boolean; overload;

    property SOM_type: TypeCode read _get_type write _set_type;
    property name: CORBAString read _get_name write _set_name;
    property id: CORBAString read _get_id write _set_id;
    property defined_in: CORBAString read _get_defined_in write _set_defined_in;
    property somModifiers: _IDL_Sequence_somModifier read _get_somModifiers write _set_somModifiers;
  end;

  ImplementationDef = class(SOMObjectBase)
  private
    function _get_impl_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_impl_id(impl_id: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_impl_alias: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_impl_alias(impl_alias: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_impl_program: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_impl_program(impl_program: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_impl_flags: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_impl_flags(impl_flags: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_impl_server_class: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_impl_server_class(impl_server_class: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_impl_refdata_file: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_impl_refdata_file(impl_refdata_file: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_impl_refdata_bkup: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_impl_refdata_bkup(impl_refdata_bkup: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_impl_hostname: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_impl_hostname(impl_hostname: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: ImplementationDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): ImplementationDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: ImplementationDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: ImplementationDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: ImplementationDef): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: ImplementationDef): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: ImplementationDef): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: ImplementationDef): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_ImplementationDef: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: ImplementationDef): Boolean; overload;

    property impl_id: CORBAString read _get_impl_id write _set_impl_id;
    property impl_alias: CORBAString read _get_impl_alias write _set_impl_alias;
    property impl_program: CORBAString read _get_impl_program write _set_impl_program;
    property impl_flags: LongWord read _get_impl_flags write _set_impl_flags;
    property impl_server_class: CORBAString read _get_impl_server_class write _set_impl_server_class;
    property impl_refdata_file: CORBAString read _get_impl_refdata_file write _set_impl_refdata_file;
    property impl_refdata_bkup: CORBAString read _get_impl_refdata_bkup write _set_impl_refdata_bkup;
    property impl_hostname: CORBAString read _get_impl_hostname write _set_impl_hostname;
  end;

  P_IDL_ArrayOf_ImplementationDef = ^_IDL_ArrayOf_ImplementationDef;
  _IDL_Sequence_ImplementationDef = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_ImplementationDef;
  end;
  ImplRepository = class(SOMObjectBase)
  public
    class function Create: ImplRepository; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): ImplRepository; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: ImplRepository; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: ImplRepository; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function find_impldef(implid: CORBAString): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function find_impldef_by_alias(alias_name: CORBAString): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function find_all_impldefs(out outimpldefs: _IDL_Sequence_ImplementationDef): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function find_impldef_by_class(classname: CORBAString): _IDL_Sequence_ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure add_impldef(impldef: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure update_impldef(impldef: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure delete_impldef(implid: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure add_class_to_impldef(implid: CORBAString; classname: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure remove_class_from_impldef(implid: CORBAString; classname: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure remove_class_from_all(classname: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function find_classes_by_impldef(implid: CORBAString): _IDL_Sequence_CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: ImplRepository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: ImplRepository): ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ImplRepository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: ImplRepository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ImplRepository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: ImplRepository): ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: ImplRepository): ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: ImplRepository): ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMMSingleInstance; // (not really new every time, but autocreated)

    { Upcasting }
    function As_ImplRepository: ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: ImplRepository): Boolean; overload;

  end;

  InterfaceDef = class(SOMObjectBase)
  private
    function _get_base_interfaces: _IDL_Sequence_CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_base_interfaces(const base_interfaces: {caller_owns} _IDL_Sequence_CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_instanceData: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_instanceData(instanceData: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: InterfaceDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): InterfaceDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: InterfaceDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: InterfaceDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe_interface: InterfaceDef_FullInterfaceDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: InterfaceDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: InterfaceDef): InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: InterfaceDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: InterfaceDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: InterfaceDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: InterfaceDef): InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: InterfaceDef): InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: InterfaceDef): InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function contents(limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function lookup_name(search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe_contents(limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_Container: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_InterfaceDef: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: InterfaceDef): Boolean; overload;

    property base_interfaces: _IDL_Sequence_CORBAString read _get_base_interfaces write _set_base_interfaces;
    property instanceData: TypeCode read _get_instanceData write _set_instanceData;
    property name: CORBAString read _get_name write _set_name;
    property id: CORBAString read _get_id write _set_id;
    property defined_in: CORBAString read _get_defined_in write _set_defined_in;
    property somModifiers: _IDL_Sequence_somModifier read _get_somModifiers write _set_somModifiers;
  end;

  ModuleDef = class(SOMObjectBase)
  private
    function _get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: ModuleDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): ModuleDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: ModuleDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: ModuleDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: ModuleDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: ModuleDef): ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ModuleDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: ModuleDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ModuleDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: ModuleDef): ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: ModuleDef): ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: ModuleDef): ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function contents(limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function lookup_name(search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe_contents(limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_Container: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_ModuleDef: ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: ModuleDef): Boolean; overload;

    property name: CORBAString read _get_name write _set_name;
    property id: CORBAString read _get_id write _set_id;
    property defined_in: CORBAString read _get_defined_in write _set_defined_in;
    property somModifiers: _IDL_Sequence_somModifier read _get_somModifiers write _set_somModifiers;
  end;

  NVList = class(SOMObjectBase)
  public
    class function Create: NVList; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): NVList; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: NVList; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: NVList; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function add_item(item_name: CORBAString; item_type: TypeCode; value: Pointer; value_len: LongInt; item_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function free: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function free_memory: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_count(out count: LongInt): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function set_item(item_number: LongInt; item_name: CORBAString; item_type: TypeCode; value: Pointer; value_len: LongInt; item_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_item(item_number: LongInt; out item_name: CORBAString; out item_type: TypeCode; out value: Pointer; out value_len: LongInt; out item_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: NVList); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: NVList): NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: NVList); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: NVList); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: NVList); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: NVList): NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: NVList): NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: NVList): NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_NVList: NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: NVList): Boolean; overload;

  end;

  ObjectMgr = class(SOMObjectBase)
  public
    class function Create: ObjectMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): ObjectMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: ObjectMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: ObjectMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdNewObject(objclass: CORBAString; hints: CORBAString): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdGetIdFromObject(obj: SOMObject): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdGetObjectFromId(id: CORBAString): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somdReleaseObject(obj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somdDestroyObject(obj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: ObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: ObjectMgr): ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: ObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: ObjectMgr): ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: ObjectMgr): ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: ObjectMgr): ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMMSingleInstance; // (not really new every time, but autocreated)

    { Upcasting }
    function As_ObjectMgr: ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: ObjectMgr): Boolean; overload;

  end;

  OperationDef = class(SOMObjectBase)
  private
    function _get_result: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_result(SOM_result: TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_mode: OperationDef_OperationMode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_mode(mode: OperationDef_OperationMode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_contexts: _IDL_Sequence_CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_contexts(const contexts: _IDL_Sequence_CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: OperationDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): OperationDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: OperationDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: OperationDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: OperationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: OperationDef): OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: OperationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: OperationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: OperationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: OperationDef): OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: OperationDef): OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: OperationDef): OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function contents(limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function lookup_name(search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe_contents(limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_Container: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_OperationDef: OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: OperationDef): Boolean; overload;

    property SOM_result: TypeCode read _get_result write _set_result;
    property mode: OperationDef_OperationMode read _get_mode write _set_mode;
    property contexts: _IDL_Sequence_CORBAString read _get_contexts write _set_contexts;
    property name: CORBAString read _get_name write _set_name;
    property id: CORBAString read _get_id write _set_id;
    property defined_in: CORBAString read _get_defined_in write _set_defined_in;
    property somModifiers: _IDL_Sequence_somModifier read _get_somModifiers write _set_somModifiers;
  end;

  ORB = class(SOMObjectBase)
  public
    class function Create: ORB; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): ORB; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: ORB; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: ORB; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function object_to_string(obj: SOMDObject): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function string_to_object(str: CORBAString): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function create_list(count: LongInt; out new_list: NVList): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function create_operation_list(oper: OperationDef; out new_list: NVList): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_default_context(out ctx: Context): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: ORB); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: ORB): ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ORB); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: ORB); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ORB); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: ORB): ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: ORB): ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: ORB): ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMMSingleInstance; // (not really new every time, but autocreated)

    { Upcasting }
    function As_ORB: ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: ORB): Boolean; overload;

  end;

  ParameterDef = class(SOMObjectBase)
  private
    function _get_type: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_type(SOM_type: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_mode: ParameterDef_ParameterMode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_mode(mode: ParameterDef_ParameterMode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: ParameterDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): ParameterDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: ParameterDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: ParameterDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: ParameterDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: ParameterDef): ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ParameterDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: ParameterDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ParameterDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: ParameterDef): ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: ParameterDef): ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: ParameterDef): ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_ParameterDef: ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: ParameterDef): Boolean; overload;

    property SOM_type: TypeCode read _get_type write _set_type;
    property mode: ParameterDef_ParameterMode read _get_mode write _set_mode;
    property name: CORBAString read _get_name write _set_name;
    property id: CORBAString read _get_id write _set_id;
    property defined_in: CORBAString read _get_defined_in write _set_defined_in;
    property somModifiers: _IDL_Sequence_somModifier read _get_somModifiers write _set_somModifiers;
  end;

  Principal = class(SOMObjectBase)
  private
    function _get_userName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_userName(userName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_hostName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_hostName(hostName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: Principal; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): Principal; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: Principal; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: Principal; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: Principal); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: Principal): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Principal); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: Principal); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Principal); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: Principal): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: Principal): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: Principal): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Principal: Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: Principal): Boolean; overload;

    property userName: CORBAString read _get_userName write _set_userName;
    property hostName: CORBAString read _get_hostName write _set_hostName;
  end;

  Repository = class(SOMObjectBase)
  public
    class function Create: Repository; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): Repository; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: Repository; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: Repository; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function lookup_id(search_id: CORBAString): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function lookup_modifier(name: CORBAString; modifier: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure release_cache; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function contents(limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function lookup_name(search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe_contents(limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: Repository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: Repository): Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Repository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: Repository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Repository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: Repository): Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: Repository): Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: Repository): Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Container: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_Repository: Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: Repository): Boolean; overload;

  end;

  Request = class(SOMObjectBase)
  public
    class function Create: Request; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): Request; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: Request; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: Request; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function add_arg(name: CORBAString; arg_type: TypeCode; value: Pointer; len: LongInt; arg_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function invoke(invoke_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function send(invoke_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_response(response_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function SOM_destroy: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: Request); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: Request): Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Request); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: Request); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Request); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: Request): Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: Request): Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: Request): Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Request: Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: Request): Boolean; overload;

  end;

  SOMTEntryC = class(SOMObjectBase)
  private
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTEntryC): SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTEntryC): SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTEntryC): SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTEntryC): SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTEntryC): Boolean; overload;

    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTAttributeEntryC = class(SOMObjectBase)
  private
    function _get_somtIsReadonly: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtAttribType: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTAttributeEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTAttributeEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTAttributeEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTAttributeEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstAttributeDeclarator: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextAttributeDeclarator: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstGetMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextGetMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstSetMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextSetMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTAttributeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTAttributeEntryC): SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTAttributeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTAttributeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTAttributeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTAttributeEntryC): SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTAttributeEntryC): SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTAttributeEntryC): SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTAttributeEntryC: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTAttributeEntryC): Boolean; overload;

    property somtIsReadonly: CORBABoolean read _get_somtIsReadonly;
    property somtAttribType: SOMTEntryC read _get_somtAttribType;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTBaseClassEntryC = class(SOMObjectBase)
  private
    function _get_somtBaseClassDef: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTBaseClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTBaseClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTBaseClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTBaseClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC): SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC): SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC): SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC): SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTBaseClassEntryC: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTBaseClassEntryC): Boolean; overload;

    property somtBaseClassDef: SOMTClassEntryC read _get_somtBaseClassDef;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTClassEntryC = class(SOMObjectBase)
  private
    function _get_somtSourceFileName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtMetaClassEntry: SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtClassModule: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtNewMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtLocalInclude: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtPrivateMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtStaticMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtOverrideMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtProcMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtVAMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtBaseCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtExternalDataCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtPublicDataCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtPrivateDataCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtMetaclassFor: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtForwardRef: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstBaseClass: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextBaseClass: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstReleaseName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextReleaseName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetReleaseNameList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstPassthru: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextPassthru: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstData: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextData: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstStaticData: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextStaticData: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstInheritedMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextInheritedMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstAttribute: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextAttribute: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstStruct: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextStruct: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstTypedef: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextTypedef: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstUnion: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextUnion: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstEnum: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextEnum: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstConstant: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextConstant: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstSequence: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextSequence: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstPubdef: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextPubdef: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFilterNew(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFilterOverridden(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFilterPrivOrPub(entry: SOMTCommonEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTClassEntryC): SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTClassEntryC): SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTClassEntryC): SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTClassEntryC): SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTClassEntryC: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTClassEntryC): Boolean; overload;

    property somtSourceFileName: CORBAString read _get_somtSourceFileName;
    property somtMetaClassEntry: SOMTMetaClassEntryC read _get_somtMetaClassEntry;
    property somtClassModule: SOMTModuleEntryC read _get_somtClassModule;
    property somtNewMethodCount: LongInt read _get_somtNewMethodCount;
    property somtLocalInclude: CORBABoolean read _get_somtLocalInclude;
    property somtPrivateMethodCount: LongInt read _get_somtPrivateMethodCount;
    property somtStaticMethodCount: LongInt read _get_somtStaticMethodCount;
    property somtOverrideMethodCount: LongInt read _get_somtOverrideMethodCount;
    property somtProcMethodCount: LongInt read _get_somtProcMethodCount;
    property somtVAMethodCount: LongInt read _get_somtVAMethodCount;
    property somtBaseCount: LongInt read _get_somtBaseCount;
    property somtExternalDataCount: LongInt read _get_somtExternalDataCount;
    property somtPublicDataCount: LongInt read _get_somtPublicDataCount;
    property somtPrivateDataCount: LongInt read _get_somtPrivateDataCount;
    property somtMetaclassFor: SOMTClassEntryC read _get_somtMetaclassFor;
    property somtForwardRef: CORBABoolean read _get_somtForwardRef;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTCommonEntryC = class(SOMObjectBase)
  private
    function _get_somtTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtPtrs: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtArrayDimsString: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceText: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtVisibility: somtVisibilityT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTCommonEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTCommonEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTCommonEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTCommonEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsArray(out size: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsPointer: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTCommonEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTCommonEntryC): SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTCommonEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTCommonEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTCommonEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTCommonEntryC): SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTCommonEntryC): SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTCommonEntryC): SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTCommonEntryC: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTCommonEntryC): Boolean; overload;

    property somtTypeObj: SOMTEntryC read _get_somtTypeObj;
    property somtPtrs: CORBAString read _get_somtPtrs;
    property somtArrayDimsString: CORBAString read _get_somtArrayDimsString;
    property somtSourceText: CORBAString read _get_somtSourceText;
    property somtType: CORBAString read _get_somtType;
    property somtVisibility: somtVisibilityT read _get_somtVisibility;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTConstEntryC = class(SOMObjectBase)
  private
    function _get_somtConstTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtConstType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtConstStringVal: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtConstNumVal: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtConstNumNegVal: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtConstIsNegative: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtConstVal: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTConstEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTConstEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTConstEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTConstEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTConstEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTConstEntryC): SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTConstEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTConstEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTConstEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTConstEntryC): SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTConstEntryC): SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTConstEntryC): SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTConstEntryC: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTConstEntryC): Boolean; overload;

    property somtConstTypeObj: SOMTEntryC read _get_somtConstTypeObj;
    property somtConstType: CORBAString read _get_somtConstType;
    property somtConstStringVal: CORBAString read _get_somtConstStringVal;
    property somtConstNumVal: LongWord read _get_somtConstNumVal;
    property somtConstNumNegVal: LongInt read _get_somtConstNumNegVal;
    property somtConstIsNegative: CORBABoolean read _get_somtConstIsNegative;
    property somtConstVal: CORBAString read _get_somtConstVal;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTDataEntryC = class(SOMObjectBase)
  private
    function _get_somtIsSelfRef: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtPtrs: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtArrayDimsString: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceText: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtVisibility: somtVisibilityT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTDataEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTDataEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTDataEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTDataEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsArray(out size: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsPointer: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTDataEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTDataEntryC): SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTDataEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTDataEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTDataEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTDataEntryC): SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTDataEntryC): SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTDataEntryC): SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTCommonEntryC: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTDataEntryC: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTDataEntryC): Boolean; overload;

    property somtIsSelfRef: CORBABoolean read _get_somtIsSelfRef;
    property somtTypeObj: SOMTEntryC read _get_somtTypeObj;
    property somtPtrs: CORBAString read _get_somtPtrs;
    property somtArrayDimsString: CORBAString read _get_somtArrayDimsString;
    property somtSourceText: CORBAString read _get_somtSourceText;
    property somtType: CORBAString read _get_somtType;
    property somtVisibility: somtVisibilityT read _get_somtVisibility;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  PSOM_FILE = Pointer{ opaque ^SOM_FILE };
  SOMTEmitC = class(SOMObjectBase)
  private
    function _get_somtTemplate: SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtTemplate(somtTemplate: SOMTTemplateOutputC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTargetFile: PSOM_FILE; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtTargetFile(somtTargetFile: PSOM_FILE); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTargetClass: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtTargetClass(somtTargetClass: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTargetModule: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtTargetModule(somtTargetModule: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTargetType: SOMTTargetTypeT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtTargetType(somtTargetType: SOMTTargetTypeT); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEmitterName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEmitterName(somtEmitterName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTEmitC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTEmitC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTEmitC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTEmitC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGenerateSections: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtOpenSymbolsFile(SOM_file: CORBAString; mode: CORBAString): PSOM_FILE; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetPredefinedSymbols; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtFileSymbols; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitBaseIncludesProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitBaseIncludes(base: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitBaseIncludesEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitMetaInclude; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitMeta; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitBaseProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitBase(base: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitBaseEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitPassthruProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitPassthru(entry: SOMTPassthruEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitPassthruEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitRelease; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitDataProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitData(entry: SOMTDataEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitDataEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitAttributeProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitAttribute(att: SOMTAttributeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitAttributeEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitConstantProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitConstant(con: SOMTConstEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitConstantEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitTypedefProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitTypedef(td: SOMTTypedefEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitTypedefEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitStructProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitStruct(struc: SOMTStructEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitStructEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitUnionProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitUnion(un: SOMTUnionEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitUnionEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitEnumProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitEnum(en: SOMTEnumEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitEnumEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitInterfaceProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitInterface(intfc: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitInterfaceEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitModuleProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitModule(SOM_mod: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitModuleEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitMethodsProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitMethods(method: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitMethodsEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitMethod(entry: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanBases(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtCheckVisibility(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtNew(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtImplemented(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtOverridden(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtInherited(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtAllVisible(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtAll(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtNewNoProc(entry: SOMTEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtPrivOrPub(entry: SOMTEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtNewProc(entry: SOMTEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtLink(entry: SOMTEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtVA(entry: SOMTEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanMethods(filter: CORBAString; prolog: CORBAString; each: CORBAString; epilog: CORBAString; forceProlog: CORBABoolean): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanConstants(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanTypedefs(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanStructs(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanUnions(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanEnums(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanData(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanAttributes(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanInterfaces(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanModules(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanPassthru(before: CORBABoolean; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtEmitFullPassthru(before: CORBABoolean; language: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanDataF(filter: CORBAString; prolog: CORBAString; each: CORBAString; epilog: CORBAString; forceProlog: CORBABoolean): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtScanBasesF(filter: CORBAString; prolog: CORBAString; each: CORBAString; epilog: CORBAString; forceProlog: CORBABoolean): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetGlobalModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstGlobalDefinition: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextGlobalDefinition: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTEmitC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTEmitC): SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTEmitC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTEmitC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTEmitC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTEmitC): SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTEmitC): SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTEmitC): SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEmitC: SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTEmitC): Boolean; overload;

    property somtTemplate: SOMTTemplateOutputC read _get_somtTemplate write _set_somtTemplate;
    property somtTargetFile: PSOM_FILE read _get_somtTargetFile write _set_somtTargetFile;
    property somtTargetClass: SOMTClassEntryC read _get_somtTargetClass write _set_somtTargetClass;
    property somtTargetModule: SOMTModuleEntryC read _get_somtTargetModule write _set_somtTargetModule;
    property somtTargetType: SOMTTargetTypeT read _get_somtTargetType write _set_somtTargetType;
    property somtEmitterName: CORBAString read _get_somtEmitterName write _set_somtEmitterName;
  end;

  SOMTEnumEntryC = class(SOMObjectBase)
  private
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTEnumEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTEnumEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTEnumEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTEnumEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstEnumName: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextEnumName: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTEnumEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTEnumEntryC): SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTEnumEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTEnumEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTEnumEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTEnumEntryC): SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTEnumEntryC): SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTEnumEntryC): SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTEnumEntryC: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTEnumEntryC): Boolean; overload;

    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTEnumNameEntryC = class(SOMObjectBase)
  private
    function _get_somtEnumPtr: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEnumVal: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTEnumNameEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTEnumNameEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTEnumNameEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTEnumNameEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC): SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC): SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC): SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC): SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTEnumNameEntryC: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTEnumNameEntryC): Boolean; overload;

    property somtEnumPtr: SOMTEnumEntryC read _get_somtEnumPtr;
    property somtEnumVal: LongWord read _get_somtEnumVal;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTMetaClassEntryC = class(SOMObjectBase)
  private
    function _get_somtMetaFile: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtMetaClassDef: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTMetaClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTMetaClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTMetaClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTMetaClassEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC): SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC): SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC): SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC): SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTMetaClassEntryC: SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTMetaClassEntryC): Boolean; overload;

    property somtMetaFile: CORBAString read _get_somtMetaFile;
    property somtMetaClassDef: SOMTClassEntryC read _get_somtMetaClassDef;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  PCORBAString = ^CORBAString;
  SOMTMethodEntryC = class(SOMObjectBase)
  private
    function _get_somtIsVarargs: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtOriginalMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtOriginalClass: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtMethodGroup: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsPrivateMethod: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsOneway: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtArgCount: SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtContextArray: PCORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCReturnType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtPtrs: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtArrayDimsString: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceText: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtVisibility: somtVisibilityT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTMethodEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTMethodEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTMethodEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTMethodEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstParameter: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextParameter: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetIDLParamList(buffer: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetShortCParamList(buffer: CORBAString; selfParm: CORBAString; varargsParm: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFullCParamList(buffer: CORBAString; varargsParm: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetShortParamNameList(buffer: CORBAString; selfParm: CORBAString; varargsParm: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFullParamNameList(buffer: CORBAString; varargsParm: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNthParameter(n: SmallInt): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstException: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextException: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsArray(out size: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsPointer: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTMethodEntryC): SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTMethodEntryC): SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTMethodEntryC): SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTMethodEntryC): SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTCommonEntryC: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTMethodEntryC: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTMethodEntryC): Boolean; overload;

    property somtIsVarargs: CORBABoolean read _get_somtIsVarargs;
    property somtOriginalMethod: SOMTMethodEntryC read _get_somtOriginalMethod;
    property somtOriginalClass: SOMTClassEntryC read _get_somtOriginalClass;
    property somtMethodGroup: SOMTEntryC read _get_somtMethodGroup;
    property somtIsPrivateMethod: CORBABoolean read _get_somtIsPrivateMethod;
    property somtIsOneway: CORBABoolean read _get_somtIsOneway;
    property somtArgCount: SmallInt read _get_somtArgCount;
    property somtContextArray: PCORBAString read _get_somtContextArray;
    property somtCReturnType: CORBAString read _get_somtCReturnType;
    property somtTypeObj: SOMTEntryC read _get_somtTypeObj;
    property somtPtrs: CORBAString read _get_somtPtrs;
    property somtArrayDimsString: CORBAString read _get_somtArrayDimsString;
    property somtSourceText: CORBAString read _get_somtSourceText;
    property somtType: CORBAString read _get_somtType;
    property somtVisibility: somtVisibilityT read _get_somtVisibility;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTModuleEntryC = class(SOMObjectBase)
  private
    function _get_somtOuterModule: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtModuleFile: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTModuleEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTModuleEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTModuleEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTModuleEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModuleStruct: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModuleStruct: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModuleTypedef: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModuleTypedef: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModuleUnion: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModuleUnion: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModuleEnum: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModuleEnum: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModuleConstant: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModuleConstant: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModuleSequence: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModuleSequence: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstInterface: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextInterface: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModule: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModule: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModuleDef: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModuleDef: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTModuleEntryC): SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTModuleEntryC): SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTModuleEntryC): SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTModuleEntryC): SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTModuleEntryC: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTModuleEntryC): Boolean; overload;

    property somtOuterModule: SOMTModuleEntryC read _get_somtOuterModule;
    property somtModuleFile: CORBAString read _get_somtModuleFile;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTParameterEntryC = class(SOMObjectBase)
  private
    function _get_somtParameterDirection: somtParameterDirectionT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLParameterDeclaration: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCParameterDeclaration: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtPtrs: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtArrayDimsString: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceText: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtVisibility: somtVisibilityT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTParameterEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTParameterEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTParameterEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTParameterEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsArray(out size: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsPointer: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTParameterEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTParameterEntryC): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTParameterEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTParameterEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTParameterEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTParameterEntryC): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTParameterEntryC): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTParameterEntryC): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTCommonEntryC: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTParameterEntryC: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTParameterEntryC): Boolean; overload;

    property somtParameterDirection: somtParameterDirectionT read _get_somtParameterDirection;
    property somtIDLParameterDeclaration: CORBAString read _get_somtIDLParameterDeclaration;
    property somtCParameterDeclaration: CORBAString read _get_somtCParameterDeclaration;
    property somtTypeObj: SOMTEntryC read _get_somtTypeObj;
    property somtPtrs: CORBAString read _get_somtPtrs;
    property somtArrayDimsString: CORBAString read _get_somtArrayDimsString;
    property somtSourceText: CORBAString read _get_somtSourceText;
    property somtType: CORBAString read _get_somtType;
    property somtVisibility: somtVisibilityT read _get_somtVisibility;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTPassthruEntryC = class(SOMObjectBase)
  private
    function _get_somtPassthruBody: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtPassthruLanguage: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtPassthruTarget: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTPassthruEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTPassthruEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTPassthruEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTPassthruEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsBeforePassthru: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTPassthruEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTPassthruEntryC): SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTPassthruEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTPassthruEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTPassthruEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTPassthruEntryC): SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTPassthruEntryC): SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTPassthruEntryC): SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTPassthruEntryC: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTPassthruEntryC): Boolean; overload;

    property somtPassthruBody: CORBAString read _get_somtPassthruBody;
    property somtPassthruLanguage: CORBAString read _get_somtPassthruLanguage;
    property somtPassthruTarget: CORBAString read _get_somtPassthruTarget;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTSequenceEntryC = class(SOMObjectBase)
  private
    function _get_somtSeqLength: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSeqType: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTSequenceEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTSequenceEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTSequenceEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTSequenceEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTSequenceEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTSequenceEntryC): SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTSequenceEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTSequenceEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTSequenceEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTSequenceEntryC): SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTSequenceEntryC): SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTSequenceEntryC): SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTSequenceEntryC: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTSequenceEntryC): Boolean; overload;

    property somtSeqLength: LongInt read _get_somtSeqLength;
    property somtSeqType: SOMTEntryC read _get_somtSeqType;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTStringEntryC = class(SOMObjectBase)
  private
    function _get_somtStringLength: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTStringEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTStringEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTStringEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTStringEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTStringEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTStringEntryC): SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTStringEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTStringEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTStringEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTStringEntryC): SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTStringEntryC): SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTStringEntryC): SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTStringEntryC: SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTStringEntryC): Boolean; overload;

    property somtStringLength: LongInt read _get_somtStringLength;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTStructEntryC = class(SOMObjectBase)
  private
    function _get_somtStructClass: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsException: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTStructEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTStructEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTStructEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTStructEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstMember: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextMember: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTStructEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTStructEntryC): SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTStructEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTStructEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTStructEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTStructEntryC): SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTStructEntryC): SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTStructEntryC): SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTStructEntryC: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTStructEntryC): Boolean; overload;

    property somtStructClass: SOMTClassEntryC read _get_somtStructClass;
    property somtIsException: CORBABoolean read _get_somtIsException;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTTypedefEntryC = class(SOMObjectBase)
  private
    function _get_somtTypedefType: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTTypedefEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTTypedefEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTTypedefEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTTypedefEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstDeclarator: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextDeclarator: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTTypedefEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTTypedefEntryC): SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTTypedefEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTTypedefEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTTypedefEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTTypedefEntryC): SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTTypedefEntryC): SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTTypedefEntryC): SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTTypedefEntryC: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTTypedefEntryC): Boolean; overload;

    property somtTypedefType: SOMTEntryC read _get_somtTypedefType;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTTemplateOutputC = class(SOMObjectBase)
  private
    function _get_somtCommentStyle: somtCommentStyleT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtCommentStyle(somtCommentStyle: somtCommentStyleT); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtLineLength: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtLineLength(somtLineLength: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCommentNewline: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtCommentNewline(somtCommentNewline: CORBABoolean); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTTemplateOutputC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTTemplateOutputC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTTemplateOutputC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTTemplateOutputC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetSymbol(name: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetSymbol(name: CORBAString; value: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetSymbolCopyName(name: CORBAString; value: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetSymbolCopyValue(name: CORBAString; value: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetSymbolCopyBoth(name: CORBAString; value: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtCheckSymbol(name: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetOutputFile(var fp{: opaque SOM_FILE}); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somto(tmplt: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtOutputComment(comment: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtOutputSection(sectionName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtAddSectionDefinitions(defString: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtReadSectionDefinitions(var fp{: opaque SOM_FILE}); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtExpandSymbol(s: CORBAString; buf: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTTemplateOutputC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTTemplateOutputC): SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTTemplateOutputC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTTemplateOutputC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTTemplateOutputC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTTemplateOutputC): SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTTemplateOutputC): SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTTemplateOutputC): SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTTemplateOutputC: SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTTemplateOutputC): Boolean; overload;

    property somtCommentStyle: somtCommentStyleT read _get_somtCommentStyle write _set_somtCommentStyle;
    property somtLineLength: LongInt read _get_somtLineLength write _set_somtLineLength;
    property somtCommentNewline: CORBABoolean read _get_somtCommentNewline write _set_somtCommentNewline;
  end;

  PSOMTUnionEntryC_somtCaseEntry = ^SOMTUnionEntryC_somtCaseEntry;
  SOMTUnionEntryC = class(SOMObjectBase)
  private
    function _get_somtSwitchType: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTUnionEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTUnionEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTUnionEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTUnionEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstCaseEntry: PSOMTUnionEntryC_somtCaseEntry; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextCaseEntry: PSOMTUnionEntryC_somtCaseEntry; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTUnionEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTUnionEntryC): SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTUnionEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTUnionEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTUnionEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTUnionEntryC): SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTUnionEntryC): SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTUnionEntryC): SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTUnionEntryC: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTUnionEntryC): Boolean; overload;

    property somtSwitchType: SOMTEntryC read _get_somtSwitchType;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMTUserDefinedTypeEntryC = class(SOMObjectBase)
  private
    function _get_somtOriginalTypedef: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtBaseTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtPtrs: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtArrayDimsString: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceText: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtVisibility: somtVisibilityT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMTUserDefinedTypeEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMTUserDefinedTypeEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMTUserDefinedTypeEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMTUserDefinedTypeEntryC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsArray(out size: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtIsPointer: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC): SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC): SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC): SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC): SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMTCommonEntryC: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMTUserDefinedTypeEntryC: SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMTUserDefinedTypeEntryC): Boolean; overload;

    property somtOriginalTypedef: SOMTTypedefEntryC read _get_somtOriginalTypedef;
    property somtBaseTypeObj: SOMTEntryC read _get_somtBaseTypeObj;
    property somtTypeObj: SOMTEntryC read _get_somtTypeObj;
    property somtPtrs: CORBAString read _get_somtPtrs;
    property somtArrayDimsString: CORBAString read _get_somtArrayDimsString;
    property somtSourceText: CORBAString read _get_somtSourceText;
    property somtType: CORBAString read _get_somtType;
    property somtVisibility: somtVisibilityT read _get_somtVisibility;
    property somtEntryName: CORBAString read _get_somtEntryName write _set_somtEntryName;
    property somtElementType: LongWord read _get_somtElementType write _set_somtElementType;
    property somtElementTypeName: CORBAString read _get_somtElementTypeName;
    property somtEntryComment: CORBAString read _get_somtEntryComment;
    property somtSourceLineNumber: LongWord read _get_somtSourceLineNumber;
    property somtTypeCode: TypeCode read _get_somtTypeCode;
    property somtIsReference: CORBABoolean read _get_somtIsReference;
    property somtIDLScopedName: CORBAString read _get_somtIDLScopedName;
    property somtCScopedName: CORBAString read _get_somtCScopedName;
  end;

  SOMDServerMgr = class(SOMObjectBase)
  public
    class function Create: SOMDServerMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMDServerMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMDServerMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMDServerMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdShutdownServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdStartServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdRestartServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdListServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdDisableServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdEnableServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdIsServerEnabled(impldef: ImplementationDef): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDServerMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMDServerMgr): SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDServerMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDServerMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDServerMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDServerMgr): SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDServerMgr): SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDServerMgr): SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMDServerMgr: SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMDServerMgr): Boolean; overload;

  end;

  SOMESinkEvent = class(SOMObjectBase)
  public
    class function Create: SOMESinkEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMESinkEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMESinkEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMESinkEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventSink: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventSink(sink: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventTime: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventTime(time: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventType(SOM_type: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMESinkEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMESinkEvent): SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMESinkEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMESinkEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMESinkEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMESinkEvent): SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMESinkEvent): SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMESinkEvent): SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMEEvent: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMESinkEvent: SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMESinkEvent): Boolean; overload;

  end;

  PsomClassDataStructure = ^somClassDataStructure;
  SOMClass = class(SOMObjectBase)
  private
    function _get_somDataAlignment: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somDirectInitClasses: _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somDirectInitClasses(const somDirectInitClasses: _IDL_Sequence_SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somClassAllocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somClassDeallocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somNew: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somNewNoInit: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenew(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoInit(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoInitNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somAllocate(size: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDeallocate(memptr: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceInitMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceDestructionMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceAssignmentMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInitClass(className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInitMIClass(inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somAddStaticMethod(methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somAddDynamicMethod(methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somOverrideSMethod(methodId: somId; method: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somClassReady; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassData: PsomClassDataStructure; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somSetClassData(const cds: somClassDataStructure); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassMtab: PsomMethodTab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceOffset: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstancePartSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceToken: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMemberToken(memberOffset: LongInt; instanceToken: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodData(methodId: somId; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetRdStub(methodId: somId): PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodDescriptor(methodId: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodIndex(id: somId): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodToken(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNthMethodData(n: LongInt; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNthMethodInfo(n: LongInt; out descriptor: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNumMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNumStaticMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetParent: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetParents: {dual_owned} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetPClsMtab: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetPClsMtabs: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somGetVersionNumbers(out majorVersion: LongInt; out minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSetMethodDescriptor(methodId: somId; descriptor: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindMethod(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindMethodOk(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindSMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindSMethodOk(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somLookupMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCheckVersion(majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDescendedFrom(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSupportsMethod(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefinedMethod(method: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somOverrideMtab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMClass): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMClass): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMClass): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMClass): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMClass): Boolean; overload;

    property somDataAlignment: LongInt read _get_somDataAlignment;
    property somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo read _get_somInstanceDataOffsets;
    property somDirectInitClasses: _IDL_Sequence_SOMClass read _get_somDirectInitClasses write _set_somDirectInitClasses;
    property somClassAllocate: PPointer read _get_somClassAllocate;
    property somClassDeallocate: PPointer read _get_somClassDeallocate;
  end;

  SOMMSingleInstance = class(SOMObjectBase)
  private
    function _get_somDataAlignment: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somDirectInitClasses: _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somDirectInitClasses(const somDirectInitClasses: _IDL_Sequence_SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somClassAllocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somClassDeallocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function sommGetSingleInstance: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure sommFreeSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somNew: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somNewNoInit: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenew(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoInit(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoInitNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somAllocate(size: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDeallocate(memptr: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceInitMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceDestructionMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceAssignmentMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInitClass(className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInitMIClass(inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somAddStaticMethod(methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somAddDynamicMethod(methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somOverrideSMethod(methodId: somId; method: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somClassReady; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassData: PsomClassDataStructure; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somSetClassData(const cds: somClassDataStructure); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassMtab: PsomMethodTab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceOffset: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstancePartSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceToken: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMemberToken(memberOffset: LongInt; instanceToken: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodData(methodId: somId; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetRdStub(methodId: somId): PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodDescriptor(methodId: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodIndex(id: somId): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodToken(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNthMethodData(n: LongInt; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNthMethodInfo(n: LongInt; out descriptor: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNumMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNumStaticMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetParent: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetParents: {dual_owned} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetPClsMtab: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetPClsMtabs: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somGetVersionNumbers(out majorVersion: LongInt; out minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSetMethodDescriptor(methodId: somId; descriptor: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindMethod(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindMethodOk(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindSMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindSMethodOk(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somLookupMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCheckVersion(majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDescendedFrom(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSupportsMethod(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefinedMethod(method: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somOverrideMtab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMMSingleInstance); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMMSingleInstance): SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMMSingleInstance); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMMSingleInstance); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMMSingleInstance); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMMSingleInstance): SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMMSingleInstance): SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMMSingleInstance): SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMMSingleInstance: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMMSingleInstance): Boolean; overload;

    property somDataAlignment: LongInt read _get_somDataAlignment;
    property somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo read _get_somInstanceDataOffsets;
    property somDirectInitClasses: _IDL_Sequence_SOMClass read _get_somDirectInitClasses write _set_somDirectInitClasses;
    property somClassAllocate: PPointer read _get_somClassAllocate;
    property somClassDeallocate: PPointer read _get_somClassDeallocate;
  end;

  SOMMBeforeAfter = class(SOMObjectBase)
  private
    function _get_somDataAlignment: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somDirectInitClasses: _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somDirectInitClasses(const somDirectInitClasses: _IDL_Sequence_SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somClassAllocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somClassDeallocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMMBeforeAfter; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMMBeforeAfter; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMMBeforeAfter; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMMBeforeAfter; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function sommBeforeMethod(SOM_object: SOMObject; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure sommAfterMethod(SOM_object: SOMObject; methodId: somId; returnedvalue: Pointer; ap: va_list); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somNew: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somNewNoInit: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenew(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoInit(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoInitNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somAllocate(size: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDeallocate(memptr: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceInitMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceDestructionMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceAssignmentMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInitClass(className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInitMIClass(inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somAddStaticMethod(methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somAddDynamicMethod(methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somOverrideSMethod(methodId: somId; method: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somClassReady; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassData: PsomClassDataStructure; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somSetClassData(const cds: somClassDataStructure); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassMtab: PsomMethodTab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceOffset: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstancePartSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceToken: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMemberToken(memberOffset: LongInt; instanceToken: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodData(methodId: somId; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetRdStub(methodId: somId): PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodDescriptor(methodId: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodIndex(id: somId): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodToken(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNthMethodData(n: LongInt; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNthMethodInfo(n: LongInt; out descriptor: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNumMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNumStaticMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetParent: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetParents: {dual_owned} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetPClsMtab: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetPClsMtabs: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somGetVersionNumbers(out majorVersion: LongInt; out minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSetMethodDescriptor(methodId: somId; descriptor: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindMethod(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindMethodOk(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindSMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindSMethodOk(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somLookupMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCheckVersion(majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDescendedFrom(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSupportsMethod(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefinedMethod(method: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somOverrideMtab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMMBeforeAfter); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMMBeforeAfter): SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMMBeforeAfter); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMMBeforeAfter); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMMBeforeAfter); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMMBeforeAfter): SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMMBeforeAfter): SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMMBeforeAfter): SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMMBeforeAfter: SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMMBeforeAfter): Boolean; overload;

    property somDataAlignment: LongInt read _get_somDataAlignment;
    property somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo read _get_somInstanceDataOffsets;
    property somDirectInitClasses: _IDL_Sequence_SOMClass read _get_somDirectInitClasses write _set_somDirectInitClasses;
    property somClassAllocate: PPointer read _get_somClassAllocate;
    property somClassDeallocate: PPointer read _get_somClassDeallocate;
  end;

  PSOMClass = ^SOMClass;
  SOMClassMgr = class(SOMObjectBase)
  private
    function _get_somInterfaceRepository: Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somInterfaceRepository(somInterfaceRepository: Repository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somRegisteredClasses: {caller_owns} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMClassMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMClassMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMClassMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMClassMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somLoadClassFile(classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt; SOM_file: {caller_owns} CORBAString): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somLocateClassFile(classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somRegisterClass(classObj: SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somRegisterClassLibrary(libraryName: {caller_owns} CORBAString; libraryInitRtn: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUnregisterClassLibrary(libraryName: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somUnloadClassFile(classObj: SOMClass): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somUnregisterClass(classObj: SOMClass): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somBeginPersistentClasses; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somEndPersistentClasses; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somJoinAffinityGroup(SOM_newClass: SOMClass; affClass: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInitFunction: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetRelatedClasses(classObj: SOMClass): {caller_owns} PSOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassFromId(classId: {caller_owns} somId): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindClass(classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindClsInFile(classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt; SOM_file: {caller_owns} CORBAString): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somMergeInto(targetObj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSubstituteClass(origClassName: {caller_owns} CORBAString; newClassName: {caller_owns} CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMClassMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMClassMgr): SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMClassMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMClassMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMClassMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMClassMgr): SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMClassMgr): SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMClassMgr): SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMClassMgr: SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMClassMgr): Boolean; overload;

    property somInterfaceRepository: Repository read _get_somInterfaceRepository write _set_somInterfaceRepository;
    property somRegisteredClasses: _IDL_Sequence_SOMClass read _get_somRegisteredClasses;
  end;

  SOMDObject = class(SOMObjectBase)
  public
    class function Create: SOMDObject; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMDObject; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMDObject; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMDObject; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_implementation: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_interface: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function is_nil: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function is_SOM_ref: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function is_constant: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function is_proxy: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function duplicate: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure release; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function create_request(ctx: Context; operation: CORBAString; arg_list: NVList; var SOM_result: NamedValue; out request: Request; req_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function create_request_args(operation: CORBAString; out arg_list: NVList; out SOM_result: NamedValue): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMDObject): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDObject): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDObject): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDObject): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMDObject: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMDObject): Boolean; overload;

  end;

  SOMDClientProxy = class(SOMObjectBase)
  public
    class function Create: SOMDClientProxy; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMDClientProxy; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMDClientProxy; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMDClientProxy; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somdTargetFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdTargetGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdTargetGetClassName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somdProxyFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdProxyGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdProxyGetClassName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somdReleaseResources; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_implementation: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_interface: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function is_nil: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function is_SOM_ref: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function is_constant: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function is_proxy: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function duplicate: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure release; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function create_request(ctx: Context; operation: CORBAString; arg_list: NVList; var SOM_result: NamedValue; out request: Request; req_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function create_request_args(operation: CORBAString; out arg_list: NVList; out SOM_result: NamedValue): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDClientProxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMDClientProxy): SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDClientProxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDClientProxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDClientProxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDClientProxy): SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDClientProxy): SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDClientProxy): SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMDObject: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMDClientProxy: SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMDClientProxy): Boolean; overload;

  end;

  SOMDMetaproxy = class(SOMObjectBase)
  private
    function _get_somDataAlignment: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somDirectInitClasses: _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somDirectInitClasses(const somDirectInitClasses: _IDL_Sequence_SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somClassAllocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somClassDeallocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMDMetaproxy; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMDMetaproxy; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMDMetaproxy; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMDMetaproxy; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somNew: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somNewNoInit: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenew(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoInit(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoInitNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somAllocate(size: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDeallocate(memptr: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceInitMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceDestructionMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceAssignmentMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInitClass(className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInitMIClass(inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somAddStaticMethod(methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somAddDynamicMethod(methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somOverrideSMethod(methodId: somId; method: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somClassReady; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassData: PsomClassDataStructure; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somSetClassData(const cds: somClassDataStructure); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassMtab: PsomMethodTab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceOffset: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstancePartSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceToken: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMemberToken(memberOffset: LongInt; instanceToken: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodData(methodId: somId; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetRdStub(methodId: somId): PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodDescriptor(methodId: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodIndex(id: somId): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodToken(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNthMethodData(n: LongInt; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNthMethodInfo(n: LongInt; out descriptor: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNumMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNumStaticMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetParent: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetParents: {dual_owned} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetPClsMtab: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetPClsMtabs: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somGetVersionNumbers(out majorVersion: LongInt; out minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSetMethodDescriptor(methodId: somId; descriptor: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindMethod(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindMethodOk(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindSMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindSMethodOk(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somLookupMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCheckVersion(majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDescendedFrom(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSupportsMethod(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefinedMethod(method: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somOverrideMtab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDMetaproxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMDMetaproxy): SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDMetaproxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDMetaproxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDMetaproxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDMetaproxy): SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDMetaproxy): SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDMetaproxy): SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMDMetaproxy: SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMDMetaproxy): Boolean; overload;

    property somDataAlignment: LongInt read _get_somDataAlignment;
    property somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo read _get_somInstanceDataOffsets;
    property somDirectInitClasses: _IDL_Sequence_SOMClass read _get_somDirectInitClasses write _set_somDirectInitClasses;
    property somClassAllocate: PPointer read _get_somClassAllocate;
    property somClassDeallocate: PPointer read _get_somClassDeallocate;
  end;

  P_IDL_ArrayOf_SOMDServer = ^_IDL_ArrayOf_SOMDServer;
  _IDL_Sequence_SOMDServer = packed record
    _maximum: LongWord;
    _length: LongWord;
    _buffer: P_IDL_ArrayOf_SOMDServer;
  end;
  SOMDObjectMgr = class(SOMObjectBase)
  private
    function _get_somd21somFree: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somd21somFree(somd21somFree: CORBABoolean); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMDObjectMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMDObjectMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMDObjectMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMDObjectMgr; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdFindServer(serverid: CORBAString): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdFindServerByName(servername: CORBAString): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdFindServersByClass(objclass: CORBAString): _IDL_Sequence_SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdFindAnyServerByClass(objclass: CORBAString): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdNewObject(objclass: CORBAString; hints: CORBAString): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdGetIdFromObject(obj: SOMObject): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdGetObjectFromId(id: CORBAString): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somdReleaseObject(obj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somdDestroyObject(obj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMDObjectMgr): SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDObjectMgr): SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDObjectMgr): SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDObjectMgr): SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_ObjectMgr: ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMDObjectMgr: SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMDObjectMgr): Boolean; overload;

    property somd21somFree: CORBABoolean read _get_somd21somFree write _set_somd21somFree;
  end;

  SOMDServer = class(SOMObjectBase)
  public
    class function Create: SOMDServer; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMDServer; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMDServer; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMDServer; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdRefFromSOMObj(somobj: SOMObject): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdSOMObjFromRef(objref: SOMDObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somdDispatchMethod(somobj: SOMObject; out retValue: Pointer; methodId: somId; ap: va_list); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdCreateObj(objclass: CORBAString; hints: CORBAString): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somdDeleteObj(somobj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdGetClassObj(objclass: CORBAString): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somdObjReferencesCached: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDServer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMDServer): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDServer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDServer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDServer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDServer): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDServer): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDServer): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMMSingleInstance; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMDServer: SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMDServer): Boolean; overload;

  end;

  SOMUTId = class(SOMObjectBase)
  public
    class function Create: SOMUTId; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMUTId; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMUTId; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMUTId; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somutSetIdId(otherId: SOMUTId); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somutEqualsId(otherId: SOMUTId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somutCompareId(otherId: SOMUTId): SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somutHashId: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMUTId); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMUTId): SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMUTId); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMUTId); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMUTId); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMUTId): SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMUTId): SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMUTId): SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMUTId: SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMUTId): Boolean; overload;

  end;

  SOMOA = class(SOMObjectBase)
  public
    class function Create: SOMOA; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMOA; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMOA; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMOA; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function execute_next_request(waitFlag: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function execute_request_loop(waitFlag: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure change_id(objref: SOMDObject; const id: _IDL_Sequence_Byte); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function create_constant(const id: _IDL_Sequence_Byte; intf: InterfaceDef; impl: ImplementationDef): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function create_SOM_ref(somobj: SOMObject; impl: ImplementationDef): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_SOM_object(somref: SOMDObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure activate_impl_failed(impl: ImplementationDef; rc: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure interrupt_server; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function SOM_create(const id: _IDL_Sequence_Byte; intf: InterfaceDef; impl: ImplementationDef): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure dispose(obj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_id(obj: SOMDObject): _IDL_Sequence_Byte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function get_principal(obj: SOMDObject; const req_ev: Environment): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure set_exception(major: exception_type; userid: CORBAString; param: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure impl_is_ready(impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure deactivate_impl(impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure change_implementation(obj: SOMDObject; impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure obj_is_ready(obj: SOMDObject; impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure deactivate_obj(obj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMOA): SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMOA): SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMOA): SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMOA): SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_BOA: BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMOA: SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMOA): Boolean; overload;

  end;

  PSockets_hostent = Pointer{ opaque ^Sockets_hostent };
  PSockets_servent = Pointer{ opaque ^Sockets_servent };
  Sockets = class(SOMObjectBase)
  private
    function _get_serrno: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_serrno(serrno: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: Sockets; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): Sockets; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: Sockets; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: Sockets; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsAccept(s: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsBind(s: LongInt; var name{: opaque Sockets_sockaddr}; namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsConnect(s: LongInt; var name{: opaque Sockets_sockaddr}; namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsGethostbyaddr(addr: PShortInt; addrlen: LongInt; domain: LongInt): PSockets_hostent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsGethostbyname(name: CORBAString): PSockets_hostent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsGethostent: PSockets_hostent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsGethostid: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsGethostname(name: CORBAString; namelength: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsGetpeername(s: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsGetservbyname(name: CORBAString; protocol: CORBAString): PSockets_servent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsGetsockname(s: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsGetsockopt(s: LongInt; level: LongInt; optname: LongInt; optval: PShortInt; out option: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsHtonl(a: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsHtons(a: Word): Word; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsIoctl(s: LongInt; cmd: LongInt; data: PShortInt; length: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsInet_addr(cp: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsInet_lnaof(addr: Sockets_in_addr): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsInet_makeaddr(net: LongWord; lna: LongWord): Sockets_in_addr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsInet_netof(addr: Sockets_in_addr): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsInet_network(cp: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsInet_ntoa(addr: Sockets_in_addr): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsListen(s: LongInt; backlog: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsNtohl(a: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsNtohs(a: Word): Word; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsReadv(s: LongInt; var iov{: opaque Sockets_iovec}; iovcnt: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsRecv(s: LongInt; buf: PShortInt; len: LongInt; flags: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsRecvfrom(s: LongInt; buf: PShortInt; len: LongInt; flags: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsRecvmsg(s: LongInt; var msg{: opaque Sockets_msghdr}; flags: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsSelect(nfds: LongInt; var readfds{: opaque Sockets_fd_set}; var writefds{: opaque Sockets_fd_set}; var exceptfds{: opaque Sockets_fd_set}; var timeout{: opaque Sockets_timeval}): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsSend(s: LongInt; msg: PShortInt; len: LongInt; flags: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsSendmsg(s: LongInt; var msg{: opaque Sockets_msghdr}; flags: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsSendto(s: LongInt; var msg: ShortInt; len: LongInt; flags: LongInt; var SOM_to{: opaque Sockets_sockaddr}; tolen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsSetsockopt(s: LongInt; level: LongInt; optname: LongInt; optval: PShortInt; optlen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsShutdown(s: LongInt; how: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsSocket(domain: LongInt; SOM_type: LongInt; protocol: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsSoclose(s: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somsWritev(s: LongInt; var iov{: opaque Sockets_iovec}; iovcnt: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: Sockets); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: Sockets): Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Sockets); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: Sockets); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Sockets); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: Sockets): Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: Sockets): Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: Sockets): Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMMSingleInstance; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Sockets: Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: Sockets): Boolean; overload;

    property serrno: LongInt read _get_serrno write _set_serrno;
  end;

  SOMStringTableC = class(SOMObjectBase)
  private
    function _get_somstTargetCapacity: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somstTargetCapacity(somstTargetCapacity: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somstAssociationsCount: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMStringTableC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMStringTableC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMStringTableC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMStringTableC; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somstAssociate(key: CORBAString; value: CORBAString): SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somstAssociateCopyKey(key: CORBAString; value: CORBAString): SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somstAssociateCopyValue(key: CORBAString; value: CORBAString): SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somstAssociateCopyBoth(key: CORBAString; value: CORBAString): SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somstGetAssociation(key: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somstClearAssociation(key: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somstGetIthKey(i: LongWord): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somstGetIthValue(i: LongWord): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMStringTableC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMStringTableC): SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMStringTableC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMStringTableC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMStringTableC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMStringTableC): SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMStringTableC): SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMStringTableC): SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMStringTableC: SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMStringTableC): Boolean; overload;

    property somstTargetCapacity: LongWord read _get_somstTargetCapacity write _set_somstTargetCapacity;
    property somstAssociationsCount: LongWord read _get_somstAssociationsCount;
  end;

  SOMMTraced = class(SOMObjectBase)
  private
    function _get_sommTraceIsOn: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_sommTraceIsOn(sommTraceIsOn: CORBABoolean); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somDataAlignment: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somDirectInitClasses: _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somDirectInitClasses(const somDirectInitClasses: _IDL_Sequence_SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somClassAllocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somClassDeallocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: SOMMTraced; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMMTraced; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMMTraced; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMMTraced; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function sommBeforeMethod(SOM_object: SOMObject; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure sommAfterMethod(SOM_object: SOMObject; methodId: somId; returnedvalue: Pointer; ap: va_list); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somNew: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somNewNoInit: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenew(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoInit(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRenewNoInitNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somAllocate(size: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDeallocate(memptr: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceInitMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceDestructionMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceAssignmentMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInitClass(className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInitMIClass(inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somAddStaticMethod(methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somAddDynamicMethod(methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somOverrideSMethod(methodId: somId; method: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somClassReady; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassData: PsomClassDataStructure; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somSetClassData(const cds: somClassDataStructure); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassMtab: PsomMethodTab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceOffset: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstancePartSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetInstanceToken: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMemberToken(memberOffset: LongInt; instanceToken: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodData(methodId: somId; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetRdStub(methodId: somId): PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodDescriptor(methodId: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodIndex(id: somId): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetMethodToken(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNthMethodData(n: LongInt; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNthMethodInfo(n: LongInt; out descriptor: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNumMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetNumStaticMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetParent: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetParents: {dual_owned} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetPClsMtab: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetPClsMtabs: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somGetVersionNumbers(out majorVersion: LongInt; out minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSetMethodDescriptor(methodId: somId; descriptor: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindMethod(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindMethodOk(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindSMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somFindSMethodOk(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somLookupMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCheckVersion(majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDescendedFrom(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somSupportsMethod(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefinedMethod(method: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somOverrideMtab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMMTraced); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMMTraced): SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMMTraced); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMMTraced); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMMTraced); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMMTraced): SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMMTraced): SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMMTraced): SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMMBeforeAfter: SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMMTraced: SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMMTraced): Boolean; overload;

    property sommTraceIsOn: CORBABoolean read _get_sommTraceIsOn write _set_sommTraceIsOn;
    property somDataAlignment: LongInt read _get_somDataAlignment;
    property somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo read _get_somInstanceDataOffsets;
    property somDirectInitClasses: _IDL_Sequence_SOMClass read _get_somDirectInitClasses write _set_somDirectInitClasses;
    property somClassAllocate: PPointer read _get_somClassAllocate;
    property somClassDeallocate: PPointer read _get_somClassDeallocate;
  end;

  SOMETimerEvent = class(SOMObjectBase)
  public
    class function Create: SOMETimerEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMETimerEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMETimerEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMETimerEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventInterval: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventInterval(interval: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventTime: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventTime(time: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventType(SOM_type: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMETimerEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMETimerEvent): SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMETimerEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMETimerEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMETimerEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMETimerEvent): SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMETimerEvent): SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMETimerEvent): SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMEEvent: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMETimerEvent: SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMETimerEvent): Boolean; overload;

  end;

  TSPortability_Sender = class(SOMObjectBase) { unresolved class name };
  TSPortability_Receiver = class(SOMObjectBase) { unresolved class name };
  TSIdentification = class(SOMObjectBase)
  private
    function _get_sender: TSPortability_Sender; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_receiver: TSPortability_Receiver; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: TSIdentification; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): TSIdentification; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMMSingleInstance; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: TSIdentification; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: TSIdentification; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure identify_sender(sender: TSPortability_Sender); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure identify_receiver(receiver: TSPortability_Receiver); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: TSIdentification); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: TSIdentification): TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: TSIdentification); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: TSIdentification); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: TSIdentification); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: TSIdentification): TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: TSIdentification): TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: TSIdentification): TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMMSingleInstance; // (not really new every time, but autocreated)

    { Upcasting }
    function As_TSIdentification: TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: TSIdentification): Boolean; overload;

    property sender: TSPortability_Sender read _get_sender;
    property receiver: TSPortability_Receiver read _get_receiver;
  end;

  TypeDef = class(SOMObjectBase)
  private
    function _get_type: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_type(SOM_type: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function _get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure _set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
  public
    class function Create: TypeDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): TypeDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: TypeDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: TypeDef; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: TypeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: TypeDef): TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: TypeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: TypeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: TypeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: TypeDef): TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: TypeDef): TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: TypeDef): TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_TypeDef: TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: TypeDef): Boolean; overload;

    property SOM_type: TypeCode read _get_type write _set_type;
    property name: CORBAString read _get_name write _set_name;
    property id: CORBAString read _get_id write _set_id;
    property defined_in: CORBAString read _get_defined_in write _set_defined_in;
    property somModifiers: _IDL_Sequence_somModifier read _get_somModifiers write _set_somModifiers;
  end;

  SOMEWorkProcEvent = class(SOMObjectBase)
  public
    class function Create: SOMEWorkProcEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InitInstance(Instance: Pointer): SOMEWorkProcEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function ClassType: SOMClass; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function ClassName: string; reintroduce;
    class function ClassNameIs(const Name: string): Boolean; reintroduce;
    class function InstanceSize: LongInt; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function InheritsFrom(AClass: SOMClass): Boolean; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    class function MethodAddress(const Name: string): Pointer; reintroduce;
    class function NewInstance: SOMEWorkProcEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function Clone: SOMEWorkProcEvent; reintroduce; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventTime: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somevGetEventType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventTime(time: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somevSetEventType(SOM_type: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMEWorkProcEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultAssign(var ctrl: Pointer; fromObj: SOMEWorkProcEvent): SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMEWorkProcEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMEWorkProcEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMEWorkProcEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMEWorkProcEvent): SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultVAssign(var ctrl: Pointer; fromObj: SOMEWorkProcEvent): SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMEWorkProcEvent): SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function somPrintSelf: SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    procedure somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Class object access and initialization }
    class function ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF} // may be nil before class is created
    class function NewClass: SOMClass; // (not really new every time, but autocreated)

    { Upcasting }
    function As_SOMEEvent: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
    function As_SOMEWorkProcEvent: SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

    { Downcasting }
    class function Supports(Instance: SOMObjectBase): Boolean; overload;
    class function Supports(Instance: SOMObjectBase; out Obj: SOMEWorkProcEvent): Boolean; overload;

  end;

  { Arrays }
  _IDL_ArrayOf_SOMObject = array[0 .. (MaxLongInt div (Abs(SizeOf(SOMObject) - 1) + 1)) - 1] of SOMObject;
  _IDL_ArrayOf_Byte = array[0 .. (MaxLongInt div (Abs(SizeOf(Byte) - 1) + 1)) - 1] of Byte;
  _IDL_ArrayOf_SOMObject_somObjectOffset = array[0 .. (MaxLongInt div (Abs(SizeOf(SOMObject_somObjectOffset) - 1) + 1)) - 1] of SOMObject_somObjectOffset;
  _IDL_ArrayOf_Pointer = array[0 .. (MaxLongInt div (Abs(SizeOf(Pointer) - 1) + 1)) - 1] of Pointer;
  _IDL_ArrayOf_SOMClass = array[0 .. (MaxLongInt div (Abs(SizeOf(SOMClass) - 1) + 1)) - 1] of SOMClass;
  _IDL_ArrayOf_SOMClass_somOffsetInfo = array[0 .. (MaxLongInt div (Abs(SizeOf(SOMClass_somOffsetInfo) - 1) + 1)) - 1] of SOMClass_somOffsetInfo;
  _IDL_ArrayOf_somId = array[0 .. (MaxLongInt div (Abs(SizeOf(somId) - 1) + 1)) - 1] of somId;
  _IDL_ArrayOf_CORBAString = array[0 .. (MaxLongInt div (Abs(SizeOf(CORBAString) - 1) + 1)) - 1] of CORBAString;
  _IDL_ArrayOf_ParameterDef_ParameterDescription = array[0 .. (MaxLongInt div (Abs(SizeOf(ParameterDef_ParameterDescription) - 1) + 1)) - 1] of ParameterDef_ParameterDescription;
  _IDL_ArrayOf_ExceptionDef_ExceptionDescription = array[0 .. (MaxLongInt div (Abs(SizeOf(ExceptionDef_ExceptionDescription) - 1) + 1)) - 1] of ExceptionDef_ExceptionDescription;
  _IDL_ArrayOf_OperationDef_OperationDescription = array[0 .. (MaxLongInt div (Abs(SizeOf(OperationDef_OperationDescription) - 1) + 1)) - 1] of OperationDef_OperationDescription;
  _IDL_ArrayOf_AttributeDef_AttributeDescription = array[0 .. (MaxLongInt div (Abs(SizeOf(AttributeDef_AttributeDescription) - 1) + 1)) - 1] of AttributeDef_AttributeDescription;
  _IDL_ArrayOf_somModifier = array[0 .. (MaxLongInt div (Abs(SizeOf(somModifier) - 1) + 1)) - 1] of somModifier;
  _IDL_ArrayOf_Container = array[0 .. (MaxLongInt div (Abs(SizeOf(Container) - 1) + 1)) - 1] of Container;
  _IDL_ArrayOf_Contained = array[0 .. (MaxLongInt div (Abs(SizeOf(Contained) - 1) + 1)) - 1] of Contained;
  _IDL_ArrayOf_Container_ContainerDescription = array[0 .. (MaxLongInt div (Abs(SizeOf(Container_ContainerDescription) - 1) + 1)) - 1] of Container_ContainerDescription;
  _IDL_ArrayOf_ImplementationDef = array[0 .. (MaxLongInt div (Abs(SizeOf(ImplementationDef) - 1) + 1)) - 1] of ImplementationDef;
  _IDL_ArrayOf_SOMDServer = array[0 .. (MaxLongInt div (Abs(SizeOf(SOMDServer) - 1) + 1)) - 1] of SOMDServer;

{ Constants }

const
  tk_null = TCKind(1);
  tk_void = TCKind(2);
  tk_short = TCKind(3);
  tk_long = TCKind(4);
  tk_ushort = TCKind(5);
  tk_ulong = TCKind(6);
  tk_float = TCKind(7);
  tk_double = TCKind(8);
  tk_boolean = TCKind(9);
  tk_char = TCKind(10);
  tk_octet = TCKind(11);
  tk_any = TCKind(12);
  tk_TypeCode = TCKind(13);
  tk_Principal = TCKind(14);
  tk_objref = TCKind(15);
  tk_struct = TCKind(16);
  tk_union = TCKind(17);
  tk_enum = TCKind(18);
  tk_string = TCKind(19);
  tk_sequence = TCKind(20);
  tk_array = TCKind(21);
  tk_pointer = TCKind(101);
  tk_self = TCKind(102);
  tk_foreign = TCKind(103);
  NO_EXCEPTION = exception_type(0);
  USER_EXCEPTION = exception_type(1);
  SYSTEM_EXCEPTION = exception_type(2);
  AttributeDef_NORMAL = AttributeDef_AttributeMode(1);
  AttributeDef_READONLY = AttributeDef_AttributeMode(2);
  YES = completion_status(0);
  NO = completion_status(1);
  MAYBE = completion_status(2);
  SOMD_SOMDVersion = '2.1';
  OperationDef_NORMAL = OperationDef_OperationMode(1);
  OperationDef_ONEWAY = OperationDef_OperationMode(2);
  ParameterDef_IN = ParameterDef_ParameterMode(1);
  ParameterDef_OUT = ParameterDef_ParameterMode(2);
  ParameterDef_INOUT = ParameterDef_ParameterMode(3);
  Repository_NOACCESS = Repository_irOpenErrorCodes(1);
  Repository_BADMAGICNUMBER = Repository_irOpenErrorCodes(2);
  Repository_MISSINGVERSIONINFO = Repository_irOpenErrorCodes(3);
  Repository_IOERROR = Repository_irOpenErrorCodes(4);
  Repository_VERSIONMISMATCH = Repository_irOpenErrorCodes(5);
  ex_Repository_irOpenError = '::Repository::irOpenError';
  somtPrivateE = SOMTTargetTypeT(0);
  somtPublicE = SOMTTargetTypeT(1);
  somtImplementationE = SOMTTargetTypeT(2);
  somtAllE = SOMTTargetTypeT(3);
  somtInternalVE = somtVisibilityT(0);
  somtPublicVE = somtVisibilityT(1);
  somtPrivateVE = somtVisibilityT(2);
  somtDashesE = somtCommentStyleT(0);
  somtCPPE = somtCommentStyleT(1);
  somtCSimpleE = somtCommentStyleT(2);
  somtCBlockE = somtCommentStyleT(3);
  somtInE = somtParameterDirectionT(0);
  somtOutE = somtParameterDirectionT(1);
  somtInOutE = somtParameterDirectionT(2);
  SOMTTemplateOutputC_MAX_INPUT_LINE_LENGTH = 1024;
  SOMTTemplateOutputC_MAX_OUTPUT_LINE_LENGTH = 4096;
  ex_StExcep_UNKNOWN = '::StExcep::UNKNOWN';
  ex_StExcep_BAD_PARAM = '::StExcep::BAD_PARAM';
  ex_StExcep_NO_MEMORY = '::StExcep::NO_MEMORY';
  ex_StExcep_IMP_LIMIT = '::StExcep::IMP_LIMIT';
  ex_StExcep_COMM_FAILURE = '::StExcep::COMM_FAILURE';
  ex_StExcep_INV_OBJREF = '::StExcep::INV_OBJREF';
  ex_StExcep_NO_PERMISSION = '::StExcep::NO_PERMISSION';
  ex_StExcep_INTERNAL = '::StExcep::INTERNAL';
  ex_StExcep_MARSHAL = '::StExcep::MARSHAL';
  ex_StExcep_INITIALIZE = '::StExcep::INITIALIZE';
  ex_StExcep_NO_IMPLEMENT = '::StExcep::NO_IMPLEMENT';
  ex_StExcep_BAD_TYPECODE = '::StExcep::BAD_TYPECODE';
  ex_StExcep_BAD_OPERATION = '::StExcep::BAD_OPERATION';
  ex_StExcep_NO_RESOURCES = '::StExcep::NO_RESOURCES';
  ex_StExcep_NO_RESPONSE = '::StExcep::NO_RESPONSE';
  ex_StExcep_PERSIST_STORE = '::StExcep::PERSIST_STORE';
  ex_StExcep_BAD_INV_ORDER = '::StExcep::BAD_INV_ORDER';
  ex_StExcep_TRANSIENT = '::StExcep::TRANSIENT';
  ex_StExcep_FREE_MEM = '::StExcep::FREE_MEM';
  ex_StExcep_INV_IDENT = '::StExcep::INV_IDENT';
  ex_StExcep_INV_FLAG = '::StExcep::INV_FLAG';
  ex_StExcep_INTF_REPOS = '::StExcep::INTF_REPOS';
  ex_StExcep_CONTEXT = '::StExcep::CONTEXT';
  ex_StExcep_OBJ_ADAPTER = '::StExcep::OBJ_ADAPTER';
  ex_StExcep_DATA_CONVERSION = '::StExcep::DATA_CONVERSION';
  ex_StExcep_OPSYS = '::StExcep::OPSYS';
  ex_StExcep_WMQUIT = '::StExcep::WMQUIT';
  ex_StExcep_DISPATCH = '::StExcep::DISPATCH';
  ex_StExcep_TransactionRequired = '::StExcep::TransactionRequired';
  ex_StExcep_TransactionRolledBack = '::StExcep::TransactionRolledBack';
  ex_StExcep_InvalidTransaction = '::StExcep::InvalidTransaction';
  ex_StExcep_WrongTransaction = '::StExcep::WrongTransaction';
  ex_TSIdentification_NotAvailable = '::TSIdentification::NotAvailable';
  ex_TSIdentification_AlreadyIdentified = '::TSIdentification::AlreadyIdentified';

(*
 *  Method and Data Resolution macros
 *)

(*
 * Default definition of somresolve_ to call the procedure, somResolve.
 * This may be be changed by emitters on systems for which method
 * tokens are thunks.
 *)
function somresolve_(obj: SOMObjectBase; mToken: somMToken): somMethodProc; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

(*
 *  Method Resolution. Methods are invoked on an object o of some
 *  object class oc, where oc has immediate ancestor classes
 *  called parent classes. Macro arguments include method names
 *  (e.g., mn), object class and parent class names (e.g., ocn, pcn)
 *  and parent class positions (e.g., pcp), expressed in terms of the
 *  left-to-right ordering (beginning with 1, for the first parent)
 *  used when declaring oc's parents. The choice of resolution
 *  macro determines the method table from which methods are selected.
 *
 *  Macros are available to select a method from ...
 *)

(* from oc's mtbl, with verification of o *)
   (*  call somresolve_ but test that the object is well formed and an
       instance of the specified class or a class derived from that class *)

function SOM_Resolve(o: SOMObjectBase; oc: SOMObjectBase{SOMClass}; m: somMToken;
  fileName: PAnsiChar = nil; lineNum: Integer = 0): somMethodProc; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

(* from oc's mtbl, without verification of o *)
function SOM_ResolveNoCheck(o: SOMObjectBase; oc: SOMObjectBase{SOMClass}; m: somMToken): somMethodProc; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

  (*
   * Main programs should register for SOM cleanup at exit
   *)

function SOM_MainProgram: SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

(* Check the validity of method resolution using the specified target  *)
(* object.  Note: this macro makes programs bigger and slower.  After  *)
(* you are confident that your program is running correctly you should *)
(* turn off this macro by defining SOM_NoTest, or adding -DSOM_NoTest  *)
(* to your makefile.                                                   *)

function SOM_TestCls(obj: SOMObjectBase; cls: SOMObjectBase{SOMClass};
  fileName: PAnsiChar = nil; lineNum: Integer = 0): SOMObjectBase; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

function somExceptionId(ev: PEnvironment): PAnsiChar; stdcall;
function somExceptionValue(ev: PEnvironment): Pointer; stdcall;
procedure somExceptionFree(ev: PEnvironment); stdcall;
procedure somSetException(ev: PEnvironment;
    major: exception_type; exception_name: PAnsiChar; params: Pointer); stdcall;
function somGetGlobalEnvironment: PEnvironment; stdcall;

(* Exception function names per CORBA 5.19, p.99 *)
function exception_id(ev: PEnvironment): PAnsiChar; stdcall;
function exception_value(ev: PEnvironment): Pointer; stdcall;
procedure exception_free(ev: PEnvironment); stdcall;

(*  Convenience macros for manipulating environment structures
 *
 *  SOM_CreateLocalEnvironment returns a pointer to an Environment.
 *  The other 3 macros all expect a single argument that is also
 *  a pointer to an Environment.  Use the create/destroy forms for
 *  a dynamic local environment and the init/uninit forms for a stack-based
 *  local environment.
 *
 *  For example
 *
 *      Environment *ev;
 *      ev = SOM_CreateLocalEnvironment ();
 *      ... Use ev in methods
 *      SOM_DestroyLocalEnvironment (ev);
 *
 *  or
 *
 *      Environment ev;
 *      SOM_InitEnvironment (&ev);
 *      ... Use &ev in methods
 *      SOM_UninitEnvironment (&ev);
 *)
function SOM_CreateLocalEnvironment: PEnvironment; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
procedure SOM_DestroyLocalEnvironment(ev: PEnvironment); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
procedure SOM_InitEnvironment(ev: PEnvironment); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
procedure SOM_UninitEnvironment(ev: PEnvironment); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

// #include <somapi.h>

(*
 *  SOMAPI.H
 *
 *  This file documents the public data structures and functions
 *  of the SOM API (Application Programming Interface). Primitive data
 *  types are defined in sombtype.h, and the public methods provided by
 *  the SOM kernel are declared in somobj.idl, somcls.idl and somcm.idl.
 *  An important header file for language bindings is somdefs.h, which
 *  defines the SOMLINK symbol used in various emitter outputs.
 *
 *  Note: typedefs & prototypes in this file explicitly show pointers
 *  to objects that support an interface described by IDL. These are
 *  C/C++ typedefs that reflect the implementation of object references
 *  in SOM as pointers to structures in memory.
 *)

 (*
  * HISTORY [04/19/96] #21264 nsk Temproary ADD WIN32 Code
  *)

(*  SOM Version Numbers  *)
function Replaceable_SOM_MajorVersion: PLongInt;
function SOM_MajorVersion: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
function Replaceable_SOM_MinorVersion: PLongInt;
function SOM_MinorVersion: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

(*  SOM Thread Support  *)
function Replaceable_SOM_MaxThreads: PLongInt;
function SOM_MaxThreads: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

(*----------------------------------------
 * Typedefs for pointers to functions
 *----------------------------------------*)

type
  somTD_SOMMalloc = function(nbytes: UIntPtr): somToken; stdcall;
  PsomTD_SOMMalloc = ^somTD_SOMMalloc;
  somTD_SOMCalloc = function(
    element_count: UIntPtr;
    element_size: UIntPtr): somToken; stdcall;
  PsomTD_SOMCalloc = ^somTD_SOMCalloc;
  somTD_SOMRealloc = function(
    memory: somToken;
    nbytes: UIntPtr): somToken; stdcall;
  PsomTD_SOMRealloc = ^somTD_SOMRealloc;
  somTD_SOMFree = procedure(memory: somToken); stdcall;
  PsomTD_SOMFree = ^somTD_SOMFree;

(*----------------------------------------------------------------------
 * SOM Environment Initialization Section
 *---------------------------------------------------------------------*)

(*
 *  Create and initialize the SOM environment.
 *
 *  This function is idempotent (may be invoked redundantly)
 *
 *  Will be called automatically when first object (including a class
 *  object) is created, if it has not already been done.
 *
 *  Returns the SOMClassMgrObject
 *)
function somEnvironmentNew: SOMClassMgr; stdcall;

procedure somEnvironmentEnd; stdcall;
function somMainProgram: SOMClassMgr; stdcall;
function somAbnormalEnd: ByteBool; stdcall;

(*
 *  Replaceable SOM Memory Management Interfaces
 *
 *  External procedure variables SOMCalloc, SOMFree, SOMMalloc, SOMRealloc
 *  have the same interface as their standard C-library analogs.
 *)
function Replaceable_SOMCalloc: PsomTD_SOMCalloc;
function SOMCalloc(element_count, element_size: UIntPtr): somToken; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
function Replaceable_SOMFree: PsomTD_SOMFree;
procedure SOMFree(memory: somToken); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
procedure SOMMemFree(memory: somToken); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
function Replaceable_SOMMalloc: PsomTD_SOMMalloc;
function SOMMalloc(nbytes: UIntPtr): somToken; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
function Replaceable_SOMRealloc: PsomTD_SOMRealloc;
function SOMRealloc(memory: somToken; nbytes: UIntPtr): somToken; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}

(*
 * Verifies that the passed object is a valid instance of the passed
 * class.  A detected failure generates an error message and causes
 * program termination.  This call is automatically employed as part
 * of the C method resolution macros if the preprocessor variable
 * SOM_TestOn is defined.
 *)
function somTestCls(
    obj: SOMObjectBase;
    classObj: SOMObjectBase{SOMClass};
    fileName: CORBAString;
    lineNumber: Integer): SOMObjectBase; stdcall;

(*
 * Return the class that introduced the method represented by a given
 * method token.
 *)
function somGetClassFromMToken(mToken: somMToken): SOMClass; stdcall;


(*----------------------------------------------------------------------
 *  SOM Id Manager Section
 *---------------------------------------------------------------------*)

(*
 * typedef char* somId; // the "public" somId type (in sombtype.h)
 *
 * This above definition prevents users from building assumptions about
 * how somIds are implemented into their programs. However, a little more
 * information is useful to understand the different alternatives for
 * creating somIds.
 *
 * All somIds point to something called an idKey. The content of the
 * idKey for a somId depends on whether the somId has been registered.
 *
 * The idKey for an unregistered somId is a char* that points to a
 * null-terminated array of chars that is called the id name.
 *
 * When a somId is registered, the idKey it points to is changed to
 * point to a special structure whose representation is not made public.
 * Among other things, of course, this structure contains the address of
 * the id name. Normally the id name for a registered somId will be a copy
 * of the originally indicated name, but copying strings is expensive
 * because it requires dynamic memory allocation. As an alternative, to
 * speed up creation of somIds and minimize memory use, you can use
 * somBeginPersistentIds and somEndPersistentIds to bracket registration
 * of somIds. If you do this, you must use somRelocateIds before the
 * names for any of the "persistent" somIds that you create are changed
 * (or perhaps destroyed as a result of program termination).
 *
 * There are basically two different ways to create registered somIds:
 * from unregistered somIds, or from id names. To create registered
 * somIds from unregistered somIds, you pass the address of an idKey
 * to either somRegisterId or somCheckId; or, to register multiple
 * somIds in one step, you can pass the address of an array of idKeys
 * to somRegisterIds. To create registered somIds from id names, you
 * pass the address of the id name to either somIdFromString or
 * somIdFromStringNoFree. These routines are declared below.
 *)

(*
 * Register a somId. Returns 1 (true) if the id is a new one, and
 * 0 (false) otherwise. An id is new if no previously-registered id
 * has the same name (where name comparison is case-insensitive).
 *)
function somRegisterId(id: somId): LongBool; stdcall;

(*
 * Like somRegisterId, but it returns the somId as its result.
 *)
function somCheckId(id: somId): somId; stdcall;

(*
 * Return a somId that must be freed (using SOMFree) when the user
 * has finished with it.
 *)
function somIdFromString(aString: CORBAString): somId; stdcall;

(*
 * Return a string that must never be freed or modified.
 *)
function somStringFromId(id: somId): CORBAString; stdcall;

(*
 * Returns true (1) if the two ids are equal, else false (0).
 *)
function somCompareIds(id1, id2: somId): LongBool; stdcall;

(*
 * Return the total number of ids that have been registered so far, you
 * can use this to advise the SOM runtime concerning expected number of
 * ids in later executions of your program, via a call to
 * somSetExpectedIds defined below
 *)
function somTotalRegIds: LongWord; stdcall;

(*
 * Tell the SOM runtime how many unique ids you expect to use during
 * the execution of your program, this can improve space and time
 * utilization slightly, this routine must be called before the SOM
 * environment is created to have any effect
 *)
procedure somSetExpectedIds(numIds: LongWord); stdcall;

(*
 * Return the unique key for this id. This is the key used for
 * comparing somIds.
 *)
function somUniqueKey(id: somId): LongWord; stdcall;

(*
 * Signal the beginning of an interval during which the id manager
 * need not copy strings when registering new ids (because the caller
 * knows that these strings will not be destroyed or modified without
 * first calling somRelocateIds for each "persistent" id registered
 * during the interval).
 *)
procedure somBeginPersistentIds; stdcall;

(*
 * End the interval started with somBeginPersistentIds. Tells the
 * id manager that strings for any new ids subsequently registered
 * may be freed or otherwise modified without first calling somRelocateIds.
 * Therefore the id manager must copy the strings remember the name of an
 * id.
 *)
procedure somEndPersistentIds; stdcall;

// #include <somtc.h>

(*
 *  Following constants used with tcNew to create union TypeCodes.
 *  See calling sequences above.
 *)
const
  TCREGULAR_CASE = LongInt(1);
  TCDEFAULT_CASE = LongInt(2);

(* somVaBuf support *)

type
  somVaBuf = type somToken;

function somVaBuf_create(vb: PAnsiChar; size: Integer): somVaBuf; stdcall;
procedure somVaBuf_get_valist(vb: somVaBuf; out ap: va_list); stdcall;
procedure somVaBuf_destroy(vb: somVaBuf); stdcall;
function somVaBuf_add(vb: somVaBuf; arg: Pointer; argType: TCKind): LongInt; stdcall;
function somvalistGetTarget(ap: va_list): LongWord; stdcall;
procedure somvalistSetTarget(ap: va_list; val: LongWord); stdcall;

// not in SOM headers

procedure SOM_UninitEnvironmentOrRaise(ev: PEnvironment); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
procedure SOMFreeAndNil(var Obj);
type
  TAnsiStringArray = array of AnsiString;
// init Buf with nil before; use somVaBuf_destroy on Buf after!
function ArrayOfConstToVaList(var Buf: somVaBuf; var StringBuf: TAnsiStringArray; const Arguments: array of const; AppendNil: Boolean): va_list;

implementation

uses
  Windows;

const
  Unknown_Source = '<unknown>.pas'; // no __FILE__ and __LINE__ macros in Delphi

var
  DLLLoad_CriticalSection : Windows.TRTLCriticalSection;

class procedure SOMObjectBase.Create;
begin
  { hide this method }
end;

procedure SOMObjectBase.Free;
begin
  if Assigned(Self) then SOMObject(Self).somFree;
end;

class procedure SOMObjectBase.InitInstance;
begin
  { hide this method }
end;

procedure SOMObjectBase.CleanupInstance;
begin
  { hard to separate from SOM destructors }
end;

function SOMObjectBase.ClassType: SOMClass;
begin
  Result := SOMObject(Self).somGetClass;
end;

class procedure SOMObjectBase.ClassName;
begin
  { hide this method }
end;

class procedure SOMObjectBase.ClassNameIs;
begin
  { hide this method }
end;

class procedure SOMObjectBase.ClassParent;
begin
  { hide this method }
end;

class procedure SOMObjectBase.ClassInfo;
begin
  { hide this method }
end;

class procedure SOMObjectBase.InstanceSize;
begin
  { hide this method }
end;

class procedure SOMObjectBase.InheritsFrom;
begin
  { hide this method }
end;

class procedure SOMObjectBase.MethodAddress;
begin
  { hide this method }
end;

class procedure SOMObjectBase.MethodName;
begin
  { hide this method }
end;

procedure SOMObjectBase.FieldAddress;
begin
  { hide this method }
end;

procedure SOMObjectBase.GetInterface;
begin
  { hide this method }
end;

class procedure SOMObjectBase.GetInterfaceEntry;
begin
  { hide this method }
end;

class procedure SOMObjectBase.GetInterfaceTable;
begin
  { hide this method }
end;

procedure SOMObjectBase.SafeCallException;
begin
  { hide this method }
end;

procedure SOMObjectBase.AfterConstruction;
begin
  { in SOM that is being done by cooperative metaclass }
end;

procedure SOMObjectBase.BeforeDestruction;
begin
  { in SOM that is being done by cooperative metaclass }
end;

procedure SOMObjectBase.Dispatch;
begin
  { hide this method }
end;

procedure SOMObjectBase.DefaultHandler;
begin
  { hide this method }
end;

class procedure SOMObjectBase.NewInstance;
begin
  { hide this method }
end;

procedure SOMObjectBase.FreeInstance;
begin // somGetClass on almost destroyed object might crash, so we use double dereference
  SOMClass(PPointer(Self)^^).somDeallocate(PAnsiChar(Pointer(Self)));
end;

procedure SOMObjectBase.Destroy;
begin
  SOMObject(Self).somFree;
end;

function SOMObjectBase.As_SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMObject(Self); { upcast }
end;

const
  SOMTC_DLL_Name = 'somtc.dll';

var
  SOMTC_DLL: System.HMODULE = 0;

procedure SOMTC_DLL_Load_Variable(var V_Pointer; const Var_Name: AnsiString);
begin
  if SOMTC_DLL = 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOMTC_DLL = 0 then
      SOMTC_DLL := Windows.LoadLibraryW(SOMTC_DLL_Name);
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOMTC_DLL <> 0 then
    Pointer(V_Pointer) := Windows.GetProcAddress(SOMTC_DLL, PAnsiChar(Var_Name));
end;

procedure TypeCode.Free;
begin
  if Assigned(Self) then
  begin
    FreeInstance;
  end;
end;

class procedure TypeCode.InitInstance;
begin
  { hide this method }
end;

procedure TypeCode.CleanupInstance;
begin
  { TypeCode_free does everything at the same time, so no separate Cleanup }
end;

procedure TypeCode.ClassType;
begin
  { hide this method }
end;

class function TypeCode.ClassName: string;
begin
  Result := 'TypeCode';
end;

class function TypeCode.ClassNameIs(const Name: string): Boolean;
begin
  Result := Name = 'TypeCode';
end;

class procedure TypeCode.ClassParent;
begin
  { hide this method }
end;

class procedure TypeCode.ClassInfo;
begin
  { hide this method }
end;

class procedure TypeCode.InstanceSize;
begin
  { hide this method }
end;

class procedure TypeCode.InheritsFrom;
begin
  { hide this method }
end;

class procedure TypeCode.MethodAddress;
begin
  { hide this method }
end;

class procedure TypeCode.MethodName;
begin
  { hide this method }
end;

procedure TypeCode.FieldAddress;
begin
  { hide this method }
end;

procedure TypeCode.GetInterface;
begin
  { hide this method }
end;

class procedure TypeCode.GetInterfaceEntry;
begin
  { hide this method }
end;

class procedure TypeCode.GetInterfaceTable;
begin
  { hide this method }
end;

procedure TypeCode.SafeCallException;
begin
  { hide this method }
end;

procedure TypeCode.AfterConstruction;
begin
  { nothing to do }
end;

procedure TypeCode.BeforeDestruction;
begin
  { nothing to do }
end;

procedure TypeCode.Dispatch;
begin
  { hide this method }
end;

procedure TypeCode.DefaultHandler;
begin
  { hide this method }
end;

class procedure TypeCode.NewInstance;
begin
  { hide this method }
end;

procedure TypeCode_free(t: TypeCode; ev: PEnvironment); stdcall; external SOMTC_DLL_Name name 'tcFree';

procedure TypeCode.FreeInstance;
var
  LocalEnv: Environment;
begin
  SOM_InitEnvironment(@LocalEnv);
  TypeCode_free(Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure TypeCode.Destroy;
begin
  FreeInstance;
end;

function TypeCode_kind(t: TypeCode; ev: PEnvironment): TCKind; stdcall; external SOMTC_DLL_Name name 'tcKind';

function TypeCode.GetKind: TCKind;
var
  LocalEnv: Environment;
begin
  SOM_InitEnvironment(@LocalEnv);
  Result := TypeCode_kind(Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeCode_param_count(t: TypeCode; ev: PEnvironment): LongInt; stdcall; external SOMTC_DLL_Name name 'tcParmCount';

function TypeCode.GetParamCount: LongInt;
var
  LocalEnv: Environment;
begin
  SOM_InitEnvironment(@LocalEnv);
  Result := TypeCode_param_count(Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeCode_parameter(t: TypeCode; ev: PEnvironment; index: LongInt): TAnyResult; stdcall; external SOMTC_DLL_Name name 'tcParameter';

function TypeCode.GetParameter(index: LongInt): any;
var
  LocalEnv: Environment;
begin
  SOM_InitEnvironment(@LocalEnv);
  Result := any(TypeCode_parameter(Self, @LocalEnv, index));
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeCode_alignment(t: TypeCode; ev: PEnvironment): SmallInt; stdcall; external SOMTC_DLL_Name name 'tcAlignment';

function TypeCode.GetAlignment: SmallInt;
var
  LocalEnv: Environment;
begin
  SOM_InitEnvironment(@LocalEnv);
  Result := TypeCode_alignment(Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure TypeCode_setAlignment(t: TypeCode; ev: PEnvironment; a: SmallInt); stdcall; external SOMTC_DLL_Name name 'tcSetAlignment';

procedure TypeCode.SetAlignment(a: SmallInt);
var
  LocalEnv: Environment;
begin
  SOM_InitEnvironment(@LocalEnv);
  TypeCode_setAlignment(Self, @LocalEnv, a);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeCode_size(t: TypeCode; ev: PEnvironment): LongInt; stdcall; external SOMTC_DLL_Name name 'tcSize';

function TypeCode.GetSize: LongInt;
var
  LocalEnv: Environment;
begin
  SOM_InitEnvironment(@LocalEnv);
  Result := TypeCode_size(Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

var
  SOMTC_DLL_TC__null: TypeCode = TypeCode(nil);

class function TypeCode.TC_null: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__null) then
    Result := SOMTC_DLL_TC__null
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__null, 'TC__null');
    Result := SOMTC_DLL_TC__null;
  end;
end;

var
  SOMTC_DLL_TC__void: TypeCode = TypeCode(nil);

class function TypeCode.TC_void: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__void) then
    Result := SOMTC_DLL_TC__void
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__void, 'TC__void');
    Result := SOMTC_DLL_TC__void;
  end;
end;

var
  SOMTC_DLL_TC__short: TypeCode = TypeCode(nil);

class function TypeCode.TC_short: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__short) then
    Result := SOMTC_DLL_TC__short
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__short, 'TC__short');
    Result := SOMTC_DLL_TC__short;
  end;
end;

var
  SOMTC_DLL_TC__long: TypeCode = TypeCode(nil);

class function TypeCode.TC_long: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__long) then
    Result := SOMTC_DLL_TC__long
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__long, 'TC__long');
    Result := SOMTC_DLL_TC__long;
  end;
end;

var
  SOMTC_DLL_TC__ushort: TypeCode = TypeCode(nil);

class function TypeCode.TC_ushort: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__ushort) then
    Result := SOMTC_DLL_TC__ushort
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__ushort, 'TC__ushort');
    Result := SOMTC_DLL_TC__ushort;
  end;
end;

var
  SOMTC_DLL_TC__ulong: TypeCode = TypeCode(nil);

class function TypeCode.TC_ulong: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__ulong) then
    Result := SOMTC_DLL_TC__ulong
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__ulong, 'TC__ulong');
    Result := SOMTC_DLL_TC__ulong;
  end;
end;

var
  SOMTC_DLL_TC__float: TypeCode = TypeCode(nil);

class function TypeCode.TC_float: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__float) then
    Result := SOMTC_DLL_TC__float
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__float, 'TC__float');
    Result := SOMTC_DLL_TC__float;
  end;
end;

var
  SOMTC_DLL_TC__double: TypeCode = TypeCode(nil);

class function TypeCode.TC_double: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__double) then
    Result := SOMTC_DLL_TC__double
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__double, 'TC__double');
    Result := SOMTC_DLL_TC__double;
  end;
end;

var
  SOMTC_DLL_TC__boolean: TypeCode = TypeCode(nil);

class function TypeCode.TC_boolean: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__boolean) then
    Result := SOMTC_DLL_TC__boolean
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__boolean, 'TC__boolean');
    Result := SOMTC_DLL_TC__boolean;
  end;
end;

var
  SOMTC_DLL_TC__char: TypeCode = TypeCode(nil);

class function TypeCode.TC_char: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__char) then
    Result := SOMTC_DLL_TC__char
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__char, 'TC__char');
    Result := SOMTC_DLL_TC__char;
  end;
end;

var
  SOMTC_DLL_TC__octet: TypeCode = TypeCode(nil);

class function TypeCode.TC_octet: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__octet) then
    Result := SOMTC_DLL_TC__octet
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__octet, 'TC__octet');
    Result := SOMTC_DLL_TC__octet;
  end;
end;

var
  SOMTC_DLL_TC__any: TypeCode = TypeCode(nil);

class function TypeCode.TC_any: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__any) then
    Result := SOMTC_DLL_TC__any
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__any, 'TC__any');
    Result := SOMTC_DLL_TC__any;
  end;
end;

var
  SOMTC_DLL_TC__TypeCode: TypeCode = TypeCode(nil);

class function TypeCode.TC_TypeCode: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__TypeCode) then
    Result := SOMTC_DLL_TC__TypeCode
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__TypeCode, 'TC__TypeCode');
    Result := SOMTC_DLL_TC__TypeCode;
  end;
end;

var
  SOMTC_DLL_TC__Principal: TypeCode = TypeCode(nil);

class function TypeCode.TC_Principal: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__Principal) then
    Result := SOMTC_DLL_TC__Principal
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__Principal, 'TC__Principal');
    Result := SOMTC_DLL_TC__Principal;
  end;
end;

var
  SOMTC_DLL_TC__Object: TypeCode = TypeCode(nil);

class function TypeCode.TC_Object: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__Object) then
    Result := SOMTC_DLL_TC__Object
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__Object, 'TC__Object');
    Result := SOMTC_DLL_TC__Object;
  end;
end;

var
  SOMTC_DLL_TC__string: TypeCode = TypeCode(nil);

class function TypeCode.TC_string: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__string) then
    Result := SOMTC_DLL_TC__string
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__string, 'TC__string');
    Result := SOMTC_DLL_TC__string;
  end;
end;

var
  SOMTC_DLL_TC__NamedValue: TypeCode = TypeCode(nil);

class function TypeCode.TC_NamedValue: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__NamedValue) then
    Result := SOMTC_DLL_TC__NamedValue
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__NamedValue, 'TC__NamedValue');
    Result := SOMTC_DLL_TC__NamedValue;
  end;
end;

var
  SOMTC_DLL_TC__InterfaceDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_InterfaceDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__InterfaceDescription) then
    Result := SOMTC_DLL_TC__InterfaceDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__InterfaceDescription, 'TC__InterfaceDescription');
    Result := SOMTC_DLL_TC__InterfaceDescription;
  end;
end;

var
  SOMTC_DLL_TC__OperationDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_OperationDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__OperationDescription) then
    Result := SOMTC_DLL_TC__OperationDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__OperationDescription, 'TC__OperationDescription');
    Result := SOMTC_DLL_TC__OperationDescription;
  end;
end;

var
  SOMTC_DLL_TC__AttributeDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_AttributeDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__AttributeDescription) then
    Result := SOMTC_DLL_TC__AttributeDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__AttributeDescription, 'TC__AttributeDescription');
    Result := SOMTC_DLL_TC__AttributeDescription;
  end;
end;

var
  SOMTC_DLL_TC__ParameterDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_ParameterDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__ParameterDescription) then
    Result := SOMTC_DLL_TC__ParameterDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__ParameterDescription, 'TC__ParameterDescription');
    Result := SOMTC_DLL_TC__ParameterDescription;
  end;
end;

var
  SOMTC_DLL_TC__RepositoryDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_RepositoryDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__RepositoryDescription) then
    Result := SOMTC_DLL_TC__RepositoryDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__RepositoryDescription, 'TC__RepositoryDescription');
    Result := SOMTC_DLL_TC__RepositoryDescription;
  end;
end;

var
  SOMTC_DLL_TC__ModuleDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_ModuleDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__ModuleDescription) then
    Result := SOMTC_DLL_TC__ModuleDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__ModuleDescription, 'TC__ModuleDescription');
    Result := SOMTC_DLL_TC__ModuleDescription;
  end;
end;

var
  SOMTC_DLL_TC__ConstDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_ConstDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__ConstDescription) then
    Result := SOMTC_DLL_TC__ConstDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__ConstDescription, 'TC__ConstDescription');
    Result := SOMTC_DLL_TC__ConstDescription;
  end;
end;

var
  SOMTC_DLL_TC__ConstantDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_ConstantDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__ConstantDescription) then
    Result := SOMTC_DLL_TC__ConstantDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__ConstantDescription, 'TC__ConstantDescription');
    Result := SOMTC_DLL_TC__ConstantDescription;
  end;
end;

var
  SOMTC_DLL_TC__ExceptionDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_ExceptionDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__ExceptionDescription) then
    Result := SOMTC_DLL_TC__ExceptionDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__ExceptionDescription, 'TC__ExceptionDescription');
    Result := SOMTC_DLL_TC__ExceptionDescription;
  end;
end;

var
  SOMTC_DLL_TC__TypeDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_TypeDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__TypeDescription) then
    Result := SOMTC_DLL_TC__TypeDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__TypeDescription, 'TC__TypeDescription');
    Result := SOMTC_DLL_TC__TypeDescription;
  end;
end;

var
  SOMTC_DLL_TC__FullInterfaceDescription: TypeCode = TypeCode(nil);

class function TypeCode.TC_FullInterfaceDescription: TypeCode;
begin
  if Assigned(SOMTC_DLL_TC__FullInterfaceDescription) then
    Result := SOMTC_DLL_TC__FullInterfaceDescription
  else
  begin
    SOMTC_DLL_Load_Variable(SOMTC_DLL_TC__FullInterfaceDescription, 'TC__FullInterfaceDescription');
    Result := SOMTC_DLL_TC__FullInterfaceDescription;
  end;
end;

function TypeCode_equal(x: TypeCode; ev: PEnvironment; y: TypeCode): CORBABoolean; stdcall; external SOMTC_DLL_Name name 'tcEqual';

function TypeCode.Equal(y: TypeCode): CORBABoolean;
var
  LocalEnv: Environment;
begin
  SOM_InitEnvironment(@LocalEnv);
  Result := TypeCode_equal(Self, @LocalEnv, y);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeCode_copy(t: TypeCode; ev: PEnvironment): TypeCode; stdcall; external SOMTC_DLL_Name name 'tcCopy';

function TypeCode.Copy: TypeCode;
var
  LocalEnv: Environment;
begin
  SOM_InitEnvironment(@LocalEnv);
  Result := TypeCode_copy(Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure TypeCode_print(t: TypeCode; ev: PEnvironment); stdcall; external SOMTC_DLL_Name name 'tcPrint';

procedure TypeCode.Print;
var
  LocalEnv: Environment;
begin
  SOM_InitEnvironment(@LocalEnv);
  TypeCode_print(Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeCodeNewVL(tag: TCKind; ap: va_list): TypeCode; stdcall; external SOMTC_DLL_Name name 'tcNewVL';

class function TypeCode.Create(tag: TCKind): TypeCode;
begin
  Result := TypeCode.Create(tag, []);
end;

class function TypeCode.Create(tag: TCKind; const Arguments: array of const): TypeCode;
var
  Buf: somVaBuf;
  StringBuf: TAnsiStringArray;
begin
  Buf := nil;
  try
    Result := TypeCodeNewVL(tag, ArrayOfConstToVaList(Buf, StringBuf, Arguments, True));
    // if not Assigned(Result) then raise something;
  finally
    somVaBuf_destroy(Buf);
  end;
end;

class function TypeCode.Create(tag: TCKind; ap: va_list): TypeCode;
begin
  Result := TypeCodeNewVL(tag, ap);
  // if not Assigned(Result) then raise something;
end;

function ESOMException.GetNestedEnvironment: PEnvironment; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := @FNestedEnvironment;
end;

constructor ESOMException.Create(ev: PEnvironment); // clears ev
var
  Msg: string;
begin
  if ev <> @FNestedEnvironment then // not from parent constructor
  begin
    Move(ev^, FNestedEnvironment, SizeOf(Environment));
    FillChar(ev^, SizeOf(Environment), 0);
  end;
  FMajor := FNestedEnvironment._major;
  case FMajor of
    SYSTEM_EXCEPTION: begin
      FExceptionId := somExceptionId(@FNestedEnvironment);
      FExceptionValue := somExceptionValue(@FNestedEnvironment);
      Msg := 'Error occured; exception string: ' + FExceptionId + '; ' +
        'minor error code: ' + IntToStr(PStExcep(FExceptionValue).minor) + '; ' +
        'completion code: ';
      case PStExcep(FExceptionValue).completed of
        YES: Msg := Msg + 'YES';
        NO: Msg := Msg + 'YES';
      else Msg := Msg + 'MAYBE';
      end;
    end;
    USER_EXCEPTION: begin
      FExceptionId := somExceptionId(@FNestedEnvironment);
      FExceptionValue := somExceptionValue(@FNestedEnvironment);
      Msg := 'Error occured; exception string: ' + FExceptionId;
    end;
  else Msg := 'Exception created from empty environment';
  end;
  inherited Create(Msg);
end;

constructor ESOMException.Create(AMajor: exception_type; const AExceptionId: string; AExceptionValue: Pointer); // from user code
var
  S: AnsiString;
begin
  S := AExceptionId;
  somSetException(@FNestedEnvironment, AMajor, PAnsiChar(S), AExceptionValue);
  Create(@FNestedEnvironment);
end;

destructor ESOMException.Destroy;
begin
  SOM_UninitEnvironment(@FNestedEnvironment);
  inherited;
end;

procedure ESOMException.ResetNestedEnvironment;
begin
  FillChar(FNestedEnvironment, SizeOf(Environment), 0);
end;

const
  SOM_DLL_Name = 'som.dll';

var
  SOM_DLL: System.HMODULE = 0;

procedure SOM_DLL_Load_Variable(var V_Pointer; const Var_Name: AnsiString);
begin
  if SOM_DLL = 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOM_DLL = 0 then
      SOM_DLL := Windows.LoadLibraryW(SOM_DLL_Name);
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOM_DLL <> 0 then
    Pointer(V_Pointer) := Windows.GetProcAddress(SOM_DLL, PAnsiChar(Var_Name));
end;

const
  SOMObject_MajorVersion = 1;
  SOMObject_MinorVersion = 4;

(*
 * Declare the class creation procedure
 *)
function SOMObjectNewClass(
  somtmajorVersion: integer4 = SOMObject_MajorVersion;
  somtminorVersion: integer4 = SOMObject_MinorVersion):
  SOMClass; stdcall; external SOM_DLL_Name name 'SOMObjectNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMObjectClassDataStructure = packed record
    classObject: SOMClass;
    somInit,
    somUninit,
    somFree,
    somDefaultVCopyInit,
    somGetClassName,
    somGetClass,
    somIsA,
    somRespondsTo,
    somIsInstanceOf,
    somGetSize,
    somDumpSelf,
    somDumpSelfInt,
    somPrintSelf,
    somDefaultConstVCopyInit,
    somDispatchV,
    somDispatchL,
    somDispatchA,
    somDispatchD,
    somDispatch,
    somClassDispatch,
    somCastObj,
    somResetObj,
    somDefaultInit,
    somDestruct,
    somPrivate1,
    somPrivate2,
    somDefaultCopyInit,
    somDefaultConstCopyInit,
    somDefaultAssign,
    somDefaultConstAssign,
    somDefaultVAssign,
    somDefaultConstVAssign: somMToken;
  end;
  PSOMObjectClassDataStructure = ^SOMObjectClassDataStructure;

var
  SOM_DLL_SOMObjectClassData: PSOMObjectClassDataStructure = nil;

function SOMObjectClassData: PSOMObjectClassDataStructure;
begin
  if Assigned(SOM_DLL_SOMObjectClassData) then
    Result := SOM_DLL_SOMObjectClassData
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOMObjectClassData, 'SOMObjectClassData');
    Result := SOM_DLL_SOMObjectClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMObjectCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMObjectCClassDataStructure = ^SOMObjectCClassDataStructure;

var
  SOM_DLL_SOMObjectCClassData: PSOMObjectCClassDataStructure = nil;

function SOMObjectCClassData: PSOMObjectCClassDataStructure;
begin
  if Assigned(SOM_DLL_SOMObjectCClassData) then
    Result := SOM_DLL_SOMObjectCClassData
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOMObjectCClassData, 'SOMObjectCClassData');
    Result := SOM_DLL_SOMObjectCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMObject.Create: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMObject(SOMClass(NewClass).somNew);
end;

class function SOMObject.InitInstance(Instance: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMObject(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMObject.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMObject.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMObject.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMObject.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMObject.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMObject.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMObject.NewInstance: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMObject(SOMClass(NewClass).somNewNoInit);
end;

function SOMObject.Clone: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMObject(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somDefaultInit
 *)
type
  somTD_SOMObject_somDefaultInit = procedure(somSelf: SOMObjectBase; var ctrl: Pointer); stdcall;

procedure SOMObject.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDestruct
 *)
type
  somTD_SOMObject_somDestruct = procedure(somSelf: SOMObjectBase; doFree: Byte; var ctrl: Pointer); stdcall;

procedure SOMObject.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDefaultCopyInit
 *)
type
  somTD_SOMObject_somDefaultCopyInit = procedure(somSelf: SOMObjectBase; var ctrl: Pointer; fromObj: SOMObjectBase); stdcall;

procedure SOMObject.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDefaultAssign
 *)
type
  somTD_SOMObject_somDefaultAssign = function(somSelf: SOMObjectBase; var ctrl: Pointer; fromObj: SOMObjectBase): SOMObject; stdcall;

function SOMObject.somDefaultAssign(var ctrl: Pointer; fromObj: SOMObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMObject(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDefaultConstCopyInit
 *)
type
  somTD_SOMObject_somDefaultConstCopyInit = procedure(somSelf: SOMObjectBase; var ctrl: Pointer; fromObj: SOMObjectBase); stdcall;

procedure SOMObject.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDefaultVCopyInit
 *)
type
  somTD_SOMObject_somDefaultVCopyInit = procedure(somSelf: SOMObjectBase; var ctrl: Pointer; fromObj: SOMObjectBase); stdcall;

procedure SOMObject.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDefaultConstVCopyInit
 *)
type
  somTD_SOMObject_somDefaultConstVCopyInit = procedure(somSelf: SOMObjectBase; var ctrl: Pointer; fromObj: SOMObjectBase); stdcall;

procedure SOMObject.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDefaultConstAssign
 *)
type
  somTD_SOMObject_somDefaultConstAssign = function(somSelf: SOMObjectBase; var ctrl: Pointer; fromObj: SOMObjectBase): SOMObject; stdcall;

function SOMObject.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMObject(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDefaultVAssign
 *)
type
  somTD_SOMObject_somDefaultVAssign = function(somSelf: SOMObjectBase; var ctrl: Pointer; fromObj: SOMObjectBase): SOMObject; stdcall;

function SOMObject.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMObject(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDefaultConstVAssign
 *)
type
  somTD_SOMObject_somDefaultConstVAssign = function(somSelf: SOMObjectBase; var ctrl: Pointer; fromObj: SOMObjectBase): SOMObject; stdcall;

function SOMObject.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMObject(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somInit
 *)
type
  somTD_SOMObject_somInit = procedure(somSelf: SOMObjectBase); stdcall;

procedure SOMObject.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somFree
 *)
type
  somTD_SOMObject_somFree = procedure(somSelf: SOMObjectBase); stdcall;

procedure SOMObject.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somUninit
 *)
type
  somTD_SOMObject_somUninit = procedure(somSelf: SOMObjectBase); stdcall;

procedure SOMObject.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetClass
 *)
type
  somTD_SOMObject_somGetClass = function(somSelf: SOMObjectBase): SOMClass; stdcall;

function SOMObject.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetClassName
 *)
type
  somTD_SOMObject_somGetClassName = function(somSelf: SOMObjectBase): {dual_owned} CORBAString; stdcall;

function SOMObject.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetSize
 *)
type
  somTD_SOMObject_somGetSize = function(somSelf: SOMObjectBase): LongInt; stdcall;

function SOMObject.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somIsA
 *)
type
  somTD_SOMObject_somIsA = function(somSelf: SOMObjectBase; aClassObj: SOMClass): CORBABoolean; stdcall;

function SOMObject.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somIsInstanceOf
 *)
type
  somTD_SOMObject_somIsInstanceOf = function(somSelf: SOMObjectBase; aClassObj: SOMClass): CORBABoolean; stdcall;

function SOMObject.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somRespondsTo
 *)
type
  somTD_SOMObject_somRespondsTo = function(somSelf: SOMObjectBase; mId: somId): CORBABoolean; stdcall;

function SOMObject.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDispatch
 *)
type
  somTD_SOMObject_somDispatch = function(somSelf: SOMObjectBase; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; stdcall;

function SOMObject.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somClassDispatch
 *)
type
  somTD_SOMObject_somClassDispatch = function(somSelf: SOMObjectBase; clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; stdcall;

function SOMObject.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somCastObj
 *)
type
  somTD_SOMObject_somCastObj = function(somSelf: SOMObjectBase; cls: SOMClass): CORBABoolean; stdcall;

function SOMObject.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somResetObj
 *)
type
  somTD_SOMObject_somResetObj = function(somSelf: SOMObjectBase): CORBABoolean; stdcall;

function SOMObject.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somPrintSelf
 *)
type
  somTD_SOMObject_somPrintSelf = function(somSelf: SOMObjectBase): SOMObject; stdcall;

function SOMObject.somPrintSelf: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMObject(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDumpSelf
 *)
type
  somTD_SOMObject_somDumpSelf = procedure(somSelf: SOMObjectBase; level: LongInt); stdcall;

procedure SOMObject.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDumpSelfInt
 *)
type
  somTD_SOMObject_somDumpSelfInt = procedure(somSelf: SOMObjectBase; level: LongInt); stdcall;

procedure SOMObject.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMObject.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMObject then { invoked on class name literal }
  begin
    Result := SOMClass(SOMObjectClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMObject.NewClass: SOMClass;
begin
  if Self = SOMObject then { invoked on class name literal }
  begin
    Result := SOMClass(SOMObjectClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMObjectNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMObject.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMObject.Supports(Instance: SOMObjectBase; out Obj: SOMObject): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMObject(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMIR_DLL_Name = 'somir.dll';

var
  SOMIR_DLL: System.HMODULE = 0;

procedure SOMIR_DLL_Load_Variable(var V_Pointer; const Var_Name: AnsiString);
begin
  if SOMIR_DLL = 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOMIR_DLL = 0 then
      SOMIR_DLL := Windows.LoadLibraryW(SOMIR_DLL_Name);
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOMIR_DLL <> 0 then
    Pointer(V_Pointer) := Windows.GetProcAddress(SOMIR_DLL, PAnsiChar(Var_Name));
end;

const
  Contained_MajorVersion = 2;
  Contained_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ContainedNewClass(
  somtmajorVersion: integer4 = Contained_MajorVersion;
  somtminorVersion: integer4 = Contained_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'ContainedNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ContainedClassDataStructure = packed record
    classObject: SOMClass;
    within,
    describe,
    _get_name,
    _set_name,
    _get_id,
    _set_id,
    _get_defined_in,
    _set_defined_in,
    _get_somModifiers,
    _set_somModifiers: somMToken;
  end;
  PContainedClassDataStructure = ^ContainedClassDataStructure;

var
  SOMIR_DLL_ContainedClassData: PContainedClassDataStructure = nil;

function ContainedClassData: PContainedClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ContainedClassData) then
    Result := SOMIR_DLL_ContainedClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ContainedClassData, 'ContainedClassData');
    Result := SOMIR_DLL_ContainedClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ContainedCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PContainedCClassDataStructure = ^ContainedCClassDataStructure;

var
  SOMIR_DLL_ContainedCClassData: PContainedCClassDataStructure = nil;

function ContainedCClassData: PContainedCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ContainedCClassData) then
    Result := SOMIR_DLL_ContainedCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ContainedCClassData, 'ContainedCClassData');
    Result := SOMIR_DLL_ContainedCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_name
 *)
type
  somTD_Contained__get_name = function(somSelf: SOMObjectBase{Contained}; ev: PEnvironment): CORBAString; stdcall;

function Contained._get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_name
   (SOM_Resolve(Self, cd.classObject, cd._get_name))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_name
 *)
type
  somTD_Contained__set_name = procedure(somSelf: SOMObjectBase{Contained}; ev: PEnvironment; name: {caller_owns} CORBAString); stdcall;

procedure Contained._set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_name
   (SOM_Resolve(Self, cd.classObject, cd._set_name))
     (Self, @LocalEnv, name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_id
 *)
type
  somTD_Contained__get_id = function(somSelf: SOMObjectBase{Contained}; ev: PEnvironment): CORBAString; stdcall;

function Contained._get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_id
   (SOM_Resolve(Self, cd.classObject, cd._get_id))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_id
 *)
type
  somTD_Contained__set_id = procedure(somSelf: SOMObjectBase{Contained}; ev: PEnvironment; id: {caller_owns} CORBAString); stdcall;

procedure Contained._set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_id
   (SOM_Resolve(Self, cd.classObject, cd._set_id))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_defined_in
 *)
type
  somTD_Contained__get_defined_in = function(somSelf: SOMObjectBase{Contained}; ev: PEnvironment): CORBAString; stdcall;

function Contained._get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._get_defined_in))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_defined_in
 *)
type
  somTD_Contained__set_defined_in = procedure(somSelf: SOMObjectBase{Contained}; ev: PEnvironment; defined_in: {caller_owns} CORBAString); stdcall;

procedure Contained._set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._set_defined_in))
     (Self, @LocalEnv, defined_in);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_somModifiers
 *)
type
  somTD_Contained__get_somModifiers = function(somSelf: SOMObjectBase{Contained}; ev: PEnvironment): _IDL_Sequence_somModifier; stdcall;

function Contained._get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._get_somModifiers))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_somModifiers
 *)
type
  somTD_Contained__set_somModifiers = procedure(somSelf: SOMObjectBase{Contained}; ev: PEnvironment; const somModifiers: {caller_owns} _IDL_Sequence_somModifier); stdcall;

procedure Contained._set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._set_somModifiers))
     (Self, @LocalEnv, somModifiers);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function Contained.Create: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(SOMClass(NewClass).somNew);
end;

class function Contained.InitInstance(Instance: Pointer): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function Contained.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function Contained.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function Contained.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function Contained.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function Contained.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function Contained.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function Contained.NewInstance: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(SOMClass(NewClass).somNewNoInit);
end;

function Contained.Clone: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: within
 *)
type
  somTD_Contained_within = function(somSelf: SOMObjectBase{Contained}; ev: PEnvironment): _IDL_Sequence_Container; stdcall;

function Contained.within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_within
   (SOM_Resolve(Self, cd.classObject, cd.within))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: describe
 *)
type
  somTD_Contained_describe = function(somSelf: SOMObjectBase{Contained}; ev: PEnvironment): Contained_Description; stdcall;

function Contained.describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_describe
   (SOM_Resolve(Self, cd.classObject, cd.describe))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure Contained.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Contained.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Contained.somDefaultCopyInit(var ctrl: Pointer; fromObj: Contained); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somDefaultAssign(var ctrl: Pointer; fromObj: Contained): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Contained(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Contained.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Contained); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Contained.somDefaultVCopyInit(var ctrl: Pointer; fromObj: Contained); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Contained.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Contained); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somDefaultConstAssign(var ctrl: Pointer; fromObj: Contained): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Contained(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somDefaultVAssign(var ctrl: Pointer; fromObj: Contained): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Contained(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somDefaultConstVAssign(var ctrl: Pointer; fromObj: Contained): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Contained(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Contained.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Contained.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Contained.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Contained.somPrintSelf: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Contained(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Contained.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Contained.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function Contained.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = Contained then { invoked on class name literal }
  begin
    Result := SOMClass(ContainedClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function Contained.NewClass: SOMClass;
begin
  if Self = Contained then { invoked on class name literal }
  begin
    Result := SOMClass(ContainedClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(ContainedNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function Contained.As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function Contained.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function Contained.Supports(Instance: SOMObjectBase; out Obj: Contained): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := Contained(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  AttributeDef_MajorVersion = 2;
  AttributeDef_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function AttributeDefNewClass(
  somtmajorVersion: integer4 = AttributeDef_MajorVersion;
  somtminorVersion: integer4 = AttributeDef_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'AttributeDefNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  AttributeDefClassDataStructure = packed record
    classObject: SOMClass;
    _get_type,
    _set_type,
    _get_mode,
    _set_mode: somMToken;
  end;
  PAttributeDefClassDataStructure = ^AttributeDefClassDataStructure;

var
  SOMIR_DLL_AttributeDefClassData: PAttributeDefClassDataStructure = nil;

function AttributeDefClassData: PAttributeDefClassDataStructure;
begin
  if Assigned(SOMIR_DLL_AttributeDefClassData) then
    Result := SOMIR_DLL_AttributeDefClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_AttributeDefClassData, 'AttributeDefClassData');
    Result := SOMIR_DLL_AttributeDefClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  AttributeDefCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PAttributeDefCClassDataStructure = ^AttributeDefCClassDataStructure;

var
  SOMIR_DLL_AttributeDefCClassData: PAttributeDefCClassDataStructure = nil;

function AttributeDefCClassData: PAttributeDefCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_AttributeDefCClassData) then
    Result := SOMIR_DLL_AttributeDefCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_AttributeDefCClassData, 'AttributeDefCClassData');
    Result := SOMIR_DLL_AttributeDefCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_type
 *)
type
  somTD_AttributeDef__get_type = function(somSelf: SOMObjectBase{AttributeDef}; ev: PEnvironment): TypeCode; stdcall;

function AttributeDef._get_type: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PAttributeDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := AttributeDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_AttributeDef__get_type
   (SOM_Resolve(Self, cd.classObject, cd._get_type))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_type
 *)
type
  somTD_AttributeDef__set_type = procedure(somSelf: SOMObjectBase{AttributeDef}; ev: PEnvironment; SOM_type: {caller_owns} TypeCode); stdcall;

procedure AttributeDef._set_type(SOM_type: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PAttributeDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := AttributeDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_AttributeDef__set_type
   (SOM_Resolve(Self, cd.classObject, cd._set_type))
     (Self, @LocalEnv, SOM_type);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_mode
 *)
type
  somTD_AttributeDef__get_mode = function(somSelf: SOMObjectBase{AttributeDef}; ev: PEnvironment): AttributeDef_AttributeMode; stdcall;

function AttributeDef._get_mode: AttributeDef_AttributeMode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PAttributeDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := AttributeDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_AttributeDef__get_mode
   (SOM_Resolve(Self, cd.classObject, cd._get_mode))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_mode
 *)
type
  somTD_AttributeDef__set_mode = procedure(somSelf: SOMObjectBase{AttributeDef}; ev: PEnvironment; mode: AttributeDef_AttributeMode); stdcall;

procedure AttributeDef._set_mode(mode: AttributeDef_AttributeMode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PAttributeDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := AttributeDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_AttributeDef__set_mode
   (SOM_Resolve(Self, cd.classObject, cd._set_mode))
     (Self, @LocalEnv, mode);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function AttributeDef._get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_name
   (SOM_Resolve(Self, cd.classObject, cd._get_name))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure AttributeDef._set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_name
   (SOM_Resolve(Self, cd.classObject, cd._set_name))
     (Self, @LocalEnv, name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function AttributeDef._get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_id
   (SOM_Resolve(Self, cd.classObject, cd._get_id))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure AttributeDef._set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_id
   (SOM_Resolve(Self, cd.classObject, cd._set_id))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function AttributeDef._get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._get_defined_in))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure AttributeDef._set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._set_defined_in))
     (Self, @LocalEnv, defined_in);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function AttributeDef._get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._get_somModifiers))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure AttributeDef._set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._set_somModifiers))
     (Self, @LocalEnv, somModifiers);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function AttributeDef.Create: AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := AttributeDef(SOMClass(NewClass).somNew);
end;

class function AttributeDef.InitInstance(Instance: Pointer): AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := AttributeDef(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function AttributeDef.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function AttributeDef.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function AttributeDef.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function AttributeDef.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function AttributeDef.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function AttributeDef.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function AttributeDef.NewInstance: AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := AttributeDef(SOMClass(NewClass).somNewNoInit);
end;

function AttributeDef.Clone: AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := AttributeDef(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function AttributeDef.within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_within
   (SOM_Resolve(Self, cd.classObject, cd.within))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function AttributeDef.describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_describe
   (SOM_Resolve(Self, cd.classObject, cd.describe))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure AttributeDef.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure AttributeDef.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure AttributeDef.somDefaultCopyInit(var ctrl: Pointer; fromObj: AttributeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somDefaultAssign(var ctrl: Pointer; fromObj: AttributeDef): AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := AttributeDef(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure AttributeDef.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: AttributeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure AttributeDef.somDefaultVCopyInit(var ctrl: Pointer; fromObj: AttributeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure AttributeDef.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: AttributeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somDefaultConstAssign(var ctrl: Pointer; fromObj: AttributeDef): AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := AttributeDef(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somDefaultVAssign(var ctrl: Pointer; fromObj: AttributeDef): AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := AttributeDef(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somDefaultConstVAssign(var ctrl: Pointer; fromObj: AttributeDef): AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := AttributeDef(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure AttributeDef.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure AttributeDef.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure AttributeDef.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function AttributeDef.somPrintSelf: AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := AttributeDef(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure AttributeDef.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure AttributeDef.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function AttributeDef.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = AttributeDef then { invoked on class name literal }
  begin
    Result := SOMClass(AttributeDefClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function AttributeDef.NewClass: SOMClass;
begin
  if Self = AttributeDef then { invoked on class name literal }
  begin
    Result := SOMClass(AttributeDefClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(AttributeDefNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function AttributeDef.As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(Self);
end;

function AttributeDef.As_AttributeDef: AttributeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function AttributeDef.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function AttributeDef.Supports(Instance: SOMObjectBase; out Obj: AttributeDef): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := AttributeDef(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMD_DLL_Name = 'somd.dll';

var
  SOMD_DLL: System.HMODULE = 0;

procedure SOMD_DLL_Load_Variable(var V_Pointer; const Var_Name: AnsiString);
begin
  if SOMD_DLL = 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOMD_DLL = 0 then
      SOMD_DLL := Windows.LoadLibraryW(SOMD_DLL_Name);
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOMD_DLL <> 0 then
    Pointer(V_Pointer) := Windows.GetProcAddress(SOMD_DLL, PAnsiChar(Var_Name));
end;

const
  BOA_MajorVersion = 2;
  BOA_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function BOANewClass(
  somtmajorVersion: integer4 = BOA_MajorVersion;
  somtminorVersion: integer4 = BOA_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'BOANewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  BOAClassDataStructure = packed record
    classObject: SOMClass;
    SOM_create,
    dispose,
    get_id,
    change_implementation,
    get_principal,
    set_exception,
    impl_is_ready,
    deactivate_impl,
    obj_is_ready,
    deactivate_obj,
    activate_impl,
    activate_obj: somMToken;
  end;
  PBOAClassDataStructure = ^BOAClassDataStructure;

var
  SOMD_DLL_BOAClassData: PBOAClassDataStructure = nil;

function BOAClassData: PBOAClassDataStructure;
begin
  if Assigned(SOMD_DLL_BOAClassData) then
    Result := SOMD_DLL_BOAClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_BOAClassData, 'BOAClassData');
    Result := SOMD_DLL_BOAClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  BOACClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PBOACClassDataStructure = ^BOACClassDataStructure;

var
  SOMD_DLL_BOACClassData: PBOACClassDataStructure = nil;

function BOACClassData: PBOACClassDataStructure;
begin
  if Assigned(SOMD_DLL_BOACClassData) then
    Result := SOMD_DLL_BOACClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_BOACClassData, 'BOACClassData');
    Result := SOMD_DLL_BOACClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function BOA.Create: BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := BOA(SOMClass(NewClass).somNew);
end;

class function BOA.InitInstance(Instance: Pointer): BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := BOA(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function BOA.ClassType: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMObject(Self).somGetClass);
end;

class function BOA.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function BOA.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function BOA.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function BOA.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function BOA.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function BOA.NewInstance: BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := BOA(SOMClass(NewClass).somNewNoInit);
end;

function BOA.Clone: BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := BOA(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: SOM_create
 *)
type
  somTD_BOA_SOM_create = function(somSelf: SOMObjectBase{BOA}; ev: PEnvironment; const id: _IDL_Sequence_Byte; intf: InterfaceDef; impl: ImplementationDef): SOMDObject; stdcall;

function BOA.SOM_create(const id: _IDL_Sequence_Byte; intf: InterfaceDef; impl: ImplementationDef): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_BOA_SOM_create
   (SOM_Resolve(Self, cd.classObject, cd.SOM_create))
     (Self, @LocalEnv, id, intf, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: dispose
 *)
type
  somTD_BOA_dispose = procedure(somSelf: SOMObjectBase{BOA}; ev: PEnvironment; obj: SOMDObject); stdcall;

procedure BOA.dispose(obj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_dispose
   (SOM_Resolve(Self, cd.classObject, cd.dispose))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: get_id
 *)
type
  somTD_BOA_get_id = function(somSelf: SOMObjectBase{BOA}; ev: PEnvironment; obj: SOMDObject): _IDL_Sequence_Byte; stdcall;

function BOA.get_id(obj: SOMDObject): _IDL_Sequence_Byte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_BOA_get_id
   (SOM_Resolve(Self, cd.classObject, cd.get_id))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: get_principal
 *)
type
  somTD_BOA_get_principal = function(somSelf: SOMObjectBase{BOA}; ev: PEnvironment; obj: SOMDObject; const req_ev: Environment): Principal; stdcall;

function BOA.get_principal(obj: SOMDObject; const req_ev: Environment): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_BOA_get_principal
   (SOM_Resolve(Self, cd.classObject, cd.get_principal))
     (Self, @LocalEnv, obj, req_ev);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: set_exception
 *)
type
  somTD_BOA_set_exception = procedure(somSelf: SOMObjectBase{BOA}; ev: PEnvironment; major: exception_type; userid: CORBAString; param: Pointer); stdcall;

procedure BOA.set_exception(major: exception_type; userid: CORBAString; param: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_set_exception
   (SOM_Resolve(Self, cd.classObject, cd.set_exception))
     (Self, @LocalEnv, major, userid, param);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: impl_is_ready
 *)
type
  somTD_BOA_impl_is_ready = procedure(somSelf: SOMObjectBase{BOA}; ev: PEnvironment; impl: ImplementationDef); stdcall;

procedure BOA.impl_is_ready(impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_impl_is_ready
   (SOM_Resolve(Self, cd.classObject, cd.impl_is_ready))
     (Self, @LocalEnv, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: deactivate_impl
 *)
type
  somTD_BOA_deactivate_impl = procedure(somSelf: SOMObjectBase{BOA}; ev: PEnvironment; impl: ImplementationDef); stdcall;

procedure BOA.deactivate_impl(impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_deactivate_impl
   (SOM_Resolve(Self, cd.classObject, cd.deactivate_impl))
     (Self, @LocalEnv, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: change_implementation
 *)
type
  somTD_BOA_change_implementation = procedure(somSelf: SOMObjectBase{BOA}; ev: PEnvironment; obj: SOMDObject; impl: ImplementationDef); stdcall;

procedure BOA.change_implementation(obj: SOMDObject; impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_change_implementation
   (SOM_Resolve(Self, cd.classObject, cd.change_implementation))
     (Self, @LocalEnv, obj, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: obj_is_ready
 *)
type
  somTD_BOA_obj_is_ready = procedure(somSelf: SOMObjectBase{BOA}; ev: PEnvironment; obj: SOMDObject; impl: ImplementationDef); stdcall;

procedure BOA.obj_is_ready(obj: SOMDObject; impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_obj_is_ready
   (SOM_Resolve(Self, cd.classObject, cd.obj_is_ready))
     (Self, @LocalEnv, obj, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: deactivate_obj
 *)
type
  somTD_BOA_deactivate_obj = procedure(somSelf: SOMObjectBase{BOA}; ev: PEnvironment; obj: SOMDObject); stdcall;

procedure BOA.deactivate_obj(obj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_deactivate_obj
   (SOM_Resolve(Self, cd.classObject, cd.deactivate_obj))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure BOA.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure BOA.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure BOA.somDefaultCopyInit(var ctrl: Pointer; fromObj: BOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somDefaultAssign(var ctrl: Pointer; fromObj: BOA): BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := BOA(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure BOA.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: BOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure BOA.somDefaultVCopyInit(var ctrl: Pointer; fromObj: BOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure BOA.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: BOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somDefaultConstAssign(var ctrl: Pointer; fromObj: BOA): BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := BOA(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somDefaultVAssign(var ctrl: Pointer; fromObj: BOA): BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := BOA(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somDefaultConstVAssign(var ctrl: Pointer; fromObj: BOA): BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := BOA(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure BOA.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure BOA.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure BOA.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function BOA.somPrintSelf: BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := BOA(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure BOA.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure BOA.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function BOA.ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = BOA then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(BOAClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

class function BOA.NewClass: SOMMSingleInstance;
begin
  if Self = BOA then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(BOAClassData.classObject);
    if not Assigned(Result) then Result := SOMMSingleInstance(BOANewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

function BOA.As_BOA: BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function BOA.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function BOA.Supports(Instance: SOMObjectBase; out Obj: BOA): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := BOA(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMEM_DLL_Name = 'somem.dll';

var
  SOMEM_DLL: System.HMODULE = 0;

procedure SOMEM_DLL_Load_Variable(var V_Pointer; const Var_Name: AnsiString);
begin
  if SOMEM_DLL = 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOMEM_DLL = 0 then
      SOMEM_DLL := Windows.LoadLibraryW(SOMEM_DLL_Name);
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOMEM_DLL <> 0 then
    Pointer(V_Pointer) := Windows.GetProcAddress(SOMEM_DLL, PAnsiChar(Var_Name));
end;

const
  SOMEEvent_MajorVersion = 2;
  SOMEEvent_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMEEventNewClass(
  somtmajorVersion: integer4 = SOMEEvent_MajorVersion;
  somtminorVersion: integer4 = SOMEEvent_MinorVersion):
  SOMClass; stdcall; external SOMEM_DLL_Name name 'SOMEEventNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMEEventClassDataStructure = packed record
    classObject: SOMClass;
    somevGetEventTime,
    somevGetEventType,
    somevSetEventTime,
    somevSetEventType: somMToken;
  end;
  PSOMEEventClassDataStructure = ^SOMEEventClassDataStructure;

var
  SOMEM_DLL_SOMEEventClassData: PSOMEEventClassDataStructure = nil;

function SOMEEventClassData: PSOMEEventClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMEEventClassData) then
    Result := SOMEM_DLL_SOMEEventClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMEEventClassData, 'SOMEEventClassData');
    Result := SOMEM_DLL_SOMEEventClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMEEventCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMEEventCClassDataStructure = ^SOMEEventCClassDataStructure;

var
  SOMEM_DLL_SOMEEventCClassData: PSOMEEventCClassDataStructure = nil;

function SOMEEventCClassData: PSOMEEventCClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMEEventCClassData) then
    Result := SOMEM_DLL_SOMEEventCClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMEEventCClassData, 'SOMEEventCClassData');
    Result := SOMEM_DLL_SOMEEventCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMEEvent.Create: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEvent(SOMClass(NewClass).somNew);
end;

class function SOMEEvent.InitInstance(Instance: Pointer): SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEvent(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMEEvent.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMEEvent.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMEEvent.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMEEvent.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMEEvent.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMEEvent.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMEEvent.NewInstance: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEvent(SOMClass(NewClass).somNewNoInit);
end;

function SOMEEvent.Clone: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEvent(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somevGetEventTime
 *)
type
  somTD_SOMEEvent_somevGetEventTime = function(somSelf: SOMObjectBase{SOMEEvent}; ev: PEnvironment): LongWord; stdcall;

function SOMEEvent.somevGetEventTime: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEvent_somevGetEventTime
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventTime))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somevGetEventType
 *)
type
  somTD_SOMEEvent_somevGetEventType = function(somSelf: SOMObjectBase{SOMEEvent}; ev: PEnvironment): LongWord; stdcall;

function SOMEEvent.somevGetEventType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEvent_somevGetEventType
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventType))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somevSetEventTime
 *)
type
  somTD_SOMEEvent_somevSetEventTime = procedure(somSelf: SOMObjectBase{SOMEEvent}; ev: PEnvironment; time: LongWord); stdcall;

procedure SOMEEvent.somevSetEventTime(time: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEvent_somevSetEventTime
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventTime))
     (Self, @LocalEnv, time);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somevSetEventType
 *)
type
  somTD_SOMEEvent_somevSetEventType = procedure(somSelf: SOMObjectBase{SOMEEvent}; ev: PEnvironment; SOM_type: LongWord); stdcall;

procedure SOMEEvent.somevSetEventType(SOM_type: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEvent_somevSetEventType
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventType))
     (Self, @LocalEnv, SOM_type);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMEEvent.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEvent.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEvent.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMEEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somDefaultAssign(var ctrl: Pointer; fromObj: SOMEEvent): SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEvent(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEvent.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMEEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEvent.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMEEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEvent.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMEEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMEEvent): SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEvent(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMEEvent): SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEvent(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMEEvent): SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEvent(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEvent.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEvent.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEvent.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEvent.somPrintSelf: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEvent(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEvent.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEvent.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMEEvent.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMEEvent then { invoked on class name literal }
  begin
    Result := SOMClass(SOMEEventClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMEEvent.NewClass: SOMClass;
begin
  if Self = SOMEEvent then { invoked on class name literal }
  begin
    Result := SOMClass(SOMEEventClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMEEventNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMEEvent.As_SOMEEvent: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMEEvent.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMEEvent.Supports(Instance: SOMObjectBase; out Obj: SOMEEvent): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMEEvent(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMEClientEvent_MajorVersion = 2;
  SOMEClientEvent_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMEClientEventNewClass(
  somtmajorVersion: integer4 = SOMEClientEvent_MajorVersion;
  somtminorVersion: integer4 = SOMEClientEvent_MinorVersion):
  SOMClass; stdcall; external SOMEM_DLL_Name name 'SOMEClientEventNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMEClientEventClassDataStructure = packed record
    classObject: SOMClass;
    somevGetEventClientData,
    somevGetEventClientType,
    somevSetEventClientData,
    somevSetEventClientType: somMToken;
  end;
  PSOMEClientEventClassDataStructure = ^SOMEClientEventClassDataStructure;

var
  SOMEM_DLL_SOMEClientEventClassData: PSOMEClientEventClassDataStructure = nil;

function SOMEClientEventClassData: PSOMEClientEventClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMEClientEventClassData) then
    Result := SOMEM_DLL_SOMEClientEventClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMEClientEventClassData, 'SOMEClientEventClassData');
    Result := SOMEM_DLL_SOMEClientEventClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMEClientEventCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMEClientEventCClassDataStructure = ^SOMEClientEventCClassDataStructure;

var
  SOMEM_DLL_SOMEClientEventCClassData: PSOMEClientEventCClassDataStructure = nil;

function SOMEClientEventCClassData: PSOMEClientEventCClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMEClientEventCClassData) then
    Result := SOMEM_DLL_SOMEClientEventCClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMEClientEventCClassData, 'SOMEClientEventCClassData');
    Result := SOMEM_DLL_SOMEClientEventCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMEClientEvent.Create: SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEClientEvent(SOMClass(NewClass).somNew);
end;

class function SOMEClientEvent.InitInstance(Instance: Pointer): SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEClientEvent(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMEClientEvent.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMEClientEvent.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMEClientEvent.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMEClientEvent.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMEClientEvent.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMEClientEvent.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMEClientEvent.NewInstance: SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEClientEvent(SOMClass(NewClass).somNewNoInit);
end;

function SOMEClientEvent.Clone: SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEClientEvent(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somevGetEventClientData
 *)
type
  somTD_SOMEClientEvent_somevGetEventClientData = function(somSelf: SOMObjectBase{SOMEClientEvent}; ev: PEnvironment): Pointer; stdcall;

function SOMEClientEvent.somevGetEventClientData: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEClientEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEClientEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEClientEvent_somevGetEventClientData
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventClientData))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somevGetEventClientType
 *)
type
  somTD_SOMEClientEvent_somevGetEventClientType = function(somSelf: SOMObjectBase{SOMEClientEvent}; ev: PEnvironment): CORBAString; stdcall;

function SOMEClientEvent.somevGetEventClientType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEClientEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEClientEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEClientEvent_somevGetEventClientType
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventClientType))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somevSetEventClientData
 *)
type
  somTD_SOMEClientEvent_somevSetEventClientData = procedure(somSelf: SOMObjectBase{SOMEClientEvent}; ev: PEnvironment; clientData: Pointer); stdcall;

procedure SOMEClientEvent.somevSetEventClientData(clientData: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEClientEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEClientEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEClientEvent_somevSetEventClientData
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventClientData))
     (Self, @LocalEnv, clientData);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somevSetEventClientType
 *)
type
  somTD_SOMEClientEvent_somevSetEventClientType = procedure(somSelf: SOMObjectBase{SOMEClientEvent}; ev: PEnvironment; clientType: CORBAString); stdcall;

procedure SOMEClientEvent.somevSetEventClientType(clientType: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEClientEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEClientEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEClientEvent_somevSetEventClientType
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventClientType))
     (Self, @LocalEnv, clientType);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMEClientEvent.somevGetEventTime: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEvent_somevGetEventTime
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventTime))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMEClientEvent.somevGetEventType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEvent_somevGetEventType
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventType))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMEClientEvent.somevSetEventTime(time: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEvent_somevSetEventTime
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventTime))
     (Self, @LocalEnv, time);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMEClientEvent.somevSetEventType(SOM_type: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEvent_somevSetEventType
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventType))
     (Self, @LocalEnv, SOM_type);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMEClientEvent.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEClientEvent.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEClientEvent.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMEClientEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somDefaultAssign(var ctrl: Pointer; fromObj: SOMEClientEvent): SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEClientEvent(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEClientEvent.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMEClientEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEClientEvent.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMEClientEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEClientEvent.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMEClientEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMEClientEvent): SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEClientEvent(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMEClientEvent): SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEClientEvent(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMEClientEvent): SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEClientEvent(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEClientEvent.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEClientEvent.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEClientEvent.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEClientEvent.somPrintSelf: SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEClientEvent(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEClientEvent.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEClientEvent.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMEClientEvent.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMEClientEvent then { invoked on class name literal }
  begin
    Result := SOMClass(SOMEClientEventClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMEClientEvent.NewClass: SOMClass;
begin
  if Self = SOMEClientEvent then { invoked on class name literal }
  begin
    Result := SOMClass(SOMEClientEventClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMEClientEventNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMEClientEvent.As_SOMEEvent: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEvent(Self);
end;

function SOMEClientEvent.As_SOMEClientEvent: SOMEClientEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMEClientEvent.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMEClientEvent.Supports(Instance: SOMObjectBase; out Obj: SOMEClientEvent): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMEClientEvent(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  Context_MajorVersion = 2;
  Context_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ContextNewClass(
  somtmajorVersion: integer4 = Context_MajorVersion;
  somtminorVersion: integer4 = Context_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'ContextNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ContextClassDataStructure = packed record
    classObject: SOMClass;
    set_one_value,
    set_values,
    get_values,
    delete_values,
    create_child,
    SOM_destroy,
    _get_context_name,
    _set_context_name,
    _get_context_parent,
    _set_context_parent,
    _get_properties,
    _set_properties: somMToken;
  end;
  PContextClassDataStructure = ^ContextClassDataStructure;

var
  SOMD_DLL_ContextClassData: PContextClassDataStructure = nil;

function ContextClassData: PContextClassDataStructure;
begin
  if Assigned(SOMD_DLL_ContextClassData) then
    Result := SOMD_DLL_ContextClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_ContextClassData, 'ContextClassData');
    Result := SOMD_DLL_ContextClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ContextCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PContextCClassDataStructure = ^ContextCClassDataStructure;

var
  SOMD_DLL_ContextCClassData: PContextCClassDataStructure = nil;

function ContextCClassData: PContextCClassDataStructure;
begin
  if Assigned(SOMD_DLL_ContextCClassData) then
    Result := SOMD_DLL_ContextCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_ContextCClassData, 'ContextCClassData');
    Result := SOMD_DLL_ContextCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function Context.Create: Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Context(SOMClass(NewClass).somNew);
end;

class function Context.InitInstance(Instance: Pointer): Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Context(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function Context.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function Context.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function Context.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function Context.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function Context.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function Context.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function Context.NewInstance: Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Context(SOMClass(NewClass).somNewNoInit);
end;

function Context.Clone: Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Context(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: set_one_value
 *)
type
  somTD_Context_set_one_value = function(somSelf: SOMObjectBase{Context}; ev: PEnvironment; prop_name: CORBAString; value: CORBAString): LongWord; stdcall;

function Context.set_one_value(prop_name: CORBAString; value: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContextClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContextClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Context_set_one_value
   (SOM_Resolve(Self, cd.classObject, cd.set_one_value))
     (Self, @LocalEnv, prop_name, value);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: set_values
 *)
type
  somTD_Context_set_values = function(somSelf: SOMObjectBase{Context}; ev: PEnvironment; values: NVList): LongWord; stdcall;

function Context.set_values(values: NVList): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContextClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContextClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Context_set_values
   (SOM_Resolve(Self, cd.classObject, cd.set_values))
     (Self, @LocalEnv, values);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: get_values
 *)
type
  somTD_Context_get_values = function(somSelf: SOMObjectBase{Context}; ev: PEnvironment; start_scope: CORBAString; op_flags: LongWord; prop_name: CORBAString; out values: NVList): LongWord; stdcall;

function Context.get_values(start_scope: CORBAString; op_flags: LongWord; prop_name: CORBAString; out values: NVList): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContextClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContextClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Context_get_values
   (SOM_Resolve(Self, cd.classObject, cd.get_values))
     (Self, @LocalEnv, start_scope, op_flags, prop_name, values);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: delete_values
 *)
type
  somTD_Context_delete_values = function(somSelf: SOMObjectBase{Context}; ev: PEnvironment; prop_name: CORBAString): LongWord; stdcall;

function Context.delete_values(prop_name: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContextClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContextClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Context_delete_values
   (SOM_Resolve(Self, cd.classObject, cd.delete_values))
     (Self, @LocalEnv, prop_name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: create_child
 *)
type
  somTD_Context_create_child = function(somSelf: SOMObjectBase{Context}; ev: PEnvironment; ctx_name: CORBAString; out child_ctx: Context): LongWord; stdcall;

function Context.create_child(ctx_name: CORBAString; out child_ctx: Context): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContextClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContextClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Context_create_child
   (SOM_Resolve(Self, cd.classObject, cd.create_child))
     (Self, @LocalEnv, ctx_name, child_ctx);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: SOM_destroy
 *)
type
  somTD_Context_SOM_destroy = function(somSelf: SOMObjectBase{Context}; ev: PEnvironment; flags: LongWord): LongWord; stdcall;

function Context.SOM_destroy(flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContextClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContextClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Context_SOM_destroy
   (SOM_Resolve(Self, cd.classObject, cd.SOM_destroy))
     (Self, @LocalEnv, flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure Context.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Context.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Context.somDefaultCopyInit(var ctrl: Pointer; fromObj: Context); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somDefaultAssign(var ctrl: Pointer; fromObj: Context): Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Context(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Context.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Context); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Context.somDefaultVCopyInit(var ctrl: Pointer; fromObj: Context); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Context.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Context); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somDefaultConstAssign(var ctrl: Pointer; fromObj: Context): Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Context(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somDefaultVAssign(var ctrl: Pointer; fromObj: Context): Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Context(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somDefaultConstVAssign(var ctrl: Pointer; fromObj: Context): Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Context(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Context.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Context.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Context.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Context.somPrintSelf: Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Context(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Context.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Context.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function Context.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = Context then { invoked on class name literal }
  begin
    Result := SOMClass(ContextClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function Context.NewClass: SOMClass;
begin
  if Self = Context then { invoked on class name literal }
  begin
    Result := SOMClass(ContextClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(ContextNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function Context.As_Context: Context; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function Context.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function Context.Supports(Instance: SOMObjectBase; out Obj: Context): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := Context(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  ConstantDef_MajorVersion = 2;
  ConstantDef_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ConstantDefNewClass(
  somtmajorVersion: integer4 = ConstantDef_MajorVersion;
  somtminorVersion: integer4 = ConstantDef_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'ConstantDefNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ConstantDefClassDataStructure = packed record
    classObject: SOMClass;
    _get_type,
    _set_type,
    _get_value,
    _set_value: somMToken;
  end;
  PConstantDefClassDataStructure = ^ConstantDefClassDataStructure;

var
  SOMIR_DLL_ConstantDefClassData: PConstantDefClassDataStructure = nil;

function ConstantDefClassData: PConstantDefClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ConstantDefClassData) then
    Result := SOMIR_DLL_ConstantDefClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ConstantDefClassData, 'ConstantDefClassData');
    Result := SOMIR_DLL_ConstantDefClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ConstantDefCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PConstantDefCClassDataStructure = ^ConstantDefCClassDataStructure;

var
  SOMIR_DLL_ConstantDefCClassData: PConstantDefCClassDataStructure = nil;

function ConstantDefCClassData: PConstantDefCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ConstantDefCClassData) then
    Result := SOMIR_DLL_ConstantDefCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ConstantDefCClassData, 'ConstantDefCClassData');
    Result := SOMIR_DLL_ConstantDefCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_type
 *)
type
  somTD_ConstantDef__get_type = function(somSelf: SOMObjectBase{ConstantDef}; ev: PEnvironment): TypeCode; stdcall;

function ConstantDef._get_type: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PConstantDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ConstantDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ConstantDef__get_type
   (SOM_Resolve(Self, cd.classObject, cd._get_type))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_type
 *)
type
  somTD_ConstantDef__set_type = procedure(somSelf: SOMObjectBase{ConstantDef}; ev: PEnvironment; SOM_type: {caller_owns} TypeCode); stdcall;

procedure ConstantDef._set_type(SOM_type: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PConstantDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ConstantDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ConstantDef__set_type
   (SOM_Resolve(Self, cd.classObject, cd._set_type))
     (Self, @LocalEnv, SOM_type);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_value
 *)
type
  somTD_ConstantDef__get_value = function(somSelf: SOMObjectBase{ConstantDef}; ev: PEnvironment): TAnyResult; stdcall;

function ConstantDef._get_value: any; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PConstantDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ConstantDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result := any(
  somTD_ConstantDef__get_value
   (SOM_Resolve(Self, cd.classObject, cd._get_value))
     (Self, @LocalEnv));
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_value
 *)
type
  somTD_ConstantDef__set_value = procedure(somSelf: SOMObjectBase{ConstantDef}; ev: PEnvironment; const value: {caller_owns} any); stdcall;

procedure ConstantDef._set_value(const value: {caller_owns} any); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PConstantDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ConstantDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ConstantDef__set_value
   (SOM_Resolve(Self, cd.classObject, cd._set_value))
     (Self, @LocalEnv, value);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ConstantDef._get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_name
   (SOM_Resolve(Self, cd.classObject, cd._get_name))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ConstantDef._set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_name
   (SOM_Resolve(Self, cd.classObject, cd._set_name))
     (Self, @LocalEnv, name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ConstantDef._get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_id
   (SOM_Resolve(Self, cd.classObject, cd._get_id))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ConstantDef._set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_id
   (SOM_Resolve(Self, cd.classObject, cd._set_id))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ConstantDef._get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._get_defined_in))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ConstantDef._set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._set_defined_in))
     (Self, @LocalEnv, defined_in);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ConstantDef._get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._get_somModifiers))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ConstantDef._set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._set_somModifiers))
     (Self, @LocalEnv, somModifiers);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function ConstantDef.Create: ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ConstantDef(SOMClass(NewClass).somNew);
end;

class function ConstantDef.InitInstance(Instance: Pointer): ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ConstantDef(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function ConstantDef.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function ConstantDef.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function ConstantDef.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function ConstantDef.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function ConstantDef.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function ConstantDef.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function ConstantDef.NewInstance: ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ConstantDef(SOMClass(NewClass).somNewNoInit);
end;

function ConstantDef.Clone: ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ConstantDef(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function ConstantDef.within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_within
   (SOM_Resolve(Self, cd.classObject, cd.within))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ConstantDef.describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_describe
   (SOM_Resolve(Self, cd.classObject, cd.describe))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ConstantDef.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ConstantDef.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ConstantDef.somDefaultCopyInit(var ctrl: Pointer; fromObj: ConstantDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somDefaultAssign(var ctrl: Pointer; fromObj: ConstantDef): ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ConstantDef(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ConstantDef.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ConstantDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ConstantDef.somDefaultVCopyInit(var ctrl: Pointer; fromObj: ConstantDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ConstantDef.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ConstantDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somDefaultConstAssign(var ctrl: Pointer; fromObj: ConstantDef): ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ConstantDef(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somDefaultVAssign(var ctrl: Pointer; fromObj: ConstantDef): ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ConstantDef(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somDefaultConstVAssign(var ctrl: Pointer; fromObj: ConstantDef): ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ConstantDef(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ConstantDef.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ConstantDef.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ConstantDef.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ConstantDef.somPrintSelf: ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ConstantDef(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ConstantDef.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ConstantDef.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function ConstantDef.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = ConstantDef then { invoked on class name literal }
  begin
    Result := SOMClass(ConstantDefClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function ConstantDef.NewClass: SOMClass;
begin
  if Self = ConstantDef then { invoked on class name literal }
  begin
    Result := SOMClass(ConstantDefClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(ConstantDefNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function ConstantDef.As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(Self);
end;

function ConstantDef.As_ConstantDef: ConstantDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function ConstantDef.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function ConstantDef.Supports(Instance: SOMObjectBase; out Obj: ConstantDef): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := ConstantDef(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  Container_MajorVersion = 2;
  Container_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ContainerNewClass(
  somtmajorVersion: integer4 = Container_MajorVersion;
  somtminorVersion: integer4 = Container_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'ContainerNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ContainerClassDataStructure = packed record
    classObject: SOMClass;
    contents,
    lookup_name,
    describe_contents: somMToken;
  end;
  PContainerClassDataStructure = ^ContainerClassDataStructure;

var
  SOMIR_DLL_ContainerClassData: PContainerClassDataStructure = nil;

function ContainerClassData: PContainerClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ContainerClassData) then
    Result := SOMIR_DLL_ContainerClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ContainerClassData, 'ContainerClassData');
    Result := SOMIR_DLL_ContainerClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ContainerCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PContainerCClassDataStructure = ^ContainerCClassDataStructure;

var
  SOMIR_DLL_ContainerCClassData: PContainerCClassDataStructure = nil;

function ContainerCClassData: PContainerCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ContainerCClassData) then
    Result := SOMIR_DLL_ContainerCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ContainerCClassData, 'ContainerCClassData');
    Result := SOMIR_DLL_ContainerCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function Container.Create: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Container(SOMClass(NewClass).somNew);
end;

class function Container.InitInstance(Instance: Pointer): Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Container(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function Container.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function Container.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function Container.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function Container.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function Container.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function Container.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function Container.NewInstance: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Container(SOMClass(NewClass).somNewNoInit);
end;

function Container.Clone: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Container(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: contents
 *)
type
  somTD_Container_contents = function(somSelf: SOMObjectBase{Container}; ev: PEnvironment; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; stdcall;

function Container.contents(limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_contents
   (SOM_Resolve(Self, cd.classObject, cd.contents))
     (Self, @LocalEnv, limit_type, exclude_inherited);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: lookup_name
 *)
type
  somTD_Container_lookup_name = function(somSelf: SOMObjectBase{Container}; ev: PEnvironment; search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; stdcall;

function Container.lookup_name(search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_lookup_name
   (SOM_Resolve(Self, cd.classObject, cd.lookup_name))
     (Self, @LocalEnv, search_name, levels_to_search, limit_type, exclude_inherited);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: describe_contents
 *)
type
  somTD_Container_describe_contents = function(somSelf: SOMObjectBase{Container}; ev: PEnvironment; limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; stdcall;

function Container.describe_contents(limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_describe_contents
   (SOM_Resolve(Self, cd.classObject, cd.describe_contents))
     (Self, @LocalEnv, limit_type, exclude_inherited, max_returned_objs);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure Container.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Container.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Container.somDefaultCopyInit(var ctrl: Pointer; fromObj: Container); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somDefaultAssign(var ctrl: Pointer; fromObj: Container): Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Container(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Container.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Container); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Container.somDefaultVCopyInit(var ctrl: Pointer; fromObj: Container); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Container.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Container); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somDefaultConstAssign(var ctrl: Pointer; fromObj: Container): Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Container(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somDefaultVAssign(var ctrl: Pointer; fromObj: Container): Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Container(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somDefaultConstVAssign(var ctrl: Pointer; fromObj: Container): Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Container(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Container.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Container.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Container.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Container.somPrintSelf: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Container(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Container.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Container.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function Container.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = Container then { invoked on class name literal }
  begin
    Result := SOMClass(ContainerClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function Container.NewClass: SOMClass;
begin
  if Self = Container then { invoked on class name literal }
  begin
    Result := SOMClass(ContainerClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(ContainerNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function Container.As_Container: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function Container.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function Container.Supports(Instance: SOMObjectBase; out Obj: Container): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := Container(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMEEMan_MajorVersion = 2;
  SOMEEMan_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMEEManNewClass(
  somtmajorVersion: integer4 = SOMEEMan_MajorVersion;
  somtminorVersion: integer4 = SOMEEMan_MinorVersion):
  SOMClass; stdcall; external SOMEM_DLL_Name name 'SOMEEManNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMEEManClassDataStructure = packed record
    classObject: SOMClass;
    someGetEManSem,
    someReleaseEManSem,
    someChangeRegData,
    someProcessEvent,
    someProcessEvents,
    someQueueEvent,
    someRegister,
    someRegisterEv,
    someRegisterProc,
    someShutdown,
    someUnRegister: somMToken;
  end;
  PSOMEEManClassDataStructure = ^SOMEEManClassDataStructure;

var
  SOMEM_DLL_SOMEEManClassData: PSOMEEManClassDataStructure = nil;

function SOMEEManClassData: PSOMEEManClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMEEManClassData) then
    Result := SOMEM_DLL_SOMEEManClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMEEManClassData, 'SOMEEManClassData');
    Result := SOMEM_DLL_SOMEEManClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMEEManCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMEEManCClassDataStructure = ^SOMEEManCClassDataStructure;

var
  SOMEM_DLL_SOMEEManCClassData: PSOMEEManCClassDataStructure = nil;

function SOMEEManCClassData: PSOMEEManCClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMEEManCClassData) then
    Result := SOMEM_DLL_SOMEEManCClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMEEManCClassData, 'SOMEEManCClassData');
    Result := SOMEM_DLL_SOMEEManCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMEEMan.Create: SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEMan(SOMClass(NewClass).somNew);
end;

class function SOMEEMan.InitInstance(Instance: Pointer): SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEMan(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMEEMan.ClassType: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMObject(Self).somGetClass);
end;

class function SOMEEMan.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMEEMan.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMEEMan.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMEEMan.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMEEMan.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMEEMan.NewInstance: SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEMan(SOMClass(NewClass).somNewNoInit);
end;

function SOMEEMan.Clone: SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEMan(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: someGetEManSem
 *)
type
  somTD_SOMEEMan_someGetEManSem = procedure(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment); stdcall;

procedure SOMEEMan.someGetEManSem; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMan_someGetEManSem
   (SOM_Resolve(Self, cd.classObject, cd.someGetEManSem))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someReleaseEManSem
 *)
type
  somTD_SOMEEMan_someReleaseEManSem = procedure(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment); stdcall;

procedure SOMEEMan.someReleaseEManSem; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMan_someReleaseEManSem
   (SOM_Resolve(Self, cd.classObject, cd.someReleaseEManSem))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someChangeRegData
 *)
type
  somTD_SOMEEMan_someChangeRegData = procedure(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment; registrationId: LongInt; registerData: SOMEEMRegisterData); stdcall;

procedure SOMEEMan.someChangeRegData(registrationId: LongInt; registerData: SOMEEMRegisterData); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMan_someChangeRegData
   (SOM_Resolve(Self, cd.classObject, cd.someChangeRegData))
     (Self, @LocalEnv, registrationId, registerData);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someProcessEvent
 *)
type
  somTD_SOMEEMan_someProcessEvent = procedure(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment; mask: LongWord); stdcall;

procedure SOMEEMan.someProcessEvent(mask: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMan_someProcessEvent
   (SOM_Resolve(Self, cd.classObject, cd.someProcessEvent))
     (Self, @LocalEnv, mask);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someProcessEvents
 *)
type
  somTD_SOMEEMan_someProcessEvents = procedure(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment); stdcall;

procedure SOMEEMan.someProcessEvents; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMan_someProcessEvents
   (SOM_Resolve(Self, cd.classObject, cd.someProcessEvents))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someQueueEvent
 *)
type
  somTD_SOMEEMan_someQueueEvent = procedure(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment; event: SOMEClientEvent); stdcall;

procedure SOMEEMan.someQueueEvent(event: SOMEClientEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMan_someQueueEvent
   (SOM_Resolve(Self, cd.classObject, cd.someQueueEvent))
     (Self, @LocalEnv, event);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someRegister
 *)
type
  somTD_SOMEEMan_someRegister = function(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment; registerData: SOMEEMRegisterData; targetObject: SOMObject; targetMethod: CORBAString; targetData: Pointer): LongInt; stdcall;

function SOMEEMan.someRegister(registerData: SOMEEMRegisterData; targetObject: SOMObject; targetMethod: CORBAString; targetData: Pointer): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEMan_someRegister
   (SOM_Resolve(Self, cd.classObject, cd.someRegister))
     (Self, @LocalEnv, registerData, targetObject, targetMethod, targetData);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someRegisterEv
 *)
type
  somTD_SOMEEMan_someRegisterEv = function(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment; registerData: SOMEEMRegisterData; targetObject: SOMObject; var callbackEv: Environment; targetMethod: CORBAString; targetData: Pointer): LongInt; stdcall;

function SOMEEMan.someRegisterEv(registerData: SOMEEMRegisterData; targetObject: SOMObject; var callbackEv: Environment; targetMethod: CORBAString; targetData: Pointer): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEMan_someRegisterEv
   (SOM_Resolve(Self, cd.classObject, cd.someRegisterEv))
     (Self, @LocalEnv, registerData, targetObject, callbackEv, targetMethod, targetData);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someRegisterProc
 *)
type
  somTD_SOMEEMan_someRegisterProc = function(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment; registerData: SOMEEMRegisterData; targetProcedure: PPointer; targetData: Pointer): LongInt; stdcall;

function SOMEEMan.someRegisterProc(registerData: SOMEEMRegisterData; targetProcedure: PPointer; targetData: Pointer): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEMan_someRegisterProc
   (SOM_Resolve(Self, cd.classObject, cd.someRegisterProc))
     (Self, @LocalEnv, registerData, targetProcedure, targetData);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someShutdown
 *)
type
  somTD_SOMEEMan_someShutdown = procedure(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment); stdcall;

procedure SOMEEMan.someShutdown; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMan_someShutdown
   (SOM_Resolve(Self, cd.classObject, cd.someShutdown))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someUnRegister
 *)
type
  somTD_SOMEEMan_someUnRegister = procedure(somSelf: SOMObjectBase{SOMEEMan}; ev: PEnvironment; registrationId: LongInt); stdcall;

procedure SOMEEMan.someUnRegister(registrationId: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEManClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEManClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMan_someUnRegister
   (SOM_Resolve(Self, cd.classObject, cd.someUnRegister))
     (Self, @LocalEnv, registrationId);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMEEMan.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMan.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMan.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMEEMan); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somDefaultAssign(var ctrl: Pointer; fromObj: SOMEEMan): SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEMan(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMan.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMEEMan); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMan.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMEEMan); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMan.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMEEMan); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMEEMan): SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEMan(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMEEMan): SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEMan(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMEEMan): SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEMan(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMan.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMan.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMan.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMan.somPrintSelf: SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEMan(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMan.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMan.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMEEMan.ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMEEMan then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(SOMEEManClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

class function SOMEEMan.NewClass: SOMMSingleInstance;
begin
  if Self = SOMEEMan then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(SOMEEManClassData.classObject);
    if not Assigned(Result) then Result := SOMMSingleInstance(SOMEEManNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

function SOMEEMan.As_SOMEEMan: SOMEEMan; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMEEMan.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMEEMan.Supports(Instance: SOMObjectBase; out Obj: SOMEEMan): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMEEMan(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMEEMRegisterData_MajorVersion = 2;
  SOMEEMRegisterData_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMEEMRegisterDataNewClass(
  somtmajorVersion: integer4 = SOMEEMRegisterData_MajorVersion;
  somtminorVersion: integer4 = SOMEEMRegisterData_MinorVersion):
  SOMClass; stdcall; external SOMEM_DLL_Name name 'SOMEEMRegisterDataNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMEEMRegisterDataClassDataStructure = packed record
    classObject: SOMClass;
    someClearRegData,
    someSetRegDataClientType,
    someSetRegDataEventMask,
    someSetRegDataSink,
    someSetRegDataSinkMask,
    someSetRegDataTimerCount,
    someSetRegDataTimerInterval: somMToken;
  end;
  PSOMEEMRegisterDataClassDataStructure = ^SOMEEMRegisterDataClassDataStructure;

var
  SOMEM_DLL_SOMEEMRegisterDataClassData: PSOMEEMRegisterDataClassDataStructure = nil;

function SOMEEMRegisterDataClassData: PSOMEEMRegisterDataClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMEEMRegisterDataClassData) then
    Result := SOMEM_DLL_SOMEEMRegisterDataClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMEEMRegisterDataClassData, 'SOMEEMRegisterDataClassData');
    Result := SOMEM_DLL_SOMEEMRegisterDataClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMEEMRegisterDataCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMEEMRegisterDataCClassDataStructure = ^SOMEEMRegisterDataCClassDataStructure;

var
  SOMEM_DLL_SOMEEMRegisterDataCClassData: PSOMEEMRegisterDataCClassDataStructure = nil;

function SOMEEMRegisterDataCClassData: PSOMEEMRegisterDataCClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMEEMRegisterDataCClassData) then
    Result := SOMEM_DLL_SOMEEMRegisterDataCClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMEEMRegisterDataCClassData, 'SOMEEMRegisterDataCClassData');
    Result := SOMEM_DLL_SOMEEMRegisterDataCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMEEMRegisterData.Create: SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEMRegisterData(SOMClass(NewClass).somNew);
end;

class function SOMEEMRegisterData.InitInstance(Instance: Pointer): SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEMRegisterData(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMEEMRegisterData.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMEEMRegisterData.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMEEMRegisterData.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMEEMRegisterData.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMEEMRegisterData.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMEEMRegisterData.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMEEMRegisterData.NewInstance: SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEMRegisterData(SOMClass(NewClass).somNewNoInit);
end;

function SOMEEMRegisterData.Clone: SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEMRegisterData(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: someClearRegData
 *)
type
  somTD_SOMEEMRegisterData_someClearRegData = procedure(somSelf: SOMObjectBase{SOMEEMRegisterData}; ev: PEnvironment); stdcall;

procedure SOMEEMRegisterData.someClearRegData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEMRegisterDataClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEMRegisterDataClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMRegisterData_someClearRegData
   (SOM_Resolve(Self, cd.classObject, cd.someClearRegData))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someSetRegDataClientType
 *)
type
  somTD_SOMEEMRegisterData_someSetRegDataClientType = procedure(somSelf: SOMObjectBase{SOMEEMRegisterData}; ev: PEnvironment; clientType: CORBAString); stdcall;

procedure SOMEEMRegisterData.someSetRegDataClientType(clientType: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEMRegisterDataClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEMRegisterDataClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMRegisterData_someSetRegDataClientType
   (SOM_Resolve(Self, cd.classObject, cd.someSetRegDataClientType))
     (Self, @LocalEnv, clientType);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someSetRegDataEventMask
 *)
type
  somTD_SOMEEMRegisterData_someSetRegDataEventMask = procedure(somSelf: SOMObjectBase{SOMEEMRegisterData}; ev: PEnvironment; eventType: LongInt; ap: va_list); stdcall;

procedure SOMEEMRegisterData.someSetRegDataEventMask(eventType: LongInt; ap: va_list); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEMRegisterDataClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEMRegisterDataClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMRegisterData_someSetRegDataEventMask
   (SOM_Resolve(Self, cd.classObject, cd.someSetRegDataEventMask))
     (Self, @LocalEnv, eventType, ap);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someSetRegDataSink
 *)
type
  somTD_SOMEEMRegisterData_someSetRegDataSink = procedure(somSelf: SOMObjectBase{SOMEEMRegisterData}; ev: PEnvironment; sink: LongInt); stdcall;

procedure SOMEEMRegisterData.someSetRegDataSink(sink: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEMRegisterDataClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEMRegisterDataClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMRegisterData_someSetRegDataSink
   (SOM_Resolve(Self, cd.classObject, cd.someSetRegDataSink))
     (Self, @LocalEnv, sink);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someSetRegDataSinkMask
 *)
type
  somTD_SOMEEMRegisterData_someSetRegDataSinkMask = procedure(somSelf: SOMObjectBase{SOMEEMRegisterData}; ev: PEnvironment; sinkMask: LongWord); stdcall;

procedure SOMEEMRegisterData.someSetRegDataSinkMask(sinkMask: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEMRegisterDataClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEMRegisterDataClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMRegisterData_someSetRegDataSinkMask
   (SOM_Resolve(Self, cd.classObject, cd.someSetRegDataSinkMask))
     (Self, @LocalEnv, sinkMask);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someSetRegDataTimerCount
 *)
type
  somTD_SOMEEMRegisterData_someSetRegDataTimerCount = procedure(somSelf: SOMObjectBase{SOMEEMRegisterData}; ev: PEnvironment; count: LongInt); stdcall;

procedure SOMEEMRegisterData.someSetRegDataTimerCount(count: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEMRegisterDataClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEMRegisterDataClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMRegisterData_someSetRegDataTimerCount
   (SOM_Resolve(Self, cd.classObject, cd.someSetRegDataTimerCount))
     (Self, @LocalEnv, count);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: someSetRegDataTimerInterval
 *)
type
  somTD_SOMEEMRegisterData_someSetRegDataTimerInterval = procedure(somSelf: SOMObjectBase{SOMEEMRegisterData}; ev: PEnvironment; interval: LongInt); stdcall;

procedure SOMEEMRegisterData.someSetRegDataTimerInterval(interval: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEMRegisterDataClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEMRegisterDataClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEMRegisterData_someSetRegDataTimerInterval
   (SOM_Resolve(Self, cd.classObject, cd.someSetRegDataTimerInterval))
     (Self, @LocalEnv, interval);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMEEMRegisterData.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMRegisterData.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMRegisterData.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMEEMRegisterData); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somDefaultAssign(var ctrl: Pointer; fromObj: SOMEEMRegisterData): SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEMRegisterData(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMRegisterData.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMEEMRegisterData); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMRegisterData.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMEEMRegisterData); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMRegisterData.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMEEMRegisterData); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMEEMRegisterData): SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEMRegisterData(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMEEMRegisterData): SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEMRegisterData(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMEEMRegisterData): SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEMRegisterData(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMRegisterData.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMRegisterData.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMRegisterData.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEEMRegisterData.somPrintSelf: SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEEMRegisterData(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMRegisterData.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEEMRegisterData.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMEEMRegisterData.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMEEMRegisterData then { invoked on class name literal }
  begin
    Result := SOMClass(SOMEEMRegisterDataClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMEEMRegisterData.NewClass: SOMClass;
begin
  if Self = SOMEEMRegisterData then { invoked on class name literal }
  begin
    Result := SOMClass(SOMEEMRegisterDataClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMEEMRegisterDataNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMEEMRegisterData.As_SOMEEMRegisterData: SOMEEMRegisterData; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMEEMRegisterData.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMEEMRegisterData.Supports(Instance: SOMObjectBase; out Obj: SOMEEMRegisterData): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMEEMRegisterData(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  ExceptionDef_MajorVersion = 2;
  ExceptionDef_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ExceptionDefNewClass(
  somtmajorVersion: integer4 = ExceptionDef_MajorVersion;
  somtminorVersion: integer4 = ExceptionDef_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'ExceptionDefNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ExceptionDefClassDataStructure = packed record
    classObject: SOMClass;
    _get_type,
    _set_type: somMToken;
  end;
  PExceptionDefClassDataStructure = ^ExceptionDefClassDataStructure;

var
  SOMIR_DLL_ExceptionDefClassData: PExceptionDefClassDataStructure = nil;

function ExceptionDefClassData: PExceptionDefClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ExceptionDefClassData) then
    Result := SOMIR_DLL_ExceptionDefClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ExceptionDefClassData, 'ExceptionDefClassData');
    Result := SOMIR_DLL_ExceptionDefClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ExceptionDefCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PExceptionDefCClassDataStructure = ^ExceptionDefCClassDataStructure;

var
  SOMIR_DLL_ExceptionDefCClassData: PExceptionDefCClassDataStructure = nil;

function ExceptionDefCClassData: PExceptionDefCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ExceptionDefCClassData) then
    Result := SOMIR_DLL_ExceptionDefCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ExceptionDefCClassData, 'ExceptionDefCClassData');
    Result := SOMIR_DLL_ExceptionDefCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_type
 *)
type
  somTD_ExceptionDef__get_type = function(somSelf: SOMObjectBase{ExceptionDef}; ev: PEnvironment): TypeCode; stdcall;

function ExceptionDef._get_type: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PExceptionDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ExceptionDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ExceptionDef__get_type
   (SOM_Resolve(Self, cd.classObject, cd._get_type))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_type
 *)
type
  somTD_ExceptionDef__set_type = procedure(somSelf: SOMObjectBase{ExceptionDef}; ev: PEnvironment; SOM_type: {caller_owns} TypeCode); stdcall;

procedure ExceptionDef._set_type(SOM_type: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PExceptionDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ExceptionDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ExceptionDef__set_type
   (SOM_Resolve(Self, cd.classObject, cd._set_type))
     (Self, @LocalEnv, SOM_type);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ExceptionDef._get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_name
   (SOM_Resolve(Self, cd.classObject, cd._get_name))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ExceptionDef._set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_name
   (SOM_Resolve(Self, cd.classObject, cd._set_name))
     (Self, @LocalEnv, name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ExceptionDef._get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_id
   (SOM_Resolve(Self, cd.classObject, cd._get_id))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ExceptionDef._set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_id
   (SOM_Resolve(Self, cd.classObject, cd._set_id))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ExceptionDef._get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._get_defined_in))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ExceptionDef._set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._set_defined_in))
     (Self, @LocalEnv, defined_in);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ExceptionDef._get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._get_somModifiers))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ExceptionDef._set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._set_somModifiers))
     (Self, @LocalEnv, somModifiers);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function ExceptionDef.Create: ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ExceptionDef(SOMClass(NewClass).somNew);
end;

class function ExceptionDef.InitInstance(Instance: Pointer): ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ExceptionDef(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function ExceptionDef.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function ExceptionDef.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function ExceptionDef.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function ExceptionDef.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function ExceptionDef.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function ExceptionDef.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function ExceptionDef.NewInstance: ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ExceptionDef(SOMClass(NewClass).somNewNoInit);
end;

function ExceptionDef.Clone: ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ExceptionDef(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function ExceptionDef.within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_within
   (SOM_Resolve(Self, cd.classObject, cd.within))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ExceptionDef.describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_describe
   (SOM_Resolve(Self, cd.classObject, cd.describe))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ExceptionDef.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ExceptionDef.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ExceptionDef.somDefaultCopyInit(var ctrl: Pointer; fromObj: ExceptionDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somDefaultAssign(var ctrl: Pointer; fromObj: ExceptionDef): ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ExceptionDef(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ExceptionDef.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ExceptionDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ExceptionDef.somDefaultVCopyInit(var ctrl: Pointer; fromObj: ExceptionDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ExceptionDef.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ExceptionDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somDefaultConstAssign(var ctrl: Pointer; fromObj: ExceptionDef): ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ExceptionDef(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somDefaultVAssign(var ctrl: Pointer; fromObj: ExceptionDef): ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ExceptionDef(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somDefaultConstVAssign(var ctrl: Pointer; fromObj: ExceptionDef): ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ExceptionDef(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ExceptionDef.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ExceptionDef.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ExceptionDef.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ExceptionDef.somPrintSelf: ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ExceptionDef(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ExceptionDef.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ExceptionDef.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function ExceptionDef.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = ExceptionDef then { invoked on class name literal }
  begin
    Result := SOMClass(ExceptionDefClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function ExceptionDef.NewClass: SOMClass;
begin
  if Self = ExceptionDef then { invoked on class name literal }
  begin
    Result := SOMClass(ExceptionDefClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(ExceptionDefNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function ExceptionDef.As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(Self);
end;

function ExceptionDef.As_ExceptionDef: ExceptionDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function ExceptionDef.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function ExceptionDef.Supports(Instance: SOMObjectBase; out Obj: ExceptionDef): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := ExceptionDef(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  ImplementationDef_MajorVersion = 2;
  ImplementationDef_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ImplementationDefNewClass(
  somtmajorVersion: integer4 = ImplementationDef_MajorVersion;
  somtminorVersion: integer4 = ImplementationDef_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'ImplementationDefNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ImplementationDefClassDataStructure = packed record
    classObject: SOMClass;
    _set_impl_id,
    _get_impl_id,
    _set_impl_alias,
    _get_impl_alias,
    _set_impl_program,
    _get_impl_program,
    _set_impl_flags,
    _get_impl_flags,
    _set_impl_server_class,
    _get_impl_server_class,
    _set_impl_socket_class,
    _get_impl_socket_class,
    _set_impl_refdata_file,
    _get_impl_refdata_file,
    _set_impl_refdata_bkup,
    _get_impl_refdata_bkup,
    _set_impl_hostname,
    _get_impl_hostname,
    _set_impl_def_struct,
    _get_impl_def_struct,
    get_impl_winserver_handle: somMToken;
  end;
  PImplementationDefClassDataStructure = ^ImplementationDefClassDataStructure;

var
  SOMD_DLL_ImplementationDefClassData: PImplementationDefClassDataStructure = nil;

function ImplementationDefClassData: PImplementationDefClassDataStructure;
begin
  if Assigned(SOMD_DLL_ImplementationDefClassData) then
    Result := SOMD_DLL_ImplementationDefClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_ImplementationDefClassData, 'ImplementationDefClassData');
    Result := SOMD_DLL_ImplementationDefClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ImplementationDefCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PImplementationDefCClassDataStructure = ^ImplementationDefCClassDataStructure;

var
  SOMD_DLL_ImplementationDefCClassData: PImplementationDefCClassDataStructure = nil;

function ImplementationDefCClassData: PImplementationDefCClassDataStructure;
begin
  if Assigned(SOMD_DLL_ImplementationDefCClassData) then
    Result := SOMD_DLL_ImplementationDefCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_ImplementationDefCClassData, 'ImplementationDefCClassData');
    Result := SOMD_DLL_ImplementationDefCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_impl_id
 *)
type
  somTD_ImplementationDef__get_impl_id = function(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment): CORBAString; stdcall;

function ImplementationDef._get_impl_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplementationDef__get_impl_id
   (SOM_Resolve(Self, cd.classObject, cd._get_impl_id))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_impl_id
 *)
type
  somTD_ImplementationDef__set_impl_id = procedure(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment; impl_id: CORBAString); stdcall;

procedure ImplementationDef._set_impl_id(impl_id: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplementationDef__set_impl_id
   (SOM_Resolve(Self, cd.classObject, cd._set_impl_id))
     (Self, @LocalEnv, impl_id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_impl_alias
 *)
type
  somTD_ImplementationDef__get_impl_alias = function(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment): CORBAString; stdcall;

function ImplementationDef._get_impl_alias: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplementationDef__get_impl_alias
   (SOM_Resolve(Self, cd.classObject, cd._get_impl_alias))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_impl_alias
 *)
type
  somTD_ImplementationDef__set_impl_alias = procedure(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment; impl_alias: CORBAString); stdcall;

procedure ImplementationDef._set_impl_alias(impl_alias: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplementationDef__set_impl_alias
   (SOM_Resolve(Self, cd.classObject, cd._set_impl_alias))
     (Self, @LocalEnv, impl_alias);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_impl_program
 *)
type
  somTD_ImplementationDef__get_impl_program = function(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment): CORBAString; stdcall;

function ImplementationDef._get_impl_program: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplementationDef__get_impl_program
   (SOM_Resolve(Self, cd.classObject, cd._get_impl_program))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_impl_program
 *)
type
  somTD_ImplementationDef__set_impl_program = procedure(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment; impl_program: CORBAString); stdcall;

procedure ImplementationDef._set_impl_program(impl_program: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplementationDef__set_impl_program
   (SOM_Resolve(Self, cd.classObject, cd._set_impl_program))
     (Self, @LocalEnv, impl_program);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_impl_flags
 *)
type
  somTD_ImplementationDef__get_impl_flags = function(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment): LongWord; stdcall;

function ImplementationDef._get_impl_flags: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplementationDef__get_impl_flags
   (SOM_Resolve(Self, cd.classObject, cd._get_impl_flags))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_impl_flags
 *)
type
  somTD_ImplementationDef__set_impl_flags = procedure(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment; impl_flags: LongWord); stdcall;

procedure ImplementationDef._set_impl_flags(impl_flags: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplementationDef__set_impl_flags
   (SOM_Resolve(Self, cd.classObject, cd._set_impl_flags))
     (Self, @LocalEnv, impl_flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_impl_server_class
 *)
type
  somTD_ImplementationDef__get_impl_server_class = function(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment): CORBAString; stdcall;

function ImplementationDef._get_impl_server_class: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplementationDef__get_impl_server_class
   (SOM_Resolve(Self, cd.classObject, cd._get_impl_server_class))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_impl_server_class
 *)
type
  somTD_ImplementationDef__set_impl_server_class = procedure(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment; impl_server_class: CORBAString); stdcall;

procedure ImplementationDef._set_impl_server_class(impl_server_class: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplementationDef__set_impl_server_class
   (SOM_Resolve(Self, cd.classObject, cd._set_impl_server_class))
     (Self, @LocalEnv, impl_server_class);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_impl_refdata_file
 *)
type
  somTD_ImplementationDef__get_impl_refdata_file = function(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment): CORBAString; stdcall;

function ImplementationDef._get_impl_refdata_file: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplementationDef__get_impl_refdata_file
   (SOM_Resolve(Self, cd.classObject, cd._get_impl_refdata_file))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_impl_refdata_file
 *)
type
  somTD_ImplementationDef__set_impl_refdata_file = procedure(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment; impl_refdata_file: CORBAString); stdcall;

procedure ImplementationDef._set_impl_refdata_file(impl_refdata_file: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplementationDef__set_impl_refdata_file
   (SOM_Resolve(Self, cd.classObject, cd._set_impl_refdata_file))
     (Self, @LocalEnv, impl_refdata_file);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_impl_refdata_bkup
 *)
type
  somTD_ImplementationDef__get_impl_refdata_bkup = function(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment): CORBAString; stdcall;

function ImplementationDef._get_impl_refdata_bkup: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplementationDef__get_impl_refdata_bkup
   (SOM_Resolve(Self, cd.classObject, cd._get_impl_refdata_bkup))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_impl_refdata_bkup
 *)
type
  somTD_ImplementationDef__set_impl_refdata_bkup = procedure(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment; impl_refdata_bkup: CORBAString); stdcall;

procedure ImplementationDef._set_impl_refdata_bkup(impl_refdata_bkup: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplementationDef__set_impl_refdata_bkup
   (SOM_Resolve(Self, cd.classObject, cd._set_impl_refdata_bkup))
     (Self, @LocalEnv, impl_refdata_bkup);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_impl_hostname
 *)
type
  somTD_ImplementationDef__get_impl_hostname = function(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment): CORBAString; stdcall;

function ImplementationDef._get_impl_hostname: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplementationDef__get_impl_hostname
   (SOM_Resolve(Self, cd.classObject, cd._get_impl_hostname))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_impl_hostname
 *)
type
  somTD_ImplementationDef__set_impl_hostname = procedure(somSelf: SOMObjectBase{ImplementationDef}; ev: PEnvironment; impl_hostname: CORBAString); stdcall;

procedure ImplementationDef._set_impl_hostname(impl_hostname: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplementationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplementationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplementationDef__set_impl_hostname
   (SOM_Resolve(Self, cd.classObject, cd._set_impl_hostname))
     (Self, @LocalEnv, impl_hostname);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function ImplementationDef.Create: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ImplementationDef(SOMClass(NewClass).somNew);
end;

class function ImplementationDef.InitInstance(Instance: Pointer): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ImplementationDef(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function ImplementationDef.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function ImplementationDef.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function ImplementationDef.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function ImplementationDef.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function ImplementationDef.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function ImplementationDef.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function ImplementationDef.NewInstance: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ImplementationDef(SOMClass(NewClass).somNewNoInit);
end;

function ImplementationDef.Clone: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ImplementationDef(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

procedure ImplementationDef.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplementationDef.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplementationDef.somDefaultCopyInit(var ctrl: Pointer; fromObj: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somDefaultAssign(var ctrl: Pointer; fromObj: ImplementationDef): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ImplementationDef(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplementationDef.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplementationDef.somDefaultVCopyInit(var ctrl: Pointer; fromObj: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplementationDef.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somDefaultConstAssign(var ctrl: Pointer; fromObj: ImplementationDef): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ImplementationDef(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somDefaultVAssign(var ctrl: Pointer; fromObj: ImplementationDef): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ImplementationDef(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somDefaultConstVAssign(var ctrl: Pointer; fromObj: ImplementationDef): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ImplementationDef(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplementationDef.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplementationDef.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplementationDef.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplementationDef.somPrintSelf: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ImplementationDef(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplementationDef.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplementationDef.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function ImplementationDef.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = ImplementationDef then { invoked on class name literal }
  begin
    Result := SOMClass(ImplementationDefClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function ImplementationDef.NewClass: SOMClass;
begin
  if Self = ImplementationDef then { invoked on class name literal }
  begin
    Result := SOMClass(ImplementationDefClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(ImplementationDefNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function ImplementationDef.As_ImplementationDef: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function ImplementationDef.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function ImplementationDef.Supports(Instance: SOMObjectBase; out Obj: ImplementationDef): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := ImplementationDef(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  ImplRepository_MajorVersion = 2;
  ImplRepository_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ImplRepositoryNewClass(
  somtmajorVersion: integer4 = ImplRepository_MajorVersion;
  somtminorVersion: integer4 = ImplRepository_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'ImplRepositoryNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ImplRepositoryClassDataStructure = packed record
    classObject: SOMClass;
    find_impldef,
    find_impldef_by_alias,
    find_impldef2,
    find_impldef_by_alias2,
    find_impldef_by_class,
    add_impldef,
    update_impldef,
    delete_impldef,
    add_class_to_impldef,
    remove_class_from_impldef,
    remove_class_from_all,
    find_classes_by_impldef,
    implr_get_impl,
    implr_search_impl,
    implr_search_class,
    implr_update_impl,
    find_all_impldefs: somMToken;
  end;
  PImplRepositoryClassDataStructure = ^ImplRepositoryClassDataStructure;

var
  SOMD_DLL_ImplRepositoryClassData: PImplRepositoryClassDataStructure = nil;

function ImplRepositoryClassData: PImplRepositoryClassDataStructure;
begin
  if Assigned(SOMD_DLL_ImplRepositoryClassData) then
    Result := SOMD_DLL_ImplRepositoryClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_ImplRepositoryClassData, 'ImplRepositoryClassData');
    Result := SOMD_DLL_ImplRepositoryClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ImplRepositoryCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PImplRepositoryCClassDataStructure = ^ImplRepositoryCClassDataStructure;

var
  SOMD_DLL_ImplRepositoryCClassData: PImplRepositoryCClassDataStructure = nil;

function ImplRepositoryCClassData: PImplRepositoryCClassDataStructure;
begin
  if Assigned(SOMD_DLL_ImplRepositoryCClassData) then
    Result := SOMD_DLL_ImplRepositoryCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_ImplRepositoryCClassData, 'ImplRepositoryCClassData');
    Result := SOMD_DLL_ImplRepositoryCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function ImplRepository.Create: ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ImplRepository(SOMClass(NewClass).somNew);
end;

class function ImplRepository.InitInstance(Instance: Pointer): ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ImplRepository(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function ImplRepository.ClassType: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMObject(Self).somGetClass);
end;

class function ImplRepository.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function ImplRepository.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function ImplRepository.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function ImplRepository.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function ImplRepository.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function ImplRepository.NewInstance: ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ImplRepository(SOMClass(NewClass).somNewNoInit);
end;

function ImplRepository.Clone: ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ImplRepository(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: find_impldef
 *)
type
  somTD_ImplRepository_find_impldef = function(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; implid: CORBAString): ImplementationDef; stdcall;

function ImplRepository.find_impldef(implid: CORBAString): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplRepository_find_impldef
   (SOM_Resolve(Self, cd.classObject, cd.find_impldef))
     (Self, @LocalEnv, implid);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: find_impldef_by_alias
 *)
type
  somTD_ImplRepository_find_impldef_by_alias = function(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; alias_name: CORBAString): ImplementationDef; stdcall;

function ImplRepository.find_impldef_by_alias(alias_name: CORBAString): ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplRepository_find_impldef_by_alias
   (SOM_Resolve(Self, cd.classObject, cd.find_impldef_by_alias))
     (Self, @LocalEnv, alias_name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: find_all_impldefs
 *)
type
  somTD_ImplRepository_find_all_impldefs = function(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; out outimpldefs: _IDL_Sequence_ImplementationDef): LongWord; stdcall;

function ImplRepository.find_all_impldefs(out outimpldefs: _IDL_Sequence_ImplementationDef): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplRepository_find_all_impldefs
   (SOM_Resolve(Self, cd.classObject, cd.find_all_impldefs))
     (Self, @LocalEnv, outimpldefs);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: find_impldef_by_class
 *)
type
  somTD_ImplRepository_find_impldef_by_class = function(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; classname: CORBAString): _IDL_Sequence_ImplementationDef; stdcall;

function ImplRepository.find_impldef_by_class(classname: CORBAString): _IDL_Sequence_ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplRepository_find_impldef_by_class
   (SOM_Resolve(Self, cd.classObject, cd.find_impldef_by_class))
     (Self, @LocalEnv, classname);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: add_impldef
 *)
type
  somTD_ImplRepository_add_impldef = procedure(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; impldef: ImplementationDef); stdcall;

procedure ImplRepository.add_impldef(impldef: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplRepository_add_impldef
   (SOM_Resolve(Self, cd.classObject, cd.add_impldef))
     (Self, @LocalEnv, impldef);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: update_impldef
 *)
type
  somTD_ImplRepository_update_impldef = procedure(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; impldef: ImplementationDef); stdcall;

procedure ImplRepository.update_impldef(impldef: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplRepository_update_impldef
   (SOM_Resolve(Self, cd.classObject, cd.update_impldef))
     (Self, @LocalEnv, impldef);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: delete_impldef
 *)
type
  somTD_ImplRepository_delete_impldef = procedure(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; implid: CORBAString); stdcall;

procedure ImplRepository.delete_impldef(implid: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplRepository_delete_impldef
   (SOM_Resolve(Self, cd.classObject, cd.delete_impldef))
     (Self, @LocalEnv, implid);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: add_class_to_impldef
 *)
type
  somTD_ImplRepository_add_class_to_impldef = procedure(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; implid: CORBAString; classname: CORBAString); stdcall;

procedure ImplRepository.add_class_to_impldef(implid: CORBAString; classname: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplRepository_add_class_to_impldef
   (SOM_Resolve(Self, cd.classObject, cd.add_class_to_impldef))
     (Self, @LocalEnv, implid, classname);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: remove_class_from_impldef
 *)
type
  somTD_ImplRepository_remove_class_from_impldef = procedure(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; implid: CORBAString; classname: CORBAString); stdcall;

procedure ImplRepository.remove_class_from_impldef(implid: CORBAString; classname: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplRepository_remove_class_from_impldef
   (SOM_Resolve(Self, cd.classObject, cd.remove_class_from_impldef))
     (Self, @LocalEnv, implid, classname);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: remove_class_from_all
 *)
type
  somTD_ImplRepository_remove_class_from_all = procedure(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; classname: CORBAString); stdcall;

procedure ImplRepository.remove_class_from_all(classname: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ImplRepository_remove_class_from_all
   (SOM_Resolve(Self, cd.classObject, cd.remove_class_from_all))
     (Self, @LocalEnv, classname);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: find_classes_by_impldef
 *)
type
  somTD_ImplRepository_find_classes_by_impldef = function(somSelf: SOMObjectBase{ImplRepository}; ev: PEnvironment; implid: CORBAString): _IDL_Sequence_CORBAString; stdcall;

function ImplRepository.find_classes_by_impldef(implid: CORBAString): _IDL_Sequence_CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PImplRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ImplRepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ImplRepository_find_classes_by_impldef
   (SOM_Resolve(Self, cd.classObject, cd.find_classes_by_impldef))
     (Self, @LocalEnv, implid);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ImplRepository.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplRepository.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplRepository.somDefaultCopyInit(var ctrl: Pointer; fromObj: ImplRepository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somDefaultAssign(var ctrl: Pointer; fromObj: ImplRepository): ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ImplRepository(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplRepository.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ImplRepository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplRepository.somDefaultVCopyInit(var ctrl: Pointer; fromObj: ImplRepository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplRepository.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ImplRepository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somDefaultConstAssign(var ctrl: Pointer; fromObj: ImplRepository): ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ImplRepository(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somDefaultVAssign(var ctrl: Pointer; fromObj: ImplRepository): ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ImplRepository(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somDefaultConstVAssign(var ctrl: Pointer; fromObj: ImplRepository): ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ImplRepository(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplRepository.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplRepository.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplRepository.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ImplRepository.somPrintSelf: ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ImplRepository(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplRepository.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ImplRepository.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function ImplRepository.ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = ImplRepository then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(ImplRepositoryClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

class function ImplRepository.NewClass: SOMMSingleInstance;
begin
  if Self = ImplRepository then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(ImplRepositoryClassData.classObject);
    if not Assigned(Result) then Result := SOMMSingleInstance(ImplRepositoryNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

function ImplRepository.As_ImplRepository: ImplRepository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function ImplRepository.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function ImplRepository.Supports(Instance: SOMObjectBase; out Obj: ImplRepository): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := ImplRepository(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  InterfaceDef_MajorVersion = 2;
  InterfaceDef_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function InterfaceDefNewClass(
  somtmajorVersion: integer4 = InterfaceDef_MajorVersion;
  somtminorVersion: integer4 = InterfaceDef_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'InterfaceDefNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  InterfaceDefClassDataStructure = packed record
    classObject: SOMClass;
    describe_interface,
    _get_base_interfaces,
    _set_base_interfaces,
    _get_instanceData,
    _set_instanceData: somMToken;
  end;
  PInterfaceDefClassDataStructure = ^InterfaceDefClassDataStructure;

var
  SOMIR_DLL_InterfaceDefClassData: PInterfaceDefClassDataStructure = nil;

function InterfaceDefClassData: PInterfaceDefClassDataStructure;
begin
  if Assigned(SOMIR_DLL_InterfaceDefClassData) then
    Result := SOMIR_DLL_InterfaceDefClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_InterfaceDefClassData, 'InterfaceDefClassData');
    Result := SOMIR_DLL_InterfaceDefClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  InterfaceDefCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PInterfaceDefCClassDataStructure = ^InterfaceDefCClassDataStructure;

var
  SOMIR_DLL_InterfaceDefCClassData: PInterfaceDefCClassDataStructure = nil;

function InterfaceDefCClassData: PInterfaceDefCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_InterfaceDefCClassData) then
    Result := SOMIR_DLL_InterfaceDefCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_InterfaceDefCClassData, 'InterfaceDefCClassData');
    Result := SOMIR_DLL_InterfaceDefCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_base_interfaces
 *)
type
  somTD_InterfaceDef__get_base_interfaces = function(somSelf: SOMObjectBase{InterfaceDef}; ev: PEnvironment): _IDL_Sequence_CORBAString; stdcall;

function InterfaceDef._get_base_interfaces: _IDL_Sequence_CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PInterfaceDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := InterfaceDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_InterfaceDef__get_base_interfaces
   (SOM_Resolve(Self, cd.classObject, cd._get_base_interfaces))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_base_interfaces
 *)
type
  somTD_InterfaceDef__set_base_interfaces = procedure(somSelf: SOMObjectBase{InterfaceDef}; ev: PEnvironment; const base_interfaces: {caller_owns} _IDL_Sequence_CORBAString); stdcall;

procedure InterfaceDef._set_base_interfaces(const base_interfaces: {caller_owns} _IDL_Sequence_CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PInterfaceDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := InterfaceDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_InterfaceDef__set_base_interfaces
   (SOM_Resolve(Self, cd.classObject, cd._set_base_interfaces))
     (Self, @LocalEnv, base_interfaces);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_instanceData
 *)
type
  somTD_InterfaceDef__get_instanceData = function(somSelf: SOMObjectBase{InterfaceDef}; ev: PEnvironment): TypeCode; stdcall;

function InterfaceDef._get_instanceData: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PInterfaceDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := InterfaceDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_InterfaceDef__get_instanceData
   (SOM_Resolve(Self, cd.classObject, cd._get_instanceData))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_instanceData
 *)
type
  somTD_InterfaceDef__set_instanceData = procedure(somSelf: SOMObjectBase{InterfaceDef}; ev: PEnvironment; instanceData: {caller_owns} TypeCode); stdcall;

procedure InterfaceDef._set_instanceData(instanceData: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PInterfaceDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := InterfaceDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_InterfaceDef__set_instanceData
   (SOM_Resolve(Self, cd.classObject, cd._set_instanceData))
     (Self, @LocalEnv, instanceData);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function InterfaceDef._get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_name
   (SOM_Resolve(Self, cd.classObject, cd._get_name))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure InterfaceDef._set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_name
   (SOM_Resolve(Self, cd.classObject, cd._set_name))
     (Self, @LocalEnv, name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function InterfaceDef._get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_id
   (SOM_Resolve(Self, cd.classObject, cd._get_id))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure InterfaceDef._set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_id
   (SOM_Resolve(Self, cd.classObject, cd._set_id))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function InterfaceDef._get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._get_defined_in))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure InterfaceDef._set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._set_defined_in))
     (Self, @LocalEnv, defined_in);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function InterfaceDef._get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._get_somModifiers))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure InterfaceDef._set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._set_somModifiers))
     (Self, @LocalEnv, somModifiers);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function InterfaceDef.Create: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := InterfaceDef(SOMClass(NewClass).somNew);
end;

class function InterfaceDef.InitInstance(Instance: Pointer): InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := InterfaceDef(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function InterfaceDef.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function InterfaceDef.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function InterfaceDef.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function InterfaceDef.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function InterfaceDef.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function InterfaceDef.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function InterfaceDef.NewInstance: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := InterfaceDef(SOMClass(NewClass).somNewNoInit);
end;

function InterfaceDef.Clone: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := InterfaceDef(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: describe_interface
 *)
type
  somTD_InterfaceDef_describe_interface = function(somSelf: SOMObjectBase{InterfaceDef}; ev: PEnvironment): InterfaceDef_FullInterfaceDescription; stdcall;

function InterfaceDef.describe_interface: InterfaceDef_FullInterfaceDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PInterfaceDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := InterfaceDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_InterfaceDef_describe_interface
   (SOM_Resolve(Self, cd.classObject, cd.describe_interface))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function InterfaceDef.within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_within
   (SOM_Resolve(Self, cd.classObject, cd.within))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function InterfaceDef.describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_describe
   (SOM_Resolve(Self, cd.classObject, cd.describe))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure InterfaceDef.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure InterfaceDef.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure InterfaceDef.somDefaultCopyInit(var ctrl: Pointer; fromObj: InterfaceDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somDefaultAssign(var ctrl: Pointer; fromObj: InterfaceDef): InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := InterfaceDef(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure InterfaceDef.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: InterfaceDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure InterfaceDef.somDefaultVCopyInit(var ctrl: Pointer; fromObj: InterfaceDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure InterfaceDef.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: InterfaceDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somDefaultConstAssign(var ctrl: Pointer; fromObj: InterfaceDef): InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := InterfaceDef(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somDefaultVAssign(var ctrl: Pointer; fromObj: InterfaceDef): InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := InterfaceDef(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somDefaultConstVAssign(var ctrl: Pointer; fromObj: InterfaceDef): InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := InterfaceDef(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure InterfaceDef.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure InterfaceDef.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure InterfaceDef.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.somPrintSelf: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := InterfaceDef(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure InterfaceDef.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure InterfaceDef.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function InterfaceDef.contents(limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_contents
   (SOM_Resolve(Self, cd.classObject, cd.contents))
     (Self, @LocalEnv, limit_type, exclude_inherited);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function InterfaceDef.lookup_name(search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_lookup_name
   (SOM_Resolve(Self, cd.classObject, cd.lookup_name))
     (Self, @LocalEnv, search_name, levels_to_search, limit_type, exclude_inherited);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function InterfaceDef.describe_contents(limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_describe_contents
   (SOM_Resolve(Self, cd.classObject, cd.describe_contents))
     (Self, @LocalEnv, limit_type, exclude_inherited, max_returned_objs);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function InterfaceDef.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = InterfaceDef then { invoked on class name literal }
  begin
    Result := SOMClass(InterfaceDefClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function InterfaceDef.NewClass: SOMClass;
begin
  if Self = InterfaceDef then { invoked on class name literal }
  begin
    Result := SOMClass(InterfaceDefClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(InterfaceDefNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function InterfaceDef.As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(Self);
end;

function InterfaceDef.As_Container: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Container(Self);
end;

function InterfaceDef.As_InterfaceDef: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function InterfaceDef.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function InterfaceDef.Supports(Instance: SOMObjectBase; out Obj: InterfaceDef): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := InterfaceDef(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  ModuleDef_MajorVersion = 2;
  ModuleDef_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ModuleDefNewClass(
  somtmajorVersion: integer4 = ModuleDef_MajorVersion;
  somtminorVersion: integer4 = ModuleDef_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'ModuleDefNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ModuleDefClassDataStructure = packed record
    classObject: SOMClass;
  end;
  PModuleDefClassDataStructure = ^ModuleDefClassDataStructure;

var
  SOMIR_DLL_ModuleDefClassData: PModuleDefClassDataStructure = nil;

function ModuleDefClassData: PModuleDefClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ModuleDefClassData) then
    Result := SOMIR_DLL_ModuleDefClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ModuleDefClassData, 'ModuleDefClassData');
    Result := SOMIR_DLL_ModuleDefClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ModuleDefCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PModuleDefCClassDataStructure = ^ModuleDefCClassDataStructure;

var
  SOMIR_DLL_ModuleDefCClassData: PModuleDefCClassDataStructure = nil;

function ModuleDefCClassData: PModuleDefCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ModuleDefCClassData) then
    Result := SOMIR_DLL_ModuleDefCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ModuleDefCClassData, 'ModuleDefCClassData');
    Result := SOMIR_DLL_ModuleDefCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

function ModuleDef._get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_name
   (SOM_Resolve(Self, cd.classObject, cd._get_name))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ModuleDef._set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_name
   (SOM_Resolve(Self, cd.classObject, cd._set_name))
     (Self, @LocalEnv, name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ModuleDef._get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_id
   (SOM_Resolve(Self, cd.classObject, cd._get_id))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ModuleDef._set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_id
   (SOM_Resolve(Self, cd.classObject, cd._set_id))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ModuleDef._get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._get_defined_in))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ModuleDef._set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._set_defined_in))
     (Self, @LocalEnv, defined_in);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ModuleDef._get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._get_somModifiers))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ModuleDef._set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._set_somModifiers))
     (Self, @LocalEnv, somModifiers);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function ModuleDef.Create: ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ModuleDef(SOMClass(NewClass).somNew);
end;

class function ModuleDef.InitInstance(Instance: Pointer): ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ModuleDef(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function ModuleDef.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function ModuleDef.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function ModuleDef.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function ModuleDef.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function ModuleDef.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function ModuleDef.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function ModuleDef.NewInstance: ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ModuleDef(SOMClass(NewClass).somNewNoInit);
end;

function ModuleDef.Clone: ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ModuleDef(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function ModuleDef.within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_within
   (SOM_Resolve(Self, cd.classObject, cd.within))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ModuleDef.describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_describe
   (SOM_Resolve(Self, cd.classObject, cd.describe))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ModuleDef.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ModuleDef.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ModuleDef.somDefaultCopyInit(var ctrl: Pointer; fromObj: ModuleDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somDefaultAssign(var ctrl: Pointer; fromObj: ModuleDef): ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ModuleDef(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ModuleDef.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ModuleDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ModuleDef.somDefaultVCopyInit(var ctrl: Pointer; fromObj: ModuleDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ModuleDef.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ModuleDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somDefaultConstAssign(var ctrl: Pointer; fromObj: ModuleDef): ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ModuleDef(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somDefaultVAssign(var ctrl: Pointer; fromObj: ModuleDef): ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ModuleDef(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somDefaultConstVAssign(var ctrl: Pointer; fromObj: ModuleDef): ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ModuleDef(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ModuleDef.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ModuleDef.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ModuleDef.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.somPrintSelf: ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ModuleDef(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ModuleDef.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ModuleDef.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ModuleDef.contents(limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_contents
   (SOM_Resolve(Self, cd.classObject, cd.contents))
     (Self, @LocalEnv, limit_type, exclude_inherited);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ModuleDef.lookup_name(search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_lookup_name
   (SOM_Resolve(Self, cd.classObject, cd.lookup_name))
     (Self, @LocalEnv, search_name, levels_to_search, limit_type, exclude_inherited);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ModuleDef.describe_contents(limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_describe_contents
   (SOM_Resolve(Self, cd.classObject, cd.describe_contents))
     (Self, @LocalEnv, limit_type, exclude_inherited, max_returned_objs);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function ModuleDef.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = ModuleDef then { invoked on class name literal }
  begin
    Result := SOMClass(ModuleDefClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function ModuleDef.NewClass: SOMClass;
begin
  if Self = ModuleDef then { invoked on class name literal }
  begin
    Result := SOMClass(ModuleDefClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(ModuleDefNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function ModuleDef.As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(Self);
end;

function ModuleDef.As_Container: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Container(Self);
end;

function ModuleDef.As_ModuleDef: ModuleDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function ModuleDef.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function ModuleDef.Supports(Instance: SOMObjectBase; out Obj: ModuleDef): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := ModuleDef(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  NVList_MajorVersion = 2;
  NVList_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function NVListNewClass(
  somtmajorVersion: integer4 = NVList_MajorVersion;
  somtminorVersion: integer4 = NVList_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'NVListNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  NVListClassDataStructure = packed record
    classObject: SOMClass;
    add_item,
    remove_item,
    free,
    free_memory,
    get_count,
    set_item,
    get_item,
    get_item_by_name: somMToken;
  end;
  PNVListClassDataStructure = ^NVListClassDataStructure;

var
  SOMD_DLL_NVListClassData: PNVListClassDataStructure = nil;

function NVListClassData: PNVListClassDataStructure;
begin
  if Assigned(SOMD_DLL_NVListClassData) then
    Result := SOMD_DLL_NVListClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_NVListClassData, 'NVListClassData');
    Result := SOMD_DLL_NVListClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  NVListCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PNVListCClassDataStructure = ^NVListCClassDataStructure;

var
  SOMD_DLL_NVListCClassData: PNVListCClassDataStructure = nil;

function NVListCClassData: PNVListCClassDataStructure;
begin
  if Assigned(SOMD_DLL_NVListCClassData) then
    Result := SOMD_DLL_NVListCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_NVListCClassData, 'NVListCClassData');
    Result := SOMD_DLL_NVListCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function NVList.Create: NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := NVList(SOMClass(NewClass).somNew);
end;

class function NVList.InitInstance(Instance: Pointer): NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := NVList(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function NVList.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function NVList.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function NVList.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function NVList.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function NVList.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function NVList.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function NVList.NewInstance: NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := NVList(SOMClass(NewClass).somNewNoInit);
end;

function NVList.Clone: NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := NVList(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: add_item
 *)
type
  somTD_NVList_add_item = function(somSelf: SOMObjectBase{NVList}; ev: PEnvironment; item_name: CORBAString; item_type: TypeCode; value: Pointer; value_len: LongInt; item_flags: LongWord): LongWord; stdcall;

function NVList.add_item(item_name: CORBAString; item_type: TypeCode; value: Pointer; value_len: LongInt; item_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PNVListClassDataStructure;
  LocalEnv: Environment;
begin
  cd := NVListClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_NVList_add_item
   (SOM_Resolve(Self, cd.classObject, cd.add_item))
     (Self, @LocalEnv, item_name, item_type, value, value_len, item_flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: free
 *)
type
  somTD_NVList_free = function(somSelf: SOMObjectBase{NVList}; ev: PEnvironment): LongWord; stdcall;

function NVList.free: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PNVListClassDataStructure;
  LocalEnv: Environment;
begin
  cd := NVListClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_NVList_free
   (SOM_Resolve(Self, cd.classObject, cd.free))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: free_memory
 *)
type
  somTD_NVList_free_memory = function(somSelf: SOMObjectBase{NVList}; ev: PEnvironment): LongWord; stdcall;

function NVList.free_memory: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PNVListClassDataStructure;
  LocalEnv: Environment;
begin
  cd := NVListClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_NVList_free_memory
   (SOM_Resolve(Self, cd.classObject, cd.free_memory))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: get_count
 *)
type
  somTD_NVList_get_count = function(somSelf: SOMObjectBase{NVList}; ev: PEnvironment; out count: LongInt): LongWord; stdcall;

function NVList.get_count(out count: LongInt): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PNVListClassDataStructure;
  LocalEnv: Environment;
begin
  cd := NVListClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_NVList_get_count
   (SOM_Resolve(Self, cd.classObject, cd.get_count))
     (Self, @LocalEnv, count);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: set_item
 *)
type
  somTD_NVList_set_item = function(somSelf: SOMObjectBase{NVList}; ev: PEnvironment; item_number: LongInt; item_name: CORBAString; item_type: TypeCode; value: Pointer; value_len: LongInt; item_flags: LongWord): LongWord; stdcall;

function NVList.set_item(item_number: LongInt; item_name: CORBAString; item_type: TypeCode; value: Pointer; value_len: LongInt; item_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PNVListClassDataStructure;
  LocalEnv: Environment;
begin
  cd := NVListClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_NVList_set_item
   (SOM_Resolve(Self, cd.classObject, cd.set_item))
     (Self, @LocalEnv, item_number, item_name, item_type, value, value_len, item_flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: get_item
 *)
type
  somTD_NVList_get_item = function(somSelf: SOMObjectBase{NVList}; ev: PEnvironment; item_number: LongInt; out item_name: CORBAString; out item_type: TypeCode; out value: Pointer; out value_len: LongInt; out item_flags: LongWord): LongWord; stdcall;

function NVList.get_item(item_number: LongInt; out item_name: CORBAString; out item_type: TypeCode; out value: Pointer; out value_len: LongInt; out item_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PNVListClassDataStructure;
  LocalEnv: Environment;
begin
  cd := NVListClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_NVList_get_item
   (SOM_Resolve(Self, cd.classObject, cd.get_item))
     (Self, @LocalEnv, item_number, item_name, item_type, value, value_len, item_flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure NVList.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure NVList.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure NVList.somDefaultCopyInit(var ctrl: Pointer; fromObj: NVList); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somDefaultAssign(var ctrl: Pointer; fromObj: NVList): NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := NVList(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure NVList.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: NVList); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure NVList.somDefaultVCopyInit(var ctrl: Pointer; fromObj: NVList); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure NVList.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: NVList); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somDefaultConstAssign(var ctrl: Pointer; fromObj: NVList): NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := NVList(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somDefaultVAssign(var ctrl: Pointer; fromObj: NVList): NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := NVList(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somDefaultConstVAssign(var ctrl: Pointer; fromObj: NVList): NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := NVList(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure NVList.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure NVList.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure NVList.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function NVList.somPrintSelf: NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := NVList(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure NVList.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure NVList.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function NVList.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = NVList then { invoked on class name literal }
  begin
    Result := SOMClass(NVListClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function NVList.NewClass: SOMClass;
begin
  if Self = NVList then { invoked on class name literal }
  begin
    Result := SOMClass(NVListClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(NVListNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function NVList.As_NVList: NVList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function NVList.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function NVList.Supports(Instance: SOMObjectBase; out Obj: NVList): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := NVList(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  ObjectMgr_MajorVersion = 2;
  ObjectMgr_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ObjectMgrNewClass(
  somtmajorVersion: integer4 = ObjectMgr_MajorVersion;
  somtminorVersion: integer4 = ObjectMgr_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'ObjectMgrNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ObjectMgrClassDataStructure = packed record
    classObject: SOMClass;
    somdNewObject,
    somdGetIdFromObject,
    somdGetObjectFromId,
    somdReleaseObject,
    somdDestroyObject: somMToken;
  end;
  PObjectMgrClassDataStructure = ^ObjectMgrClassDataStructure;

var
  SOMD_DLL_ObjectMgrClassData: PObjectMgrClassDataStructure = nil;

function ObjectMgrClassData: PObjectMgrClassDataStructure;
begin
  if Assigned(SOMD_DLL_ObjectMgrClassData) then
    Result := SOMD_DLL_ObjectMgrClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_ObjectMgrClassData, 'ObjectMgrClassData');
    Result := SOMD_DLL_ObjectMgrClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ObjectMgrCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PObjectMgrCClassDataStructure = ^ObjectMgrCClassDataStructure;

var
  SOMD_DLL_ObjectMgrCClassData: PObjectMgrCClassDataStructure = nil;

function ObjectMgrCClassData: PObjectMgrCClassDataStructure;
begin
  if Assigned(SOMD_DLL_ObjectMgrCClassData) then
    Result := SOMD_DLL_ObjectMgrCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_ObjectMgrCClassData, 'ObjectMgrCClassData');
    Result := SOMD_DLL_ObjectMgrCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function ObjectMgr.Create: ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ObjectMgr(SOMClass(NewClass).somNew);
end;

class function ObjectMgr.InitInstance(Instance: Pointer): ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ObjectMgr(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function ObjectMgr.ClassType: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMObject(Self).somGetClass);
end;

class function ObjectMgr.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function ObjectMgr.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function ObjectMgr.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function ObjectMgr.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function ObjectMgr.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function ObjectMgr.NewInstance: ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ObjectMgr(SOMClass(NewClass).somNewNoInit);
end;

function ObjectMgr.Clone: ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ObjectMgr(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somdNewObject
 *)
type
  somTD_ObjectMgr_somdNewObject = function(somSelf: SOMObjectBase{ObjectMgr}; ev: PEnvironment; objclass: CORBAString; hints: CORBAString): SOMObject; stdcall;

function ObjectMgr.somdNewObject(objclass: CORBAString; hints: CORBAString): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ObjectMgr_somdNewObject
   (SOM_Resolve(Self, cd.classObject, cd.somdNewObject))
     (Self, @LocalEnv, objclass, hints);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdGetIdFromObject
 *)
type
  somTD_ObjectMgr_somdGetIdFromObject = function(somSelf: SOMObjectBase{ObjectMgr}; ev: PEnvironment; obj: SOMObject): CORBAString; stdcall;

function ObjectMgr.somdGetIdFromObject(obj: SOMObject): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ObjectMgr_somdGetIdFromObject
   (SOM_Resolve(Self, cd.classObject, cd.somdGetIdFromObject))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdGetObjectFromId
 *)
type
  somTD_ObjectMgr_somdGetObjectFromId = function(somSelf: SOMObjectBase{ObjectMgr}; ev: PEnvironment; id: CORBAString): SOMObject; stdcall;

function ObjectMgr.somdGetObjectFromId(id: CORBAString): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ObjectMgr_somdGetObjectFromId
   (SOM_Resolve(Self, cd.classObject, cd.somdGetObjectFromId))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdReleaseObject
 *)
type
  somTD_ObjectMgr_somdReleaseObject = procedure(somSelf: SOMObjectBase{ObjectMgr}; ev: PEnvironment; obj: SOMObject); stdcall;

procedure ObjectMgr.somdReleaseObject(obj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ObjectMgr_somdReleaseObject
   (SOM_Resolve(Self, cd.classObject, cd.somdReleaseObject))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdDestroyObject
 *)
type
  somTD_ObjectMgr_somdDestroyObject = procedure(somSelf: SOMObjectBase{ObjectMgr}; ev: PEnvironment; obj: SOMObject); stdcall;

procedure ObjectMgr.somdDestroyObject(obj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ObjectMgr_somdDestroyObject
   (SOM_Resolve(Self, cd.classObject, cd.somdDestroyObject))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ObjectMgr.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ObjectMgr.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ObjectMgr.somDefaultCopyInit(var ctrl: Pointer; fromObj: ObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somDefaultAssign(var ctrl: Pointer; fromObj: ObjectMgr): ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ObjectMgr(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ObjectMgr.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ObjectMgr.somDefaultVCopyInit(var ctrl: Pointer; fromObj: ObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ObjectMgr.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somDefaultConstAssign(var ctrl: Pointer; fromObj: ObjectMgr): ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ObjectMgr(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somDefaultVAssign(var ctrl: Pointer; fromObj: ObjectMgr): ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ObjectMgr(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somDefaultConstVAssign(var ctrl: Pointer; fromObj: ObjectMgr): ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ObjectMgr(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ObjectMgr.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ObjectMgr.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ObjectMgr.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ObjectMgr.somPrintSelf: ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ObjectMgr(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ObjectMgr.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ObjectMgr.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function ObjectMgr.ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = ObjectMgr then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(ObjectMgrClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

class function ObjectMgr.NewClass: SOMMSingleInstance;
begin
  if Self = ObjectMgr then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(ObjectMgrClassData.classObject);
    if not Assigned(Result) then Result := SOMMSingleInstance(ObjectMgrNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

function ObjectMgr.As_ObjectMgr: ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function ObjectMgr.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function ObjectMgr.Supports(Instance: SOMObjectBase; out Obj: ObjectMgr): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := ObjectMgr(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  OperationDef_MajorVersion = 2;
  OperationDef_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function OperationDefNewClass(
  somtmajorVersion: integer4 = OperationDef_MajorVersion;
  somtminorVersion: integer4 = OperationDef_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'OperationDefNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  OperationDefClassDataStructure = packed record
    classObject: SOMClass;
    _get_result,
    _set_result,
    _get_mode,
    _set_mode,
    _get_contexts,
    _set_contexts: somMToken;
  end;
  POperationDefClassDataStructure = ^OperationDefClassDataStructure;

var
  SOMIR_DLL_OperationDefClassData: POperationDefClassDataStructure = nil;

function OperationDefClassData: POperationDefClassDataStructure;
begin
  if Assigned(SOMIR_DLL_OperationDefClassData) then
    Result := SOMIR_DLL_OperationDefClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_OperationDefClassData, 'OperationDefClassData');
    Result := SOMIR_DLL_OperationDefClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  OperationDefCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  POperationDefCClassDataStructure = ^OperationDefCClassDataStructure;

var
  SOMIR_DLL_OperationDefCClassData: POperationDefCClassDataStructure = nil;

function OperationDefCClassData: POperationDefCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_OperationDefCClassData) then
    Result := SOMIR_DLL_OperationDefCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_OperationDefCClassData, 'OperationDefCClassData');
    Result := SOMIR_DLL_OperationDefCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_result
 *)
type
  somTD_OperationDef__get_result = function(somSelf: SOMObjectBase{OperationDef}; ev: PEnvironment): TypeCode; stdcall;

function OperationDef._get_result: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: POperationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := OperationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_OperationDef__get_result
   (SOM_Resolve(Self, cd.classObject, cd._get_result))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_result
 *)
type
  somTD_OperationDef__set_result = procedure(somSelf: SOMObjectBase{OperationDef}; ev: PEnvironment; SOM_result: TypeCode); stdcall;

procedure OperationDef._set_result(SOM_result: TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: POperationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := OperationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_OperationDef__set_result
   (SOM_Resolve(Self, cd.classObject, cd._set_result))
     (Self, @LocalEnv, SOM_result);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_mode
 *)
type
  somTD_OperationDef__get_mode = function(somSelf: SOMObjectBase{OperationDef}; ev: PEnvironment): OperationDef_OperationMode; stdcall;

function OperationDef._get_mode: OperationDef_OperationMode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: POperationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := OperationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_OperationDef__get_mode
   (SOM_Resolve(Self, cd.classObject, cd._get_mode))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_mode
 *)
type
  somTD_OperationDef__set_mode = procedure(somSelf: SOMObjectBase{OperationDef}; ev: PEnvironment; mode: OperationDef_OperationMode); stdcall;

procedure OperationDef._set_mode(mode: OperationDef_OperationMode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: POperationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := OperationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_OperationDef__set_mode
   (SOM_Resolve(Self, cd.classObject, cd._set_mode))
     (Self, @LocalEnv, mode);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_contexts
 *)
type
  somTD_OperationDef__get_contexts = function(somSelf: SOMObjectBase{OperationDef}; ev: PEnvironment): _IDL_Sequence_CORBAString; stdcall;

function OperationDef._get_contexts: _IDL_Sequence_CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: POperationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := OperationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_OperationDef__get_contexts
   (SOM_Resolve(Self, cd.classObject, cd._get_contexts))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_contexts
 *)
type
  somTD_OperationDef__set_contexts = procedure(somSelf: SOMObjectBase{OperationDef}; ev: PEnvironment; const contexts: _IDL_Sequence_CORBAString); stdcall;

procedure OperationDef._set_contexts(const contexts: _IDL_Sequence_CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: POperationDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := OperationDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_OperationDef__set_contexts
   (SOM_Resolve(Self, cd.classObject, cd._set_contexts))
     (Self, @LocalEnv, contexts);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function OperationDef._get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_name
   (SOM_Resolve(Self, cd.classObject, cd._get_name))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure OperationDef._set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_name
   (SOM_Resolve(Self, cd.classObject, cd._set_name))
     (Self, @LocalEnv, name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function OperationDef._get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_id
   (SOM_Resolve(Self, cd.classObject, cd._get_id))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure OperationDef._set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_id
   (SOM_Resolve(Self, cd.classObject, cd._set_id))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function OperationDef._get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._get_defined_in))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure OperationDef._set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._set_defined_in))
     (Self, @LocalEnv, defined_in);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function OperationDef._get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._get_somModifiers))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure OperationDef._set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._set_somModifiers))
     (Self, @LocalEnv, somModifiers);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function OperationDef.Create: OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := OperationDef(SOMClass(NewClass).somNew);
end;

class function OperationDef.InitInstance(Instance: Pointer): OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := OperationDef(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function OperationDef.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function OperationDef.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function OperationDef.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function OperationDef.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function OperationDef.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function OperationDef.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function OperationDef.NewInstance: OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := OperationDef(SOMClass(NewClass).somNewNoInit);
end;

function OperationDef.Clone: OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := OperationDef(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function OperationDef.within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_within
   (SOM_Resolve(Self, cd.classObject, cd.within))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function OperationDef.describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_describe
   (SOM_Resolve(Self, cd.classObject, cd.describe))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure OperationDef.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure OperationDef.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure OperationDef.somDefaultCopyInit(var ctrl: Pointer; fromObj: OperationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somDefaultAssign(var ctrl: Pointer; fromObj: OperationDef): OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := OperationDef(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure OperationDef.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: OperationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure OperationDef.somDefaultVCopyInit(var ctrl: Pointer; fromObj: OperationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure OperationDef.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: OperationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somDefaultConstAssign(var ctrl: Pointer; fromObj: OperationDef): OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := OperationDef(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somDefaultVAssign(var ctrl: Pointer; fromObj: OperationDef): OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := OperationDef(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somDefaultConstVAssign(var ctrl: Pointer; fromObj: OperationDef): OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := OperationDef(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure OperationDef.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure OperationDef.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure OperationDef.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.somPrintSelf: OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := OperationDef(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure OperationDef.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure OperationDef.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function OperationDef.contents(limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_contents
   (SOM_Resolve(Self, cd.classObject, cd.contents))
     (Self, @LocalEnv, limit_type, exclude_inherited);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function OperationDef.lookup_name(search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_lookup_name
   (SOM_Resolve(Self, cd.classObject, cd.lookup_name))
     (Self, @LocalEnv, search_name, levels_to_search, limit_type, exclude_inherited);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function OperationDef.describe_contents(limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_describe_contents
   (SOM_Resolve(Self, cd.classObject, cd.describe_contents))
     (Self, @LocalEnv, limit_type, exclude_inherited, max_returned_objs);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function OperationDef.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = OperationDef then { invoked on class name literal }
  begin
    Result := SOMClass(OperationDefClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function OperationDef.NewClass: SOMClass;
begin
  if Self = OperationDef then { invoked on class name literal }
  begin
    Result := SOMClass(OperationDefClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(OperationDefNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function OperationDef.As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(Self);
end;

function OperationDef.As_Container: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Container(Self);
end;

function OperationDef.As_OperationDef: OperationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function OperationDef.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function OperationDef.Supports(Instance: SOMObjectBase; out Obj: OperationDef): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := OperationDef(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  ORB_MajorVersion = 2;
  ORB_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ORBNewClass(
  somtmajorVersion: integer4 = ORB_MajorVersion;
  somtminorVersion: integer4 = ORB_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'ORBNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ORBClassDataStructure = packed record
    classObject: SOMClass;
    object_to_string,
    string_to_object,
    create_list,
    create_operation_list,
    get_default_context,
    object_to_binary,
    binary_to_object: somMToken;
  end;
  PORBClassDataStructure = ^ORBClassDataStructure;

var
  SOMD_DLL_ORBClassData: PORBClassDataStructure = nil;

function ORBClassData: PORBClassDataStructure;
begin
  if Assigned(SOMD_DLL_ORBClassData) then
    Result := SOMD_DLL_ORBClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_ORBClassData, 'ORBClassData');
    Result := SOMD_DLL_ORBClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ORBCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PORBCClassDataStructure = ^ORBCClassDataStructure;

var
  SOMD_DLL_ORBCClassData: PORBCClassDataStructure = nil;

function ORBCClassData: PORBCClassDataStructure;
begin
  if Assigned(SOMD_DLL_ORBCClassData) then
    Result := SOMD_DLL_ORBCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_ORBCClassData, 'ORBCClassData');
    Result := SOMD_DLL_ORBCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function ORB.Create: ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ORB(SOMClass(NewClass).somNew);
end;

class function ORB.InitInstance(Instance: Pointer): ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ORB(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function ORB.ClassType: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMObject(Self).somGetClass);
end;

class function ORB.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function ORB.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function ORB.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function ORB.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function ORB.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function ORB.NewInstance: ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ORB(SOMClass(NewClass).somNewNoInit);
end;

function ORB.Clone: ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ORB(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: object_to_string
 *)
type
  somTD_ORB_object_to_string = function(somSelf: SOMObjectBase{ORB}; ev: PEnvironment; obj: SOMDObject): CORBAString; stdcall;

function ORB.object_to_string(obj: SOMDObject): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PORBClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ORBClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ORB_object_to_string
   (SOM_Resolve(Self, cd.classObject, cd.object_to_string))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: string_to_object
 *)
type
  somTD_ORB_string_to_object = function(somSelf: SOMObjectBase{ORB}; ev: PEnvironment; str: CORBAString): SOMDObject; stdcall;

function ORB.string_to_object(str: CORBAString): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PORBClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ORBClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ORB_string_to_object
   (SOM_Resolve(Self, cd.classObject, cd.string_to_object))
     (Self, @LocalEnv, str);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: create_list
 *)
type
  somTD_ORB_create_list = function(somSelf: SOMObjectBase{ORB}; ev: PEnvironment; count: LongInt; out new_list: NVList): LongWord; stdcall;

function ORB.create_list(count: LongInt; out new_list: NVList): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PORBClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ORBClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ORB_create_list
   (SOM_Resolve(Self, cd.classObject, cd.create_list))
     (Self, @LocalEnv, count, new_list);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: create_operation_list
 *)
type
  somTD_ORB_create_operation_list = function(somSelf: SOMObjectBase{ORB}; ev: PEnvironment; oper: OperationDef; out new_list: NVList): LongWord; stdcall;

function ORB.create_operation_list(oper: OperationDef; out new_list: NVList): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PORBClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ORBClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ORB_create_operation_list
   (SOM_Resolve(Self, cd.classObject, cd.create_operation_list))
     (Self, @LocalEnv, oper, new_list);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: get_default_context
 *)
type
  somTD_ORB_get_default_context = function(somSelf: SOMObjectBase{ORB}; ev: PEnvironment; out ctx: Context): LongWord; stdcall;

function ORB.get_default_context(out ctx: Context): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PORBClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ORBClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ORB_get_default_context
   (SOM_Resolve(Self, cd.classObject, cd.get_default_context))
     (Self, @LocalEnv, ctx);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ORB.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ORB.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ORB.somDefaultCopyInit(var ctrl: Pointer; fromObj: ORB); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somDefaultAssign(var ctrl: Pointer; fromObj: ORB): ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ORB(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ORB.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ORB); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ORB.somDefaultVCopyInit(var ctrl: Pointer; fromObj: ORB); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ORB.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ORB); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somDefaultConstAssign(var ctrl: Pointer; fromObj: ORB): ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ORB(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somDefaultVAssign(var ctrl: Pointer; fromObj: ORB): ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ORB(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somDefaultConstVAssign(var ctrl: Pointer; fromObj: ORB): ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ORB(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ORB.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ORB.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ORB.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ORB.somPrintSelf: ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ORB(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ORB.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ORB.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function ORB.ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = ORB then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(ORBClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

class function ORB.NewClass: SOMMSingleInstance;
begin
  if Self = ORB then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(ORBClassData.classObject);
    if not Assigned(Result) then Result := SOMMSingleInstance(ORBNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

function ORB.As_ORB: ORB; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function ORB.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function ORB.Supports(Instance: SOMObjectBase; out Obj: ORB): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := ORB(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  ParameterDef_MajorVersion = 2;
  ParameterDef_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function ParameterDefNewClass(
  somtmajorVersion: integer4 = ParameterDef_MajorVersion;
  somtminorVersion: integer4 = ParameterDef_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'ParameterDefNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  ParameterDefClassDataStructure = packed record
    classObject: SOMClass;
    _get_type,
    _set_type,
    _get_mode,
    _set_mode: somMToken;
  end;
  PParameterDefClassDataStructure = ^ParameterDefClassDataStructure;

var
  SOMIR_DLL_ParameterDefClassData: PParameterDefClassDataStructure = nil;

function ParameterDefClassData: PParameterDefClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ParameterDefClassData) then
    Result := SOMIR_DLL_ParameterDefClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ParameterDefClassData, 'ParameterDefClassData');
    Result := SOMIR_DLL_ParameterDefClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  ParameterDefCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PParameterDefCClassDataStructure = ^ParameterDefCClassDataStructure;

var
  SOMIR_DLL_ParameterDefCClassData: PParameterDefCClassDataStructure = nil;

function ParameterDefCClassData: PParameterDefCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_ParameterDefCClassData) then
    Result := SOMIR_DLL_ParameterDefCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_ParameterDefCClassData, 'ParameterDefCClassData');
    Result := SOMIR_DLL_ParameterDefCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_type
 *)
type
  somTD_ParameterDef__get_type = function(somSelf: SOMObjectBase{ParameterDef}; ev: PEnvironment): TypeCode; stdcall;

function ParameterDef._get_type: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PParameterDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ParameterDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ParameterDef__get_type
   (SOM_Resolve(Self, cd.classObject, cd._get_type))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_type
 *)
type
  somTD_ParameterDef__set_type = procedure(somSelf: SOMObjectBase{ParameterDef}; ev: PEnvironment; SOM_type: {caller_owns} TypeCode); stdcall;

procedure ParameterDef._set_type(SOM_type: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PParameterDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ParameterDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ParameterDef__set_type
   (SOM_Resolve(Self, cd.classObject, cd._set_type))
     (Self, @LocalEnv, SOM_type);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_mode
 *)
type
  somTD_ParameterDef__get_mode = function(somSelf: SOMObjectBase{ParameterDef}; ev: PEnvironment): ParameterDef_ParameterMode; stdcall;

function ParameterDef._get_mode: ParameterDef_ParameterMode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PParameterDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ParameterDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ParameterDef__get_mode
   (SOM_Resolve(Self, cd.classObject, cd._get_mode))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_mode
 *)
type
  somTD_ParameterDef__set_mode = procedure(somSelf: SOMObjectBase{ParameterDef}; ev: PEnvironment; mode: ParameterDef_ParameterMode); stdcall;

procedure ParameterDef._set_mode(mode: ParameterDef_ParameterMode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PParameterDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ParameterDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ParameterDef__set_mode
   (SOM_Resolve(Self, cd.classObject, cd._set_mode))
     (Self, @LocalEnv, mode);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ParameterDef._get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_name
   (SOM_Resolve(Self, cd.classObject, cd._get_name))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ParameterDef._set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_name
   (SOM_Resolve(Self, cd.classObject, cd._set_name))
     (Self, @LocalEnv, name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ParameterDef._get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_id
   (SOM_Resolve(Self, cd.classObject, cd._get_id))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ParameterDef._set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_id
   (SOM_Resolve(Self, cd.classObject, cd._set_id))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ParameterDef._get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._get_defined_in))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ParameterDef._set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._set_defined_in))
     (Self, @LocalEnv, defined_in);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ParameterDef._get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._get_somModifiers))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ParameterDef._set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._set_somModifiers))
     (Self, @LocalEnv, somModifiers);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function ParameterDef.Create: ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ParameterDef(SOMClass(NewClass).somNew);
end;

class function ParameterDef.InitInstance(Instance: Pointer): ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ParameterDef(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function ParameterDef.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function ParameterDef.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function ParameterDef.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function ParameterDef.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function ParameterDef.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function ParameterDef.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function ParameterDef.NewInstance: ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ParameterDef(SOMClass(NewClass).somNewNoInit);
end;

function ParameterDef.Clone: ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ParameterDef(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function ParameterDef.within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_within
   (SOM_Resolve(Self, cd.classObject, cd.within))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function ParameterDef.describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_describe
   (SOM_Resolve(Self, cd.classObject, cd.describe))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure ParameterDef.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ParameterDef.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ParameterDef.somDefaultCopyInit(var ctrl: Pointer; fromObj: ParameterDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somDefaultAssign(var ctrl: Pointer; fromObj: ParameterDef): ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ParameterDef(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ParameterDef.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: ParameterDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ParameterDef.somDefaultVCopyInit(var ctrl: Pointer; fromObj: ParameterDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ParameterDef.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: ParameterDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somDefaultConstAssign(var ctrl: Pointer; fromObj: ParameterDef): ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ParameterDef(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somDefaultVAssign(var ctrl: Pointer; fromObj: ParameterDef): ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ParameterDef(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somDefaultConstVAssign(var ctrl: Pointer; fromObj: ParameterDef): ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ParameterDef(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ParameterDef.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ParameterDef.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ParameterDef.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function ParameterDef.somPrintSelf: ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := ParameterDef(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ParameterDef.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure ParameterDef.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function ParameterDef.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = ParameterDef then { invoked on class name literal }
  begin
    Result := SOMClass(ParameterDefClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function ParameterDef.NewClass: SOMClass;
begin
  if Self = ParameterDef then { invoked on class name literal }
  begin
    Result := SOMClass(ParameterDefClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(ParameterDefNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function ParameterDef.As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(Self);
end;

function ParameterDef.As_ParameterDef: ParameterDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function ParameterDef.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function ParameterDef.Supports(Instance: SOMObjectBase; out Obj: ParameterDef): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := ParameterDef(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  Principal_MajorVersion = 1;
  Principal_MinorVersion = 0;

(*
 * Declare the class creation procedure
 *)
function PrincipalNewClass(
  somtmajorVersion: integer4 = Principal_MajorVersion;
  somtminorVersion: integer4 = Principal_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'PrincipalNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  PrincipalClassDataStructure = packed record
    classObject: SOMClass;
    _set_userName,
    _get_userName,
    _set_hostName,
    _get_hostName: somMToken;
  end;
  PPrincipalClassDataStructure = ^PrincipalClassDataStructure;

var
  SOMD_DLL_PrincipalClassData: PPrincipalClassDataStructure = nil;

function PrincipalClassData: PPrincipalClassDataStructure;
begin
  if Assigned(SOMD_DLL_PrincipalClassData) then
    Result := SOMD_DLL_PrincipalClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_PrincipalClassData, 'PrincipalClassData');
    Result := SOMD_DLL_PrincipalClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  PrincipalCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PPrincipalCClassDataStructure = ^PrincipalCClassDataStructure;

var
  SOMD_DLL_PrincipalCClassData: PPrincipalCClassDataStructure = nil;

function PrincipalCClassData: PPrincipalCClassDataStructure;
begin
  if Assigned(SOMD_DLL_PrincipalCClassData) then
    Result := SOMD_DLL_PrincipalCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_PrincipalCClassData, 'PrincipalCClassData');
    Result := SOMD_DLL_PrincipalCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_userName
 *)
type
  somTD_Principal__get_userName = function(somSelf: SOMObjectBase{Principal}; ev: PEnvironment): CORBAString; stdcall;

function Principal._get_userName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PPrincipalClassDataStructure;
  LocalEnv: Environment;
begin
  cd := PrincipalClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Principal__get_userName
   (SOM_Resolve(Self, cd.classObject, cd._get_userName))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_userName
 *)
type
  somTD_Principal__set_userName = procedure(somSelf: SOMObjectBase{Principal}; ev: PEnvironment; userName: CORBAString); stdcall;

procedure Principal._set_userName(userName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PPrincipalClassDataStructure;
  LocalEnv: Environment;
begin
  cd := PrincipalClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Principal__set_userName
   (SOM_Resolve(Self, cd.classObject, cd._set_userName))
     (Self, @LocalEnv, userName);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_hostName
 *)
type
  somTD_Principal__get_hostName = function(somSelf: SOMObjectBase{Principal}; ev: PEnvironment): CORBAString; stdcall;

function Principal._get_hostName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PPrincipalClassDataStructure;
  LocalEnv: Environment;
begin
  cd := PrincipalClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Principal__get_hostName
   (SOM_Resolve(Self, cd.classObject, cd._get_hostName))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_hostName
 *)
type
  somTD_Principal__set_hostName = procedure(somSelf: SOMObjectBase{Principal}; ev: PEnvironment; hostName: CORBAString); stdcall;

procedure Principal._set_hostName(hostName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PPrincipalClassDataStructure;
  LocalEnv: Environment;
begin
  cd := PrincipalClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Principal__set_hostName
   (SOM_Resolve(Self, cd.classObject, cd._set_hostName))
     (Self, @LocalEnv, hostName);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function Principal.Create: Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Principal(SOMClass(NewClass).somNew);
end;

class function Principal.InitInstance(Instance: Pointer): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Principal(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function Principal.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function Principal.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function Principal.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function Principal.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function Principal.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function Principal.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function Principal.NewInstance: Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Principal(SOMClass(NewClass).somNewNoInit);
end;

function Principal.Clone: Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Principal(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

procedure Principal.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Principal.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Principal.somDefaultCopyInit(var ctrl: Pointer; fromObj: Principal); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somDefaultAssign(var ctrl: Pointer; fromObj: Principal): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Principal(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Principal.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Principal); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Principal.somDefaultVCopyInit(var ctrl: Pointer; fromObj: Principal); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Principal.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Principal); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somDefaultConstAssign(var ctrl: Pointer; fromObj: Principal): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Principal(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somDefaultVAssign(var ctrl: Pointer; fromObj: Principal): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Principal(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somDefaultConstVAssign(var ctrl: Pointer; fromObj: Principal): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Principal(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Principal.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Principal.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Principal.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Principal.somPrintSelf: Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Principal(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Principal.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Principal.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function Principal.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = Principal then { invoked on class name literal }
  begin
    Result := SOMClass(PrincipalClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function Principal.NewClass: SOMClass;
begin
  if Self = Principal then { invoked on class name literal }
  begin
    Result := SOMClass(PrincipalClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(PrincipalNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function Principal.As_Principal: Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function Principal.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function Principal.Supports(Instance: SOMObjectBase; out Obj: Principal): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := Principal(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  Repository_MajorVersion = 2;
  Repository_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function RepositoryNewClass(
  somtmajorVersion: integer4 = Repository_MajorVersion;
  somtminorVersion: integer4 = Repository_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'RepositoryNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  RepositoryClassDataStructure = packed record
    classObject: SOMClass;
    lookup_id,
    lookup_modifier,
    release_cache: somMToken;
  end;
  PRepositoryClassDataStructure = ^RepositoryClassDataStructure;

var
  SOMIR_DLL_RepositoryClassData: PRepositoryClassDataStructure = nil;

function RepositoryClassData: PRepositoryClassDataStructure;
begin
  if Assigned(SOMIR_DLL_RepositoryClassData) then
    Result := SOMIR_DLL_RepositoryClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_RepositoryClassData, 'RepositoryClassData');
    Result := SOMIR_DLL_RepositoryClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  RepositoryCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PRepositoryCClassDataStructure = ^RepositoryCClassDataStructure;

var
  SOMIR_DLL_RepositoryCClassData: PRepositoryCClassDataStructure = nil;

function RepositoryCClassData: PRepositoryCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_RepositoryCClassData) then
    Result := SOMIR_DLL_RepositoryCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_RepositoryCClassData, 'RepositoryCClassData');
    Result := SOMIR_DLL_RepositoryCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function Repository.Create: Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Repository(SOMClass(NewClass).somNew);
end;

class function Repository.InitInstance(Instance: Pointer): Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Repository(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function Repository.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function Repository.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function Repository.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function Repository.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function Repository.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function Repository.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function Repository.NewInstance: Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Repository(SOMClass(NewClass).somNewNoInit);
end;

function Repository.Clone: Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Repository(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: lookup_id
 *)
type
  somTD_Repository_lookup_id = function(somSelf: SOMObjectBase{Repository}; ev: PEnvironment; search_id: CORBAString): Contained; stdcall;

function Repository.lookup_id(search_id: CORBAString): Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := RepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Repository_lookup_id
   (SOM_Resolve(Self, cd.classObject, cd.lookup_id))
     (Self, @LocalEnv, search_id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: lookup_modifier
 *)
type
  somTD_Repository_lookup_modifier = function(somSelf: SOMObjectBase{Repository}; ev: PEnvironment; name: CORBAString; modifier: CORBAString): CORBAString; stdcall;

function Repository.lookup_modifier(name: CORBAString; modifier: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := RepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Repository_lookup_modifier
   (SOM_Resolve(Self, cd.classObject, cd.lookup_modifier))
     (Self, @LocalEnv, name, modifier);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: release_cache
 *)
type
  somTD_Repository_release_cache = procedure(somSelf: SOMObjectBase{Repository}; ev: PEnvironment); stdcall;

procedure Repository.release_cache; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PRepositoryClassDataStructure;
  LocalEnv: Environment;
begin
  cd := RepositoryClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Repository_release_cache
   (SOM_Resolve(Self, cd.classObject, cd.release_cache))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function Repository.contents(limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_contents
   (SOM_Resolve(Self, cd.classObject, cd.contents))
     (Self, @LocalEnv, limit_type, exclude_inherited);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function Repository.lookup_name(search_name: {caller_owns} CORBAString; levels_to_search: LongInt; limit_type: CORBAString; exclude_inherited: CORBABoolean): {caller_owns} _IDL_Sequence_Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_lookup_name
   (SOM_Resolve(Self, cd.classObject, cd.lookup_name))
     (Self, @LocalEnv, search_name, levels_to_search, limit_type, exclude_inherited);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function Repository.describe_contents(limit_type: CORBAString; exclude_inherited: CORBABoolean; max_returned_objs: LongInt): _IDL_Sequence_Container_ContainerDescription; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Container_describe_contents
   (SOM_Resolve(Self, cd.classObject, cd.describe_contents))
     (Self, @LocalEnv, limit_type, exclude_inherited, max_returned_objs);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure Repository.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Repository.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Repository.somDefaultCopyInit(var ctrl: Pointer; fromObj: Repository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somDefaultAssign(var ctrl: Pointer; fromObj: Repository): Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Repository(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Repository.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Repository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Repository.somDefaultVCopyInit(var ctrl: Pointer; fromObj: Repository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Repository.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Repository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somDefaultConstAssign(var ctrl: Pointer; fromObj: Repository): Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Repository(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somDefaultVAssign(var ctrl: Pointer; fromObj: Repository): Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Repository(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somDefaultConstVAssign(var ctrl: Pointer; fromObj: Repository): Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Repository(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Repository.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Repository.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Repository.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Repository.somPrintSelf: Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Repository(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Repository.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Repository.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function Repository.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = Repository then { invoked on class name literal }
  begin
    Result := SOMClass(RepositoryClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function Repository.NewClass: SOMClass;
begin
  if Self = Repository then { invoked on class name literal }
  begin
    Result := SOMClass(RepositoryClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(RepositoryNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function Repository.As_Container: Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Container(Self);
end;

function Repository.As_Repository: Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function Repository.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function Repository.Supports(Instance: SOMObjectBase; out Obj: Repository): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := Repository(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  Request_MajorVersion = 2;
  Request_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function RequestNewClass(
  somtmajorVersion: integer4 = Request_MajorVersion;
  somtminorVersion: integer4 = Request_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'RequestNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  RequestClassDataStructure = packed record
    classObject: SOMClass;
    add_arg,
    invoke,
    send,
    get_response,
    SOM_destroy,
    _get_objref,
    _set_objref,
    _get_ctx,
    _set_ctx,
    _get_operation,
    _set_operation,
    _get_argument_list,
    _set_argument_list,
    _get_return_result,
    _set_return_result,
    _get_req_flags,
    _set_req_flags,
    _get_env,
    _set_env: somMToken;
  end;
  PRequestClassDataStructure = ^RequestClassDataStructure;

var
  SOMD_DLL_RequestClassData: PRequestClassDataStructure = nil;

function RequestClassData: PRequestClassDataStructure;
begin
  if Assigned(SOMD_DLL_RequestClassData) then
    Result := SOMD_DLL_RequestClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_RequestClassData, 'RequestClassData');
    Result := SOMD_DLL_RequestClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  RequestCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PRequestCClassDataStructure = ^RequestCClassDataStructure;

var
  SOMD_DLL_RequestCClassData: PRequestCClassDataStructure = nil;

function RequestCClassData: PRequestCClassDataStructure;
begin
  if Assigned(SOMD_DLL_RequestCClassData) then
    Result := SOMD_DLL_RequestCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_RequestCClassData, 'RequestCClassData');
    Result := SOMD_DLL_RequestCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function Request.Create: Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Request(SOMClass(NewClass).somNew);
end;

class function Request.InitInstance(Instance: Pointer): Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Request(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function Request.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function Request.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function Request.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function Request.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function Request.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function Request.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function Request.NewInstance: Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Request(SOMClass(NewClass).somNewNoInit);
end;

function Request.Clone: Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Request(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: add_arg
 *)
type
  somTD_Request_add_arg = function(somSelf: SOMObjectBase{Request}; ev: PEnvironment; name: CORBAString; arg_type: TypeCode; value: Pointer; len: LongInt; arg_flags: LongWord): LongWord; stdcall;

function Request.add_arg(name: CORBAString; arg_type: TypeCode; value: Pointer; len: LongInt; arg_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PRequestClassDataStructure;
  LocalEnv: Environment;
begin
  cd := RequestClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Request_add_arg
   (SOM_Resolve(Self, cd.classObject, cd.add_arg))
     (Self, @LocalEnv, name, arg_type, value, len, arg_flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: invoke
 *)
type
  somTD_Request_invoke = function(somSelf: SOMObjectBase{Request}; ev: PEnvironment; invoke_flags: LongWord): LongWord; stdcall;

function Request.invoke(invoke_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PRequestClassDataStructure;
  LocalEnv: Environment;
begin
  cd := RequestClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Request_invoke
   (SOM_Resolve(Self, cd.classObject, cd.invoke))
     (Self, @LocalEnv, invoke_flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: send
 *)
type
  somTD_Request_send = function(somSelf: SOMObjectBase{Request}; ev: PEnvironment; invoke_flags: LongWord): LongWord; stdcall;

function Request.send(invoke_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PRequestClassDataStructure;
  LocalEnv: Environment;
begin
  cd := RequestClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Request_send
   (SOM_Resolve(Self, cd.classObject, cd.send))
     (Self, @LocalEnv, invoke_flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: get_response
 *)
type
  somTD_Request_get_response = function(somSelf: SOMObjectBase{Request}; ev: PEnvironment; response_flags: LongWord): LongWord; stdcall;

function Request.get_response(response_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PRequestClassDataStructure;
  LocalEnv: Environment;
begin
  cd := RequestClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Request_get_response
   (SOM_Resolve(Self, cd.classObject, cd.get_response))
     (Self, @LocalEnv, response_flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: SOM_destroy
 *)
type
  somTD_Request_SOM_destroy = function(somSelf: SOMObjectBase{Request}; ev: PEnvironment): LongWord; stdcall;

function Request.SOM_destroy: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PRequestClassDataStructure;
  LocalEnv: Environment;
begin
  cd := RequestClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Request_SOM_destroy
   (SOM_Resolve(Self, cd.classObject, cd.SOM_destroy))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure Request.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Request.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Request.somDefaultCopyInit(var ctrl: Pointer; fromObj: Request); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somDefaultAssign(var ctrl: Pointer; fromObj: Request): Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Request(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Request.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Request); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Request.somDefaultVCopyInit(var ctrl: Pointer; fromObj: Request); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Request.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Request); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somDefaultConstAssign(var ctrl: Pointer; fromObj: Request): Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Request(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somDefaultVAssign(var ctrl: Pointer; fromObj: Request): Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Request(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somDefaultConstVAssign(var ctrl: Pointer; fromObj: Request): Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Request(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Request.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Request.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Request.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Request.somPrintSelf: Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Request(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Request.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Request.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function Request.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = Request then { invoked on class name literal }
  begin
    Result := SOMClass(RequestClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function Request.NewClass: SOMClass;
begin
  if Self = Request then { invoked on class name literal }
  begin
    Result := SOMClass(RequestClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(RequestNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function Request.As_Request: Request; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function Request.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function Request.Supports(Instance: SOMObjectBase; out Obj: Request): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := Request(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOME_DLL_Name = 'some.dll';

var
  SOME_DLL: System.HMODULE = 0;

procedure SOME_DLL_Load_Variable(var V_Pointer; const Var_Name: AnsiString);
begin
  if SOME_DLL = 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOME_DLL = 0 then
      SOME_DLL := Windows.LoadLibraryW(SOME_DLL_Name);
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOME_DLL <> 0 then
    Pointer(V_Pointer) := Windows.GetProcAddress(SOME_DLL, PAnsiChar(Var_Name));
end;

const
  SOMTEntryC_MajorVersion = 2;
  SOMTEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTEntryCNewClass(
  somtmajorVersion: integer4 = SOMTEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtEntryName,
    _set_somtEntryName,
    _get_somtElementType,
    _set_somtElementType,
    _get_somtEntryComment,
    _get_somtSourceLineNumber,
    _get_somtTypeCode,
    _get_somtIsReference,
    somtGetModifierValue,
    somtGetFirstModifier,
    somtGetNextModifier,
    somtFormatModifier,
    somtGetModifierList,
    somtSetSymbolsOnEntry,
    somtSetEntryStruct,
    _get_somtEntryStruct,
    somtShowAssocEntry,
    _get_somtCScopedName,
    _get_somtIDLScopedName,
    _get_somtElementTypeName: somMToken;
  end;
  PSOMTEntryCClassDataStructure = ^SOMTEntryCClassDataStructure;

var
  SOME_DLL_SOMTEntryCClassData: PSOMTEntryCClassDataStructure = nil;

function SOMTEntryCClassData: PSOMTEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTEntryCClassData) then
    Result := SOME_DLL_SOMTEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTEntryCClassData, 'SOMTEntryCClassData');
    Result := SOME_DLL_SOMTEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTEntryCCClassDataStructure = ^SOMTEntryCCClassDataStructure;

var
  SOME_DLL_SOMTEntryCCClassData: PSOMTEntryCCClassDataStructure = nil;

function SOMTEntryCCClassData: PSOMTEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTEntryCCClassData) then
    Result := SOME_DLL_SOMTEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTEntryCCClassData, 'SOMTEntryCCClassData');
    Result := SOME_DLL_SOMTEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtEntryName
 *)
type
  somTD_SOMTEntryC__get_somtEntryName = function(somSelf: SOMObjectBase{SOMTEntryC}): CORBAString; stdcall;

function SOMTEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtEntryName
 *)
type
  somTD_SOMTEntryC__set_somtEntryName = procedure(somSelf: SOMObjectBase{SOMTEntryC}; somtEntryName: CORBAString); stdcall;

procedure SOMTEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtElementType
 *)
type
  somTD_SOMTEntryC__get_somtElementType = function(somSelf: SOMObjectBase{SOMTEntryC}): LongWord; stdcall;

function SOMTEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtElementType
 *)
type
  somTD_SOMTEntryC__set_somtElementType = procedure(somSelf: SOMObjectBase{SOMTEntryC}; somtElementType: LongWord); stdcall;

procedure SOMTEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtElementTypeName
 *)
type
  somTD_SOMTEntryC__get_somtElementTypeName = function(somSelf: SOMObjectBase{SOMTEntryC}): CORBAString; stdcall;

function SOMTEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtEntryComment
 *)
type
  somTD_SOMTEntryC__get_somtEntryComment = function(somSelf: SOMObjectBase{SOMTEntryC}): CORBAString; stdcall;

function SOMTEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtSourceLineNumber
 *)
type
  somTD_SOMTEntryC__get_somtSourceLineNumber = function(somSelf: SOMObjectBase{SOMTEntryC}): LongWord; stdcall;

function SOMTEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtTypeCode
 *)
type
  somTD_SOMTEntryC__get_somtTypeCode = function(somSelf: SOMObjectBase{SOMTEntryC}): TypeCode; stdcall;

function SOMTEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtIsReference
 *)
type
  somTD_SOMTEntryC__get_somtIsReference = function(somSelf: SOMObjectBase{SOMTEntryC}): CORBABoolean; stdcall;

function SOMTEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtIDLScopedName
 *)
type
  somTD_SOMTEntryC__get_somtIDLScopedName = function(somSelf: SOMObjectBase{SOMTEntryC}): CORBAString; stdcall;

function SOMTEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtCScopedName
 *)
type
  somTD_SOMTEntryC__get_somtCScopedName = function(somSelf: SOMObjectBase{SOMTEntryC}): CORBAString; stdcall;

function SOMTEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTEntryC.Create: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTEntryC.InitInstance(Instance: Pointer): SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTEntryC.NewInstance: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTEntryC.Clone: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetModifierValue
 *)
type
  somTD_SOMTEntryC_somtGetModifierValue = function(somSelf: SOMObjectBase{SOMTEntryC}; modifierName: CORBAString): CORBAString; stdcall;

function SOMTEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstModifier
 *)
type
  somTD_SOMTEntryC_somtGetFirstModifier = function(somSelf: SOMObjectBase{SOMTEntryC}; var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; stdcall;

function SOMTEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextModifier
 *)
type
  somTD_SOMTEntryC_somtGetNextModifier = function(somSelf: SOMObjectBase{SOMTEntryC}; var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; stdcall;

function SOMTEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtFormatModifier
 *)
type
  somTD_SOMTEntryC_somtFormatModifier = function(somSelf: SOMObjectBase{SOMTEntryC}; buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; stdcall;

function SOMTEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetModifierList
 *)
type
  somTD_SOMTEntryC_somtGetModifierList = function(somSelf: SOMObjectBase{SOMTEntryC}; buffer: CORBAString): LongInt; stdcall;

function SOMTEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtSetSymbolsOnEntry
 *)
type
  somTD_SOMTEntryC_somtSetSymbolsOnEntry = function(somSelf: SOMObjectBase{SOMTEntryC}; emitter: SOMTEmitC; prefix: CORBAString): LongInt; stdcall;

function SOMTEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtSetEntryStruct
 *)
type
  somTD_SOMTEntryC_somtSetEntryStruct = procedure(somSelf: SOMObjectBase{SOMTEntryC}; var es: Pointer); stdcall;

procedure SOMTEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTEntryC): SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTEntryC): SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTEntryC): SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTEntryC): SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEntryC.somPrintSelf: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTEntryC.NewClass: SOMClass;
begin
  if Self = SOMTEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTAttributeEntryC_MajorVersion = 2;
  SOMTAttributeEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTAttributeEntryCNewClass(
  somtmajorVersion: integer4 = SOMTAttributeEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTAttributeEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTAttributeEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTAttributeEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtIsReadonly,
    _get_somtAttribType,
    somtGetFirstAttributeDeclarator,
    somtGetNextAttributeDeclarator,
    somtGetFirstGetMethod,
    somtGetNextGetMethod,
    somtGetFirstSetMethod,
    somtGetNextSetMethod: somMToken;
  end;
  PSOMTAttributeEntryCClassDataStructure = ^SOMTAttributeEntryCClassDataStructure;

var
  SOME_DLL_SOMTAttributeEntryCClassData: PSOMTAttributeEntryCClassDataStructure = nil;

function SOMTAttributeEntryCClassData: PSOMTAttributeEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTAttributeEntryCClassData) then
    Result := SOME_DLL_SOMTAttributeEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTAttributeEntryCClassData, 'SOMTAttributeEntryCClassData');
    Result := SOME_DLL_SOMTAttributeEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTAttributeEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTAttributeEntryCCClassDataStructure = ^SOMTAttributeEntryCCClassDataStructure;

var
  SOME_DLL_SOMTAttributeEntryCCClassData: PSOMTAttributeEntryCCClassDataStructure = nil;

function SOMTAttributeEntryCCClassData: PSOMTAttributeEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTAttributeEntryCCClassData) then
    Result := SOME_DLL_SOMTAttributeEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTAttributeEntryCCClassData, 'SOMTAttributeEntryCCClassData');
    Result := SOME_DLL_SOMTAttributeEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtIsReadonly
 *)
type
  somTD_SOMTAttributeEntryC__get_somtIsReadonly = function(somSelf: SOMObjectBase{SOMTAttributeEntryC}): CORBABoolean; stdcall;

function SOMTAttributeEntryC._get_somtIsReadonly: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTAttributeEntryCClassDataStructure;
begin
  cd := SOMTAttributeEntryCClassData;
  Result :=
  somTD_SOMTAttributeEntryC__get_somtIsReadonly
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReadonly))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtAttribType
 *)
type
  somTD_SOMTAttributeEntryC__get_somtAttribType = function(somSelf: SOMObjectBase{SOMTAttributeEntryC}): SOMTEntryC; stdcall;

function SOMTAttributeEntryC._get_somtAttribType: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTAttributeEntryCClassDataStructure;
begin
  cd := SOMTAttributeEntryCClassData;
  Result :=
  somTD_SOMTAttributeEntryC__get_somtAttribType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtAttribType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTAttributeEntryC.Create: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTAttributeEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTAttributeEntryC.InitInstance(Instance: Pointer): SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTAttributeEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTAttributeEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTAttributeEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTAttributeEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTAttributeEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTAttributeEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTAttributeEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTAttributeEntryC.NewInstance: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTAttributeEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTAttributeEntryC.Clone: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTAttributeEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetFirstAttributeDeclarator
 *)
type
  somTD_SOMTAttributeEntryC_somtGetFirstAttributeDeclarator = function(somSelf: SOMObjectBase{SOMTAttributeEntryC}): SOMTDataEntryC; stdcall;

function SOMTAttributeEntryC.somtGetFirstAttributeDeclarator: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTAttributeEntryCClassDataStructure;
begin
  cd := SOMTAttributeEntryCClassData;
  Result :=
  somTD_SOMTAttributeEntryC_somtGetFirstAttributeDeclarator
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstAttributeDeclarator))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextAttributeDeclarator
 *)
type
  somTD_SOMTAttributeEntryC_somtGetNextAttributeDeclarator = function(somSelf: SOMObjectBase{SOMTAttributeEntryC}): SOMTDataEntryC; stdcall;

function SOMTAttributeEntryC.somtGetNextAttributeDeclarator: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTAttributeEntryCClassDataStructure;
begin
  cd := SOMTAttributeEntryCClassData;
  Result :=
  somTD_SOMTAttributeEntryC_somtGetNextAttributeDeclarator
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextAttributeDeclarator))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstGetMethod
 *)
type
  somTD_SOMTAttributeEntryC_somtGetFirstGetMethod = function(somSelf: SOMObjectBase{SOMTAttributeEntryC}): SOMTMethodEntryC; stdcall;

function SOMTAttributeEntryC.somtGetFirstGetMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTAttributeEntryCClassDataStructure;
begin
  cd := SOMTAttributeEntryCClassData;
  Result :=
  somTD_SOMTAttributeEntryC_somtGetFirstGetMethod
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstGetMethod))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextGetMethod
 *)
type
  somTD_SOMTAttributeEntryC_somtGetNextGetMethod = function(somSelf: SOMObjectBase{SOMTAttributeEntryC}): SOMTMethodEntryC; stdcall;

function SOMTAttributeEntryC.somtGetNextGetMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTAttributeEntryCClassDataStructure;
begin
  cd := SOMTAttributeEntryCClassData;
  Result :=
  somTD_SOMTAttributeEntryC_somtGetNextGetMethod
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextGetMethod))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstSetMethod
 *)
type
  somTD_SOMTAttributeEntryC_somtGetFirstSetMethod = function(somSelf: SOMObjectBase{SOMTAttributeEntryC}): SOMTMethodEntryC; stdcall;

function SOMTAttributeEntryC.somtGetFirstSetMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTAttributeEntryCClassDataStructure;
begin
  cd := SOMTAttributeEntryCClassData;
  Result :=
  somTD_SOMTAttributeEntryC_somtGetFirstSetMethod
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstSetMethod))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextSetMethod
 *)
type
  somTD_SOMTAttributeEntryC_somtGetNextSetMethod = function(somSelf: SOMObjectBase{SOMTAttributeEntryC}): SOMTMethodEntryC; stdcall;

function SOMTAttributeEntryC.somtGetNextSetMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTAttributeEntryCClassDataStructure;
begin
  cd := SOMTAttributeEntryCClassData;
  Result :=
  somTD_SOMTAttributeEntryC_somtGetNextSetMethod
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextSetMethod))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTAttributeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTAttributeEntryC): SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTAttributeEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTAttributeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTAttributeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTAttributeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTAttributeEntryC): SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTAttributeEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTAttributeEntryC): SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTAttributeEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTAttributeEntryC): SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTAttributeEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTAttributeEntryC.somPrintSelf: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTAttributeEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTAttributeEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTAttributeEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTAttributeEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTAttributeEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTAttributeEntryC.NewClass: SOMClass;
begin
  if Self = SOMTAttributeEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTAttributeEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTAttributeEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTAttributeEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTAttributeEntryC.As_SOMTAttributeEntryC: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTAttributeEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTAttributeEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTAttributeEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTAttributeEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTBaseClassEntryC_MajorVersion = 2;
  SOMTBaseClassEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTBaseClassEntryCNewClass(
  somtmajorVersion: integer4 = SOMTBaseClassEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTBaseClassEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTBaseClassEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTBaseClassEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtBaseClassDef: somMToken;
  end;
  PSOMTBaseClassEntryCClassDataStructure = ^SOMTBaseClassEntryCClassDataStructure;

var
  SOME_DLL_SOMTBaseClassEntryCClassData: PSOMTBaseClassEntryCClassDataStructure = nil;

function SOMTBaseClassEntryCClassData: PSOMTBaseClassEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTBaseClassEntryCClassData) then
    Result := SOME_DLL_SOMTBaseClassEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTBaseClassEntryCClassData, 'SOMTBaseClassEntryCClassData');
    Result := SOME_DLL_SOMTBaseClassEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTBaseClassEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTBaseClassEntryCCClassDataStructure = ^SOMTBaseClassEntryCCClassDataStructure;

var
  SOME_DLL_SOMTBaseClassEntryCCClassData: PSOMTBaseClassEntryCCClassDataStructure = nil;

function SOMTBaseClassEntryCCClassData: PSOMTBaseClassEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTBaseClassEntryCCClassData) then
    Result := SOME_DLL_SOMTBaseClassEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTBaseClassEntryCCClassData, 'SOMTBaseClassEntryCCClassData');
    Result := SOME_DLL_SOMTBaseClassEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtBaseClassDef
 *)
type
  somTD_SOMTBaseClassEntryC__get_somtBaseClassDef = function(somSelf: SOMObjectBase{SOMTBaseClassEntryC}): SOMTClassEntryC; stdcall;

function SOMTBaseClassEntryC._get_somtBaseClassDef: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTBaseClassEntryCClassDataStructure;
begin
  cd := SOMTBaseClassEntryCClassData;
  Result :=
  somTD_SOMTBaseClassEntryC__get_somtBaseClassDef
   (SOM_Resolve(Self, cd.classObject, cd._get_somtBaseClassDef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTBaseClassEntryC.Create: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTBaseClassEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTBaseClassEntryC.InitInstance(Instance: Pointer): SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTBaseClassEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTBaseClassEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTBaseClassEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTBaseClassEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTBaseClassEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTBaseClassEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTBaseClassEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTBaseClassEntryC.NewInstance: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTBaseClassEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTBaseClassEntryC.Clone: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTBaseClassEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMTBaseClassEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC): SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTBaseClassEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC): SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTBaseClassEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC): SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTBaseClassEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTBaseClassEntryC): SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTBaseClassEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTBaseClassEntryC.somPrintSelf: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTBaseClassEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTBaseClassEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTBaseClassEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTBaseClassEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTBaseClassEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTBaseClassEntryC.NewClass: SOMClass;
begin
  if Self = SOMTBaseClassEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTBaseClassEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTBaseClassEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTBaseClassEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTBaseClassEntryC.As_SOMTBaseClassEntryC: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTBaseClassEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTBaseClassEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTBaseClassEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTBaseClassEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTClassEntryC_MajorVersion = 2;
  SOMTClassEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTClassEntryCNewClass(
  somtmajorVersion: integer4 = SOMTClassEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTClassEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTClassEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTClassEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtSourceFileName,
    _get_somtMetaClassEntry,
    _get_somtNewMethodCount,
    _get_somtLocalInclude,
    _get_somtPrivateMethodCount,
    _get_somtStaticMethodCount,
    _get_somtOverrideMethodCount,
    _get_somtProcMethodCount,
    _get_somtVAMethodCount,
    _get_somtBaseCount,
    _get_somtExternalDataCount,
    _get_somtPublicDataCount,
    _get_somtPrivateDataCount,
    somtGetFirstBaseClass,
    somtGetNextBaseClass,
    somtGetFirstReleaseName,
    somtGetNextReleaseName,
    somtGetReleaseNameList,
    somtGetFirstPassthru,
    somtGetNextPassthru,
    somtGetFirstData,
    somtGetNextData,
    somtGetFirstMethod,
    somtGetNextMethod,
    somtGetFirstInheritedMethod,
    somtGetNextInheritedMethod,
    somtFilterNew,
    somtFilterOverridden,
    somtFilterPrivOrPub,
    _get_somtMetaclassFor,
    _get_somtForwardRef,
    somtGetFirstAttribute,
    somtGetNextAttribute,
    somtGetFirstStruct,
    somtGetNextStruct,
    somtGetFirstTypedef,
    somtGetNextTypedef,
    somtGetFirstUnion,
    somtGetNextUnion,
    somtGetFirstEnum,
    somtGetNextEnum,
    somtGetFirstConstant,
    somtGetNextConstant,
    somtGetFirstSequence,
    somtGetNextSequence,
    _get_somtClassModule,
    somtGetFirstPubdef,
    somtGetNextPubdef,
    somtGetFirstStaticData,
    somtGetNextStaticData: somMToken;
  end;
  PSOMTClassEntryCClassDataStructure = ^SOMTClassEntryCClassDataStructure;

var
  SOME_DLL_SOMTClassEntryCClassData: PSOMTClassEntryCClassDataStructure = nil;

function SOMTClassEntryCClassData: PSOMTClassEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTClassEntryCClassData) then
    Result := SOME_DLL_SOMTClassEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTClassEntryCClassData, 'SOMTClassEntryCClassData');
    Result := SOME_DLL_SOMTClassEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTClassEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTClassEntryCCClassDataStructure = ^SOMTClassEntryCCClassDataStructure;

var
  SOME_DLL_SOMTClassEntryCCClassData: PSOMTClassEntryCCClassDataStructure = nil;

function SOMTClassEntryCCClassData: PSOMTClassEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTClassEntryCCClassData) then
    Result := SOME_DLL_SOMTClassEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTClassEntryCCClassData, 'SOMTClassEntryCCClassData');
    Result := SOME_DLL_SOMTClassEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtSourceFileName
 *)
type
  somTD_SOMTClassEntryC__get_somtSourceFileName = function(somSelf: SOMObjectBase{SOMTClassEntryC}): CORBAString; stdcall;

function SOMTClassEntryC._get_somtSourceFileName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtSourceFileName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceFileName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtMetaClassEntry
 *)
type
  somTD_SOMTClassEntryC__get_somtMetaClassEntry = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTMetaClassEntryC; stdcall;

function SOMTClassEntryC._get_somtMetaClassEntry: SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtMetaClassEntry
   (SOM_Resolve(Self, cd.classObject, cd._get_somtMetaClassEntry))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtClassModule
 *)
type
  somTD_SOMTClassEntryC__get_somtClassModule = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTModuleEntryC; stdcall;

function SOMTClassEntryC._get_somtClassModule: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtClassModule
   (SOM_Resolve(Self, cd.classObject, cd._get_somtClassModule))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtNewMethodCount
 *)
type
  somTD_SOMTClassEntryC__get_somtNewMethodCount = function(somSelf: SOMObjectBase{SOMTClassEntryC}): LongInt; stdcall;

function SOMTClassEntryC._get_somtNewMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtNewMethodCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtNewMethodCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtLocalInclude
 *)
type
  somTD_SOMTClassEntryC__get_somtLocalInclude = function(somSelf: SOMObjectBase{SOMTClassEntryC}): CORBABoolean; stdcall;

function SOMTClassEntryC._get_somtLocalInclude: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtLocalInclude
   (SOM_Resolve(Self, cd.classObject, cd._get_somtLocalInclude))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtPrivateMethodCount
 *)
type
  somTD_SOMTClassEntryC__get_somtPrivateMethodCount = function(somSelf: SOMObjectBase{SOMTClassEntryC}): LongInt; stdcall;

function SOMTClassEntryC._get_somtPrivateMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtPrivateMethodCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPrivateMethodCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtStaticMethodCount
 *)
type
  somTD_SOMTClassEntryC__get_somtStaticMethodCount = function(somSelf: SOMObjectBase{SOMTClassEntryC}): LongInt; stdcall;

function SOMTClassEntryC._get_somtStaticMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtStaticMethodCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtStaticMethodCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtOverrideMethodCount
 *)
type
  somTD_SOMTClassEntryC__get_somtOverrideMethodCount = function(somSelf: SOMObjectBase{SOMTClassEntryC}): LongInt; stdcall;

function SOMTClassEntryC._get_somtOverrideMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtOverrideMethodCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtOverrideMethodCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtProcMethodCount
 *)
type
  somTD_SOMTClassEntryC__get_somtProcMethodCount = function(somSelf: SOMObjectBase{SOMTClassEntryC}): LongInt; stdcall;

function SOMTClassEntryC._get_somtProcMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtProcMethodCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtProcMethodCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtVAMethodCount
 *)
type
  somTD_SOMTClassEntryC__get_somtVAMethodCount = function(somSelf: SOMObjectBase{SOMTClassEntryC}): LongInt; stdcall;

function SOMTClassEntryC._get_somtVAMethodCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtVAMethodCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtVAMethodCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtBaseCount
 *)
type
  somTD_SOMTClassEntryC__get_somtBaseCount = function(somSelf: SOMObjectBase{SOMTClassEntryC}): LongInt; stdcall;

function SOMTClassEntryC._get_somtBaseCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtBaseCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtBaseCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtExternalDataCount
 *)
type
  somTD_SOMTClassEntryC__get_somtExternalDataCount = function(somSelf: SOMObjectBase{SOMTClassEntryC}): LongInt; stdcall;

function SOMTClassEntryC._get_somtExternalDataCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtExternalDataCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtExternalDataCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtPublicDataCount
 *)
type
  somTD_SOMTClassEntryC__get_somtPublicDataCount = function(somSelf: SOMObjectBase{SOMTClassEntryC}): LongInt; stdcall;

function SOMTClassEntryC._get_somtPublicDataCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtPublicDataCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPublicDataCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtPrivateDataCount
 *)
type
  somTD_SOMTClassEntryC__get_somtPrivateDataCount = function(somSelf: SOMObjectBase{SOMTClassEntryC}): LongInt; stdcall;

function SOMTClassEntryC._get_somtPrivateDataCount: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtPrivateDataCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPrivateDataCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtMetaclassFor
 *)
type
  somTD_SOMTClassEntryC__get_somtMetaclassFor = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTClassEntryC; stdcall;

function SOMTClassEntryC._get_somtMetaclassFor: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtMetaclassFor
   (SOM_Resolve(Self, cd.classObject, cd._get_somtMetaclassFor))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtForwardRef
 *)
type
  somTD_SOMTClassEntryC__get_somtForwardRef = function(somSelf: SOMObjectBase{SOMTClassEntryC}): CORBABoolean; stdcall;

function SOMTClassEntryC._get_somtForwardRef: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC__get_somtForwardRef
   (SOM_Resolve(Self, cd.classObject, cd._get_somtForwardRef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTClassEntryC.Create: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTClassEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTClassEntryC.InitInstance(Instance: Pointer): SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTClassEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTClassEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTClassEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTClassEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTClassEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTClassEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTClassEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTClassEntryC.NewInstance: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTClassEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTClassEntryC.Clone: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTClassEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetFirstBaseClass
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstBaseClass = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTBaseClassEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstBaseClass: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstBaseClass
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstBaseClass))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextBaseClass
 *)
type
  somTD_SOMTClassEntryC_somtGetNextBaseClass = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTBaseClassEntryC; stdcall;

function SOMTClassEntryC.somtGetNextBaseClass: SOMTBaseClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextBaseClass
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextBaseClass))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstReleaseName
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstReleaseName = function(somSelf: SOMObjectBase{SOMTClassEntryC}): CORBAString; stdcall;

function SOMTClassEntryC.somtGetFirstReleaseName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstReleaseName
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstReleaseName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextReleaseName
 *)
type
  somTD_SOMTClassEntryC_somtGetNextReleaseName = function(somSelf: SOMObjectBase{SOMTClassEntryC}): CORBAString; stdcall;

function SOMTClassEntryC.somtGetNextReleaseName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextReleaseName
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextReleaseName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetReleaseNameList
 *)
type
  somTD_SOMTClassEntryC_somtGetReleaseNameList = function(somSelf: SOMObjectBase{SOMTClassEntryC}; buffer: CORBAString): LongInt; stdcall;

function SOMTClassEntryC.somtGetReleaseNameList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetReleaseNameList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetReleaseNameList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstPassthru
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstPassthru = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTPassthruEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstPassthru: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstPassthru
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstPassthru))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextPassthru
 *)
type
  somTD_SOMTClassEntryC_somtGetNextPassthru = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTPassthruEntryC; stdcall;

function SOMTClassEntryC.somtGetNextPassthru: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextPassthru
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextPassthru))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstData
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstData = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTDataEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstData: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstData
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstData))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextData
 *)
type
  somTD_SOMTClassEntryC_somtGetNextData = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTDataEntryC; stdcall;

function SOMTClassEntryC.somtGetNextData: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextData
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextData))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstStaticData
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstStaticData = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTDataEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstStaticData: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstStaticData
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstStaticData))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextStaticData
 *)
type
  somTD_SOMTClassEntryC_somtGetNextStaticData = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTDataEntryC; stdcall;

function SOMTClassEntryC.somtGetNextStaticData: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextStaticData
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextStaticData))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstMethod
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstMethod = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTMethodEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstMethod
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstMethod))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextMethod
 *)
type
  somTD_SOMTClassEntryC_somtGetNextMethod = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTMethodEntryC; stdcall;

function SOMTClassEntryC.somtGetNextMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextMethod
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextMethod))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstInheritedMethod
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstInheritedMethod = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTMethodEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstInheritedMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstInheritedMethod
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstInheritedMethod))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextInheritedMethod
 *)
type
  somTD_SOMTClassEntryC_somtGetNextInheritedMethod = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTMethodEntryC; stdcall;

function SOMTClassEntryC.somtGetNextInheritedMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextInheritedMethod
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextInheritedMethod))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstAttribute
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstAttribute = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTAttributeEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstAttribute: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstAttribute
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstAttribute))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextAttribute
 *)
type
  somTD_SOMTClassEntryC_somtGetNextAttribute = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTAttributeEntryC; stdcall;

function SOMTClassEntryC.somtGetNextAttribute: SOMTAttributeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextAttribute
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextAttribute))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstStruct
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstStruct = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTStructEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstStruct: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstStruct))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextStruct
 *)
type
  somTD_SOMTClassEntryC_somtGetNextStruct = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTStructEntryC; stdcall;

function SOMTClassEntryC.somtGetNextStruct: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextStruct))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstTypedef
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstTypedef = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTTypedefEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstTypedef: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstTypedef
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstTypedef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextTypedef
 *)
type
  somTD_SOMTClassEntryC_somtGetNextTypedef = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTTypedefEntryC; stdcall;

function SOMTClassEntryC.somtGetNextTypedef: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextTypedef
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextTypedef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstUnion
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstUnion = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTUnionEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstUnion: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstUnion
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstUnion))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextUnion
 *)
type
  somTD_SOMTClassEntryC_somtGetNextUnion = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTUnionEntryC; stdcall;

function SOMTClassEntryC.somtGetNextUnion: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextUnion
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextUnion))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstEnum
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstEnum = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTEnumEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstEnum: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstEnum
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstEnum))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextEnum
 *)
type
  somTD_SOMTClassEntryC_somtGetNextEnum = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTEnumEntryC; stdcall;

function SOMTClassEntryC.somtGetNextEnum: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextEnum
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextEnum))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstConstant
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstConstant = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTConstEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstConstant: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstConstant
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstConstant))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextConstant
 *)
type
  somTD_SOMTClassEntryC_somtGetNextConstant = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTConstEntryC; stdcall;

function SOMTClassEntryC.somtGetNextConstant: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextConstant
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextConstant))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstSequence
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstSequence = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTSequenceEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstSequence: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstSequence
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstSequence))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextSequence
 *)
type
  somTD_SOMTClassEntryC_somtGetNextSequence = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTSequenceEntryC; stdcall;

function SOMTClassEntryC.somtGetNextSequence: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextSequence
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextSequence))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstPubdef
 *)
type
  somTD_SOMTClassEntryC_somtGetFirstPubdef = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTEntryC; stdcall;

function SOMTClassEntryC.somtGetFirstPubdef: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetFirstPubdef
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstPubdef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextPubdef
 *)
type
  somTD_SOMTClassEntryC_somtGetNextPubdef = function(somSelf: SOMObjectBase{SOMTClassEntryC}): SOMTEntryC; stdcall;

function SOMTClassEntryC.somtGetNextPubdef: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtGetNextPubdef
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextPubdef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtFilterNew
 *)
type
  somTD_SOMTClassEntryC_somtFilterNew = function(somSelf: SOMObjectBase{SOMTClassEntryC}; entry: SOMTMethodEntryC): CORBABoolean; stdcall;

function SOMTClassEntryC.somtFilterNew(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtFilterNew
   (SOM_Resolve(Self, cd.classObject, cd.somtFilterNew))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtFilterOverridden
 *)
type
  somTD_SOMTClassEntryC_somtFilterOverridden = function(somSelf: SOMObjectBase{SOMTClassEntryC}; entry: SOMTMethodEntryC): CORBABoolean; stdcall;

function SOMTClassEntryC.somtFilterOverridden(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtFilterOverridden
   (SOM_Resolve(Self, cd.classObject, cd.somtFilterOverridden))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtFilterPrivOrPub
 *)
type
  somTD_SOMTClassEntryC_somtFilterPrivOrPub = function(somSelf: SOMObjectBase{SOMTClassEntryC}; entry: SOMTCommonEntryC): CORBABoolean; stdcall;

function SOMTClassEntryC.somtFilterPrivOrPub(entry: SOMTCommonEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTClassEntryCClassDataStructure;
begin
  cd := SOMTClassEntryCClassData;
  Result :=
  somTD_SOMTClassEntryC_somtFilterPrivOrPub
   (SOM_Resolve(Self, cd.classObject, cd.somtFilterPrivOrPub))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTClassEntryC): SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTClassEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTClassEntryC): SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTClassEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTClassEntryC): SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTClassEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTClassEntryC): SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTClassEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTClassEntryC.somPrintSelf: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTClassEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTClassEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTClassEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTClassEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTClassEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTClassEntryC.NewClass: SOMClass;
begin
  if Self = SOMTClassEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTClassEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTClassEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTClassEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTClassEntryC.As_SOMTClassEntryC: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTClassEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTClassEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTClassEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTClassEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTCommonEntryC_MajorVersion = 2;
  SOMTCommonEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTCommonEntryCNewClass(
  somtmajorVersion: integer4 = SOMTCommonEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTCommonEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTCommonEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTCommonEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtSourceText,
    _get_somtType,
    _get_somtVisibility,
    somtIsArray,
    somtIsPointer,
    somtIsArrayDominant,
    _get_somtTypeObj,
    _get_somtPtrs,
    _get_somtArrayDimsString,
    somtGetFirstArrayDimension,
    somtGetNextArrayDimension: somMToken;
  end;
  PSOMTCommonEntryCClassDataStructure = ^SOMTCommonEntryCClassDataStructure;

var
  SOME_DLL_SOMTCommonEntryCClassData: PSOMTCommonEntryCClassDataStructure = nil;

function SOMTCommonEntryCClassData: PSOMTCommonEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTCommonEntryCClassData) then
    Result := SOME_DLL_SOMTCommonEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTCommonEntryCClassData, 'SOMTCommonEntryCClassData');
    Result := SOME_DLL_SOMTCommonEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTCommonEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTCommonEntryCCClassDataStructure = ^SOMTCommonEntryCCClassDataStructure;

var
  SOME_DLL_SOMTCommonEntryCCClassData: PSOMTCommonEntryCCClassDataStructure = nil;

function SOMTCommonEntryCCClassData: PSOMTCommonEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTCommonEntryCCClassData) then
    Result := SOME_DLL_SOMTCommonEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTCommonEntryCCClassData, 'SOMTCommonEntryCCClassData');
    Result := SOME_DLL_SOMTCommonEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtTypeObj
 *)
type
  somTD_SOMTCommonEntryC__get_somtTypeObj = function(somSelf: SOMObjectBase{SOMTCommonEntryC}): SOMTEntryC; stdcall;

function SOMTCommonEntryC._get_somtTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtTypeObj
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtPtrs
 *)
type
  somTD_SOMTCommonEntryC__get_somtPtrs = function(somSelf: SOMObjectBase{SOMTCommonEntryC}): CORBAString; stdcall;

function SOMTCommonEntryC._get_somtPtrs: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtPtrs
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPtrs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtArrayDimsString
 *)
type
  somTD_SOMTCommonEntryC__get_somtArrayDimsString = function(somSelf: SOMObjectBase{SOMTCommonEntryC}): CORBAString; stdcall;

function SOMTCommonEntryC._get_somtArrayDimsString: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtArrayDimsString
   (SOM_Resolve(Self, cd.classObject, cd._get_somtArrayDimsString))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtSourceText
 *)
type
  somTD_SOMTCommonEntryC__get_somtSourceText = function(somSelf: SOMObjectBase{SOMTCommonEntryC}): CORBAString; stdcall;

function SOMTCommonEntryC._get_somtSourceText: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtSourceText
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceText))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtType
 *)
type
  somTD_SOMTCommonEntryC__get_somtType = function(somSelf: SOMObjectBase{SOMTCommonEntryC}): CORBAString; stdcall;

function SOMTCommonEntryC._get_somtType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtVisibility
 *)
type
  somTD_SOMTCommonEntryC__get_somtVisibility = function(somSelf: SOMObjectBase{SOMTCommonEntryC}): somtVisibilityT; stdcall;

function SOMTCommonEntryC._get_somtVisibility: somtVisibilityT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtVisibility
   (SOM_Resolve(Self, cd.classObject, cd._get_somtVisibility))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTCommonEntryC.Create: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTCommonEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTCommonEntryC.InitInstance(Instance: Pointer): SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTCommonEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTCommonEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTCommonEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTCommonEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTCommonEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTCommonEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTCommonEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTCommonEntryC.NewInstance: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTCommonEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTCommonEntryC.Clone: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTCommonEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetFirstArrayDimension
 *)
type
  somTD_SOMTCommonEntryC_somtGetFirstArrayDimension = function(somSelf: SOMObjectBase{SOMTCommonEntryC}): LongWord; stdcall;

function SOMTCommonEntryC.somtGetFirstArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtGetFirstArrayDimension
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstArrayDimension))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextArrayDimension
 *)
type
  somTD_SOMTCommonEntryC_somtGetNextArrayDimension = function(somSelf: SOMObjectBase{SOMTCommonEntryC}): LongWord; stdcall;

function SOMTCommonEntryC.somtGetNextArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtGetNextArrayDimension
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextArrayDimension))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtIsArray
 *)
type
  somTD_SOMTCommonEntryC_somtIsArray = function(somSelf: SOMObjectBase{SOMTCommonEntryC}; out size: LongInt): CORBABoolean; stdcall;

function SOMTCommonEntryC.somtIsArray(out size: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtIsArray
   (SOM_Resolve(Self, cd.classObject, cd.somtIsArray))
     (Self, size);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtIsPointer
 *)
type
  somTD_SOMTCommonEntryC_somtIsPointer = function(somSelf: SOMObjectBase{SOMTCommonEntryC}): CORBABoolean; stdcall;

function SOMTCommonEntryC.somtIsPointer: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtIsPointer
   (SOM_Resolve(Self, cd.classObject, cd.somtIsPointer))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTCommonEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTCommonEntryC): SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTCommonEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTCommonEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTCommonEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTCommonEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTCommonEntryC): SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTCommonEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTCommonEntryC): SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTCommonEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTCommonEntryC): SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTCommonEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTCommonEntryC.somPrintSelf: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTCommonEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTCommonEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTCommonEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTCommonEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTCommonEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTCommonEntryC.NewClass: SOMClass;
begin
  if Self = SOMTCommonEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTCommonEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTCommonEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTCommonEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTCommonEntryC.As_SOMTCommonEntryC: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTCommonEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTCommonEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTCommonEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTCommonEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTConstEntryC_MajorVersion = 2;
  SOMTConstEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTConstEntryCNewClass(
  somtmajorVersion: integer4 = SOMTConstEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTConstEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTConstEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTConstEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtConstStringVal,
    _get_somtConstNumVal,
    _get_somtConstType,
    _get_somtConstTypeObj,
    _get_somtConstVal,
    _get_somtConstNumNegVal,
    _get_somtConstIsNegative: somMToken;
  end;
  PSOMTConstEntryCClassDataStructure = ^SOMTConstEntryCClassDataStructure;

var
  SOME_DLL_SOMTConstEntryCClassData: PSOMTConstEntryCClassDataStructure = nil;

function SOMTConstEntryCClassData: PSOMTConstEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTConstEntryCClassData) then
    Result := SOME_DLL_SOMTConstEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTConstEntryCClassData, 'SOMTConstEntryCClassData');
    Result := SOME_DLL_SOMTConstEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTConstEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTConstEntryCCClassDataStructure = ^SOMTConstEntryCCClassDataStructure;

var
  SOME_DLL_SOMTConstEntryCCClassData: PSOMTConstEntryCCClassDataStructure = nil;

function SOMTConstEntryCCClassData: PSOMTConstEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTConstEntryCCClassData) then
    Result := SOME_DLL_SOMTConstEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTConstEntryCCClassData, 'SOMTConstEntryCCClassData');
    Result := SOME_DLL_SOMTConstEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtConstTypeObj
 *)
type
  somTD_SOMTConstEntryC__get_somtConstTypeObj = function(somSelf: SOMObjectBase{SOMTConstEntryC}): SOMTEntryC; stdcall;

function SOMTConstEntryC._get_somtConstTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTConstEntryCClassDataStructure;
begin
  cd := SOMTConstEntryCClassData;
  Result :=
  somTD_SOMTConstEntryC__get_somtConstTypeObj
   (SOM_Resolve(Self, cd.classObject, cd._get_somtConstTypeObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtConstType
 *)
type
  somTD_SOMTConstEntryC__get_somtConstType = function(somSelf: SOMObjectBase{SOMTConstEntryC}): CORBAString; stdcall;

function SOMTConstEntryC._get_somtConstType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTConstEntryCClassDataStructure;
begin
  cd := SOMTConstEntryCClassData;
  Result :=
  somTD_SOMTConstEntryC__get_somtConstType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtConstType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtConstStringVal
 *)
type
  somTD_SOMTConstEntryC__get_somtConstStringVal = function(somSelf: SOMObjectBase{SOMTConstEntryC}): CORBAString; stdcall;

function SOMTConstEntryC._get_somtConstStringVal: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTConstEntryCClassDataStructure;
begin
  cd := SOMTConstEntryCClassData;
  Result :=
  somTD_SOMTConstEntryC__get_somtConstStringVal
   (SOM_Resolve(Self, cd.classObject, cd._get_somtConstStringVal))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtConstNumVal
 *)
type
  somTD_SOMTConstEntryC__get_somtConstNumVal = function(somSelf: SOMObjectBase{SOMTConstEntryC}): LongWord; stdcall;

function SOMTConstEntryC._get_somtConstNumVal: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTConstEntryCClassDataStructure;
begin
  cd := SOMTConstEntryCClassData;
  Result :=
  somTD_SOMTConstEntryC__get_somtConstNumVal
   (SOM_Resolve(Self, cd.classObject, cd._get_somtConstNumVal))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtConstNumNegVal
 *)
type
  somTD_SOMTConstEntryC__get_somtConstNumNegVal = function(somSelf: SOMObjectBase{SOMTConstEntryC}): LongInt; stdcall;

function SOMTConstEntryC._get_somtConstNumNegVal: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTConstEntryCClassDataStructure;
begin
  cd := SOMTConstEntryCClassData;
  Result :=
  somTD_SOMTConstEntryC__get_somtConstNumNegVal
   (SOM_Resolve(Self, cd.classObject, cd._get_somtConstNumNegVal))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtConstIsNegative
 *)
type
  somTD_SOMTConstEntryC__get_somtConstIsNegative = function(somSelf: SOMObjectBase{SOMTConstEntryC}): CORBABoolean; stdcall;

function SOMTConstEntryC._get_somtConstIsNegative: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTConstEntryCClassDataStructure;
begin
  cd := SOMTConstEntryCClassData;
  Result :=
  somTD_SOMTConstEntryC__get_somtConstIsNegative
   (SOM_Resolve(Self, cd.classObject, cd._get_somtConstIsNegative))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtConstVal
 *)
type
  somTD_SOMTConstEntryC__get_somtConstVal = function(somSelf: SOMObjectBase{SOMTConstEntryC}): CORBAString; stdcall;

function SOMTConstEntryC._get_somtConstVal: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTConstEntryCClassDataStructure;
begin
  cd := SOMTConstEntryCClassData;
  Result :=
  somTD_SOMTConstEntryC__get_somtConstVal
   (SOM_Resolve(Self, cd.classObject, cd._get_somtConstVal))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTConstEntryC.Create: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTConstEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTConstEntryC.InitInstance(Instance: Pointer): SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTConstEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTConstEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTConstEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTConstEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTConstEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTConstEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTConstEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTConstEntryC.NewInstance: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTConstEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTConstEntryC.Clone: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTConstEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMTConstEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTConstEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTConstEntryC): SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTConstEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTConstEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTConstEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTConstEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTConstEntryC): SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTConstEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTConstEntryC): SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTConstEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTConstEntryC): SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTConstEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTConstEntryC.somPrintSelf: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTConstEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTConstEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTConstEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTConstEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTConstEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTConstEntryC.NewClass: SOMClass;
begin
  if Self = SOMTConstEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTConstEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTConstEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTConstEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTConstEntryC.As_SOMTConstEntryC: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTConstEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTConstEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTConstEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTConstEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTDataEntryC_MajorVersion = 2;
  SOMTDataEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTDataEntryCNewClass(
  somtmajorVersion: integer4 = SOMTDataEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTDataEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTDataEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTDataEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtIsSelfRef: somMToken;
  end;
  PSOMTDataEntryCClassDataStructure = ^SOMTDataEntryCClassDataStructure;

var
  SOME_DLL_SOMTDataEntryCClassData: PSOMTDataEntryCClassDataStructure = nil;

function SOMTDataEntryCClassData: PSOMTDataEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTDataEntryCClassData) then
    Result := SOME_DLL_SOMTDataEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTDataEntryCClassData, 'SOMTDataEntryCClassData');
    Result := SOME_DLL_SOMTDataEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTDataEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTDataEntryCCClassDataStructure = ^SOMTDataEntryCCClassDataStructure;

var
  SOME_DLL_SOMTDataEntryCCClassData: PSOMTDataEntryCCClassDataStructure = nil;

function SOMTDataEntryCCClassData: PSOMTDataEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTDataEntryCCClassData) then
    Result := SOME_DLL_SOMTDataEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTDataEntryCCClassData, 'SOMTDataEntryCCClassData');
    Result := SOME_DLL_SOMTDataEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtIsSelfRef
 *)
type
  somTD_SOMTDataEntryC__get_somtIsSelfRef = function(somSelf: SOMObjectBase{SOMTDataEntryC}): CORBABoolean; stdcall;

function SOMTDataEntryC._get_somtIsSelfRef: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTDataEntryCClassDataStructure;
begin
  cd := SOMTDataEntryCClassData;
  Result :=
  somTD_SOMTDataEntryC__get_somtIsSelfRef
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsSelfRef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtTypeObj
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtPtrs: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtPtrs
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPtrs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtArrayDimsString: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtArrayDimsString
   (SOM_Resolve(Self, cd.classObject, cd._get_somtArrayDimsString))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtSourceText: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtSourceText
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceText))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtVisibility: somtVisibilityT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtVisibility
   (SOM_Resolve(Self, cd.classObject, cd._get_somtVisibility))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTDataEntryC.Create: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTDataEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTDataEntryC.InitInstance(Instance: Pointer): SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTDataEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTDataEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTDataEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTDataEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTDataEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTDataEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTDataEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTDataEntryC.NewInstance: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTDataEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTDataEntryC.Clone: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTDataEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMTDataEntryC.somtGetFirstArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtGetFirstArrayDimension
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstArrayDimension))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somtGetNextArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtGetNextArrayDimension
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextArrayDimension))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somtIsArray(out size: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtIsArray
   (SOM_Resolve(Self, cd.classObject, cd.somtIsArray))
     (Self, size);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somtIsPointer: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtIsPointer
   (SOM_Resolve(Self, cd.classObject, cd.somtIsPointer))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTDataEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTDataEntryC): SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTDataEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTDataEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTDataEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTDataEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTDataEntryC): SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTDataEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTDataEntryC): SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTDataEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTDataEntryC): SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTDataEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTDataEntryC.somPrintSelf: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTDataEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTDataEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTDataEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTDataEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTDataEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTDataEntryC.NewClass: SOMClass;
begin
  if Self = SOMTDataEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTDataEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTDataEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTDataEntryC.As_SOMTCommonEntryC: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTCommonEntryC(Self);
end;

function SOMTDataEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTDataEntryC.As_SOMTDataEntryC: SOMTDataEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTDataEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTDataEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTDataEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTDataEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTEmitC_MajorVersion = 2;
  SOMTEmitC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTEmitCNewClass(
  somtmajorVersion: integer4 = SOMTEmitC_MajorVersion;
  somtminorVersion: integer4 = SOMTEmitC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTEmitCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTEmitCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtTemplate,
    _get_somtTargetFile,
    _set_somtTargetFile,
    _get_somtTargetClass,
    _set_somtTargetClass,
    _get_somtTargetModule,
    _set_somtTargetModule,
    _get_somtTargetType,
    _set_somtTargetType,
    somtGenerateSections,
    somtOpenSymbolsFile,
    somtSetPredefinedSymbols,
    somtFileSymbols,
    somtEmitProlog,
    somtEmitBaseIncludesProlog,
    somtEmitBaseIncludes,
    somtEmitBaseIncludesEpilog,
    somtEmitMetaInclude,
    somtEmitClass,
    somtEmitMeta,
    somtEmitBaseProlog,
    somtEmitBase,
    somtEmitBaseEpilog,
    somtEmitPassthruProlog,
    somtEmitPassthru,
    somtEmitPassthruEpilog,
    somtEmitRelease,
    somtEmitDataProlog,
    somtEmitData,
    somtEmitDataEpilog,
    somtEmitMethodsProlog,
    somtEmitMethods,
    somtEmitMethodsEpilog,
    somtEmitMethod,
    somtEmitEpilog,
    somtScanBases,
    somtScanConstants,
    somtCheckVisibility,
    somtNew,
    somtImplemented,
    somtOverridden,
    somtInherited,
    somtAllVisible,
    somtAll,
    somtNewNoProc,
    somtPrivOrPub,
    somtNewProc,
    somtLink,
    somtVA,
    somtScanMethods,
    somtScanData,
    somtScanPassthru,
    somtEmitFullPassthru,
    somtScanDataF,
    somtScanBasesF,
    _set_somtTemplate,
    _set_somtEmitterName,
    _get_somtEmitterName,
    somtEmitAttributeProlog,
    somtEmitAttribute,
    somtEmitAttributeEpilog,
    somtEmitConstantProlog,
    somtEmitConstant,
    somtEmitConstantEpilog,
    somtEmitTypedefProlog,
    somtEmitTypedef,
    somtEmitTypedefEpilog,
    somtEmitStructProlog,
    somtEmitStruct,
    somtEmitStructEpilog,
    somtEmitUnionProlog,
    somtEmitUnion,
    somtEmitUnionEpilog,
    somtEmitEnumProlog,
    somtEmitEnum,
    somtEmitEnumEpilog,
    somtEmitInterfaceProlog,
    somtEmitInterface,
    somtEmitInterfaceEpilog,
    somtEmitModuleProlog,
    somtEmitModule,
    somtEmitModuleEpilog,
    somtScanAttributes,
    somtScanTypedefs,
    somtScanStructs,
    somtScanUnions,
    somtScanEnums,
    somtScanInterfaces,
    somtScanModules,
    somtGetGlobalModifierValue,
    somtGetFirstGlobalDefinition,
    somtGetNextGlobalDefinition: somMToken;
  end;
  PSOMTEmitCClassDataStructure = ^SOMTEmitCClassDataStructure;

var
  SOME_DLL_SOMTEmitCClassData: PSOMTEmitCClassDataStructure = nil;

function SOMTEmitCClassData: PSOMTEmitCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTEmitCClassData) then
    Result := SOME_DLL_SOMTEmitCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTEmitCClassData, 'SOMTEmitCClassData');
    Result := SOME_DLL_SOMTEmitCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTEmitCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTEmitCCClassDataStructure = ^SOMTEmitCCClassDataStructure;

var
  SOME_DLL_SOMTEmitCCClassData: PSOMTEmitCCClassDataStructure = nil;

function SOMTEmitCCClassData: PSOMTEmitCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTEmitCCClassData) then
    Result := SOME_DLL_SOMTEmitCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTEmitCCClassData, 'SOMTEmitCCClassData');
    Result := SOME_DLL_SOMTEmitCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtTemplate
 *)
type
  somTD_SOMTEmitC__get_somtTemplate = function(somSelf: SOMObjectBase{SOMTEmitC}): SOMTTemplateOutputC; stdcall;

function SOMTEmitC._get_somtTemplate: SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC__get_somtTemplate
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTemplate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtTemplate
 *)
type
  somTD_SOMTEmitC__set_somtTemplate = procedure(somSelf: SOMObjectBase{SOMTEmitC}; somtTemplate: SOMTTemplateOutputC); stdcall;

procedure SOMTEmitC._set_somtTemplate(somtTemplate: SOMTTemplateOutputC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC__set_somtTemplate
   (SOM_Resolve(Self, cd.classObject, cd._set_somtTemplate))
     (Self, somtTemplate);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtTargetFile
 *)
type
  somTD_SOMTEmitC__get_somtTargetFile = function(somSelf: SOMObjectBase{SOMTEmitC}): PSOM_FILE; stdcall;

function SOMTEmitC._get_somtTargetFile: PSOM_FILE; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC__get_somtTargetFile
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTargetFile))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtTargetFile
 *)
type
  somTD_SOMTEmitC__set_somtTargetFile = procedure(somSelf: SOMObjectBase{SOMTEmitC}; somtTargetFile: PSOM_FILE); stdcall;

procedure SOMTEmitC._set_somtTargetFile(somtTargetFile: PSOM_FILE); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC__set_somtTargetFile
   (SOM_Resolve(Self, cd.classObject, cd._set_somtTargetFile))
     (Self, somtTargetFile);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtTargetClass
 *)
type
  somTD_SOMTEmitC__get_somtTargetClass = function(somSelf: SOMObjectBase{SOMTEmitC}): SOMTClassEntryC; stdcall;

function SOMTEmitC._get_somtTargetClass: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC__get_somtTargetClass
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTargetClass))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtTargetClass
 *)
type
  somTD_SOMTEmitC__set_somtTargetClass = procedure(somSelf: SOMObjectBase{SOMTEmitC}; somtTargetClass: SOMTClassEntryC); stdcall;

procedure SOMTEmitC._set_somtTargetClass(somtTargetClass: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC__set_somtTargetClass
   (SOM_Resolve(Self, cd.classObject, cd._set_somtTargetClass))
     (Self, somtTargetClass);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtTargetModule
 *)
type
  somTD_SOMTEmitC__get_somtTargetModule = function(somSelf: SOMObjectBase{SOMTEmitC}): SOMTModuleEntryC; stdcall;

function SOMTEmitC._get_somtTargetModule: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC__get_somtTargetModule
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTargetModule))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtTargetModule
 *)
type
  somTD_SOMTEmitC__set_somtTargetModule = procedure(somSelf: SOMObjectBase{SOMTEmitC}; somtTargetModule: SOMTModuleEntryC); stdcall;

procedure SOMTEmitC._set_somtTargetModule(somtTargetModule: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC__set_somtTargetModule
   (SOM_Resolve(Self, cd.classObject, cd._set_somtTargetModule))
     (Self, somtTargetModule);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtTargetType
 *)
type
  somTD_SOMTEmitC__get_somtTargetType = function(somSelf: SOMObjectBase{SOMTEmitC}): SOMTTargetTypeT; stdcall;

function SOMTEmitC._get_somtTargetType: SOMTTargetTypeT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC__get_somtTargetType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTargetType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtTargetType
 *)
type
  somTD_SOMTEmitC__set_somtTargetType = procedure(somSelf: SOMObjectBase{SOMTEmitC}; somtTargetType: SOMTTargetTypeT); stdcall;

procedure SOMTEmitC._set_somtTargetType(somtTargetType: SOMTTargetTypeT); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC__set_somtTargetType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtTargetType))
     (Self, somtTargetType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtEmitterName
 *)
type
  somTD_SOMTEmitC__get_somtEmitterName = function(somSelf: SOMObjectBase{SOMTEmitC}): CORBAString; stdcall;

function SOMTEmitC._get_somtEmitterName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC__get_somtEmitterName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEmitterName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtEmitterName
 *)
type
  somTD_SOMTEmitC__set_somtEmitterName = procedure(somSelf: SOMObjectBase{SOMTEmitC}; somtEmitterName: CORBAString); stdcall;

procedure SOMTEmitC._set_somtEmitterName(somtEmitterName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC__set_somtEmitterName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEmitterName))
     (Self, somtEmitterName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTEmitC.Create: SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEmitC(SOMClass(NewClass).somNew);
end;

class function SOMTEmitC.InitInstance(Instance: Pointer): SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEmitC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTEmitC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTEmitC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTEmitC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTEmitC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTEmitC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTEmitC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTEmitC.NewInstance: SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEmitC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTEmitC.Clone: SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEmitC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGenerateSections
 *)
type
  somTD_SOMTEmitC_somtGenerateSections = function(somSelf: SOMObjectBase{SOMTEmitC}): CORBABoolean; stdcall;

function SOMTEmitC.somtGenerateSections: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtGenerateSections
   (SOM_Resolve(Self, cd.classObject, cd.somtGenerateSections))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtOpenSymbolsFile
 *)
type
  somTD_SOMTEmitC_somtOpenSymbolsFile = function(somSelf: SOMObjectBase{SOMTEmitC}; SOM_file: CORBAString; mode: CORBAString): PSOM_FILE; stdcall;

function SOMTEmitC.somtOpenSymbolsFile(SOM_file: CORBAString; mode: CORBAString): PSOM_FILE; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtOpenSymbolsFile
   (SOM_Resolve(Self, cd.classObject, cd.somtOpenSymbolsFile))
     (Self, SOM_file, mode);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtSetPredefinedSymbols
 *)
type
  somTD_SOMTEmitC_somtSetPredefinedSymbols = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtSetPredefinedSymbols; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtSetPredefinedSymbols
   (SOM_Resolve(Self, cd.classObject, cd.somtSetPredefinedSymbols))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtFileSymbols
 *)
type
  somTD_SOMTEmitC_somtFileSymbols = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtFileSymbols; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtFileSymbols
   (SOM_Resolve(Self, cd.classObject, cd.somtFileSymbols))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitProlog
 *)
type
  somTD_SOMTEmitC_somtEmitProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitBaseIncludesProlog
 *)
type
  somTD_SOMTEmitC_somtEmitBaseIncludesProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitBaseIncludesProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitBaseIncludesProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitBaseIncludesProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitBaseIncludes
 *)
type
  somTD_SOMTEmitC_somtEmitBaseIncludes = procedure(somSelf: SOMObjectBase{SOMTEmitC}; base: SOMTBaseClassEntryC); stdcall;

procedure SOMTEmitC.somtEmitBaseIncludes(base: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitBaseIncludes
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitBaseIncludes))
     (Self, base);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitBaseIncludesEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitBaseIncludesEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitBaseIncludesEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitBaseIncludesEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitBaseIncludesEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitMetaInclude
 *)
type
  somTD_SOMTEmitC_somtEmitMetaInclude = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitMetaInclude; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitMetaInclude
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitMetaInclude))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitClass
 *)
type
  somTD_SOMTEmitC_somtEmitClass = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitClass
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitClass))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitMeta
 *)
type
  somTD_SOMTEmitC_somtEmitMeta = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitMeta; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitMeta
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitMeta))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitBaseProlog
 *)
type
  somTD_SOMTEmitC_somtEmitBaseProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitBaseProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitBaseProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitBaseProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitBase
 *)
type
  somTD_SOMTEmitC_somtEmitBase = procedure(somSelf: SOMObjectBase{SOMTEmitC}; base: SOMTBaseClassEntryC); stdcall;

procedure SOMTEmitC.somtEmitBase(base: SOMTBaseClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitBase
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitBase))
     (Self, base);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitBaseEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitBaseEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitBaseEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitBaseEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitBaseEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitPassthruProlog
 *)
type
  somTD_SOMTEmitC_somtEmitPassthruProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitPassthruProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitPassthruProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitPassthruProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitPassthru
 *)
type
  somTD_SOMTEmitC_somtEmitPassthru = procedure(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTPassthruEntryC); stdcall;

procedure SOMTEmitC.somtEmitPassthru(entry: SOMTPassthruEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitPassthru
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitPassthru))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitPassthruEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitPassthruEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitPassthruEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitPassthruEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitPassthruEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitRelease
 *)
type
  somTD_SOMTEmitC_somtEmitRelease = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitRelease; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitRelease
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitRelease))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitDataProlog
 *)
type
  somTD_SOMTEmitC_somtEmitDataProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitDataProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitDataProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitDataProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitData
 *)
type
  somTD_SOMTEmitC_somtEmitData = procedure(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTDataEntryC); stdcall;

procedure SOMTEmitC.somtEmitData(entry: SOMTDataEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitData
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitData))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitDataEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitDataEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitDataEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitDataEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitDataEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitAttributeProlog
 *)
type
  somTD_SOMTEmitC_somtEmitAttributeProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitAttributeProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitAttributeProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitAttributeProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitAttribute
 *)
type
  somTD_SOMTEmitC_somtEmitAttribute = procedure(somSelf: SOMObjectBase{SOMTEmitC}; att: SOMTAttributeEntryC); stdcall;

procedure SOMTEmitC.somtEmitAttribute(att: SOMTAttributeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitAttribute
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitAttribute))
     (Self, att);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitAttributeEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitAttributeEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitAttributeEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitAttributeEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitAttributeEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitConstantProlog
 *)
type
  somTD_SOMTEmitC_somtEmitConstantProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitConstantProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitConstantProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitConstantProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitConstant
 *)
type
  somTD_SOMTEmitC_somtEmitConstant = procedure(somSelf: SOMObjectBase{SOMTEmitC}; con: SOMTConstEntryC); stdcall;

procedure SOMTEmitC.somtEmitConstant(con: SOMTConstEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitConstant
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitConstant))
     (Self, con);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitConstantEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitConstantEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitConstantEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitConstantEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitConstantEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitTypedefProlog
 *)
type
  somTD_SOMTEmitC_somtEmitTypedefProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitTypedefProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitTypedefProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitTypedefProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitTypedef
 *)
type
  somTD_SOMTEmitC_somtEmitTypedef = procedure(somSelf: SOMObjectBase{SOMTEmitC}; td: SOMTTypedefEntryC); stdcall;

procedure SOMTEmitC.somtEmitTypedef(td: SOMTTypedefEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitTypedef
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitTypedef))
     (Self, td);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitTypedefEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitTypedefEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitTypedefEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitTypedefEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitTypedefEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitStructProlog
 *)
type
  somTD_SOMTEmitC_somtEmitStructProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitStructProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitStructProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitStructProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitStruct
 *)
type
  somTD_SOMTEmitC_somtEmitStruct = procedure(somSelf: SOMObjectBase{SOMTEmitC}; struc: SOMTStructEntryC); stdcall;

procedure SOMTEmitC.somtEmitStruct(struc: SOMTStructEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitStruct))
     (Self, struc);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitStructEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitStructEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitStructEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitStructEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitStructEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitUnionProlog
 *)
type
  somTD_SOMTEmitC_somtEmitUnionProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitUnionProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitUnionProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitUnionProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitUnion
 *)
type
  somTD_SOMTEmitC_somtEmitUnion = procedure(somSelf: SOMObjectBase{SOMTEmitC}; un: SOMTUnionEntryC); stdcall;

procedure SOMTEmitC.somtEmitUnion(un: SOMTUnionEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitUnion
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitUnion))
     (Self, un);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitUnionEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitUnionEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitUnionEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitUnionEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitUnionEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitEnumProlog
 *)
type
  somTD_SOMTEmitC_somtEmitEnumProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitEnumProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitEnumProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitEnumProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitEnum
 *)
type
  somTD_SOMTEmitC_somtEmitEnum = procedure(somSelf: SOMObjectBase{SOMTEmitC}; en: SOMTEnumEntryC); stdcall;

procedure SOMTEmitC.somtEmitEnum(en: SOMTEnumEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitEnum
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitEnum))
     (Self, en);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitEnumEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitEnumEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitEnumEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitEnumEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitEnumEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitInterfaceProlog
 *)
type
  somTD_SOMTEmitC_somtEmitInterfaceProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitInterfaceProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitInterfaceProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitInterfaceProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitInterface
 *)
type
  somTD_SOMTEmitC_somtEmitInterface = procedure(somSelf: SOMObjectBase{SOMTEmitC}; intfc: SOMTClassEntryC); stdcall;

procedure SOMTEmitC.somtEmitInterface(intfc: SOMTClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitInterface
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitInterface))
     (Self, intfc);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitInterfaceEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitInterfaceEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitInterfaceEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitInterfaceEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitInterfaceEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitModuleProlog
 *)
type
  somTD_SOMTEmitC_somtEmitModuleProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitModuleProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitModuleProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitModuleProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitModule
 *)
type
  somTD_SOMTEmitC_somtEmitModule = procedure(somSelf: SOMObjectBase{SOMTEmitC}; SOM_mod: SOMTModuleEntryC); stdcall;

procedure SOMTEmitC.somtEmitModule(SOM_mod: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitModule
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitModule))
     (Self, SOM_mod);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitModuleEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitModuleEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitModuleEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitModuleEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitModuleEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitMethodsProlog
 *)
type
  somTD_SOMTEmitC_somtEmitMethodsProlog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitMethodsProlog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitMethodsProlog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitMethodsProlog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitMethods
 *)
type
  somTD_SOMTEmitC_somtEmitMethods = procedure(somSelf: SOMObjectBase{SOMTEmitC}; method: SOMTMethodEntryC); stdcall;

procedure SOMTEmitC.somtEmitMethods(method: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitMethods
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitMethods))
     (Self, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitMethodsEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitMethodsEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitMethodsEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitMethodsEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitMethodsEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitMethod
 *)
type
  somTD_SOMTEmitC_somtEmitMethod = procedure(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTMethodEntryC); stdcall;

procedure SOMTEmitC.somtEmitMethod(entry: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitMethod
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitMethod))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitEpilog
 *)
type
  somTD_SOMTEmitC_somtEmitEpilog = procedure(somSelf: SOMObjectBase{SOMTEmitC}); stdcall;

procedure SOMTEmitC.somtEmitEpilog; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitEpilog
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitEpilog))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanBases
 *)
type
  somTD_SOMTEmitC_somtScanBases = function(somSelf: SOMObjectBase{SOMTEmitC}; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanBases(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanBases
   (SOM_Resolve(Self, cd.classObject, cd.somtScanBases))
     (Self, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtCheckVisibility
 *)
type
  somTD_SOMTEmitC_somtCheckVisibility = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTMethodEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtCheckVisibility(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtCheckVisibility
   (SOM_Resolve(Self, cd.classObject, cd.somtCheckVisibility))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtNew
 *)
type
  somTD_SOMTEmitC_somtNew = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTMethodEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtNew(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtNew
   (SOM_Resolve(Self, cd.classObject, cd.somtNew))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtImplemented
 *)
type
  somTD_SOMTEmitC_somtImplemented = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTMethodEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtImplemented(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtImplemented
   (SOM_Resolve(Self, cd.classObject, cd.somtImplemented))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtOverridden
 *)
type
  somTD_SOMTEmitC_somtOverridden = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTMethodEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtOverridden(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtOverridden
   (SOM_Resolve(Self, cd.classObject, cd.somtOverridden))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtInherited
 *)
type
  somTD_SOMTEmitC_somtInherited = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTMethodEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtInherited(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtInherited
   (SOM_Resolve(Self, cd.classObject, cd.somtInherited))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtAllVisible
 *)
type
  somTD_SOMTEmitC_somtAllVisible = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTMethodEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtAllVisible(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtAllVisible
   (SOM_Resolve(Self, cd.classObject, cd.somtAllVisible))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtAll
 *)
type
  somTD_SOMTEmitC_somtAll = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTMethodEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtAll(entry: SOMTMethodEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtAll
   (SOM_Resolve(Self, cd.classObject, cd.somtAll))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtNewNoProc
 *)
type
  somTD_SOMTEmitC_somtNewNoProc = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtNewNoProc(entry: SOMTEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtNewNoProc
   (SOM_Resolve(Self, cd.classObject, cd.somtNewNoProc))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtPrivOrPub
 *)
type
  somTD_SOMTEmitC_somtPrivOrPub = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtPrivOrPub(entry: SOMTEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtPrivOrPub
   (SOM_Resolve(Self, cd.classObject, cd.somtPrivOrPub))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtNewProc
 *)
type
  somTD_SOMTEmitC_somtNewProc = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtNewProc(entry: SOMTEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtNewProc
   (SOM_Resolve(Self, cd.classObject, cd.somtNewProc))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtLink
 *)
type
  somTD_SOMTEmitC_somtLink = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtLink(entry: SOMTEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtLink
   (SOM_Resolve(Self, cd.classObject, cd.somtLink))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtVA
 *)
type
  somTD_SOMTEmitC_somtVA = function(somSelf: SOMObjectBase{SOMTEmitC}; entry: SOMTEntryC): CORBABoolean; stdcall;

function SOMTEmitC.somtVA(entry: SOMTEntryC): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtVA
   (SOM_Resolve(Self, cd.classObject, cd.somtVA))
     (Self, entry);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanMethods
 *)
type
  somTD_SOMTEmitC_somtScanMethods = function(somSelf: SOMObjectBase{SOMTEmitC}; filter: CORBAString; prolog: CORBAString; each: CORBAString; epilog: CORBAString; forceProlog: CORBABoolean): CORBABoolean; stdcall;

function SOMTEmitC.somtScanMethods(filter: CORBAString; prolog: CORBAString; each: CORBAString; epilog: CORBAString; forceProlog: CORBABoolean): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanMethods
   (SOM_Resolve(Self, cd.classObject, cd.somtScanMethods))
     (Self, filter, prolog, each, epilog, forceProlog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanConstants
 *)
type
  somTD_SOMTEmitC_somtScanConstants = function(somSelf: SOMObjectBase{SOMTEmitC}; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanConstants(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanConstants
   (SOM_Resolve(Self, cd.classObject, cd.somtScanConstants))
     (Self, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanTypedefs
 *)
type
  somTD_SOMTEmitC_somtScanTypedefs = function(somSelf: SOMObjectBase{SOMTEmitC}; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanTypedefs(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanTypedefs
   (SOM_Resolve(Self, cd.classObject, cd.somtScanTypedefs))
     (Self, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanStructs
 *)
type
  somTD_SOMTEmitC_somtScanStructs = function(somSelf: SOMObjectBase{SOMTEmitC}; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanStructs(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanStructs
   (SOM_Resolve(Self, cd.classObject, cd.somtScanStructs))
     (Self, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanUnions
 *)
type
  somTD_SOMTEmitC_somtScanUnions = function(somSelf: SOMObjectBase{SOMTEmitC}; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanUnions(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanUnions
   (SOM_Resolve(Self, cd.classObject, cd.somtScanUnions))
     (Self, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanEnums
 *)
type
  somTD_SOMTEmitC_somtScanEnums = function(somSelf: SOMObjectBase{SOMTEmitC}; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanEnums(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanEnums
   (SOM_Resolve(Self, cd.classObject, cd.somtScanEnums))
     (Self, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanData
 *)
type
  somTD_SOMTEmitC_somtScanData = function(somSelf: SOMObjectBase{SOMTEmitC}; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanData(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanData
   (SOM_Resolve(Self, cd.classObject, cd.somtScanData))
     (Self, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanAttributes
 *)
type
  somTD_SOMTEmitC_somtScanAttributes = function(somSelf: SOMObjectBase{SOMTEmitC}; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanAttributes(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanAttributes
   (SOM_Resolve(Self, cd.classObject, cd.somtScanAttributes))
     (Self, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanInterfaces
 *)
type
  somTD_SOMTEmitC_somtScanInterfaces = function(somSelf: SOMObjectBase{SOMTEmitC}; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanInterfaces(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanInterfaces
   (SOM_Resolve(Self, cd.classObject, cd.somtScanInterfaces))
     (Self, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanModules
 *)
type
  somTD_SOMTEmitC_somtScanModules = function(somSelf: SOMObjectBase{SOMTEmitC}; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanModules(prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanModules
   (SOM_Resolve(Self, cd.classObject, cd.somtScanModules))
     (Self, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanPassthru
 *)
type
  somTD_SOMTEmitC_somtScanPassthru = function(somSelf: SOMObjectBase{SOMTEmitC}; before: CORBABoolean; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; stdcall;

function SOMTEmitC.somtScanPassthru(before: CORBABoolean; prolog: CORBAString; each: CORBAString; epilog: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanPassthru
   (SOM_Resolve(Self, cd.classObject, cd.somtScanPassthru))
     (Self, before, prolog, each, epilog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtEmitFullPassthru
 *)
type
  somTD_SOMTEmitC_somtEmitFullPassthru = procedure(somSelf: SOMObjectBase{SOMTEmitC}; before: CORBABoolean; language: CORBAString); stdcall;

procedure SOMTEmitC.somtEmitFullPassthru(before: CORBABoolean; language: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  somTD_SOMTEmitC_somtEmitFullPassthru
   (SOM_Resolve(Self, cd.classObject, cd.somtEmitFullPassthru))
     (Self, before, language);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanDataF
 *)
type
  somTD_SOMTEmitC_somtScanDataF = function(somSelf: SOMObjectBase{SOMTEmitC}; filter: CORBAString; prolog: CORBAString; each: CORBAString; epilog: CORBAString; forceProlog: CORBABoolean): CORBABoolean; stdcall;

function SOMTEmitC.somtScanDataF(filter: CORBAString; prolog: CORBAString; each: CORBAString; epilog: CORBAString; forceProlog: CORBABoolean): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanDataF
   (SOM_Resolve(Self, cd.classObject, cd.somtScanDataF))
     (Self, filter, prolog, each, epilog, forceProlog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtScanBasesF
 *)
type
  somTD_SOMTEmitC_somtScanBasesF = function(somSelf: SOMObjectBase{SOMTEmitC}; filter: CORBAString; prolog: CORBAString; each: CORBAString; epilog: CORBAString; forceProlog: CORBABoolean): CORBABoolean; stdcall;

function SOMTEmitC.somtScanBasesF(filter: CORBAString; prolog: CORBAString; each: CORBAString; epilog: CORBAString; forceProlog: CORBABoolean): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtScanBasesF
   (SOM_Resolve(Self, cd.classObject, cd.somtScanBasesF))
     (Self, filter, prolog, each, epilog, forceProlog);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetGlobalModifierValue
 *)
type
  somTD_SOMTEmitC_somtGetGlobalModifierValue = function(somSelf: SOMObjectBase{SOMTEmitC}; modifierName: CORBAString): CORBAString; stdcall;

function SOMTEmitC.somtGetGlobalModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtGetGlobalModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetGlobalModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstGlobalDefinition
 *)
type
  somTD_SOMTEmitC_somtGetFirstGlobalDefinition = function(somSelf: SOMObjectBase{SOMTEmitC}): SOMTEntryC; stdcall;

function SOMTEmitC.somtGetFirstGlobalDefinition: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtGetFirstGlobalDefinition
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstGlobalDefinition))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextGlobalDefinition
 *)
type
  somTD_SOMTEmitC_somtGetNextGlobalDefinition = function(somSelf: SOMObjectBase{SOMTEmitC}): SOMTEntryC; stdcall;

function SOMTEmitC.somtGetNextGlobalDefinition: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEmitCClassDataStructure;
begin
  cd := SOMTEmitCClassData;
  Result :=
  somTD_SOMTEmitC_somtGetNextGlobalDefinition
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextGlobalDefinition))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTEmitC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTEmitC): SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEmitC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTEmitC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTEmitC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTEmitC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTEmitC): SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEmitC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTEmitC): SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEmitC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTEmitC): SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEmitC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEmitC.somPrintSelf: SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEmitC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEmitC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTEmitC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTEmitC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTEmitCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTEmitC.NewClass: SOMClass;
begin
  if Self = SOMTEmitC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTEmitCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTEmitCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTEmitC.As_SOMTEmitC: SOMTEmitC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTEmitC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTEmitC.Supports(Instance: SOMObjectBase; out Obj: SOMTEmitC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTEmitC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTEnumEntryC_MajorVersion = 2;
  SOMTEnumEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTEnumEntryCNewClass(
  somtmajorVersion: integer4 = SOMTEnumEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTEnumEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTEnumEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTEnumEntryCClassDataStructure = packed record
    classObject: SOMClass;
    somtGetFirstEnumName,
    somtGetNextEnumName: somMToken;
  end;
  PSOMTEnumEntryCClassDataStructure = ^SOMTEnumEntryCClassDataStructure;

var
  SOME_DLL_SOMTEnumEntryCClassData: PSOMTEnumEntryCClassDataStructure = nil;

function SOMTEnumEntryCClassData: PSOMTEnumEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTEnumEntryCClassData) then
    Result := SOME_DLL_SOMTEnumEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTEnumEntryCClassData, 'SOMTEnumEntryCClassData');
    Result := SOME_DLL_SOMTEnumEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTEnumEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTEnumEntryCCClassDataStructure = ^SOMTEnumEntryCCClassDataStructure;

var
  SOME_DLL_SOMTEnumEntryCCClassData: PSOMTEnumEntryCCClassDataStructure = nil;

function SOMTEnumEntryCCClassData: PSOMTEnumEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTEnumEntryCCClassData) then
    Result := SOME_DLL_SOMTEnumEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTEnumEntryCCClassData, 'SOMTEnumEntryCCClassData');
    Result := SOME_DLL_SOMTEnumEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

function SOMTEnumEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTEnumEntryC.Create: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEnumEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTEnumEntryC.InitInstance(Instance: Pointer): SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEnumEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTEnumEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTEnumEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTEnumEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTEnumEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTEnumEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTEnumEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTEnumEntryC.NewInstance: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEnumEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTEnumEntryC.Clone: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEnumEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetFirstEnumName
 *)
type
  somTD_SOMTEnumEntryC_somtGetFirstEnumName = function(somSelf: SOMObjectBase{SOMTEnumEntryC}): SOMTEnumNameEntryC; stdcall;

function SOMTEnumEntryC.somtGetFirstEnumName: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEnumEntryCClassDataStructure;
begin
  cd := SOMTEnumEntryCClassData;
  Result :=
  somTD_SOMTEnumEntryC_somtGetFirstEnumName
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstEnumName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextEnumName
 *)
type
  somTD_SOMTEnumEntryC_somtGetNextEnumName = function(somSelf: SOMObjectBase{SOMTEnumEntryC}): SOMTEnumNameEntryC; stdcall;

function SOMTEnumEntryC.somtGetNextEnumName: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEnumEntryCClassDataStructure;
begin
  cd := SOMTEnumEntryCClassData;
  Result :=
  somTD_SOMTEnumEntryC_somtGetNextEnumName
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextEnumName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTEnumEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTEnumEntryC): SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEnumEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTEnumEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTEnumEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTEnumEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTEnumEntryC): SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEnumEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTEnumEntryC): SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEnumEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTEnumEntryC): SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEnumEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumEntryC.somPrintSelf: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEnumEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTEnumEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTEnumEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTEnumEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTEnumEntryC.NewClass: SOMClass;
begin
  if Self = SOMTEnumEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTEnumEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTEnumEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTEnumEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTEnumEntryC.As_SOMTEnumEntryC: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTEnumEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTEnumEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTEnumEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTEnumEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTEnumNameEntryC_MajorVersion = 2;
  SOMTEnumNameEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTEnumNameEntryCNewClass(
  somtmajorVersion: integer4 = SOMTEnumNameEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTEnumNameEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTEnumNameEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTEnumNameEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtEnumPtr,
    _get_somtEnumVal: somMToken;
  end;
  PSOMTEnumNameEntryCClassDataStructure = ^SOMTEnumNameEntryCClassDataStructure;

var
  SOME_DLL_SOMTEnumNameEntryCClassData: PSOMTEnumNameEntryCClassDataStructure = nil;

function SOMTEnumNameEntryCClassData: PSOMTEnumNameEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTEnumNameEntryCClassData) then
    Result := SOME_DLL_SOMTEnumNameEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTEnumNameEntryCClassData, 'SOMTEnumNameEntryCClassData');
    Result := SOME_DLL_SOMTEnumNameEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTEnumNameEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTEnumNameEntryCCClassDataStructure = ^SOMTEnumNameEntryCCClassDataStructure;

var
  SOME_DLL_SOMTEnumNameEntryCCClassData: PSOMTEnumNameEntryCCClassDataStructure = nil;

function SOMTEnumNameEntryCCClassData: PSOMTEnumNameEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTEnumNameEntryCCClassData) then
    Result := SOME_DLL_SOMTEnumNameEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTEnumNameEntryCCClassData, 'SOMTEnumNameEntryCCClassData');
    Result := SOME_DLL_SOMTEnumNameEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtEnumPtr
 *)
type
  somTD_SOMTEnumNameEntryC__get_somtEnumPtr = function(somSelf: SOMObjectBase{SOMTEnumNameEntryC}): SOMTEnumEntryC; stdcall;

function SOMTEnumNameEntryC._get_somtEnumPtr: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEnumNameEntryCClassDataStructure;
begin
  cd := SOMTEnumNameEntryCClassData;
  Result :=
  somTD_SOMTEnumNameEntryC__get_somtEnumPtr
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEnumPtr))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtEnumVal
 *)
type
  somTD_SOMTEnumNameEntryC__get_somtEnumVal = function(somSelf: SOMObjectBase{SOMTEnumNameEntryC}): LongWord; stdcall;

function SOMTEnumNameEntryC._get_somtEnumVal: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEnumNameEntryCClassDataStructure;
begin
  cd := SOMTEnumNameEntryCClassData;
  Result :=
  somTD_SOMTEnumNameEntryC__get_somtEnumVal
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEnumVal))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTEnumNameEntryC.Create: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEnumNameEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTEnumNameEntryC.InitInstance(Instance: Pointer): SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEnumNameEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTEnumNameEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTEnumNameEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTEnumNameEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTEnumNameEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTEnumNameEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTEnumNameEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTEnumNameEntryC.NewInstance: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEnumNameEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTEnumNameEntryC.Clone: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEnumNameEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMTEnumNameEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC): SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEnumNameEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC): SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEnumNameEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC): SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEnumNameEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTEnumNameEntryC): SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEnumNameEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTEnumNameEntryC.somPrintSelf: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTEnumNameEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTEnumNameEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTEnumNameEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTEnumNameEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTEnumNameEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTEnumNameEntryC.NewClass: SOMClass;
begin
  if Self = SOMTEnumNameEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTEnumNameEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTEnumNameEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTEnumNameEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTEnumNameEntryC.As_SOMTEnumNameEntryC: SOMTEnumNameEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTEnumNameEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTEnumNameEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTEnumNameEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTEnumNameEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTMetaClassEntryC_MajorVersion = 2;
  SOMTMetaClassEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTMetaClassEntryCNewClass(
  somtmajorVersion: integer4 = SOMTMetaClassEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTMetaClassEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTMetaClassEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTMetaClassEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtMetaFile,
    _get_somtMetaClassDef: somMToken;
  end;
  PSOMTMetaClassEntryCClassDataStructure = ^SOMTMetaClassEntryCClassDataStructure;

var
  SOME_DLL_SOMTMetaClassEntryCClassData: PSOMTMetaClassEntryCClassDataStructure = nil;

function SOMTMetaClassEntryCClassData: PSOMTMetaClassEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTMetaClassEntryCClassData) then
    Result := SOME_DLL_SOMTMetaClassEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTMetaClassEntryCClassData, 'SOMTMetaClassEntryCClassData');
    Result := SOME_DLL_SOMTMetaClassEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTMetaClassEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTMetaClassEntryCCClassDataStructure = ^SOMTMetaClassEntryCCClassDataStructure;

var
  SOME_DLL_SOMTMetaClassEntryCCClassData: PSOMTMetaClassEntryCCClassDataStructure = nil;

function SOMTMetaClassEntryCCClassData: PSOMTMetaClassEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTMetaClassEntryCCClassData) then
    Result := SOME_DLL_SOMTMetaClassEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTMetaClassEntryCCClassData, 'SOMTMetaClassEntryCCClassData');
    Result := SOME_DLL_SOMTMetaClassEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtMetaFile
 *)
type
  somTD_SOMTMetaClassEntryC__get_somtMetaFile = function(somSelf: SOMObjectBase{SOMTMetaClassEntryC}): CORBAString; stdcall;

function SOMTMetaClassEntryC._get_somtMetaFile: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMetaClassEntryCClassDataStructure;
begin
  cd := SOMTMetaClassEntryCClassData;
  Result :=
  somTD_SOMTMetaClassEntryC__get_somtMetaFile
   (SOM_Resolve(Self, cd.classObject, cd._get_somtMetaFile))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtMetaClassDef
 *)
type
  somTD_SOMTMetaClassEntryC__get_somtMetaClassDef = function(somSelf: SOMObjectBase{SOMTMetaClassEntryC}): SOMTClassEntryC; stdcall;

function SOMTMetaClassEntryC._get_somtMetaClassDef: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMetaClassEntryCClassDataStructure;
begin
  cd := SOMTMetaClassEntryCClassData;
  Result :=
  somTD_SOMTMetaClassEntryC__get_somtMetaClassDef
   (SOM_Resolve(Self, cd.classObject, cd._get_somtMetaClassDef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTMetaClassEntryC.Create: SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTMetaClassEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTMetaClassEntryC.InitInstance(Instance: Pointer): SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTMetaClassEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTMetaClassEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTMetaClassEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTMetaClassEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTMetaClassEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTMetaClassEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTMetaClassEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTMetaClassEntryC.NewInstance: SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTMetaClassEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTMetaClassEntryC.Clone: SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTMetaClassEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMTMetaClassEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC): SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTMetaClassEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC): SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTMetaClassEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC): SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTMetaClassEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTMetaClassEntryC): SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTMetaClassEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMetaClassEntryC.somPrintSelf: SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTMetaClassEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMetaClassEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTMetaClassEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTMetaClassEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTMetaClassEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTMetaClassEntryC.NewClass: SOMClass;
begin
  if Self = SOMTMetaClassEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTMetaClassEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTMetaClassEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTMetaClassEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTMetaClassEntryC.As_SOMTMetaClassEntryC: SOMTMetaClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTMetaClassEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTMetaClassEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTMetaClassEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTMetaClassEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTMethodEntryC_MajorVersion = 2;
  SOMTMethodEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTMethodEntryCNewClass(
  somtmajorVersion: integer4 = SOMTMethodEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTMethodEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTMethodEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTMethodEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtIsVarargs,
    _get_somtOriginalMethod,
    _get_somtOriginalClass,
    _get_somtMethodGroup,
    somtGetFirstParameter,
    somtGetNextParameter,
    somtGetArgList,
    somtGetParmList,
    _get_somtIsPrivateMethod,
    _get_somtIsOneway,
    _get_somtArgCount,
    somtGetFirstException,
    somtGetNextException,
    _get_somtContextArray,
    somtGetShortCPrototype,
    somtGetFullCPrototype,
    somtGetShortParmList,
    somtGetFullParmList,
    somtGetNthParameter,
    _get_somtCReturnType,
    somtGetIDLParamList,
    somtGetShortCParamList,
    somtGetFullCParamList,
    somtGetShortParamNameList,
    somtGetFullParamNameList: somMToken;
  end;
  PSOMTMethodEntryCClassDataStructure = ^SOMTMethodEntryCClassDataStructure;

var
  SOME_DLL_SOMTMethodEntryCClassData: PSOMTMethodEntryCClassDataStructure = nil;

function SOMTMethodEntryCClassData: PSOMTMethodEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTMethodEntryCClassData) then
    Result := SOME_DLL_SOMTMethodEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTMethodEntryCClassData, 'SOMTMethodEntryCClassData');
    Result := SOME_DLL_SOMTMethodEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTMethodEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTMethodEntryCCClassDataStructure = ^SOMTMethodEntryCCClassDataStructure;

var
  SOME_DLL_SOMTMethodEntryCCClassData: PSOMTMethodEntryCCClassDataStructure = nil;

function SOMTMethodEntryCCClassData: PSOMTMethodEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTMethodEntryCCClassData) then
    Result := SOME_DLL_SOMTMethodEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTMethodEntryCCClassData, 'SOMTMethodEntryCCClassData');
    Result := SOME_DLL_SOMTMethodEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtIsVarargs
 *)
type
  somTD_SOMTMethodEntryC__get_somtIsVarargs = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): CORBABoolean; stdcall;

function SOMTMethodEntryC._get_somtIsVarargs: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC__get_somtIsVarargs
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsVarargs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtOriginalMethod
 *)
type
  somTD_SOMTMethodEntryC__get_somtOriginalMethod = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): SOMTMethodEntryC; stdcall;

function SOMTMethodEntryC._get_somtOriginalMethod: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC__get_somtOriginalMethod
   (SOM_Resolve(Self, cd.classObject, cd._get_somtOriginalMethod))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtOriginalClass
 *)
type
  somTD_SOMTMethodEntryC__get_somtOriginalClass = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): SOMTClassEntryC; stdcall;

function SOMTMethodEntryC._get_somtOriginalClass: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC__get_somtOriginalClass
   (SOM_Resolve(Self, cd.classObject, cd._get_somtOriginalClass))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtMethodGroup
 *)
type
  somTD_SOMTMethodEntryC__get_somtMethodGroup = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): SOMTEntryC; stdcall;

function SOMTMethodEntryC._get_somtMethodGroup: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC__get_somtMethodGroup
   (SOM_Resolve(Self, cd.classObject, cd._get_somtMethodGroup))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtIsPrivateMethod
 *)
type
  somTD_SOMTMethodEntryC__get_somtIsPrivateMethod = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): CORBABoolean; stdcall;

function SOMTMethodEntryC._get_somtIsPrivateMethod: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC__get_somtIsPrivateMethod
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsPrivateMethod))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtIsOneway
 *)
type
  somTD_SOMTMethodEntryC__get_somtIsOneway = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): CORBABoolean; stdcall;

function SOMTMethodEntryC._get_somtIsOneway: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC__get_somtIsOneway
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsOneway))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtArgCount
 *)
type
  somTD_SOMTMethodEntryC__get_somtArgCount = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): SmallInt; stdcall;

function SOMTMethodEntryC._get_somtArgCount: SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC__get_somtArgCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somtArgCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtContextArray
 *)
type
  somTD_SOMTMethodEntryC__get_somtContextArray = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): PCORBAString; stdcall;

function SOMTMethodEntryC._get_somtContextArray: PCORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC__get_somtContextArray
   (SOM_Resolve(Self, cd.classObject, cd._get_somtContextArray))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtCReturnType
 *)
type
  somTD_SOMTMethodEntryC__get_somtCReturnType = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): CORBAString; stdcall;

function SOMTMethodEntryC._get_somtCReturnType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC__get_somtCReturnType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCReturnType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtTypeObj
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtPtrs: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtPtrs
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPtrs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtArrayDimsString: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtArrayDimsString
   (SOM_Resolve(Self, cd.classObject, cd._get_somtArrayDimsString))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtSourceText: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtSourceText
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceText))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtVisibility: somtVisibilityT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtVisibility
   (SOM_Resolve(Self, cd.classObject, cd._get_somtVisibility))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTMethodEntryC.Create: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTMethodEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTMethodEntryC.InitInstance(Instance: Pointer): SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTMethodEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTMethodEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTMethodEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTMethodEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTMethodEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTMethodEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTMethodEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTMethodEntryC.NewInstance: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTMethodEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTMethodEntryC.Clone: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTMethodEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetFirstParameter
 *)
type
  somTD_SOMTMethodEntryC_somtGetFirstParameter = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): SOMTParameterEntryC; stdcall;

function SOMTMethodEntryC.somtGetFirstParameter: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC_somtGetFirstParameter
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstParameter))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextParameter
 *)
type
  somTD_SOMTMethodEntryC_somtGetNextParameter = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): SOMTParameterEntryC; stdcall;

function SOMTMethodEntryC.somtGetNextParameter: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC_somtGetNextParameter
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextParameter))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetIDLParamList
 *)
type
  somTD_SOMTMethodEntryC_somtGetIDLParamList = function(somSelf: SOMObjectBase{SOMTMethodEntryC}; buffer: CORBAString): CORBAString; stdcall;

function SOMTMethodEntryC.somtGetIDLParamList(buffer: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC_somtGetIDLParamList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetIDLParamList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetShortCParamList
 *)
type
  somTD_SOMTMethodEntryC_somtGetShortCParamList = function(somSelf: SOMObjectBase{SOMTMethodEntryC}; buffer: CORBAString; selfParm: CORBAString; varargsParm: CORBAString): CORBAString; stdcall;

function SOMTMethodEntryC.somtGetShortCParamList(buffer: CORBAString; selfParm: CORBAString; varargsParm: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC_somtGetShortCParamList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetShortCParamList))
     (Self, buffer, selfParm, varargsParm);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFullCParamList
 *)
type
  somTD_SOMTMethodEntryC_somtGetFullCParamList = function(somSelf: SOMObjectBase{SOMTMethodEntryC}; buffer: CORBAString; varargsParm: CORBAString): CORBAString; stdcall;

function SOMTMethodEntryC.somtGetFullCParamList(buffer: CORBAString; varargsParm: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC_somtGetFullCParamList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFullCParamList))
     (Self, buffer, varargsParm);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetShortParamNameList
 *)
type
  somTD_SOMTMethodEntryC_somtGetShortParamNameList = function(somSelf: SOMObjectBase{SOMTMethodEntryC}; buffer: CORBAString; selfParm: CORBAString; varargsParm: CORBAString): CORBAString; stdcall;

function SOMTMethodEntryC.somtGetShortParamNameList(buffer: CORBAString; selfParm: CORBAString; varargsParm: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC_somtGetShortParamNameList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetShortParamNameList))
     (Self, buffer, selfParm, varargsParm);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFullParamNameList
 *)
type
  somTD_SOMTMethodEntryC_somtGetFullParamNameList = function(somSelf: SOMObjectBase{SOMTMethodEntryC}; buffer: CORBAString; varargsParm: CORBAString): CORBAString; stdcall;

function SOMTMethodEntryC.somtGetFullParamNameList(buffer: CORBAString; varargsParm: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC_somtGetFullParamNameList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFullParamNameList))
     (Self, buffer, varargsParm);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNthParameter
 *)
type
  somTD_SOMTMethodEntryC_somtGetNthParameter = function(somSelf: SOMObjectBase{SOMTMethodEntryC}; n: SmallInt): SOMTParameterEntryC; stdcall;

function SOMTMethodEntryC.somtGetNthParameter(n: SmallInt): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC_somtGetNthParameter
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNthParameter))
     (Self, n);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstException
 *)
type
  somTD_SOMTMethodEntryC_somtGetFirstException = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): SOMTStructEntryC; stdcall;

function SOMTMethodEntryC.somtGetFirstException: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC_somtGetFirstException
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstException))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextException
 *)
type
  somTD_SOMTMethodEntryC_somtGetNextException = function(somSelf: SOMObjectBase{SOMTMethodEntryC}): SOMTStructEntryC; stdcall;

function SOMTMethodEntryC.somtGetNextException: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTMethodEntryCClassDataStructure;
begin
  cd := SOMTMethodEntryCClassData;
  Result :=
  somTD_SOMTMethodEntryC_somtGetNextException
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextException))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somtGetFirstArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtGetFirstArrayDimension
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstArrayDimension))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somtGetNextArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtGetNextArrayDimension
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextArrayDimension))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somtIsArray(out size: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtIsArray
   (SOM_Resolve(Self, cd.classObject, cd.somtIsArray))
     (Self, size);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somtIsPointer: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtIsPointer
   (SOM_Resolve(Self, cd.classObject, cd.somtIsPointer))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTMethodEntryC): SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTMethodEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTMethodEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTMethodEntryC): SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTMethodEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTMethodEntryC): SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTMethodEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTMethodEntryC): SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTMethodEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTMethodEntryC.somPrintSelf: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTMethodEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTMethodEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTMethodEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTMethodEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTMethodEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTMethodEntryC.NewClass: SOMClass;
begin
  if Self = SOMTMethodEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTMethodEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTMethodEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTMethodEntryC.As_SOMTCommonEntryC: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTCommonEntryC(Self);
end;

function SOMTMethodEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTMethodEntryC.As_SOMTMethodEntryC: SOMTMethodEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTMethodEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTMethodEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTMethodEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTMethodEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTModuleEntryC_MajorVersion = 2;
  SOMTModuleEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTModuleEntryCNewClass(
  somtmajorVersion: integer4 = SOMTModuleEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTModuleEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTModuleEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTModuleEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtOuterModule,
    somtGetFirstModuleStruct,
    somtGetNextModuleStruct,
    somtGetFirstModuleTypedef,
    somtGetNextModuleTypedef,
    somtGetFirstModuleUnion,
    somtGetNextModuleUnion,
    somtGetFirstModuleEnum,
    somtGetNextModuleEnum,
    somtGetFirstModuleConstant,
    somtGetNextModuleConstant,
    somtGetFirstModuleSequence,
    somtGetNextModuleSequence,
    somtGetFirstInterface,
    somtGetNextInterface,
    somtGetFirstModule,
    somtGetNextModule,
    somtGetFirstModuleDef,
    somtGetNextModuleDef,
    _get_somtModuleFile: somMToken;
  end;
  PSOMTModuleEntryCClassDataStructure = ^SOMTModuleEntryCClassDataStructure;

var
  SOME_DLL_SOMTModuleEntryCClassData: PSOMTModuleEntryCClassDataStructure = nil;

function SOMTModuleEntryCClassData: PSOMTModuleEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTModuleEntryCClassData) then
    Result := SOME_DLL_SOMTModuleEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTModuleEntryCClassData, 'SOMTModuleEntryCClassData');
    Result := SOME_DLL_SOMTModuleEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTModuleEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTModuleEntryCCClassDataStructure = ^SOMTModuleEntryCCClassDataStructure;

var
  SOME_DLL_SOMTModuleEntryCCClassData: PSOMTModuleEntryCCClassDataStructure = nil;

function SOMTModuleEntryCCClassData: PSOMTModuleEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTModuleEntryCCClassData) then
    Result := SOME_DLL_SOMTModuleEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTModuleEntryCCClassData, 'SOMTModuleEntryCCClassData');
    Result := SOME_DLL_SOMTModuleEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtOuterModule
 *)
type
  somTD_SOMTModuleEntryC__get_somtOuterModule = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTModuleEntryC; stdcall;

function SOMTModuleEntryC._get_somtOuterModule: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC__get_somtOuterModule
   (SOM_Resolve(Self, cd.classObject, cd._get_somtOuterModule))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtModuleFile
 *)
type
  somTD_SOMTModuleEntryC__get_somtModuleFile = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): CORBAString; stdcall;

function SOMTModuleEntryC._get_somtModuleFile: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC__get_somtModuleFile
   (SOM_Resolve(Self, cd.classObject, cd._get_somtModuleFile))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTModuleEntryC.Create: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTModuleEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTModuleEntryC.InitInstance(Instance: Pointer): SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTModuleEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTModuleEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTModuleEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTModuleEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTModuleEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTModuleEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTModuleEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTModuleEntryC.NewInstance: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTModuleEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTModuleEntryC.Clone: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTModuleEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetFirstModuleStruct
 *)
type
  somTD_SOMTModuleEntryC_somtGetFirstModuleStruct = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTStructEntryC; stdcall;

function SOMTModuleEntryC.somtGetFirstModuleStruct: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetFirstModuleStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModuleStruct))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextModuleStruct
 *)
type
  somTD_SOMTModuleEntryC_somtGetNextModuleStruct = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTStructEntryC; stdcall;

function SOMTModuleEntryC.somtGetNextModuleStruct: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetNextModuleStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModuleStruct))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstModuleTypedef
 *)
type
  somTD_SOMTModuleEntryC_somtGetFirstModuleTypedef = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTTypedefEntryC; stdcall;

function SOMTModuleEntryC.somtGetFirstModuleTypedef: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetFirstModuleTypedef
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModuleTypedef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextModuleTypedef
 *)
type
  somTD_SOMTModuleEntryC_somtGetNextModuleTypedef = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTTypedefEntryC; stdcall;

function SOMTModuleEntryC.somtGetNextModuleTypedef: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetNextModuleTypedef
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModuleTypedef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstModuleUnion
 *)
type
  somTD_SOMTModuleEntryC_somtGetFirstModuleUnion = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTUnionEntryC; stdcall;

function SOMTModuleEntryC.somtGetFirstModuleUnion: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetFirstModuleUnion
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModuleUnion))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextModuleUnion
 *)
type
  somTD_SOMTModuleEntryC_somtGetNextModuleUnion = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTUnionEntryC; stdcall;

function SOMTModuleEntryC.somtGetNextModuleUnion: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetNextModuleUnion
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModuleUnion))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstModuleEnum
 *)
type
  somTD_SOMTModuleEntryC_somtGetFirstModuleEnum = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTEnumEntryC; stdcall;

function SOMTModuleEntryC.somtGetFirstModuleEnum: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetFirstModuleEnum
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModuleEnum))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextModuleEnum
 *)
type
  somTD_SOMTModuleEntryC_somtGetNextModuleEnum = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTEnumEntryC; stdcall;

function SOMTModuleEntryC.somtGetNextModuleEnum: SOMTEnumEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetNextModuleEnum
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModuleEnum))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstModuleConstant
 *)
type
  somTD_SOMTModuleEntryC_somtGetFirstModuleConstant = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTConstEntryC; stdcall;

function SOMTModuleEntryC.somtGetFirstModuleConstant: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetFirstModuleConstant
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModuleConstant))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextModuleConstant
 *)
type
  somTD_SOMTModuleEntryC_somtGetNextModuleConstant = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTConstEntryC; stdcall;

function SOMTModuleEntryC.somtGetNextModuleConstant: SOMTConstEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetNextModuleConstant
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModuleConstant))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstModuleSequence
 *)
type
  somTD_SOMTModuleEntryC_somtGetFirstModuleSequence = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTSequenceEntryC; stdcall;

function SOMTModuleEntryC.somtGetFirstModuleSequence: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetFirstModuleSequence
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModuleSequence))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextModuleSequence
 *)
type
  somTD_SOMTModuleEntryC_somtGetNextModuleSequence = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTSequenceEntryC; stdcall;

function SOMTModuleEntryC.somtGetNextModuleSequence: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetNextModuleSequence
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModuleSequence))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstInterface
 *)
type
  somTD_SOMTModuleEntryC_somtGetFirstInterface = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTClassEntryC; stdcall;

function SOMTModuleEntryC.somtGetFirstInterface: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetFirstInterface
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstInterface))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextInterface
 *)
type
  somTD_SOMTModuleEntryC_somtGetNextInterface = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTClassEntryC; stdcall;

function SOMTModuleEntryC.somtGetNextInterface: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetNextInterface
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextInterface))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstModule
 *)
type
  somTD_SOMTModuleEntryC_somtGetFirstModule = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTModuleEntryC; stdcall;

function SOMTModuleEntryC.somtGetFirstModule: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetFirstModule
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModule))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextModule
 *)
type
  somTD_SOMTModuleEntryC_somtGetNextModule = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTModuleEntryC; stdcall;

function SOMTModuleEntryC.somtGetNextModule: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetNextModule
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModule))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetFirstModuleDef
 *)
type
  somTD_SOMTModuleEntryC_somtGetFirstModuleDef = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTEntryC; stdcall;

function SOMTModuleEntryC.somtGetFirstModuleDef: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetFirstModuleDef
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModuleDef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextModuleDef
 *)
type
  somTD_SOMTModuleEntryC_somtGetNextModuleDef = function(somSelf: SOMObjectBase{SOMTModuleEntryC}): SOMTEntryC; stdcall;

function SOMTModuleEntryC.somtGetNextModuleDef: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTModuleEntryCClassDataStructure;
begin
  cd := SOMTModuleEntryCClassData;
  Result :=
  somTD_SOMTModuleEntryC_somtGetNextModuleDef
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModuleDef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTModuleEntryC): SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTModuleEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTModuleEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTModuleEntryC): SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTModuleEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTModuleEntryC): SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTModuleEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTModuleEntryC): SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTModuleEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTModuleEntryC.somPrintSelf: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTModuleEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTModuleEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTModuleEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTModuleEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTModuleEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTModuleEntryC.NewClass: SOMClass;
begin
  if Self = SOMTModuleEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTModuleEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTModuleEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTModuleEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTModuleEntryC.As_SOMTModuleEntryC: SOMTModuleEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTModuleEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTModuleEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTModuleEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTModuleEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTParameterEntryC_MajorVersion = 2;
  SOMTParameterEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTParameterEntryCNewClass(
  somtmajorVersion: integer4 = SOMTParameterEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTParameterEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTParameterEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTParameterEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtParameterDirection,
    _get_somtCParameterDeclaration,
    _get_somtIDLParameterDeclaration: somMToken;
  end;
  PSOMTParameterEntryCClassDataStructure = ^SOMTParameterEntryCClassDataStructure;

var
  SOME_DLL_SOMTParameterEntryCClassData: PSOMTParameterEntryCClassDataStructure = nil;

function SOMTParameterEntryCClassData: PSOMTParameterEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTParameterEntryCClassData) then
    Result := SOME_DLL_SOMTParameterEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTParameterEntryCClassData, 'SOMTParameterEntryCClassData');
    Result := SOME_DLL_SOMTParameterEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTParameterEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTParameterEntryCCClassDataStructure = ^SOMTParameterEntryCCClassDataStructure;

var
  SOME_DLL_SOMTParameterEntryCCClassData: PSOMTParameterEntryCCClassDataStructure = nil;

function SOMTParameterEntryCCClassData: PSOMTParameterEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTParameterEntryCCClassData) then
    Result := SOME_DLL_SOMTParameterEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTParameterEntryCCClassData, 'SOMTParameterEntryCCClassData');
    Result := SOME_DLL_SOMTParameterEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtParameterDirection
 *)
type
  somTD_SOMTParameterEntryC__get_somtParameterDirection = function(somSelf: SOMObjectBase{SOMTParameterEntryC}): somtParameterDirectionT; stdcall;

function SOMTParameterEntryC._get_somtParameterDirection: somtParameterDirectionT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTParameterEntryCClassDataStructure;
begin
  cd := SOMTParameterEntryCClassData;
  Result :=
  somTD_SOMTParameterEntryC__get_somtParameterDirection
   (SOM_Resolve(Self, cd.classObject, cd._get_somtParameterDirection))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtIDLParameterDeclaration
 *)
type
  somTD_SOMTParameterEntryC__get_somtIDLParameterDeclaration = function(somSelf: SOMObjectBase{SOMTParameterEntryC}): CORBAString; stdcall;

function SOMTParameterEntryC._get_somtIDLParameterDeclaration: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTParameterEntryCClassDataStructure;
begin
  cd := SOMTParameterEntryCClassData;
  Result :=
  somTD_SOMTParameterEntryC__get_somtIDLParameterDeclaration
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLParameterDeclaration))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtCParameterDeclaration
 *)
type
  somTD_SOMTParameterEntryC__get_somtCParameterDeclaration = function(somSelf: SOMObjectBase{SOMTParameterEntryC}): CORBAString; stdcall;

function SOMTParameterEntryC._get_somtCParameterDeclaration: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTParameterEntryCClassDataStructure;
begin
  cd := SOMTParameterEntryCClassData;
  Result :=
  somTD_SOMTParameterEntryC__get_somtCParameterDeclaration
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCParameterDeclaration))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtTypeObj
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtPtrs: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtPtrs
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPtrs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtArrayDimsString: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtArrayDimsString
   (SOM_Resolve(Self, cd.classObject, cd._get_somtArrayDimsString))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtSourceText: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtSourceText
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceText))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtVisibility: somtVisibilityT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtVisibility
   (SOM_Resolve(Self, cd.classObject, cd._get_somtVisibility))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTParameterEntryC.Create: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTParameterEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTParameterEntryC.InitInstance(Instance: Pointer): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTParameterEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTParameterEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTParameterEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTParameterEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTParameterEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTParameterEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTParameterEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTParameterEntryC.NewInstance: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTParameterEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTParameterEntryC.Clone: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTParameterEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMTParameterEntryC.somtGetFirstArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtGetFirstArrayDimension
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstArrayDimension))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somtGetNextArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtGetNextArrayDimension
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextArrayDimension))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somtIsArray(out size: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtIsArray
   (SOM_Resolve(Self, cd.classObject, cd.somtIsArray))
     (Self, size);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somtIsPointer: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtIsPointer
   (SOM_Resolve(Self, cd.classObject, cd.somtIsPointer))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTParameterEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTParameterEntryC): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTParameterEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTParameterEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTParameterEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTParameterEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTParameterEntryC): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTParameterEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTParameterEntryC): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTParameterEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTParameterEntryC): SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTParameterEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTParameterEntryC.somPrintSelf: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTParameterEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTParameterEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTParameterEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTParameterEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTParameterEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTParameterEntryC.NewClass: SOMClass;
begin
  if Self = SOMTParameterEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTParameterEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTParameterEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTParameterEntryC.As_SOMTCommonEntryC: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTCommonEntryC(Self);
end;

function SOMTParameterEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTParameterEntryC.As_SOMTParameterEntryC: SOMTParameterEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTParameterEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTParameterEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTParameterEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTParameterEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTPassthruEntryC_MajorVersion = 2;
  SOMTPassthruEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTPassthruEntryCNewClass(
  somtmajorVersion: integer4 = SOMTPassthruEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTPassthruEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTPassthruEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTPassthruEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtPassthruBody,
    _get_somtPassthruTarget,
    _get_somtPassthruLanguage,
    somtIsBeforePassthru: somMToken;
  end;
  PSOMTPassthruEntryCClassDataStructure = ^SOMTPassthruEntryCClassDataStructure;

var
  SOME_DLL_SOMTPassthruEntryCClassData: PSOMTPassthruEntryCClassDataStructure = nil;

function SOMTPassthruEntryCClassData: PSOMTPassthruEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTPassthruEntryCClassData) then
    Result := SOME_DLL_SOMTPassthruEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTPassthruEntryCClassData, 'SOMTPassthruEntryCClassData');
    Result := SOME_DLL_SOMTPassthruEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTPassthruEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTPassthruEntryCCClassDataStructure = ^SOMTPassthruEntryCCClassDataStructure;

var
  SOME_DLL_SOMTPassthruEntryCCClassData: PSOMTPassthruEntryCCClassDataStructure = nil;

function SOMTPassthruEntryCCClassData: PSOMTPassthruEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTPassthruEntryCCClassData) then
    Result := SOME_DLL_SOMTPassthruEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTPassthruEntryCCClassData, 'SOMTPassthruEntryCCClassData');
    Result := SOME_DLL_SOMTPassthruEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtPassthruBody
 *)
type
  somTD_SOMTPassthruEntryC__get_somtPassthruBody = function(somSelf: SOMObjectBase{SOMTPassthruEntryC}): CORBAString; stdcall;

function SOMTPassthruEntryC._get_somtPassthruBody: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTPassthruEntryCClassDataStructure;
begin
  cd := SOMTPassthruEntryCClassData;
  Result :=
  somTD_SOMTPassthruEntryC__get_somtPassthruBody
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPassthruBody))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtPassthruLanguage
 *)
type
  somTD_SOMTPassthruEntryC__get_somtPassthruLanguage = function(somSelf: SOMObjectBase{SOMTPassthruEntryC}): CORBAString; stdcall;

function SOMTPassthruEntryC._get_somtPassthruLanguage: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTPassthruEntryCClassDataStructure;
begin
  cd := SOMTPassthruEntryCClassData;
  Result :=
  somTD_SOMTPassthruEntryC__get_somtPassthruLanguage
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPassthruLanguage))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtPassthruTarget
 *)
type
  somTD_SOMTPassthruEntryC__get_somtPassthruTarget = function(somSelf: SOMObjectBase{SOMTPassthruEntryC}): CORBAString; stdcall;

function SOMTPassthruEntryC._get_somtPassthruTarget: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTPassthruEntryCClassDataStructure;
begin
  cd := SOMTPassthruEntryCClassData;
  Result :=
  somTD_SOMTPassthruEntryC__get_somtPassthruTarget
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPassthruTarget))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTPassthruEntryC.Create: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTPassthruEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTPassthruEntryC.InitInstance(Instance: Pointer): SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTPassthruEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTPassthruEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTPassthruEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTPassthruEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTPassthruEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTPassthruEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTPassthruEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTPassthruEntryC.NewInstance: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTPassthruEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTPassthruEntryC.Clone: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTPassthruEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtIsBeforePassthru
 *)
type
  somTD_SOMTPassthruEntryC_somtIsBeforePassthru = function(somSelf: SOMObjectBase{SOMTPassthruEntryC}): CORBABoolean; stdcall;

function SOMTPassthruEntryC.somtIsBeforePassthru: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTPassthruEntryCClassDataStructure;
begin
  cd := SOMTPassthruEntryCClassData;
  Result :=
  somTD_SOMTPassthruEntryC_somtIsBeforePassthru
   (SOM_Resolve(Self, cd.classObject, cd.somtIsBeforePassthru))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTPassthruEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTPassthruEntryC): SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTPassthruEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTPassthruEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTPassthruEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTPassthruEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTPassthruEntryC): SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTPassthruEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTPassthruEntryC): SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTPassthruEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTPassthruEntryC): SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTPassthruEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTPassthruEntryC.somPrintSelf: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTPassthruEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTPassthruEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTPassthruEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTPassthruEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTPassthruEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTPassthruEntryC.NewClass: SOMClass;
begin
  if Self = SOMTPassthruEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTPassthruEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTPassthruEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTPassthruEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTPassthruEntryC.As_SOMTPassthruEntryC: SOMTPassthruEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTPassthruEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTPassthruEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTPassthruEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTPassthruEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTSequenceEntryC_MajorVersion = 2;
  SOMTSequenceEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTSequenceEntryCNewClass(
  somtmajorVersion: integer4 = SOMTSequenceEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTSequenceEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTSequenceEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTSequenceEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtSeqLength,
    _get_somtSeqType,
    _get_somtSeqTypedef: somMToken;
  end;
  PSOMTSequenceEntryCClassDataStructure = ^SOMTSequenceEntryCClassDataStructure;

var
  SOME_DLL_SOMTSequenceEntryCClassData: PSOMTSequenceEntryCClassDataStructure = nil;

function SOMTSequenceEntryCClassData: PSOMTSequenceEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTSequenceEntryCClassData) then
    Result := SOME_DLL_SOMTSequenceEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTSequenceEntryCClassData, 'SOMTSequenceEntryCClassData');
    Result := SOME_DLL_SOMTSequenceEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTSequenceEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTSequenceEntryCCClassDataStructure = ^SOMTSequenceEntryCCClassDataStructure;

var
  SOME_DLL_SOMTSequenceEntryCCClassData: PSOMTSequenceEntryCCClassDataStructure = nil;

function SOMTSequenceEntryCCClassData: PSOMTSequenceEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTSequenceEntryCCClassData) then
    Result := SOME_DLL_SOMTSequenceEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTSequenceEntryCCClassData, 'SOMTSequenceEntryCCClassData');
    Result := SOME_DLL_SOMTSequenceEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtSeqLength
 *)
type
  somTD_SOMTSequenceEntryC__get_somtSeqLength = function(somSelf: SOMObjectBase{SOMTSequenceEntryC}): LongInt; stdcall;

function SOMTSequenceEntryC._get_somtSeqLength: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTSequenceEntryCClassDataStructure;
begin
  cd := SOMTSequenceEntryCClassData;
  Result :=
  somTD_SOMTSequenceEntryC__get_somtSeqLength
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSeqLength))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtSeqType
 *)
type
  somTD_SOMTSequenceEntryC__get_somtSeqType = function(somSelf: SOMObjectBase{SOMTSequenceEntryC}): SOMTEntryC; stdcall;

function SOMTSequenceEntryC._get_somtSeqType: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTSequenceEntryCClassDataStructure;
begin
  cd := SOMTSequenceEntryCClassData;
  Result :=
  somTD_SOMTSequenceEntryC__get_somtSeqType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSeqType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTSequenceEntryC.Create: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTSequenceEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTSequenceEntryC.InitInstance(Instance: Pointer): SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTSequenceEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTSequenceEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTSequenceEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTSequenceEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTSequenceEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTSequenceEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTSequenceEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTSequenceEntryC.NewInstance: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTSequenceEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTSequenceEntryC.Clone: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTSequenceEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMTSequenceEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTSequenceEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTSequenceEntryC): SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTSequenceEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTSequenceEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTSequenceEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTSequenceEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTSequenceEntryC): SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTSequenceEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTSequenceEntryC): SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTSequenceEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTSequenceEntryC): SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTSequenceEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTSequenceEntryC.somPrintSelf: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTSequenceEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTSequenceEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTSequenceEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTSequenceEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTSequenceEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTSequenceEntryC.NewClass: SOMClass;
begin
  if Self = SOMTSequenceEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTSequenceEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTSequenceEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTSequenceEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTSequenceEntryC.As_SOMTSequenceEntryC: SOMTSequenceEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTSequenceEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTSequenceEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTSequenceEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTSequenceEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTStringEntryC_MajorVersion = 2;
  SOMTStringEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTStringEntryCNewClass(
  somtmajorVersion: integer4 = SOMTStringEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTStringEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTStringEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTStringEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtStringLength: somMToken;
  end;
  PSOMTStringEntryCClassDataStructure = ^SOMTStringEntryCClassDataStructure;

var
  SOME_DLL_SOMTStringEntryCClassData: PSOMTStringEntryCClassDataStructure = nil;

function SOMTStringEntryCClassData: PSOMTStringEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTStringEntryCClassData) then
    Result := SOME_DLL_SOMTStringEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTStringEntryCClassData, 'SOMTStringEntryCClassData');
    Result := SOME_DLL_SOMTStringEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTStringEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTStringEntryCCClassDataStructure = ^SOMTStringEntryCCClassDataStructure;

var
  SOME_DLL_SOMTStringEntryCCClassData: PSOMTStringEntryCCClassDataStructure = nil;

function SOMTStringEntryCCClassData: PSOMTStringEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTStringEntryCCClassData) then
    Result := SOME_DLL_SOMTStringEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTStringEntryCCClassData, 'SOMTStringEntryCCClassData');
    Result := SOME_DLL_SOMTStringEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtStringLength
 *)
type
  somTD_SOMTStringEntryC__get_somtStringLength = function(somSelf: SOMObjectBase{SOMTStringEntryC}): LongInt; stdcall;

function SOMTStringEntryC._get_somtStringLength: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTStringEntryCClassDataStructure;
begin
  cd := SOMTStringEntryCClassData;
  Result :=
  somTD_SOMTStringEntryC__get_somtStringLength
   (SOM_Resolve(Self, cd.classObject, cd._get_somtStringLength))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTStringEntryC.Create: SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTStringEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTStringEntryC.InitInstance(Instance: Pointer): SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTStringEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTStringEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTStringEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTStringEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTStringEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTStringEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTStringEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTStringEntryC.NewInstance: SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTStringEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTStringEntryC.Clone: SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTStringEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMTStringEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTStringEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTStringEntryC): SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTStringEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTStringEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTStringEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTStringEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTStringEntryC): SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTStringEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTStringEntryC): SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTStringEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTStringEntryC): SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTStringEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStringEntryC.somPrintSelf: SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTStringEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStringEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTStringEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTStringEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTStringEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTStringEntryC.NewClass: SOMClass;
begin
  if Self = SOMTStringEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTStringEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTStringEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTStringEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTStringEntryC.As_SOMTStringEntryC: SOMTStringEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTStringEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTStringEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTStringEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTStringEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTStructEntryC_MajorVersion = 2;
  SOMTStructEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTStructEntryCNewClass(
  somtmajorVersion: integer4 = SOMTStructEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTStructEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTStructEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTStructEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtStructClass,
    _get_somtIsException,
    somtGetFirstMember,
    somtGetNextMember: somMToken;
  end;
  PSOMTStructEntryCClassDataStructure = ^SOMTStructEntryCClassDataStructure;

var
  SOME_DLL_SOMTStructEntryCClassData: PSOMTStructEntryCClassDataStructure = nil;

function SOMTStructEntryCClassData: PSOMTStructEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTStructEntryCClassData) then
    Result := SOME_DLL_SOMTStructEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTStructEntryCClassData, 'SOMTStructEntryCClassData');
    Result := SOME_DLL_SOMTStructEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTStructEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTStructEntryCCClassDataStructure = ^SOMTStructEntryCCClassDataStructure;

var
  SOME_DLL_SOMTStructEntryCCClassData: PSOMTStructEntryCCClassDataStructure = nil;

function SOMTStructEntryCCClassData: PSOMTStructEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTStructEntryCCClassData) then
    Result := SOME_DLL_SOMTStructEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTStructEntryCCClassData, 'SOMTStructEntryCCClassData');
    Result := SOME_DLL_SOMTStructEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtStructClass
 *)
type
  somTD_SOMTStructEntryC__get_somtStructClass = function(somSelf: SOMObjectBase{SOMTStructEntryC}): SOMTClassEntryC; stdcall;

function SOMTStructEntryC._get_somtStructClass: SOMTClassEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTStructEntryCClassDataStructure;
begin
  cd := SOMTStructEntryCClassData;
  Result :=
  somTD_SOMTStructEntryC__get_somtStructClass
   (SOM_Resolve(Self, cd.classObject, cd._get_somtStructClass))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtIsException
 *)
type
  somTD_SOMTStructEntryC__get_somtIsException = function(somSelf: SOMObjectBase{SOMTStructEntryC}): CORBABoolean; stdcall;

function SOMTStructEntryC._get_somtIsException: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTStructEntryCClassDataStructure;
begin
  cd := SOMTStructEntryCClassData;
  Result :=
  somTD_SOMTStructEntryC__get_somtIsException
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsException))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTStructEntryC.Create: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTStructEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTStructEntryC.InitInstance(Instance: Pointer): SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTStructEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTStructEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTStructEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTStructEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTStructEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTStructEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTStructEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTStructEntryC.NewInstance: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTStructEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTStructEntryC.Clone: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTStructEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetFirstMember
 *)
type
  somTD_SOMTStructEntryC_somtGetFirstMember = function(somSelf: SOMObjectBase{SOMTStructEntryC}): SOMTTypedefEntryC; stdcall;

function SOMTStructEntryC.somtGetFirstMember: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTStructEntryCClassDataStructure;
begin
  cd := SOMTStructEntryCClassData;
  Result :=
  somTD_SOMTStructEntryC_somtGetFirstMember
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstMember))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextMember
 *)
type
  somTD_SOMTStructEntryC_somtGetNextMember = function(somSelf: SOMObjectBase{SOMTStructEntryC}): SOMTTypedefEntryC; stdcall;

function SOMTStructEntryC.somtGetNextMember: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTStructEntryCClassDataStructure;
begin
  cd := SOMTStructEntryCClassData;
  Result :=
  somTD_SOMTStructEntryC_somtGetNextMember
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextMember))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTStructEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTStructEntryC): SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTStructEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTStructEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTStructEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTStructEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTStructEntryC): SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTStructEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTStructEntryC): SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTStructEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTStructEntryC): SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTStructEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTStructEntryC.somPrintSelf: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTStructEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTStructEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTStructEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTStructEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTStructEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTStructEntryC.NewClass: SOMClass;
begin
  if Self = SOMTStructEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTStructEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTStructEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTStructEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTStructEntryC.As_SOMTStructEntryC: SOMTStructEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTStructEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTStructEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTStructEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTStructEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTTypedefEntryC_MajorVersion = 2;
  SOMTTypedefEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTTypedefEntryCNewClass(
  somtmajorVersion: integer4 = SOMTTypedefEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTTypedefEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTTypedefEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTTypedefEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtTypedefType,
    somtGetFirstDeclarator,
    somtGetNextDeclarator: somMToken;
  end;
  PSOMTTypedefEntryCClassDataStructure = ^SOMTTypedefEntryCClassDataStructure;

var
  SOME_DLL_SOMTTypedefEntryCClassData: PSOMTTypedefEntryCClassDataStructure = nil;

function SOMTTypedefEntryCClassData: PSOMTTypedefEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTTypedefEntryCClassData) then
    Result := SOME_DLL_SOMTTypedefEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTTypedefEntryCClassData, 'SOMTTypedefEntryCClassData');
    Result := SOME_DLL_SOMTTypedefEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTTypedefEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTTypedefEntryCCClassDataStructure = ^SOMTTypedefEntryCCClassDataStructure;

var
  SOME_DLL_SOMTTypedefEntryCCClassData: PSOMTTypedefEntryCCClassDataStructure = nil;

function SOMTTypedefEntryCCClassData: PSOMTTypedefEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTTypedefEntryCCClassData) then
    Result := SOME_DLL_SOMTTypedefEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTTypedefEntryCCClassData, 'SOMTTypedefEntryCCClassData');
    Result := SOME_DLL_SOMTTypedefEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtTypedefType
 *)
type
  somTD_SOMTTypedefEntryC__get_somtTypedefType = function(somSelf: SOMObjectBase{SOMTTypedefEntryC}): SOMTEntryC; stdcall;

function SOMTTypedefEntryC._get_somtTypedefType: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTypedefEntryCClassDataStructure;
begin
  cd := SOMTTypedefEntryCClassData;
  Result :=
  somTD_SOMTTypedefEntryC__get_somtTypedefType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypedefType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTTypedefEntryC.Create: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTTypedefEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTTypedefEntryC.InitInstance(Instance: Pointer): SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTTypedefEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTTypedefEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTTypedefEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTTypedefEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTTypedefEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTTypedefEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTTypedefEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTTypedefEntryC.NewInstance: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTTypedefEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTTypedefEntryC.Clone: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTTypedefEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetFirstDeclarator
 *)
type
  somTD_SOMTTypedefEntryC_somtGetFirstDeclarator = function(somSelf: SOMObjectBase{SOMTTypedefEntryC}): SOMTCommonEntryC; stdcall;

function SOMTTypedefEntryC.somtGetFirstDeclarator: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTypedefEntryCClassDataStructure;
begin
  cd := SOMTTypedefEntryCClassData;
  Result :=
  somTD_SOMTTypedefEntryC_somtGetFirstDeclarator
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstDeclarator))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextDeclarator
 *)
type
  somTD_SOMTTypedefEntryC_somtGetNextDeclarator = function(somSelf: SOMObjectBase{SOMTTypedefEntryC}): SOMTCommonEntryC; stdcall;

function SOMTTypedefEntryC.somtGetNextDeclarator: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTypedefEntryCClassDataStructure;
begin
  cd := SOMTTypedefEntryCClassData;
  Result :=
  somTD_SOMTTypedefEntryC_somtGetNextDeclarator
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextDeclarator))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTTypedefEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTTypedefEntryC): SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTTypedefEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTTypedefEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTTypedefEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTTypedefEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTTypedefEntryC): SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTTypedefEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTTypedefEntryC): SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTTypedefEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTTypedefEntryC): SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTTypedefEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTypedefEntryC.somPrintSelf: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTTypedefEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTypedefEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTTypedefEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTTypedefEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTTypedefEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTTypedefEntryC.NewClass: SOMClass;
begin
  if Self = SOMTTypedefEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTTypedefEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTTypedefEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTTypedefEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTTypedefEntryC.As_SOMTTypedefEntryC: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTTypedefEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTTypedefEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTTypedefEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTTypedefEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTTemplateOutputC_MajorVersion = 2;
  SOMTTemplateOutputC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTTemplateOutputCNewClass(
  somtmajorVersion: integer4 = SOMTTemplateOutputC_MajorVersion;
  somtminorVersion: integer4 = SOMTTemplateOutputC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTTemplateOutputCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTTemplateOutputCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtCommentStyle,
    _set_somtCommentStyle,
    _get_somtLineLength,
    _set_somtLineLength,
    _set_somtCommentNewline,
    _get_somtCommentNewline,
    somtGetSymbol,
    somtSetSymbol,
    somtSetSymbolCopyName,
    somtSetSymbolCopyValue,
    somtSetSymbolCopyBoth,
    somtCheckSymbol,
    somtSetOutputFile,
    somto,
    somtOutputComment,
    somtOutputSection,
    somtAddSectionDefinitions,
    somtReadSectionDefinitions,
    somtExpandSymbol: somMToken;
  end;
  PSOMTTemplateOutputCClassDataStructure = ^SOMTTemplateOutputCClassDataStructure;

var
  SOME_DLL_SOMTTemplateOutputCClassData: PSOMTTemplateOutputCClassDataStructure = nil;

function SOMTTemplateOutputCClassData: PSOMTTemplateOutputCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTTemplateOutputCClassData) then
    Result := SOME_DLL_SOMTTemplateOutputCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTTemplateOutputCClassData, 'SOMTTemplateOutputCClassData');
    Result := SOME_DLL_SOMTTemplateOutputCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTTemplateOutputCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTTemplateOutputCCClassDataStructure = ^SOMTTemplateOutputCCClassDataStructure;

var
  SOME_DLL_SOMTTemplateOutputCCClassData: PSOMTTemplateOutputCCClassDataStructure = nil;

function SOMTTemplateOutputCCClassData: PSOMTTemplateOutputCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTTemplateOutputCCClassData) then
    Result := SOME_DLL_SOMTTemplateOutputCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTTemplateOutputCCClassData, 'SOMTTemplateOutputCCClassData');
    Result := SOME_DLL_SOMTTemplateOutputCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtCommentStyle
 *)
type
  somTD_SOMTTemplateOutputC__get_somtCommentStyle = function(somSelf: SOMObjectBase{SOMTTemplateOutputC}): somtCommentStyleT; stdcall;

function SOMTTemplateOutputC._get_somtCommentStyle: somtCommentStyleT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  Result :=
  somTD_SOMTTemplateOutputC__get_somtCommentStyle
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCommentStyle))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtCommentStyle
 *)
type
  somTD_SOMTTemplateOutputC__set_somtCommentStyle = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; somtCommentStyle: somtCommentStyleT); stdcall;

procedure SOMTTemplateOutputC._set_somtCommentStyle(somtCommentStyle: somtCommentStyleT); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC__set_somtCommentStyle
   (SOM_Resolve(Self, cd.classObject, cd._set_somtCommentStyle))
     (Self, somtCommentStyle);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtLineLength
 *)
type
  somTD_SOMTTemplateOutputC__get_somtLineLength = function(somSelf: SOMObjectBase{SOMTTemplateOutputC}): LongInt; stdcall;

function SOMTTemplateOutputC._get_somtLineLength: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  Result :=
  somTD_SOMTTemplateOutputC__get_somtLineLength
   (SOM_Resolve(Self, cd.classObject, cd._get_somtLineLength))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtLineLength
 *)
type
  somTD_SOMTTemplateOutputC__set_somtLineLength = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; somtLineLength: LongInt); stdcall;

procedure SOMTTemplateOutputC._set_somtLineLength(somtLineLength: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC__set_somtLineLength
   (SOM_Resolve(Self, cd.classObject, cd._set_somtLineLength))
     (Self, somtLineLength);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtCommentNewline
 *)
type
  somTD_SOMTTemplateOutputC__get_somtCommentNewline = function(somSelf: SOMObjectBase{SOMTTemplateOutputC}): CORBABoolean; stdcall;

function SOMTTemplateOutputC._get_somtCommentNewline: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  Result :=
  somTD_SOMTTemplateOutputC__get_somtCommentNewline
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCommentNewline))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somtCommentNewline
 *)
type
  somTD_SOMTTemplateOutputC__set_somtCommentNewline = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; somtCommentNewline: CORBABoolean); stdcall;

procedure SOMTTemplateOutputC._set_somtCommentNewline(somtCommentNewline: CORBABoolean); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC__set_somtCommentNewline
   (SOM_Resolve(Self, cd.classObject, cd._set_somtCommentNewline))
     (Self, somtCommentNewline);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTTemplateOutputC.Create: SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTTemplateOutputC(SOMClass(NewClass).somNew);
end;

class function SOMTTemplateOutputC.InitInstance(Instance: Pointer): SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTTemplateOutputC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTTemplateOutputC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTTemplateOutputC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTTemplateOutputC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTTemplateOutputC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTTemplateOutputC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTTemplateOutputC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTTemplateOutputC.NewInstance: SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTTemplateOutputC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTTemplateOutputC.Clone: SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTTemplateOutputC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetSymbol
 *)
type
  somTD_SOMTTemplateOutputC_somtGetSymbol = function(somSelf: SOMObjectBase{SOMTTemplateOutputC}; name: CORBAString): CORBAString; stdcall;

function SOMTTemplateOutputC.somtGetSymbol(name: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  Result :=
  somTD_SOMTTemplateOutputC_somtGetSymbol
   (SOM_Resolve(Self, cd.classObject, cd.somtGetSymbol))
     (Self, name);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtSetSymbol
 *)
type
  somTD_SOMTTemplateOutputC_somtSetSymbol = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; name: CORBAString; value: CORBAString); stdcall;

procedure SOMTTemplateOutputC.somtSetSymbol(name: CORBAString; value: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC_somtSetSymbol
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbol))
     (Self, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtSetSymbolCopyName
 *)
type
  somTD_SOMTTemplateOutputC_somtSetSymbolCopyName = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; name: CORBAString; value: CORBAString); stdcall;

procedure SOMTTemplateOutputC.somtSetSymbolCopyName(name: CORBAString; value: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC_somtSetSymbolCopyName
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolCopyName))
     (Self, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtSetSymbolCopyValue
 *)
type
  somTD_SOMTTemplateOutputC_somtSetSymbolCopyValue = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; name: CORBAString; value: CORBAString); stdcall;

procedure SOMTTemplateOutputC.somtSetSymbolCopyValue(name: CORBAString; value: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC_somtSetSymbolCopyValue
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolCopyValue))
     (Self, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtSetSymbolCopyBoth
 *)
type
  somTD_SOMTTemplateOutputC_somtSetSymbolCopyBoth = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; name: CORBAString; value: CORBAString); stdcall;

procedure SOMTTemplateOutputC.somtSetSymbolCopyBoth(name: CORBAString; value: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC_somtSetSymbolCopyBoth
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolCopyBoth))
     (Self, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtCheckSymbol
 *)
type
  somTD_SOMTTemplateOutputC_somtCheckSymbol = function(somSelf: SOMObjectBase{SOMTTemplateOutputC}; name: CORBAString): CORBABoolean; stdcall;

function SOMTTemplateOutputC.somtCheckSymbol(name: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  Result :=
  somTD_SOMTTemplateOutputC_somtCheckSymbol
   (SOM_Resolve(Self, cd.classObject, cd.somtCheckSymbol))
     (Self, name);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtSetOutputFile
 *)
type
  somTD_SOMTTemplateOutputC_somtSetOutputFile = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; var fp{: opaque SOM_FILE}); stdcall;

procedure SOMTTemplateOutputC.somtSetOutputFile(var fp{: opaque SOM_FILE}); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC_somtSetOutputFile
   (SOM_Resolve(Self, cd.classObject, cd.somtSetOutputFile))
     (Self, fp);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somto
 *)
type
  somTD_SOMTTemplateOutputC_somto = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; tmplt: CORBAString); stdcall;

procedure SOMTTemplateOutputC.somto(tmplt: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC_somto
   (SOM_Resolve(Self, cd.classObject, cd.somto))
     (Self, tmplt);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtOutputComment
 *)
type
  somTD_SOMTTemplateOutputC_somtOutputComment = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; comment: CORBAString); stdcall;

procedure SOMTTemplateOutputC.somtOutputComment(comment: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC_somtOutputComment
   (SOM_Resolve(Self, cd.classObject, cd.somtOutputComment))
     (Self, comment);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtOutputSection
 *)
type
  somTD_SOMTTemplateOutputC_somtOutputSection = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; sectionName: CORBAString); stdcall;

procedure SOMTTemplateOutputC.somtOutputSection(sectionName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC_somtOutputSection
   (SOM_Resolve(Self, cd.classObject, cd.somtOutputSection))
     (Self, sectionName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtAddSectionDefinitions
 *)
type
  somTD_SOMTTemplateOutputC_somtAddSectionDefinitions = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; defString: CORBAString); stdcall;

procedure SOMTTemplateOutputC.somtAddSectionDefinitions(defString: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC_somtAddSectionDefinitions
   (SOM_Resolve(Self, cd.classObject, cd.somtAddSectionDefinitions))
     (Self, defString);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtReadSectionDefinitions
 *)
type
  somTD_SOMTTemplateOutputC_somtReadSectionDefinitions = procedure(somSelf: SOMObjectBase{SOMTTemplateOutputC}; var fp{: opaque SOM_FILE}); stdcall;

procedure SOMTTemplateOutputC.somtReadSectionDefinitions(var fp{: opaque SOM_FILE}); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  somTD_SOMTTemplateOutputC_somtReadSectionDefinitions
   (SOM_Resolve(Self, cd.classObject, cd.somtReadSectionDefinitions))
     (Self, fp);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtExpandSymbol
 *)
type
  somTD_SOMTTemplateOutputC_somtExpandSymbol = function(somSelf: SOMObjectBase{SOMTTemplateOutputC}; s: CORBAString; buf: CORBAString): CORBAString; stdcall;

function SOMTTemplateOutputC.somtExpandSymbol(s: CORBAString; buf: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTTemplateOutputCClassDataStructure;
begin
  cd := SOMTTemplateOutputCClassData;
  Result :=
  somTD_SOMTTemplateOutputC_somtExpandSymbol
   (SOM_Resolve(Self, cd.classObject, cd.somtExpandSymbol))
     (Self, s, buf);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTTemplateOutputC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTTemplateOutputC): SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTTemplateOutputC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTTemplateOutputC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTTemplateOutputC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTTemplateOutputC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTTemplateOutputC): SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTTemplateOutputC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTTemplateOutputC): SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTTemplateOutputC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTTemplateOutputC): SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTTemplateOutputC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTTemplateOutputC.somPrintSelf: SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTTemplateOutputC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTTemplateOutputC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTTemplateOutputC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTTemplateOutputC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTTemplateOutputCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTTemplateOutputC.NewClass: SOMClass;
begin
  if Self = SOMTTemplateOutputC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTTemplateOutputCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTTemplateOutputCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTTemplateOutputC.As_SOMTTemplateOutputC: SOMTTemplateOutputC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTTemplateOutputC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTTemplateOutputC.Supports(Instance: SOMObjectBase; out Obj: SOMTTemplateOutputC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTTemplateOutputC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTUnionEntryC_MajorVersion = 2;
  SOMTUnionEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTUnionEntryCNewClass(
  somtmajorVersion: integer4 = SOMTUnionEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTUnionEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTUnionEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTUnionEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtSwitchType,
    somtGetFirstCaseEntry,
    somtGetNextCaseEntry: somMToken;
  end;
  PSOMTUnionEntryCClassDataStructure = ^SOMTUnionEntryCClassDataStructure;

var
  SOME_DLL_SOMTUnionEntryCClassData: PSOMTUnionEntryCClassDataStructure = nil;

function SOMTUnionEntryCClassData: PSOMTUnionEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTUnionEntryCClassData) then
    Result := SOME_DLL_SOMTUnionEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTUnionEntryCClassData, 'SOMTUnionEntryCClassData');
    Result := SOME_DLL_SOMTUnionEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTUnionEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTUnionEntryCCClassDataStructure = ^SOMTUnionEntryCCClassDataStructure;

var
  SOME_DLL_SOMTUnionEntryCCClassData: PSOMTUnionEntryCCClassDataStructure = nil;

function SOMTUnionEntryCCClassData: PSOMTUnionEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTUnionEntryCCClassData) then
    Result := SOME_DLL_SOMTUnionEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTUnionEntryCCClassData, 'SOMTUnionEntryCCClassData');
    Result := SOME_DLL_SOMTUnionEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtSwitchType
 *)
type
  somTD_SOMTUnionEntryC__get_somtSwitchType = function(somSelf: SOMObjectBase{SOMTUnionEntryC}): SOMTEntryC; stdcall;

function SOMTUnionEntryC._get_somtSwitchType: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTUnionEntryCClassDataStructure;
begin
  cd := SOMTUnionEntryCClassData;
  Result :=
  somTD_SOMTUnionEntryC__get_somtSwitchType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSwitchType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTUnionEntryC.Create: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTUnionEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTUnionEntryC.InitInstance(Instance: Pointer): SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTUnionEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTUnionEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTUnionEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTUnionEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTUnionEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTUnionEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTUnionEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTUnionEntryC.NewInstance: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTUnionEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTUnionEntryC.Clone: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTUnionEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somtGetFirstCaseEntry
 *)
type
  somTD_SOMTUnionEntryC_somtGetFirstCaseEntry = function(somSelf: SOMObjectBase{SOMTUnionEntryC}): PSOMTUnionEntryC_somtCaseEntry; stdcall;

function SOMTUnionEntryC.somtGetFirstCaseEntry: PSOMTUnionEntryC_somtCaseEntry; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTUnionEntryCClassDataStructure;
begin
  cd := SOMTUnionEntryCClassData;
  Result :=
  somTD_SOMTUnionEntryC_somtGetFirstCaseEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstCaseEntry))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somtGetNextCaseEntry
 *)
type
  somTD_SOMTUnionEntryC_somtGetNextCaseEntry = function(somSelf: SOMObjectBase{SOMTUnionEntryC}): PSOMTUnionEntryC_somtCaseEntry; stdcall;

function SOMTUnionEntryC.somtGetNextCaseEntry: PSOMTUnionEntryC_somtCaseEntry; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTUnionEntryCClassDataStructure;
begin
  cd := SOMTUnionEntryCClassData;
  Result :=
  somTD_SOMTUnionEntryC_somtGetNextCaseEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextCaseEntry))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTUnionEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTUnionEntryC): SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTUnionEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTUnionEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTUnionEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTUnionEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTUnionEntryC): SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTUnionEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTUnionEntryC): SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTUnionEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTUnionEntryC): SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTUnionEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUnionEntryC.somPrintSelf: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTUnionEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUnionEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTUnionEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTUnionEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTUnionEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTUnionEntryC.NewClass: SOMClass;
begin
  if Self = SOMTUnionEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTUnionEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTUnionEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTUnionEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTUnionEntryC.As_SOMTUnionEntryC: SOMTUnionEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTUnionEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTUnionEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTUnionEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTUnionEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMTUserDefinedTypeEntryC_MajorVersion = 2;
  SOMTUserDefinedTypeEntryC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMTUserDefinedTypeEntryCNewClass(
  somtmajorVersion: integer4 = SOMTUserDefinedTypeEntryC_MajorVersion;
  somtminorVersion: integer4 = SOMTUserDefinedTypeEntryC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMTUserDefinedTypeEntryCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMTUserDefinedTypeEntryCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somtOriginalTypedef,
    _get_somtBaseTypeObj: somMToken;
  end;
  PSOMTUserDefinedTypeEntryCClassDataStructure = ^SOMTUserDefinedTypeEntryCClassDataStructure;

var
  SOME_DLL_SOMTUserDefinedTypeEntryCClassData: PSOMTUserDefinedTypeEntryCClassDataStructure = nil;

function SOMTUserDefinedTypeEntryCClassData: PSOMTUserDefinedTypeEntryCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTUserDefinedTypeEntryCClassData) then
    Result := SOME_DLL_SOMTUserDefinedTypeEntryCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTUserDefinedTypeEntryCClassData, 'SOMTUserDefinedTypeEntryCClassData');
    Result := SOME_DLL_SOMTUserDefinedTypeEntryCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMTUserDefinedTypeEntryCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMTUserDefinedTypeEntryCCClassDataStructure = ^SOMTUserDefinedTypeEntryCCClassDataStructure;

var
  SOME_DLL_SOMTUserDefinedTypeEntryCCClassData: PSOMTUserDefinedTypeEntryCCClassDataStructure = nil;

function SOMTUserDefinedTypeEntryCCClassData: PSOMTUserDefinedTypeEntryCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMTUserDefinedTypeEntryCCClassData) then
    Result := SOME_DLL_SOMTUserDefinedTypeEntryCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMTUserDefinedTypeEntryCCClassData, 'SOMTUserDefinedTypeEntryCCClassData');
    Result := SOME_DLL_SOMTUserDefinedTypeEntryCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somtOriginalTypedef
 *)
type
  somTD_SOMTUserDefinedTypeEntryC__get_somtOriginalTypedef = function(somSelf: SOMObjectBase{SOMTUserDefinedTypeEntryC}): SOMTTypedefEntryC; stdcall;

function SOMTUserDefinedTypeEntryC._get_somtOriginalTypedef: SOMTTypedefEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTUserDefinedTypeEntryCClassDataStructure;
begin
  cd := SOMTUserDefinedTypeEntryCClassData;
  Result :=
  somTD_SOMTUserDefinedTypeEntryC__get_somtOriginalTypedef
   (SOM_Resolve(Self, cd.classObject, cd._get_somtOriginalTypedef))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somtBaseTypeObj
 *)
type
  somTD_SOMTUserDefinedTypeEntryC__get_somtBaseTypeObj = function(somSelf: SOMObjectBase{SOMTUserDefinedTypeEntryC}): SOMTEntryC; stdcall;

function SOMTUserDefinedTypeEntryC._get_somtBaseTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTUserDefinedTypeEntryCClassDataStructure;
begin
  cd := SOMTUserDefinedTypeEntryCClassData;
  Result :=
  somTD_SOMTUserDefinedTypeEntryC__get_somtBaseTypeObj
   (SOM_Resolve(Self, cd.classObject, cd._get_somtBaseTypeObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtTypeObj: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtTypeObj
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtPtrs: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtPtrs
   (SOM_Resolve(Self, cd.classObject, cd._get_somtPtrs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtArrayDimsString: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtArrayDimsString
   (SOM_Resolve(Self, cd.classObject, cd._get_somtArrayDimsString))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtSourceText: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtSourceText
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceText))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtType: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtVisibility: somtVisibilityT; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC__get_somtVisibility
   (SOM_Resolve(Self, cd.classObject, cd._get_somtVisibility))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtEntryName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC._set_somtEntryName(somtEntryName: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtEntryName
   (SOM_Resolve(Self, cd.classObject, cd._set_somtEntryName))
     (Self, somtEntryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtElementType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementType))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC._set_somtElementType(somtElementType: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC__set_somtElementType
   (SOM_Resolve(Self, cd.classObject, cd._set_somtElementType))
     (Self, somtElementType);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtElementTypeName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtElementTypeName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtElementTypeName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtEntryComment: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtEntryComment
   (SOM_Resolve(Self, cd.classObject, cd._get_somtEntryComment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtSourceLineNumber: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtSourceLineNumber
   (SOM_Resolve(Self, cd.classObject, cd._get_somtSourceLineNumber))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtTypeCode: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtTypeCode
   (SOM_Resolve(Self, cd.classObject, cd._get_somtTypeCode))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtIsReference: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIsReference
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIsReference))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtIDLScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtIDLScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtIDLScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC._get_somtCScopedName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC__get_somtCScopedName
   (SOM_Resolve(Self, cd.classObject, cd._get_somtCScopedName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTUserDefinedTypeEntryC.Create: SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTUserDefinedTypeEntryC(SOMClass(NewClass).somNew);
end;

class function SOMTUserDefinedTypeEntryC.InitInstance(Instance: Pointer): SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTUserDefinedTypeEntryC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMTUserDefinedTypeEntryC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMTUserDefinedTypeEntryC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMTUserDefinedTypeEntryC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMTUserDefinedTypeEntryC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMTUserDefinedTypeEntryC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMTUserDefinedTypeEntryC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMTUserDefinedTypeEntryC.NewInstance: SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTUserDefinedTypeEntryC(SOMClass(NewClass).somNewNoInit);
end;

function SOMTUserDefinedTypeEntryC.Clone: SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTUserDefinedTypeEntryC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMTUserDefinedTypeEntryC.somtGetFirstArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtGetFirstArrayDimension
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstArrayDimension))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somtGetNextArrayDimension: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtGetNextArrayDimension
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextArrayDimension))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somtIsArray(out size: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtIsArray
   (SOM_Resolve(Self, cd.classObject, cd.somtIsArray))
     (Self, size);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somtIsPointer: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTCommonEntryCClassDataStructure;
begin
  cd := SOMTCommonEntryCClassData;
  Result :=
  somTD_SOMTCommonEntryC_somtIsPointer
   (SOM_Resolve(Self, cd.classObject, cd.somtIsPointer))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somtGetModifierValue(modifierName: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierValue
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierValue))
     (Self, modifierName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somtGetFirstModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetFirstModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetFirstModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somtGetNextModifier(var modifierName: CORBAString; var modifierValue: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetNextModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtGetNextModifier))
     (Self, modifierName, modifierValue);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somtFormatModifier(buffer: CORBAString; name: CORBAString; value: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtFormatModifier
   (SOM_Resolve(Self, cd.classObject, cd.somtFormatModifier))
     (Self, buffer, name, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somtGetModifierList(buffer: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtGetModifierList
   (SOM_Resolve(Self, cd.classObject, cd.somtGetModifierList))
     (Self, buffer);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somtSetSymbolsOnEntry(emitter: SOMTEmitC; prefix: CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  Result :=
  somTD_SOMTEntryC_somtSetSymbolsOnEntry
   (SOM_Resolve(Self, cd.classObject, cd.somtSetSymbolsOnEntry))
     (Self, emitter, prefix);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somtSetEntryStruct(var es: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMTEntryCClassDataStructure;
begin
  cd := SOMTEntryCClassData;
  somTD_SOMTEntryC_somtSetEntryStruct
   (SOM_Resolve(Self, cd.classObject, cd.somtSetEntryStruct))
     (Self, es);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC): SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTUserDefinedTypeEntryC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC): SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTUserDefinedTypeEntryC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC): SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTUserDefinedTypeEntryC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMTUserDefinedTypeEntryC): SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTUserDefinedTypeEntryC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMTUserDefinedTypeEntryC.somPrintSelf: SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMTUserDefinedTypeEntryC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMTUserDefinedTypeEntryC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMTUserDefinedTypeEntryC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMTUserDefinedTypeEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTUserDefinedTypeEntryCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMTUserDefinedTypeEntryC.NewClass: SOMClass;
begin
  if Self = SOMTUserDefinedTypeEntryC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMTUserDefinedTypeEntryCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMTUserDefinedTypeEntryCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMTUserDefinedTypeEntryC.As_SOMTCommonEntryC: SOMTCommonEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTCommonEntryC(Self);
end;

function SOMTUserDefinedTypeEntryC.As_SOMTEntryC: SOMTEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMTEntryC(Self);
end;

function SOMTUserDefinedTypeEntryC.As_SOMTUserDefinedTypeEntryC: SOMTUserDefinedTypeEntryC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMTUserDefinedTypeEntryC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMTUserDefinedTypeEntryC.Supports(Instance: SOMObjectBase; out Obj: SOMTUserDefinedTypeEntryC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMTUserDefinedTypeEntryC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMDServerMgr_MajorVersion = 2;
  SOMDServerMgr_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMDServerMgrNewClass(
  somtmajorVersion: integer4 = SOMDServerMgr_MajorVersion;
  somtminorVersion: integer4 = SOMDServerMgr_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'SOMDServerMgrNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMDServerMgrClassDataStructure = packed record
    classObject: SOMClass;
    somdShutdownServer,
    somdStartServer,
    somdRestartServer,
    somdListServer,
    somdDisableServer,
    somdEnableServer,
    somdIsServerEnabled: somMToken;
  end;
  PSOMDServerMgrClassDataStructure = ^SOMDServerMgrClassDataStructure;

var
  SOMD_DLL_SOMDServerMgrClassData: PSOMDServerMgrClassDataStructure = nil;

function SOMDServerMgrClassData: PSOMDServerMgrClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMDServerMgrClassData) then
    Result := SOMD_DLL_SOMDServerMgrClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMDServerMgrClassData, 'SOMDServerMgrClassData');
    Result := SOMD_DLL_SOMDServerMgrClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMDServerMgrCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMDServerMgrCClassDataStructure = ^SOMDServerMgrCClassDataStructure;

var
  SOMD_DLL_SOMDServerMgrCClassData: PSOMDServerMgrCClassDataStructure = nil;

function SOMDServerMgrCClassData: PSOMDServerMgrCClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMDServerMgrCClassData) then
    Result := SOMD_DLL_SOMDServerMgrCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMDServerMgrCClassData, 'SOMDServerMgrCClassData');
    Result := SOMD_DLL_SOMDServerMgrCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMDServerMgr.Create: SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDServerMgr(SOMClass(NewClass).somNew);
end;

class function SOMDServerMgr.InitInstance(Instance: Pointer): SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDServerMgr(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMDServerMgr.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMDServerMgr.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMDServerMgr.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMDServerMgr.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMDServerMgr.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMDServerMgr.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMDServerMgr.NewInstance: SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDServerMgr(SOMClass(NewClass).somNewNoInit);
end;

function SOMDServerMgr.Clone: SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDServerMgr(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somdShutdownServer
 *)
type
  somTD_SOMDServerMgr_somdShutdownServer = function(somSelf: SOMObjectBase{SOMDServerMgr}; ev: PEnvironment; server_alias: CORBAString): LongWord; stdcall;

function SOMDServerMgr.somdShutdownServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServerMgr_somdShutdownServer
   (SOM_Resolve(Self, cd.classObject, cd.somdShutdownServer))
     (Self, @LocalEnv, server_alias);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdStartServer
 *)
type
  somTD_SOMDServerMgr_somdStartServer = function(somSelf: SOMObjectBase{SOMDServerMgr}; ev: PEnvironment; server_alias: CORBAString): LongWord; stdcall;

function SOMDServerMgr.somdStartServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServerMgr_somdStartServer
   (SOM_Resolve(Self, cd.classObject, cd.somdStartServer))
     (Self, @LocalEnv, server_alias);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdRestartServer
 *)
type
  somTD_SOMDServerMgr_somdRestartServer = function(somSelf: SOMObjectBase{SOMDServerMgr}; ev: PEnvironment; server_alias: CORBAString): LongWord; stdcall;

function SOMDServerMgr.somdRestartServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServerMgr_somdRestartServer
   (SOM_Resolve(Self, cd.classObject, cd.somdRestartServer))
     (Self, @LocalEnv, server_alias);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdListServer
 *)
type
  somTD_SOMDServerMgr_somdListServer = function(somSelf: SOMObjectBase{SOMDServerMgr}; ev: PEnvironment; server_alias: CORBAString): LongWord; stdcall;

function SOMDServerMgr.somdListServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServerMgr_somdListServer
   (SOM_Resolve(Self, cd.classObject, cd.somdListServer))
     (Self, @LocalEnv, server_alias);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdDisableServer
 *)
type
  somTD_SOMDServerMgr_somdDisableServer = function(somSelf: SOMObjectBase{SOMDServerMgr}; ev: PEnvironment; server_alias: CORBAString): LongWord; stdcall;

function SOMDServerMgr.somdDisableServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServerMgr_somdDisableServer
   (SOM_Resolve(Self, cd.classObject, cd.somdDisableServer))
     (Self, @LocalEnv, server_alias);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdEnableServer
 *)
type
  somTD_SOMDServerMgr_somdEnableServer = function(somSelf: SOMObjectBase{SOMDServerMgr}; ev: PEnvironment; server_alias: CORBAString): LongWord; stdcall;

function SOMDServerMgr.somdEnableServer(server_alias: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServerMgr_somdEnableServer
   (SOM_Resolve(Self, cd.classObject, cd.somdEnableServer))
     (Self, @LocalEnv, server_alias);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdIsServerEnabled
 *)
type
  somTD_SOMDServerMgr_somdIsServerEnabled = function(somSelf: SOMObjectBase{SOMDServerMgr}; ev: PEnvironment; impldef: ImplementationDef): CORBABoolean; stdcall;

function SOMDServerMgr.somdIsServerEnabled(impldef: ImplementationDef): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServerMgr_somdIsServerEnabled
   (SOM_Resolve(Self, cd.classObject, cd.somdIsServerEnabled))
     (Self, @LocalEnv, impldef);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMDServerMgr.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServerMgr.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServerMgr.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDServerMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somDefaultAssign(var ctrl: Pointer; fromObj: SOMDServerMgr): SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDServerMgr(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServerMgr.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDServerMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServerMgr.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDServerMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServerMgr.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDServerMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDServerMgr): SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDServerMgr(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDServerMgr): SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDServerMgr(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDServerMgr): SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDServerMgr(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServerMgr.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServerMgr.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServerMgr.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServerMgr.somPrintSelf: SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDServerMgr(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServerMgr.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServerMgr.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMDServerMgr.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMDServerMgr then { invoked on class name literal }
  begin
    Result := SOMClass(SOMDServerMgrClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMDServerMgr.NewClass: SOMClass;
begin
  if Self = SOMDServerMgr then { invoked on class name literal }
  begin
    Result := SOMClass(SOMDServerMgrClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMDServerMgrNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMDServerMgr.As_SOMDServerMgr: SOMDServerMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMDServerMgr.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMDServerMgr.Supports(Instance: SOMObjectBase; out Obj: SOMDServerMgr): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMDServerMgr(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMESinkEvent_MajorVersion = 2;
  SOMESinkEvent_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMESinkEventNewClass(
  somtmajorVersion: integer4 = SOMESinkEvent_MajorVersion;
  somtminorVersion: integer4 = SOMESinkEvent_MinorVersion):
  SOMClass; stdcall; external SOMEM_DLL_Name name 'SOMESinkEventNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMESinkEventClassDataStructure = packed record
    classObject: SOMClass;
    somevGetEventSink,
    somevSetEventSink: somMToken;
  end;
  PSOMESinkEventClassDataStructure = ^SOMESinkEventClassDataStructure;

var
  SOMEM_DLL_SOMESinkEventClassData: PSOMESinkEventClassDataStructure = nil;

function SOMESinkEventClassData: PSOMESinkEventClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMESinkEventClassData) then
    Result := SOMEM_DLL_SOMESinkEventClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMESinkEventClassData, 'SOMESinkEventClassData');
    Result := SOMEM_DLL_SOMESinkEventClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMESinkEventCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMESinkEventCClassDataStructure = ^SOMESinkEventCClassDataStructure;

var
  SOMEM_DLL_SOMESinkEventCClassData: PSOMESinkEventCClassDataStructure = nil;

function SOMESinkEventCClassData: PSOMESinkEventCClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMESinkEventCClassData) then
    Result := SOMEM_DLL_SOMESinkEventCClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMESinkEventCClassData, 'SOMESinkEventCClassData');
    Result := SOMEM_DLL_SOMESinkEventCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMESinkEvent.Create: SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMESinkEvent(SOMClass(NewClass).somNew);
end;

class function SOMESinkEvent.InitInstance(Instance: Pointer): SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMESinkEvent(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMESinkEvent.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMESinkEvent.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMESinkEvent.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMESinkEvent.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMESinkEvent.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMESinkEvent.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMESinkEvent.NewInstance: SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMESinkEvent(SOMClass(NewClass).somNewNoInit);
end;

function SOMESinkEvent.Clone: SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMESinkEvent(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somevGetEventSink
 *)
type
  somTD_SOMESinkEvent_somevGetEventSink = function(somSelf: SOMObjectBase{SOMESinkEvent}; ev: PEnvironment): LongInt; stdcall;

function SOMESinkEvent.somevGetEventSink: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMESinkEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMESinkEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMESinkEvent_somevGetEventSink
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventSink))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somevSetEventSink
 *)
type
  somTD_SOMESinkEvent_somevSetEventSink = procedure(somSelf: SOMObjectBase{SOMESinkEvent}; ev: PEnvironment; sink: LongInt); stdcall;

procedure SOMESinkEvent.somevSetEventSink(sink: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMESinkEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMESinkEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMESinkEvent_somevSetEventSink
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventSink))
     (Self, @LocalEnv, sink);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMESinkEvent.somevGetEventTime: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEvent_somevGetEventTime
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventTime))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMESinkEvent.somevGetEventType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEvent_somevGetEventType
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventType))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMESinkEvent.somevSetEventTime(time: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEvent_somevSetEventTime
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventTime))
     (Self, @LocalEnv, time);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMESinkEvent.somevSetEventType(SOM_type: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEvent_somevSetEventType
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventType))
     (Self, @LocalEnv, SOM_type);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMESinkEvent.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMESinkEvent.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMESinkEvent.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMESinkEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somDefaultAssign(var ctrl: Pointer; fromObj: SOMESinkEvent): SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMESinkEvent(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMESinkEvent.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMESinkEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMESinkEvent.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMESinkEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMESinkEvent.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMESinkEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMESinkEvent): SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMESinkEvent(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMESinkEvent): SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMESinkEvent(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMESinkEvent): SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMESinkEvent(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMESinkEvent.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMESinkEvent.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMESinkEvent.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMESinkEvent.somPrintSelf: SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMESinkEvent(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMESinkEvent.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMESinkEvent.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMESinkEvent.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMESinkEvent then { invoked on class name literal }
  begin
    Result := SOMClass(SOMESinkEventClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMESinkEvent.NewClass: SOMClass;
begin
  if Self = SOMESinkEvent then { invoked on class name literal }
  begin
    Result := SOMClass(SOMESinkEventClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMESinkEventNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMESinkEvent.As_SOMEEvent: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEvent(Self);
end;

function SOMESinkEvent.As_SOMESinkEvent: SOMESinkEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMESinkEvent.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMESinkEvent.Supports(Instance: SOMObjectBase; out Obj: SOMESinkEvent): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMESinkEvent(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMClass_MajorVersion = 1;
  SOMClass_MinorVersion = 4;

(*
 * Declare the class creation procedure
 *)
function SOMClassNewClass(
  somtmajorVersion: integer4 = SOMClass_MajorVersion;
  somtminorVersion: integer4 = SOMClass_MinorVersion):
  SOMClass; stdcall; external SOM_DLL_Name name 'SOMClassNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMClassClassDataStructure = packed record
    classObject: SOMClass;
    somNew,
    somRenew,
    somInitClass,
    somClassReady,
    somGetName,
    somGetParent,
    somDescendedFrom,
    somCheckVersion,
    somFindMethod,
    somFindMethodOk,
    somSupportsMethod,
    somGetNumMethods,
    somGetInstanceSize,
    somGetInstanceOffset,
    somGetInstancePartSize,
    somGetMethodIndex,
    somGetNumStaticMethods,
    somGetPClsMtab,
    somGetClassMtab,
    somAddStaticMethod,
    somOverrideSMethod,
    somAddDynamicMethod,
    somcPrivate0,
    somGetApplyStub,
    somFindSMethod,
    somFindSMethodOk,
    somGetMethodDescriptor,
    somGetNthMethodInfo,
    somSetClassData,
    somGetClassData,
    somNewNoInit,
    somRenewNoInit,
    somGetInstanceToken,
    somGetMemberToken,
    somSetMethodDescriptor,
    somGetMethodData,
    somOverrideMtab,
    somGetMethodToken,
    somGetParents,
    somGetPClsMtabs,
    somInitMIClass,
    somGetVersionNumbers,
    somLookupMethod,
    _get_somInstanceDataOffsets,
    somRenewNoZero,
    somRenewNoInitNoZero,
    somAllocate,
    somDeallocate,
    somGetRdStub,
    somGetNthMethodData,
    somcPrivate1,
    somcPrivate2,
    _get_somDirectInitClasses,
    _set_somDirectInitClasses,
    somGetInstanceInitMask,
    somGetInstanceDestructionMask,
    somcPrivate3,
    somcPrivate4,
    somcPrivate5,
    somcPrivate6,
    somcPrivate7,
    somDefinedMethod,
    somcPrivate8,
    somcPrivate9,
    somcPrivate10,
    somcPrivate11,
    somcPrivate12,
    somcPrivate13,
    somcPrivate14,
    somcPrivate15,
    _get_somDataAlignment,
    somGetInstanceAssignmentMask,
    somcPrivate16,
    somcPrivate17,
    _get_somClassAllocate,
    _get_somClassDeallocate: somMToken;
  end;
  PSOMClassClassDataStructure = ^SOMClassClassDataStructure;

var
  SOM_DLL_SOMClassClassData: PSOMClassClassDataStructure = nil;

function SOMClassClassData: PSOMClassClassDataStructure;
begin
  if Assigned(SOM_DLL_SOMClassClassData) then
    Result := SOM_DLL_SOMClassClassData
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOMClassClassData, 'SOMClassClassData');
    Result := SOM_DLL_SOMClassClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMClassCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMClassCClassDataStructure = ^SOMClassCClassDataStructure;

var
  SOM_DLL_SOMClassCClassData: PSOMClassCClassDataStructure = nil;

function SOMClassCClassData: PSOMClassCClassDataStructure;
begin
  if Assigned(SOM_DLL_SOMClassCClassData) then
    Result := SOM_DLL_SOMClassCClassData
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOMClassCClassData, 'SOMClassCClassData');
    Result := SOM_DLL_SOMClassCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somDataAlignment
 *)
type
  somTD_SOMClass__get_somDataAlignment = function(somSelf: SOMObjectBase{SOMClass}): LongInt; stdcall;

function SOMClass._get_somDataAlignment: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somDataAlignment
   (SOM_Resolve(Self, cd.classObject, cd._get_somDataAlignment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somInstanceDataOffsets
 *)
type
  somTD_SOMClass__get_somInstanceDataOffsets = function(somSelf: SOMObjectBase{SOMClass}): _IDL_Sequence_SOMClass_somOffsetInfo; stdcall;

function SOMClass._get_somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somInstanceDataOffsets
   (SOM_Resolve(Self, cd.classObject, cd._get_somInstanceDataOffsets))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somDirectInitClasses
 *)
type
  somTD_SOMClass__get_somDirectInitClasses = function(somSelf: SOMObjectBase{SOMClass}): _IDL_Sequence_SOMClass; stdcall;

function SOMClass._get_somDirectInitClasses: _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somDirectInitClasses
   (SOM_Resolve(Self, cd.classObject, cd._get_somDirectInitClasses))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somDirectInitClasses
 *)
type
  somTD_SOMClass__set_somDirectInitClasses = procedure(somSelf: SOMObjectBase{SOMClass}; const somDirectInitClasses: _IDL_Sequence_SOMClass); stdcall;

procedure SOMClass._set_somDirectInitClasses(const somDirectInitClasses: _IDL_Sequence_SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass__set_somDirectInitClasses
   (SOM_Resolve(Self, cd.classObject, cd._set_somDirectInitClasses))
     (Self, somDirectInitClasses);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somClassAllocate
 *)
type
  somTD_SOMClass__get_somClassAllocate = function(somSelf: SOMObjectBase{SOMClass}): PPointer; stdcall;

function SOMClass._get_somClassAllocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somClassAllocate
   (SOM_Resolve(Self, cd.classObject, cd._get_somClassAllocate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somClassDeallocate
 *)
type
  somTD_SOMClass__get_somClassDeallocate = function(somSelf: SOMObjectBase{SOMClass}): PPointer; stdcall;

function SOMClass._get_somClassDeallocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somClassDeallocate
   (SOM_Resolve(Self, cd.classObject, cd._get_somClassDeallocate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMClass.Create: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMClass(NewClass).somNew);
end;

class function SOMClass.InitInstance(Instance: Pointer): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMClass.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMClass.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMClass.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMClass.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMClass.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMClass.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMClass.NewInstance: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMClass(NewClass).somNewNoInit);
end;

function SOMClass.Clone: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somNew
 *)
type
  somTD_SOMClass_somNew = function(somSelf: SOMObjectBase{SOMClass}): SOMObject; stdcall;

function SOMClass.somNew: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somNew
   (SOM_Resolve(Self, cd.classObject, cd.somNew))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somNewNoInit
 *)
type
  somTD_SOMClass_somNewNoInit = function(somSelf: SOMObjectBase{SOMClass}): SOMObject; stdcall;

function SOMClass.somNewNoInit: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somNewNoInit
   (SOM_Resolve(Self, cd.classObject, cd.somNewNoInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somRenew
 *)
type
  somTD_SOMClass_somRenew = function(somSelf: SOMObjectBase{SOMClass}; obj: Pointer): SOMObject; stdcall;

function SOMClass.somRenew(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenew
   (SOM_Resolve(Self, cd.classObject, cd.somRenew))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somRenewNoInit
 *)
type
  somTD_SOMClass_somRenewNoInit = function(somSelf: SOMObjectBase{SOMClass}; obj: Pointer): SOMObject; stdcall;

function SOMClass.somRenewNoInit(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoInit
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoInit))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somRenewNoZero
 *)
type
  somTD_SOMClass_somRenewNoZero = function(somSelf: SOMObjectBase{SOMClass}; obj: Pointer): SOMObject; stdcall;

function SOMClass.somRenewNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoZero
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoZero))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somRenewNoInitNoZero
 *)
type
  somTD_SOMClass_somRenewNoInitNoZero = function(somSelf: SOMObjectBase{SOMClass}; obj: Pointer): SOMObject; stdcall;

function SOMClass.somRenewNoInitNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoInitNoZero
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoInitNoZero))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somAllocate
 *)
type
  somTD_SOMClass_somAllocate = function(somSelf: SOMObjectBase{SOMClass}; size: LongInt): CORBAString; stdcall;

function SOMClass.somAllocate(size: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somAllocate
   (SOM_Resolve(Self, cd.classObject, cd.somAllocate))
     (Self, size);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDeallocate
 *)
type
  somTD_SOMClass_somDeallocate = procedure(somSelf: SOMObjectBase{SOMClass}; memptr: CORBAString); stdcall;

procedure SOMClass.somDeallocate(memptr: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somDeallocate
   (SOM_Resolve(Self, cd.classObject, cd.somDeallocate))
     (Self, memptr);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetInstanceInitMask
 *)
type
  somTD_SOMClass_somGetInstanceInitMask = function(somSelf: SOMObjectBase{SOMClass}; out ctrl: Pointer): PByte; stdcall;

function SOMClass.somGetInstanceInitMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceInitMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceInitMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetInstanceDestructionMask
 *)
type
  somTD_SOMClass_somGetInstanceDestructionMask = function(somSelf: SOMObjectBase{SOMClass}; out ctrl: Pointer): PByte; stdcall;

function SOMClass.somGetInstanceDestructionMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceDestructionMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceDestructionMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetInstanceAssignmentMask
 *)
type
  somTD_SOMClass_somGetInstanceAssignmentMask = function(somSelf: SOMObjectBase{SOMClass}; out ctrl: Pointer): PByte; stdcall;

function SOMClass.somGetInstanceAssignmentMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceAssignmentMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceAssignmentMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somInitClass
 *)
type
  somTD_SOMClass_somInitClass = procedure(somSelf: SOMObjectBase{SOMClass}; className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); stdcall;

procedure SOMClass.somInitClass(className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somInitClass
   (SOM_Resolve(Self, cd.classObject, cd.somInitClass))
     (Self, className, parentClass, dataSize, maxStaticMethods, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somInitMIClass
 *)
type
  somTD_SOMClass_somInitMIClass = procedure(somSelf: SOMObjectBase{SOMClass}; inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); stdcall;

procedure SOMClass.somInitMIClass(inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somInitMIClass
   (SOM_Resolve(Self, cd.classObject, cd.somInitMIClass))
     (Self, inherit_vars, className, parentClasses, dataSize, dataAlignment, maxStaticMethods, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somAddStaticMethod
 *)
type
  somTD_SOMClass_somAddStaticMethod = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; stdcall;

function SOMClass.somAddStaticMethod(methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somAddStaticMethod
   (SOM_Resolve(Self, cd.classObject, cd.somAddStaticMethod))
     (Self, methodId, methodDescriptor, method, redispatchStub, applyStub);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somAddDynamicMethod
 *)
type
  somTD_SOMClass_somAddDynamicMethod = procedure(somSelf: SOMObjectBase{SOMClass}; methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); stdcall;

procedure SOMClass.somAddDynamicMethod(methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somAddDynamicMethod
   (SOM_Resolve(Self, cd.classObject, cd.somAddDynamicMethod))
     (Self, methodId, methodDescriptor, method, applyStub);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somOverrideSMethod
 *)
type
  somTD_SOMClass_somOverrideSMethod = procedure(somSelf: SOMObjectBase{SOMClass}; methodId: somId; method: Pointer); stdcall;

procedure SOMClass.somOverrideSMethod(methodId: somId; method: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somOverrideSMethod
   (SOM_Resolve(Self, cd.classObject, cd.somOverrideSMethod))
     (Self, methodId, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somClassReady
 *)
type
  somTD_SOMClass_somClassReady = procedure(somSelf: SOMObjectBase{SOMClass}); stdcall;

procedure SOMClass.somClassReady; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somClassReady
   (SOM_Resolve(Self, cd.classObject, cd.somClassReady))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetClassData
 *)
type
  somTD_SOMClass_somGetClassData = function(somSelf: SOMObjectBase{SOMClass}): PsomClassDataStructure; stdcall;

function SOMClass.somGetClassData: PsomClassDataStructure; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetClassData
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassData))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somSetClassData
 *)
type
  somTD_SOMClass_somSetClassData = procedure(somSelf: SOMObjectBase{SOMClass}; const cds: somClassDataStructure); stdcall;

procedure SOMClass.somSetClassData(const cds: somClassDataStructure); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somSetClassData
   (SOM_Resolve(Self, cd.classObject, cd.somSetClassData))
     (Self, cds);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetClassMtab
 *)
type
  somTD_SOMClass_somGetClassMtab = function(somSelf: SOMObjectBase{SOMClass}): PsomMethodTab; stdcall;

function SOMClass.somGetClassMtab: PsomMethodTab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetClassMtab
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetInstanceOffset
 *)
type
  somTD_SOMClass_somGetInstanceOffset = function(somSelf: SOMObjectBase{SOMClass}): LongInt; stdcall;

function SOMClass.somGetInstanceOffset: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceOffset
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceOffset))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetInstancePartSize
 *)
type
  somTD_SOMClass_somGetInstancePartSize = function(somSelf: SOMObjectBase{SOMClass}): LongInt; stdcall;

function SOMClass.somGetInstancePartSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstancePartSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstancePartSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetInstanceSize
 *)
type
  somTD_SOMClass_somGetInstanceSize = function(somSelf: SOMObjectBase{SOMClass}): LongInt; stdcall;

function SOMClass.somGetInstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetInstanceToken
 *)
type
  somTD_SOMClass_somGetInstanceToken = function(somSelf: SOMObjectBase{SOMClass}): Pointer; stdcall;

function SOMClass.somGetInstanceToken: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceToken))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetMemberToken
 *)
type
  somTD_SOMClass_somGetMemberToken = function(somSelf: SOMObjectBase{SOMClass}; memberOffset: LongInt; instanceToken: Pointer): Pointer; stdcall;

function SOMClass.somGetMemberToken(memberOffset: LongInt; instanceToken: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMemberToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetMemberToken))
     (Self, memberOffset, instanceToken);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetMethodData
 *)
type
  somTD_SOMClass_somGetMethodData = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId; out md: somMethodDataStruct): CORBABoolean; stdcall;

function SOMClass.somGetMethodData(methodId: somId; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodData
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodData))
     (Self, methodId, md);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetRdStub
 *)
type
  somTD_SOMClass_somGetRdStub = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId): PPointer; stdcall;

function SOMClass.somGetRdStub(methodId: somId): PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetRdStub
   (SOM_Resolve(Self, cd.classObject, cd.somGetRdStub))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetMethodDescriptor
 *)
type
  somTD_SOMClass_somGetMethodDescriptor = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId): somId; stdcall;

function SOMClass.somGetMethodDescriptor(methodId: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodDescriptor
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodDescriptor))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetMethodIndex
 *)
type
  somTD_SOMClass_somGetMethodIndex = function(somSelf: SOMObjectBase{SOMClass}; id: somId): LongInt; stdcall;

function SOMClass.somGetMethodIndex(id: somId): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodIndex
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodIndex))
     (Self, id);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetMethodToken
 *)
type
  somTD_SOMClass_somGetMethodToken = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId): Pointer; stdcall;

function SOMClass.somGetMethodToken(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodToken))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetName
 *)
type
  somTD_SOMClass_somGetName = function(somSelf: SOMObjectBase{SOMClass}): {dual_owned} CORBAString; stdcall;

function SOMClass.somGetName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetName
   (SOM_Resolve(Self, cd.classObject, cd.somGetName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetNthMethodData
 *)
type
  somTD_SOMClass_somGetNthMethodData = function(somSelf: SOMObjectBase{SOMClass}; n: LongInt; out md: somMethodDataStruct): CORBABoolean; stdcall;

function SOMClass.somGetNthMethodData(n: LongInt; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNthMethodData
   (SOM_Resolve(Self, cd.classObject, cd.somGetNthMethodData))
     (Self, n, md);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetNthMethodInfo
 *)
type
  somTD_SOMClass_somGetNthMethodInfo = function(somSelf: SOMObjectBase{SOMClass}; n: LongInt; out descriptor: somId): somId; stdcall;

function SOMClass.somGetNthMethodInfo(n: LongInt; out descriptor: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNthMethodInfo
   (SOM_Resolve(Self, cd.classObject, cd.somGetNthMethodInfo))
     (Self, n, descriptor);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetNumMethods
 *)
type
  somTD_SOMClass_somGetNumMethods = function(somSelf: SOMObjectBase{SOMClass}): LongInt; stdcall;

function SOMClass.somGetNumMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNumMethods
   (SOM_Resolve(Self, cd.classObject, cd.somGetNumMethods))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetNumStaticMethods
 *)
type
  somTD_SOMClass_somGetNumStaticMethods = function(somSelf: SOMObjectBase{SOMClass}): LongInt; stdcall;

function SOMClass.somGetNumStaticMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNumStaticMethods
   (SOM_Resolve(Self, cd.classObject, cd.somGetNumStaticMethods))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetParent
 *)
type
  somTD_SOMClass_somGetParent = function(somSelf: SOMObjectBase{SOMClass}): SOMClass; stdcall;

function SOMClass.somGetParent: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetParent
   (SOM_Resolve(Self, cd.classObject, cd.somGetParent))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetParents
 *)
type
  somTD_SOMClass_somGetParents = function(somSelf: SOMObjectBase{SOMClass}): {dual_owned} _IDL_Sequence_SOMClass; stdcall;

function SOMClass.somGetParents: {dual_owned} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetParents
   (SOM_Resolve(Self, cd.classObject, cd.somGetParents))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetPClsMtab
 *)
type
  somTD_SOMClass_somGetPClsMtab = function(somSelf: SOMObjectBase{SOMClass}): PsomMethodTabList; stdcall;

function SOMClass.somGetPClsMtab: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetPClsMtab
   (SOM_Resolve(Self, cd.classObject, cd.somGetPClsMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetPClsMtabs
 *)
type
  somTD_SOMClass_somGetPClsMtabs = function(somSelf: SOMObjectBase{SOMClass}): PsomMethodTabList; stdcall;

function SOMClass.somGetPClsMtabs: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetPClsMtabs
   (SOM_Resolve(Self, cd.classObject, cd.somGetPClsMtabs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetVersionNumbers
 *)
type
  somTD_SOMClass_somGetVersionNumbers = procedure(somSelf: SOMObjectBase{SOMClass}; out majorVersion: LongInt; out minorVersion: LongInt); stdcall;

procedure SOMClass.somGetVersionNumbers(out majorVersion: LongInt; out minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somGetVersionNumbers
   (SOM_Resolve(Self, cd.classObject, cd.somGetVersionNumbers))
     (Self, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somSetMethodDescriptor
 *)
type
  somTD_SOMClass_somSetMethodDescriptor = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId; descriptor: somId): CORBABoolean; stdcall;

function SOMClass.somSetMethodDescriptor(methodId: somId; descriptor: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somSetMethodDescriptor
   (SOM_Resolve(Self, cd.classObject, cd.somSetMethodDescriptor))
     (Self, methodId, descriptor);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somFindMethod
 *)
type
  somTD_SOMClass_somFindMethod = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId; out m: Pointer): CORBABoolean; stdcall;

function SOMClass.somFindMethod(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindMethod
   (SOM_Resolve(Self, cd.classObject, cd.somFindMethod))
     (Self, methodId, m);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somFindMethodOk
 *)
type
  somTD_SOMClass_somFindMethodOk = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId; out m: Pointer): CORBABoolean; stdcall;

function SOMClass.somFindMethodOk(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindMethodOk
   (SOM_Resolve(Self, cd.classObject, cd.somFindMethodOk))
     (Self, methodId, m);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somFindSMethod
 *)
type
  somTD_SOMClass_somFindSMethod = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId): Pointer; stdcall;

function SOMClass.somFindSMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindSMethod
   (SOM_Resolve(Self, cd.classObject, cd.somFindSMethod))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somFindSMethodOk
 *)
type
  somTD_SOMClass_somFindSMethodOk = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId): Pointer; stdcall;

function SOMClass.somFindSMethodOk(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindSMethodOk
   (SOM_Resolve(Self, cd.classObject, cd.somFindSMethodOk))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somLookupMethod
 *)
type
  somTD_SOMClass_somLookupMethod = function(somSelf: SOMObjectBase{SOMClass}; methodId: somId): Pointer; stdcall;

function SOMClass.somLookupMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somLookupMethod
   (SOM_Resolve(Self, cd.classObject, cd.somLookupMethod))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somCheckVersion
 *)
type
  somTD_SOMClass_somCheckVersion = function(somSelf: SOMObjectBase{SOMClass}; majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; stdcall;

function SOMClass.somCheckVersion(majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somCheckVersion
   (SOM_Resolve(Self, cd.classObject, cd.somCheckVersion))
     (Self, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDescendedFrom
 *)
type
  somTD_SOMClass_somDescendedFrom = function(somSelf: SOMObjectBase{SOMClass}; aClassObj: SOMClass): CORBABoolean; stdcall;

function SOMClass.somDescendedFrom(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somDescendedFrom
   (SOM_Resolve(Self, cd.classObject, cd.somDescendedFrom))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somSupportsMethod
 *)
type
  somTD_SOMClass_somSupportsMethod = function(somSelf: SOMObjectBase{SOMClass}; mId: somId): CORBABoolean; stdcall;

function SOMClass.somSupportsMethod(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somSupportsMethod
   (SOM_Resolve(Self, cd.classObject, cd.somSupportsMethod))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somDefinedMethod
 *)
type
  somTD_SOMClass_somDefinedMethod = function(somSelf: SOMObjectBase{SOMClass}; method: Pointer): Pointer; stdcall;

function SOMClass.somDefinedMethod(method: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somDefinedMethod
   (SOM_Resolve(Self, cd.classObject, cd.somDefinedMethod))
     (Self, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somOverrideMtab
 *)
type
  somTD_SOMClass_somOverrideMtab = procedure(somSelf: SOMObjectBase{SOMClass}); stdcall;

procedure SOMClass.somOverrideMtab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somOverrideMtab
   (SOM_Resolve(Self, cd.classObject, cd.somOverrideMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somDefaultAssign(var ctrl: Pointer; fromObj: SOMClass): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMClass): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMClass): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMClass): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClass.somPrintSelf: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClass.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMClass.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMClass then { invoked on class name literal }
  begin
    Result := SOMClass(SOMClassClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMClass.NewClass: SOMClass;
begin
  if Self = SOMClass then { invoked on class name literal }
  begin
    Result := SOMClass(SOMClassClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMClassNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMClass.As_SOMClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMClass.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMClass.Supports(Instance: SOMObjectBase; out Obj: SOMClass): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMClass(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMMSingleInstance_MajorVersion = 2;
  SOMMSingleInstance_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMMSingleInstanceNewClass(
  somtmajorVersion: integer4 = SOMMSingleInstance_MajorVersion;
  somtminorVersion: integer4 = SOMMSingleInstance_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMMSingleInstanceNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMMSingleInstanceClassDataStructure = packed record
    classObject: SOMClass;
    sommGetSingleInstance,
    sommFreeSingleInstance: somMToken;
  end;
  PSOMMSingleInstanceClassDataStructure = ^SOMMSingleInstanceClassDataStructure;

var
  SOME_DLL_SOMMSingleInstanceClassData: PSOMMSingleInstanceClassDataStructure = nil;

function SOMMSingleInstanceClassData: PSOMMSingleInstanceClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMMSingleInstanceClassData) then
    Result := SOME_DLL_SOMMSingleInstanceClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMMSingleInstanceClassData, 'SOMMSingleInstanceClassData');
    Result := SOME_DLL_SOMMSingleInstanceClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMMSingleInstanceCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMMSingleInstanceCClassDataStructure = ^SOMMSingleInstanceCClassDataStructure;

var
  SOME_DLL_SOMMSingleInstanceCClassData: PSOMMSingleInstanceCClassDataStructure = nil;

function SOMMSingleInstanceCClassData: PSOMMSingleInstanceCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMMSingleInstanceCClassData) then
    Result := SOME_DLL_SOMMSingleInstanceCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMMSingleInstanceCClassData, 'SOMMSingleInstanceCClassData');
    Result := SOME_DLL_SOMMSingleInstanceCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

function SOMMSingleInstance._get_somDataAlignment: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somDataAlignment
   (SOM_Resolve(Self, cd.classObject, cd._get_somDataAlignment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance._get_somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somInstanceDataOffsets
   (SOM_Resolve(Self, cd.classObject, cd._get_somInstanceDataOffsets))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance._get_somDirectInitClasses: _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somDirectInitClasses
   (SOM_Resolve(Self, cd.classObject, cd._get_somDirectInitClasses))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance._set_somDirectInitClasses(const somDirectInitClasses: _IDL_Sequence_SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass__set_somDirectInitClasses
   (SOM_Resolve(Self, cd.classObject, cd._set_somDirectInitClasses))
     (Self, somDirectInitClasses);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance._get_somClassAllocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somClassAllocate
   (SOM_Resolve(Self, cd.classObject, cd._get_somClassAllocate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance._get_somClassDeallocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somClassDeallocate
   (SOM_Resolve(Self, cd.classObject, cd._get_somClassDeallocate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMMSingleInstance.Create: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMClass(NewClass).somNew);
end;

class function SOMMSingleInstance.InitInstance(Instance: Pointer): SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMMSingleInstance.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMMSingleInstance.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMMSingleInstance.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMMSingleInstance.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMMSingleInstance.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMMSingleInstance.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMMSingleInstance.NewInstance: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMClass(NewClass).somNewNoInit);
end;

function SOMMSingleInstance.Clone: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: sommGetSingleInstance
 *)
type
  somTD_SOMMSingleInstance_sommGetSingleInstance = function(somSelf: SOMObjectBase{SOMMSingleInstance}; ev: PEnvironment): SOMObject; stdcall;

function SOMMSingleInstance.sommGetSingleInstance: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMMSingleInstanceClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMMSingleInstanceClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMMSingleInstance_sommGetSingleInstance
   (SOM_Resolve(Self, cd.classObject, cd.sommGetSingleInstance))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: sommFreeSingleInstance
 *)
type
  somTD_SOMMSingleInstance_sommFreeSingleInstance = procedure(somSelf: SOMObjectBase{SOMMSingleInstance}; ev: PEnvironment); stdcall;

procedure SOMMSingleInstance.sommFreeSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMMSingleInstanceClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMMSingleInstanceClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMMSingleInstance_sommFreeSingleInstance
   (SOM_Resolve(Self, cd.classObject, cd.sommFreeSingleInstance))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMMSingleInstance.somNew: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somNew
   (SOM_Resolve(Self, cd.classObject, cd.somNew))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somNewNoInit: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somNewNoInit
   (SOM_Resolve(Self, cd.classObject, cd.somNewNoInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somRenew(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenew
   (SOM_Resolve(Self, cd.classObject, cd.somRenew))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somRenewNoInit(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoInit
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoInit))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somRenewNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoZero
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoZero))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somRenewNoInitNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoInitNoZero
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoInitNoZero))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somAllocate(size: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somAllocate
   (SOM_Resolve(Self, cd.classObject, cd.somAllocate))
     (Self, size);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somDeallocate(memptr: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somDeallocate
   (SOM_Resolve(Self, cd.classObject, cd.somDeallocate))
     (Self, memptr);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetInstanceInitMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceInitMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceInitMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetInstanceDestructionMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceDestructionMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceDestructionMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetInstanceAssignmentMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceAssignmentMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceAssignmentMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somInitClass(className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somInitClass
   (SOM_Resolve(Self, cd.classObject, cd.somInitClass))
     (Self, className, parentClass, dataSize, maxStaticMethods, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somInitMIClass(inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somInitMIClass
   (SOM_Resolve(Self, cd.classObject, cd.somInitMIClass))
     (Self, inherit_vars, className, parentClasses, dataSize, dataAlignment, maxStaticMethods, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somAddStaticMethod(methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somAddStaticMethod
   (SOM_Resolve(Self, cd.classObject, cd.somAddStaticMethod))
     (Self, methodId, methodDescriptor, method, redispatchStub, applyStub);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somAddDynamicMethod(methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somAddDynamicMethod
   (SOM_Resolve(Self, cd.classObject, cd.somAddDynamicMethod))
     (Self, methodId, methodDescriptor, method, applyStub);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somOverrideSMethod(methodId: somId; method: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somOverrideSMethod
   (SOM_Resolve(Self, cd.classObject, cd.somOverrideSMethod))
     (Self, methodId, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somClassReady; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somClassReady
   (SOM_Resolve(Self, cd.classObject, cd.somClassReady))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetClassData: PsomClassDataStructure; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetClassData
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassData))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somSetClassData(const cds: somClassDataStructure); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somSetClassData
   (SOM_Resolve(Self, cd.classObject, cd.somSetClassData))
     (Self, cds);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetClassMtab: PsomMethodTab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetClassMtab
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetInstanceOffset: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceOffset
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceOffset))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetInstancePartSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstancePartSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstancePartSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetInstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetInstanceToken: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceToken))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetMemberToken(memberOffset: LongInt; instanceToken: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMemberToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetMemberToken))
     (Self, memberOffset, instanceToken);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetMethodData(methodId: somId; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodData
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodData))
     (Self, methodId, md);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetRdStub(methodId: somId): PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetRdStub
   (SOM_Resolve(Self, cd.classObject, cd.somGetRdStub))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetMethodDescriptor(methodId: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodDescriptor
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodDescriptor))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetMethodIndex(id: somId): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodIndex
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodIndex))
     (Self, id);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetMethodToken(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodToken))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetName
   (SOM_Resolve(Self, cd.classObject, cd.somGetName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetNthMethodData(n: LongInt; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNthMethodData
   (SOM_Resolve(Self, cd.classObject, cd.somGetNthMethodData))
     (Self, n, md);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetNthMethodInfo(n: LongInt; out descriptor: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNthMethodInfo
   (SOM_Resolve(Self, cd.classObject, cd.somGetNthMethodInfo))
     (Self, n, descriptor);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetNumMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNumMethods
   (SOM_Resolve(Self, cd.classObject, cd.somGetNumMethods))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetNumStaticMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNumStaticMethods
   (SOM_Resolve(Self, cd.classObject, cd.somGetNumStaticMethods))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetParent: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetParent
   (SOM_Resolve(Self, cd.classObject, cd.somGetParent))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetParents: {dual_owned} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetParents
   (SOM_Resolve(Self, cd.classObject, cd.somGetParents))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetPClsMtab: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetPClsMtab
   (SOM_Resolve(Self, cd.classObject, cd.somGetPClsMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetPClsMtabs: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetPClsMtabs
   (SOM_Resolve(Self, cd.classObject, cd.somGetPClsMtabs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somGetVersionNumbers(out majorVersion: LongInt; out minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somGetVersionNumbers
   (SOM_Resolve(Self, cd.classObject, cd.somGetVersionNumbers))
     (Self, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somSetMethodDescriptor(methodId: somId; descriptor: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somSetMethodDescriptor
   (SOM_Resolve(Self, cd.classObject, cd.somSetMethodDescriptor))
     (Self, methodId, descriptor);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somFindMethod(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindMethod
   (SOM_Resolve(Self, cd.classObject, cd.somFindMethod))
     (Self, methodId, m);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somFindMethodOk(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindMethodOk
   (SOM_Resolve(Self, cd.classObject, cd.somFindMethodOk))
     (Self, methodId, m);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somFindSMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindSMethod
   (SOM_Resolve(Self, cd.classObject, cd.somFindSMethod))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somFindSMethodOk(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindSMethodOk
   (SOM_Resolve(Self, cd.classObject, cd.somFindSMethodOk))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somLookupMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somLookupMethod
   (SOM_Resolve(Self, cd.classObject, cd.somLookupMethod))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somCheckVersion(majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somCheckVersion
   (SOM_Resolve(Self, cd.classObject, cd.somCheckVersion))
     (Self, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somDescendedFrom(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somDescendedFrom
   (SOM_Resolve(Self, cd.classObject, cd.somDescendedFrom))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somSupportsMethod(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somSupportsMethod
   (SOM_Resolve(Self, cd.classObject, cd.somSupportsMethod))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somDefinedMethod(method: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somDefinedMethod
   (SOM_Resolve(Self, cd.classObject, cd.somDefinedMethod))
     (Self, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somOverrideMtab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somOverrideMtab
   (SOM_Resolve(Self, cd.classObject, cd.somOverrideMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMMSingleInstance); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somDefaultAssign(var ctrl: Pointer; fromObj: SOMMSingleInstance): SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMMSingleInstance); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMMSingleInstance); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMMSingleInstance); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMMSingleInstance): SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMMSingleInstance): SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMMSingleInstance): SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMSingleInstance.somPrintSelf: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMSingleInstance.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMMSingleInstance.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMMSingleInstance then { invoked on class name literal }
  begin
    Result := SOMClass(SOMMSingleInstanceClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMMSingleInstance.NewClass: SOMClass;
begin
  if Self = SOMMSingleInstance then { invoked on class name literal }
  begin
    Result := SOMClass(SOMMSingleInstanceClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMMSingleInstanceNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMMSingleInstance.As_SOMClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(Self);
end;

function SOMMSingleInstance.As_SOMMSingleInstance: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMMSingleInstance.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMMSingleInstance.Supports(Instance: SOMObjectBase; out Obj: SOMMSingleInstance): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMMSingleInstance(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMMBeforeAfter_MajorVersion = 2;
  SOMMBeforeAfter_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMMBeforeAfterNewClass(
  somtmajorVersion: integer4 = SOMMBeforeAfter_MajorVersion;
  somtminorVersion: integer4 = SOMMBeforeAfter_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMMBeforeAfterNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMMBeforeAfterClassDataStructure = packed record
    classObject: SOMClass;
    sommBeforeMethod,
    sommAfterMethod: somMToken;
  end;
  PSOMMBeforeAfterClassDataStructure = ^SOMMBeforeAfterClassDataStructure;

var
  SOME_DLL_SOMMBeforeAfterClassData: PSOMMBeforeAfterClassDataStructure = nil;

function SOMMBeforeAfterClassData: PSOMMBeforeAfterClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMMBeforeAfterClassData) then
    Result := SOME_DLL_SOMMBeforeAfterClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMMBeforeAfterClassData, 'SOMMBeforeAfterClassData');
    Result := SOME_DLL_SOMMBeforeAfterClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMMBeforeAfterCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMMBeforeAfterCClassDataStructure = ^SOMMBeforeAfterCClassDataStructure;

var
  SOME_DLL_SOMMBeforeAfterCClassData: PSOMMBeforeAfterCClassDataStructure = nil;

function SOMMBeforeAfterCClassData: PSOMMBeforeAfterCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMMBeforeAfterCClassData) then
    Result := SOME_DLL_SOMMBeforeAfterCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMMBeforeAfterCClassData, 'SOMMBeforeAfterCClassData');
    Result := SOME_DLL_SOMMBeforeAfterCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

function SOMMBeforeAfter._get_somDataAlignment: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somDataAlignment
   (SOM_Resolve(Self, cd.classObject, cd._get_somDataAlignment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter._get_somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somInstanceDataOffsets
   (SOM_Resolve(Self, cd.classObject, cd._get_somInstanceDataOffsets))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter._get_somDirectInitClasses: _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somDirectInitClasses
   (SOM_Resolve(Self, cd.classObject, cd._get_somDirectInitClasses))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter._set_somDirectInitClasses(const somDirectInitClasses: _IDL_Sequence_SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass__set_somDirectInitClasses
   (SOM_Resolve(Self, cd.classObject, cd._set_somDirectInitClasses))
     (Self, somDirectInitClasses);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter._get_somClassAllocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somClassAllocate
   (SOM_Resolve(Self, cd.classObject, cd._get_somClassAllocate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter._get_somClassDeallocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somClassDeallocate
   (SOM_Resolve(Self, cd.classObject, cd._get_somClassDeallocate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMMBeforeAfter.Create: SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMBeforeAfter(SOMClass(NewClass).somNew);
end;

class function SOMMBeforeAfter.InitInstance(Instance: Pointer): SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMBeforeAfter(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMMBeforeAfter.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMMBeforeAfter.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMMBeforeAfter.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMMBeforeAfter.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMMBeforeAfter.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMMBeforeAfter.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMMBeforeAfter.NewInstance: SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMBeforeAfter(SOMClass(NewClass).somNewNoInit);
end;

function SOMMBeforeAfter.Clone: SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMBeforeAfter(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: sommBeforeMethod
 *)
type
  somTD_SOMMBeforeAfter_sommBeforeMethod = function(somSelf: SOMObjectBase{SOMMBeforeAfter}; ev: PEnvironment; SOM_object: SOMObject; methodId: somId; ap: va_list): CORBABoolean; stdcall;

function SOMMBeforeAfter.sommBeforeMethod(SOM_object: SOMObject; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMMBeforeAfterClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMMBeforeAfterClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMMBeforeAfter_sommBeforeMethod
   (SOM_Resolve(Self, cd.classObject, cd.sommBeforeMethod))
     (Self, @LocalEnv, SOM_object, methodId, ap);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: sommAfterMethod
 *)
type
  somTD_SOMMBeforeAfter_sommAfterMethod = procedure(somSelf: SOMObjectBase{SOMMBeforeAfter}; ev: PEnvironment; SOM_object: SOMObject; methodId: somId; returnedvalue: Pointer; ap: va_list); stdcall;

procedure SOMMBeforeAfter.sommAfterMethod(SOM_object: SOMObject; methodId: somId; returnedvalue: Pointer; ap: va_list); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMMBeforeAfterClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMMBeforeAfterClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMMBeforeAfter_sommAfterMethod
   (SOM_Resolve(Self, cd.classObject, cd.sommAfterMethod))
     (Self, @LocalEnv, SOM_object, methodId, returnedvalue, ap);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMMBeforeAfter.somNew: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somNew
   (SOM_Resolve(Self, cd.classObject, cd.somNew))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somNewNoInit: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somNewNoInit
   (SOM_Resolve(Self, cd.classObject, cd.somNewNoInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somRenew(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenew
   (SOM_Resolve(Self, cd.classObject, cd.somRenew))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somRenewNoInit(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoInit
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoInit))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somRenewNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoZero
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoZero))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somRenewNoInitNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoInitNoZero
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoInitNoZero))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somAllocate(size: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somAllocate
   (SOM_Resolve(Self, cd.classObject, cd.somAllocate))
     (Self, size);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somDeallocate(memptr: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somDeallocate
   (SOM_Resolve(Self, cd.classObject, cd.somDeallocate))
     (Self, memptr);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetInstanceInitMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceInitMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceInitMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetInstanceDestructionMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceDestructionMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceDestructionMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetInstanceAssignmentMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceAssignmentMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceAssignmentMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somInitClass(className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somInitClass
   (SOM_Resolve(Self, cd.classObject, cd.somInitClass))
     (Self, className, parentClass, dataSize, maxStaticMethods, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somInitMIClass(inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somInitMIClass
   (SOM_Resolve(Self, cd.classObject, cd.somInitMIClass))
     (Self, inherit_vars, className, parentClasses, dataSize, dataAlignment, maxStaticMethods, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somAddStaticMethod(methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somAddStaticMethod
   (SOM_Resolve(Self, cd.classObject, cd.somAddStaticMethod))
     (Self, methodId, methodDescriptor, method, redispatchStub, applyStub);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somAddDynamicMethod(methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somAddDynamicMethod
   (SOM_Resolve(Self, cd.classObject, cd.somAddDynamicMethod))
     (Self, methodId, methodDescriptor, method, applyStub);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somOverrideSMethod(methodId: somId; method: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somOverrideSMethod
   (SOM_Resolve(Self, cd.classObject, cd.somOverrideSMethod))
     (Self, methodId, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somClassReady; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somClassReady
   (SOM_Resolve(Self, cd.classObject, cd.somClassReady))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetClassData: PsomClassDataStructure; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetClassData
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassData))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somSetClassData(const cds: somClassDataStructure); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somSetClassData
   (SOM_Resolve(Self, cd.classObject, cd.somSetClassData))
     (Self, cds);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetClassMtab: PsomMethodTab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetClassMtab
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetInstanceOffset: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceOffset
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceOffset))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetInstancePartSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstancePartSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstancePartSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetInstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetInstanceToken: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceToken))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetMemberToken(memberOffset: LongInt; instanceToken: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMemberToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetMemberToken))
     (Self, memberOffset, instanceToken);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetMethodData(methodId: somId; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodData
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodData))
     (Self, methodId, md);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetRdStub(methodId: somId): PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetRdStub
   (SOM_Resolve(Self, cd.classObject, cd.somGetRdStub))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetMethodDescriptor(methodId: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodDescriptor
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodDescriptor))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetMethodIndex(id: somId): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodIndex
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodIndex))
     (Self, id);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetMethodToken(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodToken))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetName
   (SOM_Resolve(Self, cd.classObject, cd.somGetName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetNthMethodData(n: LongInt; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNthMethodData
   (SOM_Resolve(Self, cd.classObject, cd.somGetNthMethodData))
     (Self, n, md);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetNthMethodInfo(n: LongInt; out descriptor: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNthMethodInfo
   (SOM_Resolve(Self, cd.classObject, cd.somGetNthMethodInfo))
     (Self, n, descriptor);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetNumMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNumMethods
   (SOM_Resolve(Self, cd.classObject, cd.somGetNumMethods))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetNumStaticMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNumStaticMethods
   (SOM_Resolve(Self, cd.classObject, cd.somGetNumStaticMethods))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetParent: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetParent
   (SOM_Resolve(Self, cd.classObject, cd.somGetParent))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetParents: {dual_owned} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetParents
   (SOM_Resolve(Self, cd.classObject, cd.somGetParents))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetPClsMtab: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetPClsMtab
   (SOM_Resolve(Self, cd.classObject, cd.somGetPClsMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetPClsMtabs: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetPClsMtabs
   (SOM_Resolve(Self, cd.classObject, cd.somGetPClsMtabs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somGetVersionNumbers(out majorVersion: LongInt; out minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somGetVersionNumbers
   (SOM_Resolve(Self, cd.classObject, cd.somGetVersionNumbers))
     (Self, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somSetMethodDescriptor(methodId: somId; descriptor: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somSetMethodDescriptor
   (SOM_Resolve(Self, cd.classObject, cd.somSetMethodDescriptor))
     (Self, methodId, descriptor);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somFindMethod(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindMethod
   (SOM_Resolve(Self, cd.classObject, cd.somFindMethod))
     (Self, methodId, m);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somFindMethodOk(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindMethodOk
   (SOM_Resolve(Self, cd.classObject, cd.somFindMethodOk))
     (Self, methodId, m);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somFindSMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindSMethod
   (SOM_Resolve(Self, cd.classObject, cd.somFindSMethod))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somFindSMethodOk(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindSMethodOk
   (SOM_Resolve(Self, cd.classObject, cd.somFindSMethodOk))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somLookupMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somLookupMethod
   (SOM_Resolve(Self, cd.classObject, cd.somLookupMethod))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somCheckVersion(majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somCheckVersion
   (SOM_Resolve(Self, cd.classObject, cd.somCheckVersion))
     (Self, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somDescendedFrom(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somDescendedFrom
   (SOM_Resolve(Self, cd.classObject, cd.somDescendedFrom))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somSupportsMethod(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somSupportsMethod
   (SOM_Resolve(Self, cd.classObject, cd.somSupportsMethod))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somDefinedMethod(method: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somDefinedMethod
   (SOM_Resolve(Self, cd.classObject, cd.somDefinedMethod))
     (Self, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somOverrideMtab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somOverrideMtab
   (SOM_Resolve(Self, cd.classObject, cd.somOverrideMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMMBeforeAfter); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somDefaultAssign(var ctrl: Pointer; fromObj: SOMMBeforeAfter): SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMBeforeAfter(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMMBeforeAfter); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMMBeforeAfter); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMMBeforeAfter); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMMBeforeAfter): SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMBeforeAfter(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMMBeforeAfter): SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMBeforeAfter(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMMBeforeAfter): SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMBeforeAfter(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMBeforeAfter.somPrintSelf: SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMBeforeAfter(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMBeforeAfter.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMMBeforeAfter.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMMBeforeAfter then { invoked on class name literal }
  begin
    Result := SOMClass(SOMMBeforeAfterClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMMBeforeAfter.NewClass: SOMClass;
begin
  if Self = SOMMBeforeAfter then { invoked on class name literal }
  begin
    Result := SOMClass(SOMMBeforeAfterClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMMBeforeAfterNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMMBeforeAfter.As_SOMClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(Self);
end;

function SOMMBeforeAfter.As_SOMMBeforeAfter: SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMMBeforeAfter.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMMBeforeAfter.Supports(Instance: SOMObjectBase; out Obj: SOMMBeforeAfter): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMMBeforeAfter(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMClassMgr_MajorVersion = 1;
  SOMClassMgr_MinorVersion = 4;

(*
 * Declare the class creation procedure
 *)
function SOMClassMgrNewClass(
  somtmajorVersion: integer4 = SOMClassMgr_MajorVersion;
  somtminorVersion: integer4 = SOMClassMgr_MinorVersion):
  SOMClass; stdcall; external SOM_DLL_Name name 'SOMClassMgrNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMClassMgrClassDataStructure = packed record
    classObject: SOMClass;
    somFindClsInFile,
    somFindClass,
    somClassFromId,
    somRegisterClass,
    somUnregisterClass,
    somLocateClassFile,
    somLoadClassFile,
    somUnloadClassFile,
    somGetInitFunction,
    somMergeInto,
    somGetRelatedClasses,
    somSubstituteClass,
    _get_somInterfaceRepository,
    _set_somInterfaceRepository,
    _get_somRegisteredClasses,
    somBeginPersistentClasses,
    somEndPersistentClasses,
    somcmPrivate1,
    somcmPrivate2,
    somRegisterClassLibrary,
    somJoinAffinityGroup,
    somUnregisterClassLibrary: somMToken;
  end;
  PSOMClassMgrClassDataStructure = ^SOMClassMgrClassDataStructure;

var
  SOM_DLL_SOMClassMgrClassData: PSOMClassMgrClassDataStructure = nil;

function SOMClassMgrClassData: PSOMClassMgrClassDataStructure;
begin
  if Assigned(SOM_DLL_SOMClassMgrClassData) then
    Result := SOM_DLL_SOMClassMgrClassData
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOMClassMgrClassData, 'SOMClassMgrClassData');
    Result := SOM_DLL_SOMClassMgrClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMClassMgrCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMClassMgrCClassDataStructure = ^SOMClassMgrCClassDataStructure;

var
  SOM_DLL_SOMClassMgrCClassData: PSOMClassMgrCClassDataStructure = nil;

function SOMClassMgrCClassData: PSOMClassMgrCClassDataStructure;
begin
  if Assigned(SOM_DLL_SOMClassMgrCClassData) then
    Result := SOM_DLL_SOMClassMgrCClassData
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOMClassMgrCClassData, 'SOMClassMgrCClassData');
    Result := SOM_DLL_SOMClassMgrCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somInterfaceRepository
 *)
type
  somTD_SOMClassMgr__get_somInterfaceRepository = function(somSelf: SOMObjectBase{SOMClassMgr}): Repository; stdcall;

function SOMClassMgr._get_somInterfaceRepository: Repository; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr__get_somInterfaceRepository
   (SOM_Resolve(Self, cd.classObject, cd._get_somInterfaceRepository))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somInterfaceRepository
 *)
type
  somTD_SOMClassMgr__set_somInterfaceRepository = procedure(somSelf: SOMObjectBase{SOMClassMgr}; somInterfaceRepository: Repository); stdcall;

procedure SOMClassMgr._set_somInterfaceRepository(somInterfaceRepository: Repository); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  somTD_SOMClassMgr__set_somInterfaceRepository
   (SOM_Resolve(Self, cd.classObject, cd._set_somInterfaceRepository))
     (Self, somInterfaceRepository);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somRegisteredClasses
 *)
type
  somTD_SOMClassMgr__get_somRegisteredClasses = function(somSelf: SOMObjectBase{SOMClassMgr}): {caller_owns} _IDL_Sequence_SOMClass; stdcall;

function SOMClassMgr._get_somRegisteredClasses: {caller_owns} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr__get_somRegisteredClasses
   (SOM_Resolve(Self, cd.classObject, cd._get_somRegisteredClasses))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMClassMgr.Create: SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClassMgr(SOMClass(NewClass).somNew);
end;

class function SOMClassMgr.InitInstance(Instance: Pointer): SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClassMgr(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMClassMgr.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMClassMgr.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMClassMgr.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMClassMgr.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMClassMgr.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMClassMgr.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMClassMgr.NewInstance: SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClassMgr(SOMClass(NewClass).somNewNoInit);
end;

function SOMClassMgr.Clone: SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClassMgr(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somLoadClassFile
 *)
type
  somTD_SOMClassMgr_somLoadClassFile = function(somSelf: SOMObjectBase{SOMClassMgr}; classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt; SOM_file: {caller_owns} CORBAString): SOMClass; stdcall;

function SOMClassMgr.somLoadClassFile(classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt; SOM_file: {caller_owns} CORBAString): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somLoadClassFile
   (SOM_Resolve(Self, cd.classObject, cd.somLoadClassFile))
     (Self, classId, majorVersion, minorVersion, SOM_file);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somLocateClassFile
 *)
type
  somTD_SOMClassMgr_somLocateClassFile = function(somSelf: SOMObjectBase{SOMClassMgr}; classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt): CORBAString; stdcall;

function SOMClassMgr.somLocateClassFile(classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somLocateClassFile
   (SOM_Resolve(Self, cd.classObject, cd.somLocateClassFile))
     (Self, classId, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somRegisterClass
 *)
type
  somTD_SOMClassMgr_somRegisterClass = procedure(somSelf: SOMObjectBase{SOMClassMgr}; classObj: SOMClass); stdcall;

procedure SOMClassMgr.somRegisterClass(classObj: SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  somTD_SOMClassMgr_somRegisterClass
   (SOM_Resolve(Self, cd.classObject, cd.somRegisterClass))
     (Self, classObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somRegisterClassLibrary
 *)
type
  somTD_SOMClassMgr_somRegisterClassLibrary = procedure(somSelf: SOMObjectBase{SOMClassMgr}; libraryName: {caller_owns} CORBAString; libraryInitRtn: Pointer); stdcall;

procedure SOMClassMgr.somRegisterClassLibrary(libraryName: {caller_owns} CORBAString; libraryInitRtn: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  somTD_SOMClassMgr_somRegisterClassLibrary
   (SOM_Resolve(Self, cd.classObject, cd.somRegisterClassLibrary))
     (Self, libraryName, libraryInitRtn);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somUnregisterClassLibrary
 *)
type
  somTD_SOMClassMgr_somUnregisterClassLibrary = procedure(somSelf: SOMObjectBase{SOMClassMgr}; libraryName: {caller_owns} CORBAString); stdcall;

procedure SOMClassMgr.somUnregisterClassLibrary(libraryName: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  somTD_SOMClassMgr_somUnregisterClassLibrary
   (SOM_Resolve(Self, cd.classObject, cd.somUnregisterClassLibrary))
     (Self, libraryName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somUnloadClassFile
 *)
type
  somTD_SOMClassMgr_somUnloadClassFile = function(somSelf: SOMObjectBase{SOMClassMgr}; classObj: SOMClass): LongInt; stdcall;

function SOMClassMgr.somUnloadClassFile(classObj: SOMClass): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somUnloadClassFile
   (SOM_Resolve(Self, cd.classObject, cd.somUnloadClassFile))
     (Self, classObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somUnregisterClass
 *)
type
  somTD_SOMClassMgr_somUnregisterClass = function(somSelf: SOMObjectBase{SOMClassMgr}; classObj: SOMClass): LongInt; stdcall;

function SOMClassMgr.somUnregisterClass(classObj: SOMClass): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somUnregisterClass
   (SOM_Resolve(Self, cd.classObject, cd.somUnregisterClass))
     (Self, classObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somBeginPersistentClasses
 *)
type
  somTD_SOMClassMgr_somBeginPersistentClasses = procedure(somSelf: SOMObjectBase{SOMClassMgr}); stdcall;

procedure SOMClassMgr.somBeginPersistentClasses; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  somTD_SOMClassMgr_somBeginPersistentClasses
   (SOM_Resolve(Self, cd.classObject, cd.somBeginPersistentClasses))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somEndPersistentClasses
 *)
type
  somTD_SOMClassMgr_somEndPersistentClasses = procedure(somSelf: SOMObjectBase{SOMClassMgr}); stdcall;

procedure SOMClassMgr.somEndPersistentClasses; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  somTD_SOMClassMgr_somEndPersistentClasses
   (SOM_Resolve(Self, cd.classObject, cd.somEndPersistentClasses))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somJoinAffinityGroup
 *)
type
  somTD_SOMClassMgr_somJoinAffinityGroup = function(somSelf: SOMObjectBase{SOMClassMgr}; SOM_newClass: SOMClass; affClass: SOMClass): CORBABoolean; stdcall;

function SOMClassMgr.somJoinAffinityGroup(SOM_newClass: SOMClass; affClass: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somJoinAffinityGroup
   (SOM_Resolve(Self, cd.classObject, cd.somJoinAffinityGroup))
     (Self, SOM_newClass, affClass);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetInitFunction
 *)
type
  somTD_SOMClassMgr_somGetInitFunction = function(somSelf: SOMObjectBase{SOMClassMgr}): CORBAString; stdcall;

function SOMClassMgr.somGetInitFunction: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somGetInitFunction
   (SOM_Resolve(Self, cd.classObject, cd.somGetInitFunction))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somGetRelatedClasses
 *)
type
  somTD_SOMClassMgr_somGetRelatedClasses = function(somSelf: SOMObjectBase{SOMClassMgr}; classObj: SOMClass): {caller_owns} PSOMClass; stdcall;

function SOMClassMgr.somGetRelatedClasses(classObj: SOMClass): {caller_owns} PSOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somGetRelatedClasses
   (SOM_Resolve(Self, cd.classObject, cd.somGetRelatedClasses))
     (Self, classObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somClassFromId
 *)
type
  somTD_SOMClassMgr_somClassFromId = function(somSelf: SOMObjectBase{SOMClassMgr}; classId: {caller_owns} somId): SOMClass; stdcall;

function SOMClassMgr.somClassFromId(classId: {caller_owns} somId): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somClassFromId
   (SOM_Resolve(Self, cd.classObject, cd.somClassFromId))
     (Self, classId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somFindClass
 *)
type
  somTD_SOMClassMgr_somFindClass = function(somSelf: SOMObjectBase{SOMClassMgr}; classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt): SOMClass; stdcall;

function SOMClassMgr.somFindClass(classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somFindClass
   (SOM_Resolve(Self, cd.classObject, cd.somFindClass))
     (Self, classId, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somFindClsInFile
 *)
type
  somTD_SOMClassMgr_somFindClsInFile = function(somSelf: SOMObjectBase{SOMClassMgr}; classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt; SOM_file: {caller_owns} CORBAString): SOMClass; stdcall;

function SOMClassMgr.somFindClsInFile(classId: {caller_owns} somId; majorVersion: LongInt; minorVersion: LongInt; SOM_file: {caller_owns} CORBAString): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somFindClsInFile
   (SOM_Resolve(Self, cd.classObject, cd.somFindClsInFile))
     (Self, classId, majorVersion, minorVersion, SOM_file);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somMergeInto
 *)
type
  somTD_SOMClassMgr_somMergeInto = procedure(somSelf: SOMObjectBase{SOMClassMgr}; targetObj: SOMObject); stdcall;

procedure SOMClassMgr.somMergeInto(targetObj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  somTD_SOMClassMgr_somMergeInto
   (SOM_Resolve(Self, cd.classObject, cd.somMergeInto))
     (Self, targetObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somSubstituteClass
 *)
type
  somTD_SOMClassMgr_somSubstituteClass = function(somSelf: SOMObjectBase{SOMClassMgr}; origClassName: {caller_owns} CORBAString; newClassName: {caller_owns} CORBAString): LongInt; stdcall;

function SOMClassMgr.somSubstituteClass(origClassName: {caller_owns} CORBAString; newClassName: {caller_owns} CORBAString): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassMgrClassDataStructure;
begin
  cd := SOMClassMgrClassData;
  Result :=
  somTD_SOMClassMgr_somSubstituteClass
   (SOM_Resolve(Self, cd.classObject, cd.somSubstituteClass))
     (Self, origClassName, newClassName);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMClassMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somDefaultAssign(var ctrl: Pointer; fromObj: SOMClassMgr): SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClassMgr(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMClassMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMClassMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMClassMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMClassMgr): SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClassMgr(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMClassMgr): SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClassMgr(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMClassMgr): SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClassMgr(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMClassMgr.somPrintSelf: SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClassMgr(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMClassMgr.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMClassMgr.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMClassMgr then { invoked on class name literal }
  begin
    Result := SOMClass(SOMClassMgrClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMClassMgr.NewClass: SOMClass;
begin
  if Self = SOMClassMgr then { invoked on class name literal }
  begin
    Result := SOMClass(SOMClassMgrClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMClassMgrNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMClassMgr.As_SOMClassMgr: SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMClassMgr.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMClassMgr.Supports(Instance: SOMObjectBase; out Obj: SOMClassMgr): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMClassMgr(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMDObject_MajorVersion = 2;
  SOMDObject_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMDObjectNewClass(
  somtmajorVersion: integer4 = SOMDObject_MajorVersion;
  somtminorVersion: integer4 = SOMDObject_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'SOMDObjectNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMDObjectClassDataStructure = packed record
    classObject: SOMClass;
    get_implementation,
    get_interface,
    set_to_nil,
    is_nil,
    is_SOM_ref,
    is_constant,
    is_proxy,
    duplicate,
    release,
    create_request,
    create_request_args,
    _get_somd_tag,
    _get_somd_flags,
    _set_somd_flags,
    _get_somd_impl,
    _set_somd_impl,
    _get_somd_rid,
    _set_somd_rid,
    _get_somd_id,
    _set_somd_id: somMToken;
  end;
  PSOMDObjectClassDataStructure = ^SOMDObjectClassDataStructure;

var
  SOMD_DLL_SOMDObjectClassData: PSOMDObjectClassDataStructure = nil;

function SOMDObjectClassData: PSOMDObjectClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMDObjectClassData) then
    Result := SOMD_DLL_SOMDObjectClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMDObjectClassData, 'SOMDObjectClassData');
    Result := SOMD_DLL_SOMDObjectClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMDObjectCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMDObjectCClassDataStructure = ^SOMDObjectCClassDataStructure;

var
  SOMD_DLL_SOMDObjectCClassData: PSOMDObjectCClassDataStructure = nil;

function SOMDObjectCClassData: PSOMDObjectCClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMDObjectCClassData) then
    Result := SOMD_DLL_SOMDObjectCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMDObjectCClassData, 'SOMDObjectCClassData');
    Result := SOMD_DLL_SOMDObjectCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMDObject.Create: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDObject(SOMClass(NewClass).somNew);
end;

class function SOMDObject.InitInstance(Instance: Pointer): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDObject(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMDObject.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMDObject.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMDObject.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMDObject.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMDObject.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMDObject.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMDObject.NewInstance: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDObject(SOMClass(NewClass).somNewNoInit);
end;

function SOMDObject.Clone: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDObject(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: get_implementation
 *)
type
  somTD_SOMDObject_get_implementation = function(somSelf: SOMObjectBase{SOMDObject}; ev: PEnvironment): ImplementationDef; stdcall;

function SOMDObject.get_implementation: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_get_implementation
   (SOM_Resolve(Self, cd.classObject, cd.get_implementation))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: get_interface
 *)
type
  somTD_SOMDObject_get_interface = function(somSelf: SOMObjectBase{SOMDObject}; ev: PEnvironment): InterfaceDef; stdcall;

function SOMDObject.get_interface: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_get_interface
   (SOM_Resolve(Self, cd.classObject, cd.get_interface))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: is_nil
 *)
type
  somTD_SOMDObject_is_nil = function(somSelf: SOMObjectBase{SOMDObject}; ev: PEnvironment): CORBABoolean; stdcall;

function SOMDObject.is_nil: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_is_nil
   (SOM_Resolve(Self, cd.classObject, cd.is_nil))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: is_SOM_ref
 *)
type
  somTD_SOMDObject_is_SOM_ref = function(somSelf: SOMObjectBase{SOMDObject}; ev: PEnvironment): CORBABoolean; stdcall;

function SOMDObject.is_SOM_ref: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_is_SOM_ref
   (SOM_Resolve(Self, cd.classObject, cd.is_SOM_ref))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: is_constant
 *)
type
  somTD_SOMDObject_is_constant = function(somSelf: SOMObjectBase{SOMDObject}; ev: PEnvironment): CORBABoolean; stdcall;

function SOMDObject.is_constant: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_is_constant
   (SOM_Resolve(Self, cd.classObject, cd.is_constant))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: is_proxy
 *)
type
  somTD_SOMDObject_is_proxy = function(somSelf: SOMObjectBase{SOMDObject}; ev: PEnvironment): CORBABoolean; stdcall;

function SOMDObject.is_proxy: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_is_proxy
   (SOM_Resolve(Self, cd.classObject, cd.is_proxy))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: duplicate
 *)
type
  somTD_SOMDObject_duplicate = function(somSelf: SOMObjectBase{SOMDObject}; ev: PEnvironment): SOMDObject; stdcall;

function SOMDObject.duplicate: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_duplicate
   (SOM_Resolve(Self, cd.classObject, cd.duplicate))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: release
 *)
type
  somTD_SOMDObject_release = procedure(somSelf: SOMObjectBase{SOMDObject}; ev: PEnvironment); stdcall;

procedure SOMDObject.release; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMDObject_release
   (SOM_Resolve(Self, cd.classObject, cd.release))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: create_request
 *)
type
  somTD_SOMDObject_create_request = function(somSelf: SOMObjectBase{SOMDObject}; ev: PEnvironment; ctx: Context; operation: CORBAString; arg_list: NVList; var SOM_result: NamedValue; out request: Request; req_flags: LongWord): LongWord; stdcall;

function SOMDObject.create_request(ctx: Context; operation: CORBAString; arg_list: NVList; var SOM_result: NamedValue; out request: Request; req_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_create_request
   (SOM_Resolve(Self, cd.classObject, cd.create_request))
     (Self, @LocalEnv, ctx, operation, arg_list, SOM_result, request, req_flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: create_request_args
 *)
type
  somTD_SOMDObject_create_request_args = function(somSelf: SOMObjectBase{SOMDObject}; ev: PEnvironment; operation: CORBAString; out arg_list: NVList; out SOM_result: NamedValue): LongWord; stdcall;

function SOMDObject.create_request_args(operation: CORBAString; out arg_list: NVList; out SOM_result: NamedValue): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_create_request_args
   (SOM_Resolve(Self, cd.classObject, cd.create_request_args))
     (Self, @LocalEnv, operation, arg_list, SOM_result);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMDObject.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObject.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObject.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somDefaultAssign(var ctrl: Pointer; fromObj: SOMDObject): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDObject(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObject.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObject.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObject.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDObject): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDObject(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDObject): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDObject(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDObject): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDObject(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObject.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObject.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObject.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObject.somPrintSelf: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDObject(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObject.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObject.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMDObject.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMDObject then { invoked on class name literal }
  begin
    Result := SOMClass(SOMDObjectClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMDObject.NewClass: SOMClass;
begin
  if Self = SOMDObject then { invoked on class name literal }
  begin
    Result := SOMClass(SOMDObjectClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMDObjectNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMDObject.As_SOMDObject: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMDObject.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMDObject.Supports(Instance: SOMObjectBase; out Obj: SOMDObject): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMDObject(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMDClientProxy_MajorVersion = 2;
  SOMDClientProxy_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMDClientProxyNewClass(
  somtmajorVersion: integer4 = SOMDClientProxy_MajorVersion;
  somtminorVersion: integer4 = SOMDClientProxy_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'SOMDClientProxyNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMDClientProxyClassDataStructure = packed record
    classObject: SOMClass;
    somdTargetFree,
    somdTargetGetClass,
    somdTargetGetClassName,
    somdProxyFree,
    somdProxyGetClass,
    somdProxyGetClassName,
    set_binding,
    get_binding,
    reset_binding,
    _get_ctx_seq,
    _set_ctx_seq,
    somdReleaseResources,
    _get_memoryMgr: somMToken;
  end;
  PSOMDClientProxyClassDataStructure = ^SOMDClientProxyClassDataStructure;

var
  SOMD_DLL_SOMDClientProxyClassData: PSOMDClientProxyClassDataStructure = nil;

function SOMDClientProxyClassData: PSOMDClientProxyClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMDClientProxyClassData) then
    Result := SOMD_DLL_SOMDClientProxyClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMDClientProxyClassData, 'SOMDClientProxyClassData');
    Result := SOMD_DLL_SOMDClientProxyClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMDClientProxyCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMDClientProxyCClassDataStructure = ^SOMDClientProxyCClassDataStructure;

var
  SOMD_DLL_SOMDClientProxyCClassData: PSOMDClientProxyCClassDataStructure = nil;

function SOMDClientProxyCClassData: PSOMDClientProxyCClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMDClientProxyCClassData) then
    Result := SOMD_DLL_SOMDClientProxyCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMDClientProxyCClassData, 'SOMDClientProxyCClassData');
    Result := SOMD_DLL_SOMDClientProxyCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMDClientProxy.Create: SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDClientProxy(SOMClass(NewClass).somNew);
end;

class function SOMDClientProxy.InitInstance(Instance: Pointer): SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDClientProxy(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMDClientProxy.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMDClientProxy.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMDClientProxy.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMDClientProxy.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMDClientProxy.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMDClientProxy.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMDClientProxy.NewInstance: SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDClientProxy(SOMClass(NewClass).somNewNoInit);
end;

function SOMDClientProxy.Clone: SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDClientProxy(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somdTargetFree
 *)
type
  somTD_SOMDClientProxy_somdTargetFree = procedure(somSelf: SOMObjectBase{SOMDClientProxy}; ev: PEnvironment); stdcall;

procedure SOMDClientProxy.somdTargetFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDClientProxyClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDClientProxyClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMDClientProxy_somdTargetFree
   (SOM_Resolve(Self, cd.classObject, cd.somdTargetFree))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdTargetGetClass
 *)
type
  somTD_SOMDClientProxy_somdTargetGetClass = function(somSelf: SOMObjectBase{SOMDClientProxy}; ev: PEnvironment): SOMClass; stdcall;

function SOMDClientProxy.somdTargetGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDClientProxyClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDClientProxyClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDClientProxy_somdTargetGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somdTargetGetClass))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdTargetGetClassName
 *)
type
  somTD_SOMDClientProxy_somdTargetGetClassName = function(somSelf: SOMObjectBase{SOMDClientProxy}; ev: PEnvironment): CORBAString; stdcall;

function SOMDClientProxy.somdTargetGetClassName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDClientProxyClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDClientProxyClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDClientProxy_somdTargetGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somdTargetGetClassName))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdProxyFree
 *)
type
  somTD_SOMDClientProxy_somdProxyFree = procedure(somSelf: SOMObjectBase{SOMDClientProxy}; ev: PEnvironment); stdcall;

procedure SOMDClientProxy.somdProxyFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDClientProxyClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDClientProxyClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMDClientProxy_somdProxyFree
   (SOM_Resolve(Self, cd.classObject, cd.somdProxyFree))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdProxyGetClass
 *)
type
  somTD_SOMDClientProxy_somdProxyGetClass = function(somSelf: SOMObjectBase{SOMDClientProxy}; ev: PEnvironment): SOMClass; stdcall;

function SOMDClientProxy.somdProxyGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDClientProxyClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDClientProxyClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDClientProxy_somdProxyGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somdProxyGetClass))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdProxyGetClassName
 *)
type
  somTD_SOMDClientProxy_somdProxyGetClassName = function(somSelf: SOMObjectBase{SOMDClientProxy}; ev: PEnvironment): CORBAString; stdcall;

function SOMDClientProxy.somdProxyGetClassName: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDClientProxyClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDClientProxyClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDClientProxy_somdProxyGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somdProxyGetClassName))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdReleaseResources
 *)
type
  somTD_SOMDClientProxy_somdReleaseResources = procedure(somSelf: SOMObjectBase{SOMDClientProxy}; ev: PEnvironment); stdcall;

procedure SOMDClientProxy.somdReleaseResources; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDClientProxyClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDClientProxyClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMDClientProxy_somdReleaseResources
   (SOM_Resolve(Self, cd.classObject, cd.somdReleaseResources))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDClientProxy.get_implementation: ImplementationDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_get_implementation
   (SOM_Resolve(Self, cd.classObject, cd.get_implementation))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDClientProxy.get_interface: InterfaceDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_get_interface
   (SOM_Resolve(Self, cd.classObject, cd.get_interface))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDClientProxy.is_nil: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_is_nil
   (SOM_Resolve(Self, cd.classObject, cd.is_nil))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDClientProxy.is_SOM_ref: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_is_SOM_ref
   (SOM_Resolve(Self, cd.classObject, cd.is_SOM_ref))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDClientProxy.is_constant: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_is_constant
   (SOM_Resolve(Self, cd.classObject, cd.is_constant))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDClientProxy.is_proxy: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_is_proxy
   (SOM_Resolve(Self, cd.classObject, cd.is_proxy))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDClientProxy.duplicate: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_duplicate
   (SOM_Resolve(Self, cd.classObject, cd.duplicate))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMDClientProxy.release; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMDObject_release
   (SOM_Resolve(Self, cd.classObject, cd.release))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDClientProxy.create_request(ctx: Context; operation: CORBAString; arg_list: NVList; var SOM_result: NamedValue; out request: Request; req_flags: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_create_request
   (SOM_Resolve(Self, cd.classObject, cd.create_request))
     (Self, @LocalEnv, ctx, operation, arg_list, SOM_result, request, req_flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDClientProxy.create_request_args(operation: CORBAString; out arg_list: NVList; out SOM_result: NamedValue): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObject_create_request_args
   (SOM_Resolve(Self, cd.classObject, cd.create_request_args))
     (Self, @LocalEnv, operation, arg_list, SOM_result);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMDClientProxy.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDClientProxy.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDClientProxy.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDClientProxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somDefaultAssign(var ctrl: Pointer; fromObj: SOMDClientProxy): SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDClientProxy(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDClientProxy.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDClientProxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDClientProxy.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDClientProxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDClientProxy.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDClientProxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDClientProxy): SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDClientProxy(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDClientProxy): SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDClientProxy(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDClientProxy): SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDClientProxy(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDClientProxy.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDClientProxy.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDClientProxy.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDClientProxy.somPrintSelf: SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDClientProxy(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDClientProxy.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDClientProxy.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMDClientProxy.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMDClientProxy then { invoked on class name literal }
  begin
    Result := SOMClass(SOMDClientProxyClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMDClientProxy.NewClass: SOMClass;
begin
  if Self = SOMDClientProxy then { invoked on class name literal }
  begin
    Result := SOMClass(SOMDClientProxyClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMDClientProxyNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMDClientProxy.As_SOMDObject: SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDObject(Self);
end;

function SOMDClientProxy.As_SOMDClientProxy: SOMDClientProxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMDClientProxy.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMDClientProxy.Supports(Instance: SOMObjectBase; out Obj: SOMDClientProxy): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMDClientProxy(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMDMetaproxy_MajorVersion = 0;
  SOMDMetaproxy_MinorVersion = 0;

(*
 * Declare the class creation procedure
 *)
function SOMDMetaproxyNewClass(
  somtmajorVersion: integer4 = SOMDMetaproxy_MajorVersion;
  somtminorVersion: integer4 = SOMDMetaproxy_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMDMetaproxyNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMDMetaproxyClassDataStructure = packed record
    classObject: SOMClass;
  end;
  PSOMDMetaproxyClassDataStructure = ^SOMDMetaproxyClassDataStructure;

var
  SOME_DLL_SOMDMetaproxyClassData: PSOMDMetaproxyClassDataStructure = nil;

function SOMDMetaproxyClassData: PSOMDMetaproxyClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMDMetaproxyClassData) then
    Result := SOME_DLL_SOMDMetaproxyClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMDMetaproxyClassData, 'SOMDMetaproxyClassData');
    Result := SOME_DLL_SOMDMetaproxyClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMDMetaproxyCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMDMetaproxyCClassDataStructure = ^SOMDMetaproxyCClassDataStructure;

var
  SOME_DLL_SOMDMetaproxyCClassData: PSOMDMetaproxyCClassDataStructure = nil;

function SOMDMetaproxyCClassData: PSOMDMetaproxyCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMDMetaproxyCClassData) then
    Result := SOME_DLL_SOMDMetaproxyCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMDMetaproxyCClassData, 'SOMDMetaproxyCClassData');
    Result := SOME_DLL_SOMDMetaproxyCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

function SOMDMetaproxy._get_somDataAlignment: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somDataAlignment
   (SOM_Resolve(Self, cd.classObject, cd._get_somDataAlignment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy._get_somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somInstanceDataOffsets
   (SOM_Resolve(Self, cd.classObject, cd._get_somInstanceDataOffsets))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy._get_somDirectInitClasses: _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somDirectInitClasses
   (SOM_Resolve(Self, cd.classObject, cd._get_somDirectInitClasses))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy._set_somDirectInitClasses(const somDirectInitClasses: _IDL_Sequence_SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass__set_somDirectInitClasses
   (SOM_Resolve(Self, cd.classObject, cd._set_somDirectInitClasses))
     (Self, somDirectInitClasses);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy._get_somClassAllocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somClassAllocate
   (SOM_Resolve(Self, cd.classObject, cd._get_somClassAllocate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy._get_somClassDeallocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somClassDeallocate
   (SOM_Resolve(Self, cd.classObject, cd._get_somClassDeallocate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMDMetaproxy.Create: SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDMetaproxy(SOMClass(NewClass).somNew);
end;

class function SOMDMetaproxy.InitInstance(Instance: Pointer): SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDMetaproxy(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMDMetaproxy.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMDMetaproxy.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMDMetaproxy.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMDMetaproxy.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMDMetaproxy.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMDMetaproxy.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMDMetaproxy.NewInstance: SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDMetaproxy(SOMClass(NewClass).somNewNoInit);
end;

function SOMDMetaproxy.Clone: SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDMetaproxy(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMDMetaproxy.somNew: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somNew
   (SOM_Resolve(Self, cd.classObject, cd.somNew))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somNewNoInit: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somNewNoInit
   (SOM_Resolve(Self, cd.classObject, cd.somNewNoInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somRenew(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenew
   (SOM_Resolve(Self, cd.classObject, cd.somRenew))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somRenewNoInit(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoInit
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoInit))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somRenewNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoZero
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoZero))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somRenewNoInitNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoInitNoZero
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoInitNoZero))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somAllocate(size: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somAllocate
   (SOM_Resolve(Self, cd.classObject, cd.somAllocate))
     (Self, size);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somDeallocate(memptr: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somDeallocate
   (SOM_Resolve(Self, cd.classObject, cd.somDeallocate))
     (Self, memptr);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetInstanceInitMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceInitMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceInitMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetInstanceDestructionMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceDestructionMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceDestructionMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetInstanceAssignmentMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceAssignmentMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceAssignmentMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somInitClass(className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somInitClass
   (SOM_Resolve(Self, cd.classObject, cd.somInitClass))
     (Self, className, parentClass, dataSize, maxStaticMethods, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somInitMIClass(inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somInitMIClass
   (SOM_Resolve(Self, cd.classObject, cd.somInitMIClass))
     (Self, inherit_vars, className, parentClasses, dataSize, dataAlignment, maxStaticMethods, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somAddStaticMethod(methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somAddStaticMethod
   (SOM_Resolve(Self, cd.classObject, cd.somAddStaticMethod))
     (Self, methodId, methodDescriptor, method, redispatchStub, applyStub);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somAddDynamicMethod(methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somAddDynamicMethod
   (SOM_Resolve(Self, cd.classObject, cd.somAddDynamicMethod))
     (Self, methodId, methodDescriptor, method, applyStub);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somOverrideSMethod(methodId: somId; method: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somOverrideSMethod
   (SOM_Resolve(Self, cd.classObject, cd.somOverrideSMethod))
     (Self, methodId, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somClassReady; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somClassReady
   (SOM_Resolve(Self, cd.classObject, cd.somClassReady))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetClassData: PsomClassDataStructure; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetClassData
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassData))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somSetClassData(const cds: somClassDataStructure); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somSetClassData
   (SOM_Resolve(Self, cd.classObject, cd.somSetClassData))
     (Self, cds);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetClassMtab: PsomMethodTab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetClassMtab
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetInstanceOffset: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceOffset
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceOffset))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetInstancePartSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstancePartSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstancePartSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetInstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetInstanceToken: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceToken))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetMemberToken(memberOffset: LongInt; instanceToken: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMemberToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetMemberToken))
     (Self, memberOffset, instanceToken);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetMethodData(methodId: somId; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodData
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodData))
     (Self, methodId, md);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetRdStub(methodId: somId): PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetRdStub
   (SOM_Resolve(Self, cd.classObject, cd.somGetRdStub))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetMethodDescriptor(methodId: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodDescriptor
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodDescriptor))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetMethodIndex(id: somId): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodIndex
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodIndex))
     (Self, id);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetMethodToken(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodToken))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetName
   (SOM_Resolve(Self, cd.classObject, cd.somGetName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetNthMethodData(n: LongInt; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNthMethodData
   (SOM_Resolve(Self, cd.classObject, cd.somGetNthMethodData))
     (Self, n, md);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetNthMethodInfo(n: LongInt; out descriptor: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNthMethodInfo
   (SOM_Resolve(Self, cd.classObject, cd.somGetNthMethodInfo))
     (Self, n, descriptor);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetNumMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNumMethods
   (SOM_Resolve(Self, cd.classObject, cd.somGetNumMethods))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetNumStaticMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNumStaticMethods
   (SOM_Resolve(Self, cd.classObject, cd.somGetNumStaticMethods))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetParent: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetParent
   (SOM_Resolve(Self, cd.classObject, cd.somGetParent))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetParents: {dual_owned} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetParents
   (SOM_Resolve(Self, cd.classObject, cd.somGetParents))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetPClsMtab: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetPClsMtab
   (SOM_Resolve(Self, cd.classObject, cd.somGetPClsMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetPClsMtabs: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetPClsMtabs
   (SOM_Resolve(Self, cd.classObject, cd.somGetPClsMtabs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somGetVersionNumbers(out majorVersion: LongInt; out minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somGetVersionNumbers
   (SOM_Resolve(Self, cd.classObject, cd.somGetVersionNumbers))
     (Self, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somSetMethodDescriptor(methodId: somId; descriptor: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somSetMethodDescriptor
   (SOM_Resolve(Self, cd.classObject, cd.somSetMethodDescriptor))
     (Self, methodId, descriptor);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somFindMethod(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindMethod
   (SOM_Resolve(Self, cd.classObject, cd.somFindMethod))
     (Self, methodId, m);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somFindMethodOk(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindMethodOk
   (SOM_Resolve(Self, cd.classObject, cd.somFindMethodOk))
     (Self, methodId, m);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somFindSMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindSMethod
   (SOM_Resolve(Self, cd.classObject, cd.somFindSMethod))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somFindSMethodOk(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindSMethodOk
   (SOM_Resolve(Self, cd.classObject, cd.somFindSMethodOk))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somLookupMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somLookupMethod
   (SOM_Resolve(Self, cd.classObject, cd.somLookupMethod))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somCheckVersion(majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somCheckVersion
   (SOM_Resolve(Self, cd.classObject, cd.somCheckVersion))
     (Self, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somDescendedFrom(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somDescendedFrom
   (SOM_Resolve(Self, cd.classObject, cd.somDescendedFrom))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somSupportsMethod(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somSupportsMethod
   (SOM_Resolve(Self, cd.classObject, cd.somSupportsMethod))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somDefinedMethod(method: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somDefinedMethod
   (SOM_Resolve(Self, cd.classObject, cd.somDefinedMethod))
     (Self, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somOverrideMtab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somOverrideMtab
   (SOM_Resolve(Self, cd.classObject, cd.somOverrideMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDMetaproxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somDefaultAssign(var ctrl: Pointer; fromObj: SOMDMetaproxy): SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDMetaproxy(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDMetaproxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDMetaproxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDMetaproxy); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDMetaproxy): SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDMetaproxy(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDMetaproxy): SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDMetaproxy(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDMetaproxy): SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDMetaproxy(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDMetaproxy.somPrintSelf: SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDMetaproxy(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDMetaproxy.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMDMetaproxy.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMDMetaproxy then { invoked on class name literal }
  begin
    Result := SOMClass(SOMDMetaproxyClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMDMetaproxy.NewClass: SOMClass;
begin
  if Self = SOMDMetaproxy then { invoked on class name literal }
  begin
    Result := SOMClass(SOMDMetaproxyClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMDMetaproxyNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMDMetaproxy.As_SOMClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(Self);
end;

function SOMDMetaproxy.As_SOMDMetaproxy: SOMDMetaproxy; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMDMetaproxy.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMDMetaproxy.Supports(Instance: SOMObjectBase; out Obj: SOMDMetaproxy): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMDMetaproxy(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMDObjectMgr_MajorVersion = 2;
  SOMDObjectMgr_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMDObjectMgrNewClass(
  somtmajorVersion: integer4 = SOMDObjectMgr_MajorVersion;
  somtminorVersion: integer4 = SOMDObjectMgr_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'SOMDObjectMgrNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMDObjectMgrClassDataStructure = packed record
    classObject: SOMClass;
    somdFindServer,
    somdFindServerByName,
    somdFindServersByClass,
    somdFindAnyServerByClass,
    _get_somd21somFree,
    _set_somd21somFree: somMToken;
  end;
  PSOMDObjectMgrClassDataStructure = ^SOMDObjectMgrClassDataStructure;

var
  SOMD_DLL_SOMDObjectMgrClassData: PSOMDObjectMgrClassDataStructure = nil;

function SOMDObjectMgrClassData: PSOMDObjectMgrClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMDObjectMgrClassData) then
    Result := SOMD_DLL_SOMDObjectMgrClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMDObjectMgrClassData, 'SOMDObjectMgrClassData');
    Result := SOMD_DLL_SOMDObjectMgrClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMDObjectMgrCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMDObjectMgrCClassDataStructure = ^SOMDObjectMgrCClassDataStructure;

var
  SOMD_DLL_SOMDObjectMgrCClassData: PSOMDObjectMgrCClassDataStructure = nil;

function SOMDObjectMgrCClassData: PSOMDObjectMgrCClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMDObjectMgrCClassData) then
    Result := SOMD_DLL_SOMDObjectMgrCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMDObjectMgrCClassData, 'SOMDObjectMgrCClassData');
    Result := SOMD_DLL_SOMDObjectMgrCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somd21somFree
 *)
type
  somTD_SOMDObjectMgr__get_somd21somFree = function(somSelf: SOMObjectBase{SOMDObjectMgr}; ev: PEnvironment): CORBABoolean; stdcall;

function SOMDObjectMgr._get_somd21somFree: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObjectMgr__get_somd21somFree
   (SOM_Resolve(Self, cd.classObject, cd._get_somd21somFree))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_somd21somFree
 *)
type
  somTD_SOMDObjectMgr__set_somd21somFree = procedure(somSelf: SOMObjectBase{SOMDObjectMgr}; ev: PEnvironment; somd21somFree: CORBABoolean); stdcall;

procedure SOMDObjectMgr._set_somd21somFree(somd21somFree: CORBABoolean); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMDObjectMgr__set_somd21somFree
   (SOM_Resolve(Self, cd.classObject, cd._set_somd21somFree))
     (Self, @LocalEnv, somd21somFree);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function SOMDObjectMgr.Create: SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDObjectMgr(SOMClass(NewClass).somNew);
end;

class function SOMDObjectMgr.InitInstance(Instance: Pointer): SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDObjectMgr(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMDObjectMgr.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMDObjectMgr.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMDObjectMgr.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMDObjectMgr.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMDObjectMgr.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMDObjectMgr.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMDObjectMgr.NewInstance: SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDObjectMgr(SOMClass(NewClass).somNewNoInit);
end;

function SOMDObjectMgr.Clone: SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDObjectMgr(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somdFindServer
 *)
type
  somTD_SOMDObjectMgr_somdFindServer = function(somSelf: SOMObjectBase{SOMDObjectMgr}; ev: PEnvironment; serverid: CORBAString): SOMDServer; stdcall;

function SOMDObjectMgr.somdFindServer(serverid: CORBAString): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObjectMgr_somdFindServer
   (SOM_Resolve(Self, cd.classObject, cd.somdFindServer))
     (Self, @LocalEnv, serverid);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdFindServerByName
 *)
type
  somTD_SOMDObjectMgr_somdFindServerByName = function(somSelf: SOMObjectBase{SOMDObjectMgr}; ev: PEnvironment; servername: CORBAString): SOMDServer; stdcall;

function SOMDObjectMgr.somdFindServerByName(servername: CORBAString): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObjectMgr_somdFindServerByName
   (SOM_Resolve(Self, cd.classObject, cd.somdFindServerByName))
     (Self, @LocalEnv, servername);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdFindServersByClass
 *)
type
  somTD_SOMDObjectMgr_somdFindServersByClass = function(somSelf: SOMObjectBase{SOMDObjectMgr}; ev: PEnvironment; objclass: CORBAString): _IDL_Sequence_SOMDServer; stdcall;

function SOMDObjectMgr.somdFindServersByClass(objclass: CORBAString): _IDL_Sequence_SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObjectMgr_somdFindServersByClass
   (SOM_Resolve(Self, cd.classObject, cd.somdFindServersByClass))
     (Self, @LocalEnv, objclass);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdFindAnyServerByClass
 *)
type
  somTD_SOMDObjectMgr_somdFindAnyServerByClass = function(somSelf: SOMObjectBase{SOMDObjectMgr}; ev: PEnvironment; objclass: CORBAString): SOMDServer; stdcall;

function SOMDObjectMgr.somdFindAnyServerByClass(objclass: CORBAString): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDObjectMgr_somdFindAnyServerByClass
   (SOM_Resolve(Self, cd.classObject, cd.somdFindAnyServerByClass))
     (Self, @LocalEnv, objclass);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDObjectMgr.somdNewObject(objclass: CORBAString; hints: CORBAString): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ObjectMgr_somdNewObject
   (SOM_Resolve(Self, cd.classObject, cd.somdNewObject))
     (Self, @LocalEnv, objclass, hints);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDObjectMgr.somdGetIdFromObject(obj: SOMObject): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ObjectMgr_somdGetIdFromObject
   (SOM_Resolve(Self, cd.classObject, cd.somdGetIdFromObject))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMDObjectMgr.somdGetObjectFromId(id: CORBAString): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_ObjectMgr_somdGetObjectFromId
   (SOM_Resolve(Self, cd.classObject, cd.somdGetObjectFromId))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMDObjectMgr.somdReleaseObject(obj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ObjectMgr_somdReleaseObject
   (SOM_Resolve(Self, cd.classObject, cd.somdReleaseObject))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMDObjectMgr.somdDestroyObject(obj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PObjectMgrClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ObjectMgrClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_ObjectMgr_somdDestroyObject
   (SOM_Resolve(Self, cd.classObject, cd.somdDestroyObject))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMDObjectMgr.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObjectMgr.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObjectMgr.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somDefaultAssign(var ctrl: Pointer; fromObj: SOMDObjectMgr): SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDObjectMgr(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObjectMgr.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObjectMgr.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObjectMgr.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDObjectMgr); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDObjectMgr): SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDObjectMgr(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDObjectMgr): SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDObjectMgr(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDObjectMgr): SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDObjectMgr(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObjectMgr.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObjectMgr.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObjectMgr.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDObjectMgr.somPrintSelf: SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDObjectMgr(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObjectMgr.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDObjectMgr.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMDObjectMgr.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMDObjectMgr then { invoked on class name literal }
  begin
    Result := SOMClass(SOMDObjectMgrClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMDObjectMgr.NewClass: SOMClass;
begin
  if Self = SOMDObjectMgr then { invoked on class name literal }
  begin
    Result := SOMClass(SOMDObjectMgrClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMDObjectMgrNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMDObjectMgr.As_ObjectMgr: ObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := ObjectMgr(Self);
end;

function SOMDObjectMgr.As_SOMDObjectMgr: SOMDObjectMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMDObjectMgr.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMDObjectMgr.Supports(Instance: SOMObjectBase; out Obj: SOMDObjectMgr): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMDObjectMgr(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMDServer_MajorVersion = 2;
  SOMDServer_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMDServerNewClass(
  somtmajorVersion: integer4 = SOMDServer_MajorVersion;
  somtminorVersion: integer4 = SOMDServer_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'SOMDServerNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMDServerClassDataStructure = packed record
    classObject: SOMClass;
    somdSOMObjFromRef,
    somdRefFromSOMObj,
    somdCreateObj,
    somdDeleteObj,
    somdGetClassObj,
    somdDispatchMethod,
    somdObjReferencesCached: somMToken;
  end;
  PSOMDServerClassDataStructure = ^SOMDServerClassDataStructure;

var
  SOMD_DLL_SOMDServerClassData: PSOMDServerClassDataStructure = nil;

function SOMDServerClassData: PSOMDServerClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMDServerClassData) then
    Result := SOMD_DLL_SOMDServerClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMDServerClassData, 'SOMDServerClassData');
    Result := SOMD_DLL_SOMDServerClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMDServerCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMDServerCClassDataStructure = ^SOMDServerCClassDataStructure;

var
  SOMD_DLL_SOMDServerCClassData: PSOMDServerCClassDataStructure = nil;

function SOMDServerCClassData: PSOMDServerCClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMDServerCClassData) then
    Result := SOMD_DLL_SOMDServerCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMDServerCClassData, 'SOMDServerCClassData');
    Result := SOMD_DLL_SOMDServerCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMDServer.Create: SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDServer(SOMClass(NewClass).somNew);
end;

class function SOMDServer.InitInstance(Instance: Pointer): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDServer(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMDServer.ClassType: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMObject(Self).somGetClass);
end;

class function SOMDServer.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMDServer.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMDServer.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMDServer.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMDServer.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMDServer.NewInstance: SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDServer(SOMClass(NewClass).somNewNoInit);
end;

function SOMDServer.Clone: SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMDServer(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somdRefFromSOMObj
 *)
type
  somTD_SOMDServer_somdRefFromSOMObj = function(somSelf: SOMObjectBase{SOMDServer}; ev: PEnvironment; somobj: SOMObject): SOMDObject; stdcall;

function SOMDServer.somdRefFromSOMObj(somobj: SOMObject): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServer_somdRefFromSOMObj
   (SOM_Resolve(Self, cd.classObject, cd.somdRefFromSOMObj))
     (Self, @LocalEnv, somobj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdSOMObjFromRef
 *)
type
  somTD_SOMDServer_somdSOMObjFromRef = function(somSelf: SOMObjectBase{SOMDServer}; ev: PEnvironment; objref: SOMDObject): SOMObject; stdcall;

function SOMDServer.somdSOMObjFromRef(objref: SOMDObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServer_somdSOMObjFromRef
   (SOM_Resolve(Self, cd.classObject, cd.somdSOMObjFromRef))
     (Self, @LocalEnv, objref);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdDispatchMethod
 *)
type
  somTD_SOMDServer_somdDispatchMethod = procedure(somSelf: SOMObjectBase{SOMDServer}; ev: PEnvironment; somobj: SOMObject; out retValue: Pointer; methodId: somId; ap: va_list); stdcall;

procedure SOMDServer.somdDispatchMethod(somobj: SOMObject; out retValue: Pointer; methodId: somId; ap: va_list); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMDServer_somdDispatchMethod
   (SOM_Resolve(Self, cd.classObject, cd.somdDispatchMethod))
     (Self, @LocalEnv, somobj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdCreateObj
 *)
type
  somTD_SOMDServer_somdCreateObj = function(somSelf: SOMObjectBase{SOMDServer}; ev: PEnvironment; objclass: CORBAString; hints: CORBAString): SOMObject; stdcall;

function SOMDServer.somdCreateObj(objclass: CORBAString; hints: CORBAString): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServer_somdCreateObj
   (SOM_Resolve(Self, cd.classObject, cd.somdCreateObj))
     (Self, @LocalEnv, objclass, hints);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdDeleteObj
 *)
type
  somTD_SOMDServer_somdDeleteObj = procedure(somSelf: SOMObjectBase{SOMDServer}; ev: PEnvironment; somobj: SOMObject); stdcall;

procedure SOMDServer.somdDeleteObj(somobj: SOMObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMDServer_somdDeleteObj
   (SOM_Resolve(Self, cd.classObject, cd.somdDeleteObj))
     (Self, @LocalEnv, somobj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdGetClassObj
 *)
type
  somTD_SOMDServer_somdGetClassObj = function(somSelf: SOMObjectBase{SOMDServer}; ev: PEnvironment; objclass: CORBAString): SOMClass; stdcall;

function SOMDServer.somdGetClassObj(objclass: CORBAString): SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServer_somdGetClassObj
   (SOM_Resolve(Self, cd.classObject, cd.somdGetClassObj))
     (Self, @LocalEnv, objclass);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somdObjReferencesCached
 *)
type
  somTD_SOMDServer_somdObjReferencesCached = function(somSelf: SOMObjectBase{SOMDServer}; ev: PEnvironment): CORBABoolean; stdcall;

function SOMDServer.somdObjReferencesCached: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMDServerClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMDServerClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMDServer_somdObjReferencesCached
   (SOM_Resolve(Self, cd.classObject, cd.somdObjReferencesCached))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMDServer.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServer.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServer.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMDServer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somDefaultAssign(var ctrl: Pointer; fromObj: SOMDServer): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDServer(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServer.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMDServer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServer.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMDServer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServer.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMDServer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMDServer): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDServer(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMDServer): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDServer(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMDServer): SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDServer(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServer.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServer.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServer.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMDServer.somPrintSelf: SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMDServer(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServer.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMDServer.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMDServer.ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMDServer then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(SOMDServerClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

class function SOMDServer.NewClass: SOMMSingleInstance;
begin
  if Self = SOMDServer then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(SOMDServerClassData.classObject);
    if not Assigned(Result) then Result := SOMMSingleInstance(SOMDServerNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

function SOMDServer.As_SOMDServer: SOMDServer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMDServer.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMDServer.Supports(Instance: SOMObjectBase; out Obj: SOMDServer): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMDServer(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMUTId_MajorVersion = 2;
  SOMUTId_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMUTIdNewClass(
  somtmajorVersion: integer4 = SOMUTId_MajorVersion;
  somtminorVersion: integer4 = SOMUTId_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMUTIdNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMUTIdClassDataStructure = packed record
    classObject: SOMClass;
    somutSetIdId,
    somutEqualsId,
    somutCompareId,
    somutHashId: somMToken;
  end;
  PSOMUTIdClassDataStructure = ^SOMUTIdClassDataStructure;

var
  SOME_DLL_SOMUTIdClassData: PSOMUTIdClassDataStructure = nil;

function SOMUTIdClassData: PSOMUTIdClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMUTIdClassData) then
    Result := SOME_DLL_SOMUTIdClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMUTIdClassData, 'SOMUTIdClassData');
    Result := SOME_DLL_SOMUTIdClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMUTIdCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMUTIdCClassDataStructure = ^SOMUTIdCClassDataStructure;

var
  SOME_DLL_SOMUTIdCClassData: PSOMUTIdCClassDataStructure = nil;

function SOMUTIdCClassData: PSOMUTIdCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMUTIdCClassData) then
    Result := SOME_DLL_SOMUTIdCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMUTIdCClassData, 'SOMUTIdCClassData');
    Result := SOME_DLL_SOMUTIdCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMUTId.Create: SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMUTId(SOMClass(NewClass).somNew);
end;

class function SOMUTId.InitInstance(Instance: Pointer): SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMUTId(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMUTId.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMUTId.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMUTId.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMUTId.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMUTId.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMUTId.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMUTId.NewInstance: SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMUTId(SOMClass(NewClass).somNewNoInit);
end;

function SOMUTId.Clone: SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMUTId(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somutSetIdId
 *)
type
  somTD_SOMUTId_somutSetIdId = procedure(somSelf: SOMObjectBase{SOMUTId}; ev: PEnvironment; otherId: SOMUTId); stdcall;

procedure SOMUTId.somutSetIdId(otherId: SOMUTId); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMUTIdClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMUTIdClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMUTId_somutSetIdId
   (SOM_Resolve(Self, cd.classObject, cd.somutSetIdId))
     (Self, @LocalEnv, otherId);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somutEqualsId
 *)
type
  somTD_SOMUTId_somutEqualsId = function(somSelf: SOMObjectBase{SOMUTId}; ev: PEnvironment; otherId: SOMUTId): CORBABoolean; stdcall;

function SOMUTId.somutEqualsId(otherId: SOMUTId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMUTIdClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMUTIdClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMUTId_somutEqualsId
   (SOM_Resolve(Self, cd.classObject, cd.somutEqualsId))
     (Self, @LocalEnv, otherId);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somutCompareId
 *)
type
  somTD_SOMUTId_somutCompareId = function(somSelf: SOMObjectBase{SOMUTId}; ev: PEnvironment; otherId: SOMUTId): SmallInt; stdcall;

function SOMUTId.somutCompareId(otherId: SOMUTId): SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMUTIdClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMUTIdClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMUTId_somutCompareId
   (SOM_Resolve(Self, cd.classObject, cd.somutCompareId))
     (Self, @LocalEnv, otherId);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somutHashId
 *)
type
  somTD_SOMUTId_somutHashId = function(somSelf: SOMObjectBase{SOMUTId}; ev: PEnvironment): LongWord; stdcall;

function SOMUTId.somutHashId: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMUTIdClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMUTIdClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMUTId_somutHashId
   (SOM_Resolve(Self, cd.classObject, cd.somutHashId))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMUTId.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMUTId.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMUTId.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMUTId); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somDefaultAssign(var ctrl: Pointer; fromObj: SOMUTId): SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMUTId(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMUTId.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMUTId); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMUTId.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMUTId); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMUTId.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMUTId); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMUTId): SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMUTId(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMUTId): SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMUTId(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMUTId): SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMUTId(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMUTId.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMUTId.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMUTId.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMUTId.somPrintSelf: SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMUTId(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMUTId.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMUTId.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMUTId.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMUTId then { invoked on class name literal }
  begin
    Result := SOMClass(SOMUTIdClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMUTId.NewClass: SOMClass;
begin
  if Self = SOMUTId then { invoked on class name literal }
  begin
    Result := SOMClass(SOMUTIdClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMUTIdNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMUTId.As_SOMUTId: SOMUTId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMUTId.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMUTId.Supports(Instance: SOMObjectBase; out Obj: SOMUTId): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMUTId(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMOA_MajorVersion = 2;
  SOMOA_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMOANewClass(
  somtmajorVersion: integer4 = SOMOA_MajorVersion;
  somtminorVersion: integer4 = SOMOA_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'SOMOANewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMOAClassDataStructure = packed record
    classObject: SOMClass;
    execute_next_request,
    execute_request_loop,
    create_constant,
    change_id,
    create_SOM_ref,
    get_SOM_object,
    activate_impl_failed,
    interrupt_server: somMToken;
  end;
  PSOMOAClassDataStructure = ^SOMOAClassDataStructure;

var
  SOMD_DLL_SOMOAClassData: PSOMOAClassDataStructure = nil;

function SOMOAClassData: PSOMOAClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMOAClassData) then
    Result := SOMD_DLL_SOMOAClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMOAClassData, 'SOMOAClassData');
    Result := SOMD_DLL_SOMOAClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMOACClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMOACClassDataStructure = ^SOMOACClassDataStructure;

var
  SOMD_DLL_SOMOACClassData: PSOMOACClassDataStructure = nil;

function SOMOACClassData: PSOMOACClassDataStructure;
begin
  if Assigned(SOMD_DLL_SOMOACClassData) then
    Result := SOMD_DLL_SOMOACClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_SOMOACClassData, 'SOMOACClassData');
    Result := SOMD_DLL_SOMOACClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMOA.Create: SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMOA(SOMClass(NewClass).somNew);
end;

class function SOMOA.InitInstance(Instance: Pointer): SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMOA(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMOA.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMOA.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMOA.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMOA.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMOA.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMOA.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMOA.NewInstance: SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMOA(SOMClass(NewClass).somNewNoInit);
end;

function SOMOA.Clone: SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMOA(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: execute_next_request
 *)
type
  somTD_SOMOA_execute_next_request = function(somSelf: SOMObjectBase{SOMOA}; ev: PEnvironment; waitFlag: LongWord): LongWord; stdcall;

function SOMOA.execute_next_request(waitFlag: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMOA_execute_next_request
   (SOM_Resolve(Self, cd.classObject, cd.execute_next_request))
     (Self, @LocalEnv, waitFlag);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: execute_request_loop
 *)
type
  somTD_SOMOA_execute_request_loop = function(somSelf: SOMObjectBase{SOMOA}; ev: PEnvironment; waitFlag: LongWord): LongWord; stdcall;

function SOMOA.execute_request_loop(waitFlag: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMOA_execute_request_loop
   (SOM_Resolve(Self, cd.classObject, cd.execute_request_loop))
     (Self, @LocalEnv, waitFlag);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: change_id
 *)
type
  somTD_SOMOA_change_id = procedure(somSelf: SOMObjectBase{SOMOA}; ev: PEnvironment; objref: SOMDObject; const id: _IDL_Sequence_Byte); stdcall;

procedure SOMOA.change_id(objref: SOMDObject; const id: _IDL_Sequence_Byte); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMOA_change_id
   (SOM_Resolve(Self, cd.classObject, cd.change_id))
     (Self, @LocalEnv, objref, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: create_constant
 *)
type
  somTD_SOMOA_create_constant = function(somSelf: SOMObjectBase{SOMOA}; ev: PEnvironment; const id: _IDL_Sequence_Byte; intf: InterfaceDef; impl: ImplementationDef): SOMDObject; stdcall;

function SOMOA.create_constant(const id: _IDL_Sequence_Byte; intf: InterfaceDef; impl: ImplementationDef): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMOA_create_constant
   (SOM_Resolve(Self, cd.classObject, cd.create_constant))
     (Self, @LocalEnv, id, intf, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: create_SOM_ref
 *)
type
  somTD_SOMOA_create_SOM_ref = function(somSelf: SOMObjectBase{SOMOA}; ev: PEnvironment; somobj: SOMObject; impl: ImplementationDef): SOMDObject; stdcall;

function SOMOA.create_SOM_ref(somobj: SOMObject; impl: ImplementationDef): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMOA_create_SOM_ref
   (SOM_Resolve(Self, cd.classObject, cd.create_SOM_ref))
     (Self, @LocalEnv, somobj, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: get_SOM_object
 *)
type
  somTD_SOMOA_get_SOM_object = function(somSelf: SOMObjectBase{SOMOA}; ev: PEnvironment; somref: SOMDObject): SOMObject; stdcall;

function SOMOA.get_SOM_object(somref: SOMDObject): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMOA_get_SOM_object
   (SOM_Resolve(Self, cd.classObject, cd.get_SOM_object))
     (Self, @LocalEnv, somref);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: activate_impl_failed
 *)
type
  somTD_SOMOA_activate_impl_failed = procedure(somSelf: SOMObjectBase{SOMOA}; ev: PEnvironment; impl: ImplementationDef; rc: LongWord); stdcall;

procedure SOMOA.activate_impl_failed(impl: ImplementationDef; rc: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMOA_activate_impl_failed
   (SOM_Resolve(Self, cd.classObject, cd.activate_impl_failed))
     (Self, @LocalEnv, impl, rc);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: interrupt_server
 *)
type
  somTD_SOMOA_interrupt_server = procedure(somSelf: SOMObjectBase{SOMOA}; ev: PEnvironment); stdcall;

procedure SOMOA.interrupt_server; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMOA_interrupt_server
   (SOM_Resolve(Self, cd.classObject, cd.interrupt_server))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMOA.SOM_create(const id: _IDL_Sequence_Byte; intf: InterfaceDef; impl: ImplementationDef): SOMDObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_BOA_SOM_create
   (SOM_Resolve(Self, cd.classObject, cd.SOM_create))
     (Self, @LocalEnv, id, intf, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMOA.dispose(obj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_dispose
   (SOM_Resolve(Self, cd.classObject, cd.dispose))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMOA.get_id(obj: SOMDObject): _IDL_Sequence_Byte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_BOA_get_id
   (SOM_Resolve(Self, cd.classObject, cd.get_id))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMOA.get_principal(obj: SOMDObject; const req_ev: Environment): Principal; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_BOA_get_principal
   (SOM_Resolve(Self, cd.classObject, cd.get_principal))
     (Self, @LocalEnv, obj, req_ev);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMOA.set_exception(major: exception_type; userid: CORBAString; param: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_set_exception
   (SOM_Resolve(Self, cd.classObject, cd.set_exception))
     (Self, @LocalEnv, major, userid, param);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMOA.impl_is_ready(impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_impl_is_ready
   (SOM_Resolve(Self, cd.classObject, cd.impl_is_ready))
     (Self, @LocalEnv, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMOA.deactivate_impl(impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_deactivate_impl
   (SOM_Resolve(Self, cd.classObject, cd.deactivate_impl))
     (Self, @LocalEnv, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMOA.change_implementation(obj: SOMDObject; impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_change_implementation
   (SOM_Resolve(Self, cd.classObject, cd.change_implementation))
     (Self, @LocalEnv, obj, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMOA.obj_is_ready(obj: SOMDObject; impl: ImplementationDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_obj_is_ready
   (SOM_Resolve(Self, cd.classObject, cd.obj_is_ready))
     (Self, @LocalEnv, obj, impl);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMOA.deactivate_obj(obj: SOMDObject); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PBOAClassDataStructure;
  LocalEnv: Environment;
begin
  cd := BOAClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_BOA_deactivate_obj
   (SOM_Resolve(Self, cd.classObject, cd.deactivate_obj))
     (Self, @LocalEnv, obj);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMOA.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMOA.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMOA.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somDefaultAssign(var ctrl: Pointer; fromObj: SOMOA): SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMOA(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMOA.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMOA.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMOA.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMOA); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMOA): SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMOA(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMOA): SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMOA(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMOA): SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMOA(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMOA.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMOA.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMOA.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMOA.somPrintSelf: SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMOA(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMOA.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMOA.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMOA.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMOA then { invoked on class name literal }
  begin
    Result := SOMClass(SOMOAClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMOA.NewClass: SOMClass;
begin
  if Self = SOMOA then { invoked on class name literal }
  begin
    Result := SOMClass(SOMOAClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMOANewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMOA.As_BOA: BOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := BOA(Self);
end;

function SOMOA.As_SOMOA: SOMOA; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMOA.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMOA.Supports(Instance: SOMObjectBase; out Obj: SOMOA): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMOA(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMS_DLL_Name = 'soms.dll';

var
  SOMS_DLL: System.HMODULE = 0;

procedure SOMS_DLL_Load_Variable(var V_Pointer; const Var_Name: AnsiString);
begin
  if SOMS_DLL = 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOMS_DLL = 0 then
      SOMS_DLL := Windows.LoadLibraryW(SOMS_DLL_Name);
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOMS_DLL <> 0 then
    Pointer(V_Pointer) := Windows.GetProcAddress(SOMS_DLL, PAnsiChar(Var_Name));
end;

const
  Sockets_MajorVersion = 2;
  Sockets_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SocketsNewClass(
  somtmajorVersion: integer4 = Sockets_MajorVersion;
  somtminorVersion: integer4 = Sockets_MinorVersion):
  SOMClass; stdcall; external SOMS_DLL_Name name 'SocketsNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SocketsClassDataStructure = packed record
    classObject: SOMClass;
    somsAccept,
    somsBind,
    somsConnect,
    somsGethostbyaddr,
    somsGethostbyname,
    somsGethostent,
    somsGethostid,
    somsGethostname,
    somsGetpeername,
    somsGetsockname,
    somsGetsockopt,
    somsHtonl,
    somsHtons,
    somsIoctl,
    somsInet_addr,
    somsInet_lnaof,
    somsInet_makeaddr,
    somsInet_netof,
    somsInet_network,
    somsInet_ntoa,
    somsListen,
    somsNtohl,
    somsNtohs,
    somsReadv,
    somsRecv,
    somsRecvfrom,
    somsRecvmsg,
    somsSelect,
    somsSend,
    somsSendmsg,
    somsSendto,
    somsSetsockopt,
    somsShutdown,
    somsSocket,
    somsSoclose,
    somsWritev,
    _set_serrno,
    _get_serrno,
    somsGetservbyname: somMToken;
  end;
  PSocketsClassDataStructure = ^SocketsClassDataStructure;

var
  SOMS_DLL_SocketsClassData: PSocketsClassDataStructure = nil;

function SocketsClassData: PSocketsClassDataStructure;
begin
  if Assigned(SOMS_DLL_SocketsClassData) then
    Result := SOMS_DLL_SocketsClassData
  else
  begin
    SOMS_DLL_Load_Variable(SOMS_DLL_SocketsClassData, 'SocketsClassData');
    Result := SOMS_DLL_SocketsClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SocketsCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSocketsCClassDataStructure = ^SocketsCClassDataStructure;

var
  SOMS_DLL_SocketsCClassData: PSocketsCClassDataStructure = nil;

function SocketsCClassData: PSocketsCClassDataStructure;
begin
  if Assigned(SOMS_DLL_SocketsCClassData) then
    Result := SOMS_DLL_SocketsCClassData
  else
  begin
    SOMS_DLL_Load_Variable(SOMS_DLL_SocketsCClassData, 'SocketsCClassData');
    Result := SOMS_DLL_SocketsCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_serrno
 *)
type
  somTD_Sockets__get_serrno = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment): LongInt; stdcall;

function Sockets._get_serrno: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets__get_serrno
   (SOM_Resolve(Self, cd.classObject, cd._get_serrno))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_serrno
 *)
type
  somTD_Sockets__set_serrno = procedure(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; serrno: LongInt); stdcall;

procedure Sockets._set_serrno(serrno: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Sockets__set_serrno
   (SOM_Resolve(Self, cd.classObject, cd._set_serrno))
     (Self, @LocalEnv, serrno);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function Sockets.Create: Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Sockets(SOMClass(NewClass).somNew);
end;

class function Sockets.InitInstance(Instance: Pointer): Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Sockets(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function Sockets.ClassType: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMObject(Self).somGetClass);
end;

class function Sockets.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function Sockets.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function Sockets.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function Sockets.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function Sockets.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function Sockets.NewInstance: Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Sockets(SOMClass(NewClass).somNewNoInit);
end;

function Sockets.Clone: Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Sockets(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somsAccept
 *)
type
  somTD_Sockets_somsAccept = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; stdcall;

function Sockets.somsAccept(s: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsAccept
   (SOM_Resolve(Self, cd.classObject, cd.somsAccept))
     (Self, @LocalEnv, s, name, namelen);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsBind
 *)
type
  somTD_Sockets_somsBind = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; var name{: opaque Sockets_sockaddr}; namelen: LongInt): LongInt; stdcall;

function Sockets.somsBind(s: LongInt; var name{: opaque Sockets_sockaddr}; namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsBind
   (SOM_Resolve(Self, cd.classObject, cd.somsBind))
     (Self, @LocalEnv, s, name, namelen);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsConnect
 *)
type
  somTD_Sockets_somsConnect = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; var name{: opaque Sockets_sockaddr}; namelen: LongInt): LongInt; stdcall;

function Sockets.somsConnect(s: LongInt; var name{: opaque Sockets_sockaddr}; namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsConnect
   (SOM_Resolve(Self, cd.classObject, cd.somsConnect))
     (Self, @LocalEnv, s, name, namelen);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsGethostbyaddr
 *)
type
  somTD_Sockets_somsGethostbyaddr = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; addr: PShortInt; addrlen: LongInt; domain: LongInt): PSockets_hostent; stdcall;

function Sockets.somsGethostbyaddr(addr: PShortInt; addrlen: LongInt; domain: LongInt): PSockets_hostent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsGethostbyaddr
   (SOM_Resolve(Self, cd.classObject, cd.somsGethostbyaddr))
     (Self, @LocalEnv, addr, addrlen, domain);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsGethostbyname
 *)
type
  somTD_Sockets_somsGethostbyname = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; name: CORBAString): PSockets_hostent; stdcall;

function Sockets.somsGethostbyname(name: CORBAString): PSockets_hostent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsGethostbyname
   (SOM_Resolve(Self, cd.classObject, cd.somsGethostbyname))
     (Self, @LocalEnv, name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsGethostent
 *)
type
  somTD_Sockets_somsGethostent = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment): PSockets_hostent; stdcall;

function Sockets.somsGethostent: PSockets_hostent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsGethostent
   (SOM_Resolve(Self, cd.classObject, cd.somsGethostent))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsGethostid
 *)
type
  somTD_Sockets_somsGethostid = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment): LongWord; stdcall;

function Sockets.somsGethostid: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsGethostid
   (SOM_Resolve(Self, cd.classObject, cd.somsGethostid))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsGethostname
 *)
type
  somTD_Sockets_somsGethostname = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; name: CORBAString; namelength: LongInt): LongInt; stdcall;

function Sockets.somsGethostname(name: CORBAString; namelength: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsGethostname
   (SOM_Resolve(Self, cd.classObject, cd.somsGethostname))
     (Self, @LocalEnv, name, namelength);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsGetpeername
 *)
type
  somTD_Sockets_somsGetpeername = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; stdcall;

function Sockets.somsGetpeername(s: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsGetpeername
   (SOM_Resolve(Self, cd.classObject, cd.somsGetpeername))
     (Self, @LocalEnv, s, name, namelen);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsGetservbyname
 *)
type
  somTD_Sockets_somsGetservbyname = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; name: CORBAString; protocol: CORBAString): PSockets_servent; stdcall;

function Sockets.somsGetservbyname(name: CORBAString; protocol: CORBAString): PSockets_servent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsGetservbyname
   (SOM_Resolve(Self, cd.classObject, cd.somsGetservbyname))
     (Self, @LocalEnv, name, protocol);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsGetsockname
 *)
type
  somTD_Sockets_somsGetsockname = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; stdcall;

function Sockets.somsGetsockname(s: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsGetsockname
   (SOM_Resolve(Self, cd.classObject, cd.somsGetsockname))
     (Self, @LocalEnv, s, name, namelen);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsGetsockopt
 *)
type
  somTD_Sockets_somsGetsockopt = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; level: LongInt; optname: LongInt; optval: PShortInt; out option: LongInt): LongInt; stdcall;

function Sockets.somsGetsockopt(s: LongInt; level: LongInt; optname: LongInt; optval: PShortInt; out option: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsGetsockopt
   (SOM_Resolve(Self, cd.classObject, cd.somsGetsockopt))
     (Self, @LocalEnv, s, level, optname, optval, option);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsHtonl
 *)
type
  somTD_Sockets_somsHtonl = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; a: LongWord): LongWord; stdcall;

function Sockets.somsHtonl(a: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsHtonl
   (SOM_Resolve(Self, cd.classObject, cd.somsHtonl))
     (Self, @LocalEnv, a);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsHtons
 *)
type
  somTD_Sockets_somsHtons = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; a: Word): Word; stdcall;

function Sockets.somsHtons(a: Word): Word; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsHtons
   (SOM_Resolve(Self, cd.classObject, cd.somsHtons))
     (Self, @LocalEnv, a);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsIoctl
 *)
type
  somTD_Sockets_somsIoctl = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; cmd: LongInt; data: PShortInt; length: LongInt): LongInt; stdcall;

function Sockets.somsIoctl(s: LongInt; cmd: LongInt; data: PShortInt; length: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsIoctl
   (SOM_Resolve(Self, cd.classObject, cd.somsIoctl))
     (Self, @LocalEnv, s, cmd, data, length);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsInet_addr
 *)
type
  somTD_Sockets_somsInet_addr = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; cp: CORBAString): LongWord; stdcall;

function Sockets.somsInet_addr(cp: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsInet_addr
   (SOM_Resolve(Self, cd.classObject, cd.somsInet_addr))
     (Self, @LocalEnv, cp);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsInet_lnaof
 *)
type
  somTD_Sockets_somsInet_lnaof = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; addr: Sockets_in_addr): LongWord; stdcall;

function Sockets.somsInet_lnaof(addr: Sockets_in_addr): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsInet_lnaof
   (SOM_Resolve(Self, cd.classObject, cd.somsInet_lnaof))
     (Self, @LocalEnv, addr);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsInet_makeaddr
 *)
type
  somTD_Sockets_somsInet_makeaddr = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; net: LongWord; lna: LongWord): Sockets_in_addr; stdcall;

function Sockets.somsInet_makeaddr(net: LongWord; lna: LongWord): Sockets_in_addr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsInet_makeaddr
   (SOM_Resolve(Self, cd.classObject, cd.somsInet_makeaddr))
     (Self, @LocalEnv, net, lna);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsInet_netof
 *)
type
  somTD_Sockets_somsInet_netof = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; addr: Sockets_in_addr): LongWord; stdcall;

function Sockets.somsInet_netof(addr: Sockets_in_addr): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsInet_netof
   (SOM_Resolve(Self, cd.classObject, cd.somsInet_netof))
     (Self, @LocalEnv, addr);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsInet_network
 *)
type
  somTD_Sockets_somsInet_network = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; cp: CORBAString): LongWord; stdcall;

function Sockets.somsInet_network(cp: CORBAString): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsInet_network
   (SOM_Resolve(Self, cd.classObject, cd.somsInet_network))
     (Self, @LocalEnv, cp);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsInet_ntoa
 *)
type
  somTD_Sockets_somsInet_ntoa = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; addr: Sockets_in_addr): CORBAString; stdcall;

function Sockets.somsInet_ntoa(addr: Sockets_in_addr): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsInet_ntoa
   (SOM_Resolve(Self, cd.classObject, cd.somsInet_ntoa))
     (Self, @LocalEnv, addr);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsListen
 *)
type
  somTD_Sockets_somsListen = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; backlog: LongInt): LongInt; stdcall;

function Sockets.somsListen(s: LongInt; backlog: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsListen
   (SOM_Resolve(Self, cd.classObject, cd.somsListen))
     (Self, @LocalEnv, s, backlog);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsNtohl
 *)
type
  somTD_Sockets_somsNtohl = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; a: LongWord): LongWord; stdcall;

function Sockets.somsNtohl(a: LongWord): LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsNtohl
   (SOM_Resolve(Self, cd.classObject, cd.somsNtohl))
     (Self, @LocalEnv, a);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsNtohs
 *)
type
  somTD_Sockets_somsNtohs = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; a: Word): Word; stdcall;

function Sockets.somsNtohs(a: Word): Word; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsNtohs
   (SOM_Resolve(Self, cd.classObject, cd.somsNtohs))
     (Self, @LocalEnv, a);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsReadv
 *)
type
  somTD_Sockets_somsReadv = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; var iov{: opaque Sockets_iovec}; iovcnt: LongInt): LongInt; stdcall;

function Sockets.somsReadv(s: LongInt; var iov{: opaque Sockets_iovec}; iovcnt: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsReadv
   (SOM_Resolve(Self, cd.classObject, cd.somsReadv))
     (Self, @LocalEnv, s, iov, iovcnt);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsRecv
 *)
type
  somTD_Sockets_somsRecv = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; buf: PShortInt; len: LongInt; flags: LongInt): LongInt; stdcall;

function Sockets.somsRecv(s: LongInt; buf: PShortInt; len: LongInt; flags: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsRecv
   (SOM_Resolve(Self, cd.classObject, cd.somsRecv))
     (Self, @LocalEnv, s, buf, len, flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsRecvfrom
 *)
type
  somTD_Sockets_somsRecvfrom = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; buf: PShortInt; len: LongInt; flags: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; stdcall;

function Sockets.somsRecvfrom(s: LongInt; buf: PShortInt; len: LongInt; flags: LongInt; out name{: opaque Sockets_sockaddr}; out namelen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsRecvfrom
   (SOM_Resolve(Self, cd.classObject, cd.somsRecvfrom))
     (Self, @LocalEnv, s, buf, len, flags, name, namelen);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsRecvmsg
 *)
type
  somTD_Sockets_somsRecvmsg = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; var msg{: opaque Sockets_msghdr}; flags: LongInt): LongInt; stdcall;

function Sockets.somsRecvmsg(s: LongInt; var msg{: opaque Sockets_msghdr}; flags: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsRecvmsg
   (SOM_Resolve(Self, cd.classObject, cd.somsRecvmsg))
     (Self, @LocalEnv, s, msg, flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsSelect
 *)
type
  somTD_Sockets_somsSelect = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; nfds: LongInt; var readfds{: opaque Sockets_fd_set}; var writefds{: opaque Sockets_fd_set}; var exceptfds{: opaque Sockets_fd_set}; var timeout{: opaque Sockets_timeval}): LongInt; stdcall;

function Sockets.somsSelect(nfds: LongInt; var readfds{: opaque Sockets_fd_set}; var writefds{: opaque Sockets_fd_set}; var exceptfds{: opaque Sockets_fd_set}; var timeout{: opaque Sockets_timeval}): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsSelect
   (SOM_Resolve(Self, cd.classObject, cd.somsSelect))
     (Self, @LocalEnv, nfds, readfds, writefds, exceptfds, timeout);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsSend
 *)
type
  somTD_Sockets_somsSend = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; msg: PShortInt; len: LongInt; flags: LongInt): LongInt; stdcall;

function Sockets.somsSend(s: LongInt; msg: PShortInt; len: LongInt; flags: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsSend
   (SOM_Resolve(Self, cd.classObject, cd.somsSend))
     (Self, @LocalEnv, s, msg, len, flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsSendmsg
 *)
type
  somTD_Sockets_somsSendmsg = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; var msg{: opaque Sockets_msghdr}; flags: LongInt): LongInt; stdcall;

function Sockets.somsSendmsg(s: LongInt; var msg{: opaque Sockets_msghdr}; flags: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsSendmsg
   (SOM_Resolve(Self, cd.classObject, cd.somsSendmsg))
     (Self, @LocalEnv, s, msg, flags);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsSendto
 *)
type
  somTD_Sockets_somsSendto = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; var msg: ShortInt; len: LongInt; flags: LongInt; var SOM_to{: opaque Sockets_sockaddr}; tolen: LongInt): LongInt; stdcall;

function Sockets.somsSendto(s: LongInt; var msg: ShortInt; len: LongInt; flags: LongInt; var SOM_to{: opaque Sockets_sockaddr}; tolen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsSendto
   (SOM_Resolve(Self, cd.classObject, cd.somsSendto))
     (Self, @LocalEnv, s, msg, len, flags, SOM_to, tolen);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsSetsockopt
 *)
type
  somTD_Sockets_somsSetsockopt = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; level: LongInt; optname: LongInt; optval: PShortInt; optlen: LongInt): LongInt; stdcall;

function Sockets.somsSetsockopt(s: LongInt; level: LongInt; optname: LongInt; optval: PShortInt; optlen: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsSetsockopt
   (SOM_Resolve(Self, cd.classObject, cd.somsSetsockopt))
     (Self, @LocalEnv, s, level, optname, optval, optlen);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsShutdown
 *)
type
  somTD_Sockets_somsShutdown = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; how: LongInt): LongInt; stdcall;

function Sockets.somsShutdown(s: LongInt; how: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsShutdown
   (SOM_Resolve(Self, cd.classObject, cd.somsShutdown))
     (Self, @LocalEnv, s, how);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsSocket
 *)
type
  somTD_Sockets_somsSocket = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; domain: LongInt; SOM_type: LongInt; protocol: LongInt): LongInt; stdcall;

function Sockets.somsSocket(domain: LongInt; SOM_type: LongInt; protocol: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsSocket
   (SOM_Resolve(Self, cd.classObject, cd.somsSocket))
     (Self, @LocalEnv, domain, SOM_type, protocol);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsSoclose
 *)
type
  somTD_Sockets_somsSoclose = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt): LongInt; stdcall;

function Sockets.somsSoclose(s: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsSoclose
   (SOM_Resolve(Self, cd.classObject, cd.somsSoclose))
     (Self, @LocalEnv, s);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somsWritev
 *)
type
  somTD_Sockets_somsWritev = function(somSelf: SOMObjectBase{Sockets}; ev: PEnvironment; s: LongInt; var iov{: opaque Sockets_iovec}; iovcnt: LongInt): LongInt; stdcall;

function Sockets.somsWritev(s: LongInt; var iov{: opaque Sockets_iovec}; iovcnt: LongInt): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSocketsClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SocketsClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Sockets_somsWritev
   (SOM_Resolve(Self, cd.classObject, cd.somsWritev))
     (Self, @LocalEnv, s, iov, iovcnt);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure Sockets.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Sockets.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Sockets.somDefaultCopyInit(var ctrl: Pointer; fromObj: Sockets); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somDefaultAssign(var ctrl: Pointer; fromObj: Sockets): Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Sockets(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Sockets.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: Sockets); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Sockets.somDefaultVCopyInit(var ctrl: Pointer; fromObj: Sockets); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Sockets.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: Sockets); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somDefaultConstAssign(var ctrl: Pointer; fromObj: Sockets): Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Sockets(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somDefaultVAssign(var ctrl: Pointer; fromObj: Sockets): Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Sockets(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somDefaultConstVAssign(var ctrl: Pointer; fromObj: Sockets): Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Sockets(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Sockets.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Sockets.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Sockets.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function Sockets.somPrintSelf: Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := Sockets(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Sockets.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure Sockets.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function Sockets.ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = Sockets then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(SocketsClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

class function Sockets.NewClass: SOMMSingleInstance;
begin
  if Self = Sockets then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(SocketsClassData.classObject);
    if not Assigned(Result) then Result := SOMMSingleInstance(SocketsNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

function Sockets.As_Sockets: Sockets; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function Sockets.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function Sockets.Supports(Instance: SOMObjectBase; out Obj: Sockets): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := Sockets(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMStringTableC_MajorVersion = 2;
  SOMStringTableC_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMStringTableCNewClass(
  somtmajorVersion: integer4 = SOMStringTableC_MajorVersion;
  somtminorVersion: integer4 = SOMStringTableC_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMStringTableCNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMStringTableCClassDataStructure = packed record
    classObject: SOMClass;
    _get_somstTargetCapacity,
    _set_somstTargetCapacity,
    _get_somstAssociationsCount,
    somstAssociate,
    somstAssociateCopyKey,
    somstAssociateCopyValue,
    somstAssociateCopyBoth,
    somstGetAssociation,
    somstClearAssociation,
    somstGetIthKey,
    somstGetIthValue: somMToken;
  end;
  PSOMStringTableCClassDataStructure = ^SOMStringTableCClassDataStructure;

var
  SOME_DLL_SOMStringTableCClassData: PSOMStringTableCClassDataStructure = nil;

function SOMStringTableCClassData: PSOMStringTableCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMStringTableCClassData) then
    Result := SOME_DLL_SOMStringTableCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMStringTableCClassData, 'SOMStringTableCClassData');
    Result := SOME_DLL_SOMStringTableCClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMStringTableCCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMStringTableCCClassDataStructure = ^SOMStringTableCCClassDataStructure;

var
  SOME_DLL_SOMStringTableCCClassData: PSOMStringTableCCClassDataStructure = nil;

function SOMStringTableCCClassData: PSOMStringTableCCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMStringTableCCClassData) then
    Result := SOME_DLL_SOMStringTableCCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMStringTableCCClassData, 'SOMStringTableCCClassData');
    Result := SOME_DLL_SOMStringTableCCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_somstTargetCapacity
 *)
type
  somTD_SOMStringTableC__get_somstTargetCapacity = function(somSelf: SOMObjectBase{SOMStringTableC}): LongWord; stdcall;

function SOMStringTableC._get_somstTargetCapacity: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  Result :=
  somTD_SOMStringTableC__get_somstTargetCapacity
   (SOM_Resolve(Self, cd.classObject, cd._get_somstTargetCapacity))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _set_somstTargetCapacity
 *)
type
  somTD_SOMStringTableC__set_somstTargetCapacity = procedure(somSelf: SOMObjectBase{SOMStringTableC}; somstTargetCapacity: LongWord); stdcall;

procedure SOMStringTableC._set_somstTargetCapacity(somstTargetCapacity: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  somTD_SOMStringTableC__set_somstTargetCapacity
   (SOM_Resolve(Self, cd.classObject, cd._set_somstTargetCapacity))
     (Self, somstTargetCapacity);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: _get_somstAssociationsCount
 *)
type
  somTD_SOMStringTableC__get_somstAssociationsCount = function(somSelf: SOMObjectBase{SOMStringTableC}): LongWord; stdcall;

function SOMStringTableC._get_somstAssociationsCount: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  Result :=
  somTD_SOMStringTableC__get_somstAssociationsCount
   (SOM_Resolve(Self, cd.classObject, cd._get_somstAssociationsCount))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMStringTableC.Create: SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMStringTableC(SOMClass(NewClass).somNew);
end;

class function SOMStringTableC.InitInstance(Instance: Pointer): SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMStringTableC(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMStringTableC.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMStringTableC.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMStringTableC.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMStringTableC.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMStringTableC.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMStringTableC.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMStringTableC.NewInstance: SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMStringTableC(SOMClass(NewClass).somNewNoInit);
end;

function SOMStringTableC.Clone: SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMStringTableC(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somstAssociate
 *)
type
  somTD_SOMStringTableC_somstAssociate = function(somSelf: SOMObjectBase{SOMStringTableC}; key: CORBAString; value: CORBAString): SmallInt; stdcall;

function SOMStringTableC.somstAssociate(key: CORBAString; value: CORBAString): SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  Result :=
  somTD_SOMStringTableC_somstAssociate
   (SOM_Resolve(Self, cd.classObject, cd.somstAssociate))
     (Self, key, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somstAssociateCopyKey
 *)
type
  somTD_SOMStringTableC_somstAssociateCopyKey = function(somSelf: SOMObjectBase{SOMStringTableC}; key: CORBAString; value: CORBAString): SmallInt; stdcall;

function SOMStringTableC.somstAssociateCopyKey(key: CORBAString; value: CORBAString): SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  Result :=
  somTD_SOMStringTableC_somstAssociateCopyKey
   (SOM_Resolve(Self, cd.classObject, cd.somstAssociateCopyKey))
     (Self, key, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somstAssociateCopyValue
 *)
type
  somTD_SOMStringTableC_somstAssociateCopyValue = function(somSelf: SOMObjectBase{SOMStringTableC}; key: CORBAString; value: CORBAString): SmallInt; stdcall;

function SOMStringTableC.somstAssociateCopyValue(key: CORBAString; value: CORBAString): SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  Result :=
  somTD_SOMStringTableC_somstAssociateCopyValue
   (SOM_Resolve(Self, cd.classObject, cd.somstAssociateCopyValue))
     (Self, key, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somstAssociateCopyBoth
 *)
type
  somTD_SOMStringTableC_somstAssociateCopyBoth = function(somSelf: SOMObjectBase{SOMStringTableC}; key: CORBAString; value: CORBAString): SmallInt; stdcall;

function SOMStringTableC.somstAssociateCopyBoth(key: CORBAString; value: CORBAString): SmallInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  Result :=
  somTD_SOMStringTableC_somstAssociateCopyBoth
   (SOM_Resolve(Self, cd.classObject, cd.somstAssociateCopyBoth))
     (Self, key, value);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somstGetAssociation
 *)
type
  somTD_SOMStringTableC_somstGetAssociation = function(somSelf: SOMObjectBase{SOMStringTableC}; key: CORBAString): CORBAString; stdcall;

function SOMStringTableC.somstGetAssociation(key: CORBAString): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  Result :=
  somTD_SOMStringTableC_somstGetAssociation
   (SOM_Resolve(Self, cd.classObject, cd.somstGetAssociation))
     (Self, key);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somstClearAssociation
 *)
type
  somTD_SOMStringTableC_somstClearAssociation = function(somSelf: SOMObjectBase{SOMStringTableC}; key: CORBAString): CORBABoolean; stdcall;

function SOMStringTableC.somstClearAssociation(key: CORBAString): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  Result :=
  somTD_SOMStringTableC_somstClearAssociation
   (SOM_Resolve(Self, cd.classObject, cd.somstClearAssociation))
     (Self, key);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somstGetIthKey
 *)
type
  somTD_SOMStringTableC_somstGetIthKey = function(somSelf: SOMObjectBase{SOMStringTableC}; i: LongWord): CORBAString; stdcall;

function SOMStringTableC.somstGetIthKey(i: LongWord): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  Result :=
  somTD_SOMStringTableC_somstGetIthKey
   (SOM_Resolve(Self, cd.classObject, cd.somstGetIthKey))
     (Self, i);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

(*
 * New Method: somstGetIthValue
 *)
type
  somTD_SOMStringTableC_somstGetIthValue = function(somSelf: SOMObjectBase{SOMStringTableC}; i: LongWord): CORBAString; stdcall;

function SOMStringTableC.somstGetIthValue(i: LongWord): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMStringTableCClassDataStructure;
begin
  cd := SOMStringTableCClassData;
  Result :=
  somTD_SOMStringTableC_somstGetIthValue
   (SOM_Resolve(Self, cd.classObject, cd.somstGetIthValue))
     (Self, i);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMStringTableC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somDefaultAssign(var ctrl: Pointer; fromObj: SOMStringTableC): SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMStringTableC(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMStringTableC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMStringTableC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMStringTableC); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMStringTableC): SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMStringTableC(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMStringTableC): SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMStringTableC(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMStringTableC): SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMStringTableC(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMStringTableC.somPrintSelf: SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMStringTableC(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMStringTableC.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMStringTableC.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMStringTableC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMStringTableCClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMStringTableC.NewClass: SOMClass;
begin
  if Self = SOMStringTableC then { invoked on class name literal }
  begin
    Result := SOMClass(SOMStringTableCClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMStringTableCNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMStringTableC.As_SOMStringTableC: SOMStringTableC; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMStringTableC.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMStringTableC.Supports(Instance: SOMObjectBase; out Obj: SOMStringTableC): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMStringTableC(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMMTraced_MajorVersion = 2;
  SOMMTraced_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMMTracedNewClass(
  somtmajorVersion: integer4 = SOMMTraced_MajorVersion;
  somtminorVersion: integer4 = SOMMTraced_MinorVersion):
  SOMClass; stdcall; external SOME_DLL_Name name 'SOMMTracedNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMMTracedClassDataStructure = packed record
    classObject: SOMClass;
    _set_sommTraceIsOn,
    _get_sommTraceIsOn: somMToken;
  end;
  PSOMMTracedClassDataStructure = ^SOMMTracedClassDataStructure;

var
  SOME_DLL_SOMMTracedClassData: PSOMMTracedClassDataStructure = nil;

function SOMMTracedClassData: PSOMMTracedClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMMTracedClassData) then
    Result := SOME_DLL_SOMMTracedClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMMTracedClassData, 'SOMMTracedClassData');
    Result := SOME_DLL_SOMMTracedClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMMTracedCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMMTracedCClassDataStructure = ^SOMMTracedCClassDataStructure;

var
  SOME_DLL_SOMMTracedCClassData: PSOMMTracedCClassDataStructure = nil;

function SOMMTracedCClassData: PSOMMTracedCClassDataStructure;
begin
  if Assigned(SOME_DLL_SOMMTracedCClassData) then
    Result := SOME_DLL_SOMMTracedCClassData
  else
  begin
    SOME_DLL_Load_Variable(SOME_DLL_SOMMTracedCClassData, 'SOMMTracedCClassData');
    Result := SOME_DLL_SOMMTracedCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_sommTraceIsOn
 *)
type
  somTD_SOMMTraced__get_sommTraceIsOn = function(somSelf: SOMObjectBase{SOMMTraced}; ev: PEnvironment): CORBABoolean; stdcall;

function SOMMTraced._get_sommTraceIsOn: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMMTracedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMMTracedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMMTraced__get_sommTraceIsOn
   (SOM_Resolve(Self, cd.classObject, cd._get_sommTraceIsOn))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_sommTraceIsOn
 *)
type
  somTD_SOMMTraced__set_sommTraceIsOn = procedure(somSelf: SOMObjectBase{SOMMTraced}; ev: PEnvironment; sommTraceIsOn: CORBABoolean); stdcall;

procedure SOMMTraced._set_sommTraceIsOn(sommTraceIsOn: CORBABoolean); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMMTracedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMMTracedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMMTraced__set_sommTraceIsOn
   (SOM_Resolve(Self, cd.classObject, cd._set_sommTraceIsOn))
     (Self, @LocalEnv, sommTraceIsOn);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMMTraced._get_somDataAlignment: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somDataAlignment
   (SOM_Resolve(Self, cd.classObject, cd._get_somDataAlignment))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced._get_somInstanceDataOffsets: _IDL_Sequence_SOMClass_somOffsetInfo; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somInstanceDataOffsets
   (SOM_Resolve(Self, cd.classObject, cd._get_somInstanceDataOffsets))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced._get_somDirectInitClasses: _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somDirectInitClasses
   (SOM_Resolve(Self, cd.classObject, cd._get_somDirectInitClasses))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced._set_somDirectInitClasses(const somDirectInitClasses: _IDL_Sequence_SOMClass); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass__set_somDirectInitClasses
   (SOM_Resolve(Self, cd.classObject, cd._set_somDirectInitClasses))
     (Self, somDirectInitClasses);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced._get_somClassAllocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somClassAllocate
   (SOM_Resolve(Self, cd.classObject, cd._get_somClassAllocate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced._get_somClassDeallocate: PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass__get_somClassDeallocate
   (SOM_Resolve(Self, cd.classObject, cd._get_somClassDeallocate))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMMTraced.Create: SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMTraced(SOMClass(NewClass).somNew);
end;

class function SOMMTraced.InitInstance(Instance: Pointer): SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMTraced(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMMTraced.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMMTraced.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMMTraced.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMMTraced.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMMTraced.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMMTraced.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMMTraced.NewInstance: SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMTraced(SOMClass(NewClass).somNewNoInit);
end;

function SOMMTraced.Clone: SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMTraced(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMMTraced.sommBeforeMethod(SOM_object: SOMObject; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMMBeforeAfterClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMMBeforeAfterClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMMBeforeAfter_sommBeforeMethod
   (SOM_Resolve(Self, cd.classObject, cd.sommBeforeMethod))
     (Self, @LocalEnv, SOM_object, methodId, ap);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMMTraced.sommAfterMethod(SOM_object: SOMObject; methodId: somId; returnedvalue: Pointer; ap: va_list); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMMBeforeAfterClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMMBeforeAfterClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMMBeforeAfter_sommAfterMethod
   (SOM_Resolve(Self, cd.classObject, cd.sommAfterMethod))
     (Self, @LocalEnv, SOM_object, methodId, returnedvalue, ap);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMMTraced.somNew: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somNew
   (SOM_Resolve(Self, cd.classObject, cd.somNew))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somNewNoInit: SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somNewNoInit
   (SOM_Resolve(Self, cd.classObject, cd.somNewNoInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somRenew(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenew
   (SOM_Resolve(Self, cd.classObject, cd.somRenew))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somRenewNoInit(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoInit
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoInit))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somRenewNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoZero
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoZero))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somRenewNoInitNoZero(obj: Pointer): SOMObject; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somRenewNoInitNoZero
   (SOM_Resolve(Self, cd.classObject, cd.somRenewNoInitNoZero))
     (Self, obj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somAllocate(size: LongInt): CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somAllocate
   (SOM_Resolve(Self, cd.classObject, cd.somAllocate))
     (Self, size);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somDeallocate(memptr: CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somDeallocate
   (SOM_Resolve(Self, cd.classObject, cd.somDeallocate))
     (Self, memptr);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetInstanceInitMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceInitMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceInitMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetInstanceDestructionMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceDestructionMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceDestructionMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetInstanceAssignmentMask(out ctrl: Pointer): PByte; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceAssignmentMask
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceAssignmentMask))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somInitClass(className: CORBAString; parentClass: SOMClass; dataSize: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somInitClass
   (SOM_Resolve(Self, cd.classObject, cd.somInitClass))
     (Self, className, parentClass, dataSize, maxStaticMethods, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somInitMIClass(inherit_vars: LongInt; className: CORBAString; const parentClasses: _IDL_Sequence_SOMClass; dataSize: LongInt; dataAlignment: LongInt; maxStaticMethods: LongInt; majorVersion: LongInt; minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somInitMIClass
   (SOM_Resolve(Self, cd.classObject, cd.somInitMIClass))
     (Self, inherit_vars, className, parentClasses, dataSize, dataAlignment, maxStaticMethods, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somAddStaticMethod(methodId: somId; methodDescriptor: somId; method: Pointer; redispatchStub: Pointer; applyStub: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somAddStaticMethod
   (SOM_Resolve(Self, cd.classObject, cd.somAddStaticMethod))
     (Self, methodId, methodDescriptor, method, redispatchStub, applyStub);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somAddDynamicMethod(methodId: somId; methodDescriptor: somId; method: Pointer; applyStub: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somAddDynamicMethod
   (SOM_Resolve(Self, cd.classObject, cd.somAddDynamicMethod))
     (Self, methodId, methodDescriptor, method, applyStub);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somOverrideSMethod(methodId: somId; method: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somOverrideSMethod
   (SOM_Resolve(Self, cd.classObject, cd.somOverrideSMethod))
     (Self, methodId, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somClassReady; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somClassReady
   (SOM_Resolve(Self, cd.classObject, cd.somClassReady))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetClassData: PsomClassDataStructure; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetClassData
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassData))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somSetClassData(const cds: somClassDataStructure); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somSetClassData
   (SOM_Resolve(Self, cd.classObject, cd.somSetClassData))
     (Self, cds);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetClassMtab: PsomMethodTab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetClassMtab
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetInstanceOffset: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceOffset
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceOffset))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetInstancePartSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstancePartSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstancePartSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetInstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetInstanceToken: Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetInstanceToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetInstanceToken))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetMemberToken(memberOffset: LongInt; instanceToken: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMemberToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetMemberToken))
     (Self, memberOffset, instanceToken);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetMethodData(methodId: somId; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodData
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodData))
     (Self, methodId, md);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetRdStub(methodId: somId): PPointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetRdStub
   (SOM_Resolve(Self, cd.classObject, cd.somGetRdStub))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetMethodDescriptor(methodId: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodDescriptor
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodDescriptor))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetMethodIndex(id: somId): LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodIndex
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodIndex))
     (Self, id);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetMethodToken(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetMethodToken
   (SOM_Resolve(Self, cd.classObject, cd.somGetMethodToken))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetName
   (SOM_Resolve(Self, cd.classObject, cd.somGetName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetNthMethodData(n: LongInt; out md: somMethodDataStruct): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNthMethodData
   (SOM_Resolve(Self, cd.classObject, cd.somGetNthMethodData))
     (Self, n, md);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetNthMethodInfo(n: LongInt; out descriptor: somId): somId; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNthMethodInfo
   (SOM_Resolve(Self, cd.classObject, cd.somGetNthMethodInfo))
     (Self, n, descriptor);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetNumMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNumMethods
   (SOM_Resolve(Self, cd.classObject, cd.somGetNumMethods))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetNumStaticMethods: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetNumStaticMethods
   (SOM_Resolve(Self, cd.classObject, cd.somGetNumStaticMethods))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetParent: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetParent
   (SOM_Resolve(Self, cd.classObject, cd.somGetParent))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetParents: {dual_owned} _IDL_Sequence_SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetParents
   (SOM_Resolve(Self, cd.classObject, cd.somGetParents))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetPClsMtab: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetPClsMtab
   (SOM_Resolve(Self, cd.classObject, cd.somGetPClsMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetPClsMtabs: PsomMethodTabList; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somGetPClsMtabs
   (SOM_Resolve(Self, cd.classObject, cd.somGetPClsMtabs))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somGetVersionNumbers(out majorVersion: LongInt; out minorVersion: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somGetVersionNumbers
   (SOM_Resolve(Self, cd.classObject, cd.somGetVersionNumbers))
     (Self, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somSetMethodDescriptor(methodId: somId; descriptor: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somSetMethodDescriptor
   (SOM_Resolve(Self, cd.classObject, cd.somSetMethodDescriptor))
     (Self, methodId, descriptor);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somFindMethod(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindMethod
   (SOM_Resolve(Self, cd.classObject, cd.somFindMethod))
     (Self, methodId, m);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somFindMethodOk(methodId: somId; out m: Pointer): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindMethodOk
   (SOM_Resolve(Self, cd.classObject, cd.somFindMethodOk))
     (Self, methodId, m);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somFindSMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindSMethod
   (SOM_Resolve(Self, cd.classObject, cd.somFindSMethod))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somFindSMethodOk(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somFindSMethodOk
   (SOM_Resolve(Self, cd.classObject, cd.somFindSMethodOk))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somLookupMethod(methodId: somId): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somLookupMethod
   (SOM_Resolve(Self, cd.classObject, cd.somLookupMethod))
     (Self, methodId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somCheckVersion(majorVersion: LongInt; minorVersion: LongInt): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somCheckVersion
   (SOM_Resolve(Self, cd.classObject, cd.somCheckVersion))
     (Self, majorVersion, minorVersion);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somDescendedFrom(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somDescendedFrom
   (SOM_Resolve(Self, cd.classObject, cd.somDescendedFrom))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somSupportsMethod(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somSupportsMethod
   (SOM_Resolve(Self, cd.classObject, cd.somSupportsMethod))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somDefinedMethod(method: Pointer): Pointer; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  Result :=
  somTD_SOMClass_somDefinedMethod
   (SOM_Resolve(Self, cd.classObject, cd.somDefinedMethod))
     (Self, method);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somOverrideMtab; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMClassClassDataStructure;
begin
  cd := SOMClassClassData;
  somTD_SOMClass_somOverrideMtab
   (SOM_Resolve(Self, cd.classObject, cd.somOverrideMtab))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMMTraced); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somDefaultAssign(var ctrl: Pointer; fromObj: SOMMTraced): SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMTraced(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMMTraced); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMMTraced); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMMTraced); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMMTraced): SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMTraced(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMMTraced): SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMTraced(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMMTraced): SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMTraced(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMMTraced.somPrintSelf: SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMTraced(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMMTraced.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMMTraced.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMMTraced then { invoked on class name literal }
  begin
    Result := SOMClass(SOMMTracedClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMMTraced.NewClass: SOMClass;
begin
  if Self = SOMMTraced then { invoked on class name literal }
  begin
    Result := SOMClass(SOMMTracedClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMMTracedNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMMTraced.As_SOMClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(Self);
end;

function SOMMTraced.As_SOMMBeforeAfter: SOMMBeforeAfter; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMBeforeAfter(Self);
end;

function SOMMTraced.As_SOMMTraced: SOMMTraced; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMMTraced.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMMTraced.Supports(Instance: SOMObjectBase; out Obj: SOMMTraced): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMMTraced(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMETimerEvent_MajorVersion = 2;
  SOMETimerEvent_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMETimerEventNewClass(
  somtmajorVersion: integer4 = SOMETimerEvent_MajorVersion;
  somtminorVersion: integer4 = SOMETimerEvent_MinorVersion):
  SOMClass; stdcall; external SOMEM_DLL_Name name 'SOMETimerEventNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMETimerEventClassDataStructure = packed record
    classObject: SOMClass;
    somevGetEventInterval,
    somevSetEventInterval: somMToken;
  end;
  PSOMETimerEventClassDataStructure = ^SOMETimerEventClassDataStructure;

var
  SOMEM_DLL_SOMETimerEventClassData: PSOMETimerEventClassDataStructure = nil;

function SOMETimerEventClassData: PSOMETimerEventClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMETimerEventClassData) then
    Result := SOMEM_DLL_SOMETimerEventClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMETimerEventClassData, 'SOMETimerEventClassData');
    Result := SOMEM_DLL_SOMETimerEventClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMETimerEventCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMETimerEventCClassDataStructure = ^SOMETimerEventCClassDataStructure;

var
  SOMEM_DLL_SOMETimerEventCClassData: PSOMETimerEventCClassDataStructure = nil;

function SOMETimerEventCClassData: PSOMETimerEventCClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMETimerEventCClassData) then
    Result := SOMEM_DLL_SOMETimerEventCClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMETimerEventCClassData, 'SOMETimerEventCClassData');
    Result := SOMEM_DLL_SOMETimerEventCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMETimerEvent.Create: SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMETimerEvent(SOMClass(NewClass).somNew);
end;

class function SOMETimerEvent.InitInstance(Instance: Pointer): SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMETimerEvent(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMETimerEvent.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMETimerEvent.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMETimerEvent.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMETimerEvent.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMETimerEvent.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMETimerEvent.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMETimerEvent.NewInstance: SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMETimerEvent(SOMClass(NewClass).somNewNoInit);
end;

function SOMETimerEvent.Clone: SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMETimerEvent(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: somevGetEventInterval
 *)
type
  somTD_SOMETimerEvent_somevGetEventInterval = function(somSelf: SOMObjectBase{SOMETimerEvent}; ev: PEnvironment): LongInt; stdcall;

function SOMETimerEvent.somevGetEventInterval: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMETimerEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMETimerEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMETimerEvent_somevGetEventInterval
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventInterval))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: somevSetEventInterval
 *)
type
  somTD_SOMETimerEvent_somevSetEventInterval = procedure(somSelf: SOMObjectBase{SOMETimerEvent}; ev: PEnvironment; interval: LongInt); stdcall;

procedure SOMETimerEvent.somevSetEventInterval(interval: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMETimerEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMETimerEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMETimerEvent_somevSetEventInterval
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventInterval))
     (Self, @LocalEnv, interval);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMETimerEvent.somevGetEventTime: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEvent_somevGetEventTime
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventTime))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMETimerEvent.somevGetEventType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEvent_somevGetEventType
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventType))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMETimerEvent.somevSetEventTime(time: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEvent_somevSetEventTime
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventTime))
     (Self, @LocalEnv, time);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMETimerEvent.somevSetEventType(SOM_type: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEvent_somevSetEventType
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventType))
     (Self, @LocalEnv, SOM_type);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMETimerEvent.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMETimerEvent.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMETimerEvent.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMETimerEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somDefaultAssign(var ctrl: Pointer; fromObj: SOMETimerEvent): SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMETimerEvent(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMETimerEvent.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMETimerEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMETimerEvent.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMETimerEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMETimerEvent.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMETimerEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMETimerEvent): SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMETimerEvent(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMETimerEvent): SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMETimerEvent(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMETimerEvent): SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMETimerEvent(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMETimerEvent.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMETimerEvent.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMETimerEvent.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMETimerEvent.somPrintSelf: SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMETimerEvent(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMETimerEvent.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMETimerEvent.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMETimerEvent.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMETimerEvent then { invoked on class name literal }
  begin
    Result := SOMClass(SOMETimerEventClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMETimerEvent.NewClass: SOMClass;
begin
  if Self = SOMETimerEvent then { invoked on class name literal }
  begin
    Result := SOMClass(SOMETimerEventClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMETimerEventNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMETimerEvent.As_SOMEEvent: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEvent(Self);
end;

function SOMETimerEvent.As_SOMETimerEvent: SOMETimerEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMETimerEvent.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMETimerEvent.Supports(Instance: SOMObjectBase; out Obj: SOMETimerEvent): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMETimerEvent(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  TSIdentification_MajorVersion = 2;
  TSIdentification_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function TSIdentificationNewClass(
  somtmajorVersion: integer4 = TSIdentification_MajorVersion;
  somtminorVersion: integer4 = TSIdentification_MinorVersion):
  SOMClass; stdcall; external SOMD_DLL_Name name 'TSIdentificationNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  TSIdentificationClassDataStructure = packed record
    classObject: SOMClass;
    identify_sender,
    identify_receiver,
    _get_sender,
    _get_receiver: somMToken;
  end;
  PTSIdentificationClassDataStructure = ^TSIdentificationClassDataStructure;

var
  SOMD_DLL_TSIdentificationClassData: PTSIdentificationClassDataStructure = nil;

function TSIdentificationClassData: PTSIdentificationClassDataStructure;
begin
  if Assigned(SOMD_DLL_TSIdentificationClassData) then
    Result := SOMD_DLL_TSIdentificationClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_TSIdentificationClassData, 'TSIdentificationClassData');
    Result := SOMD_DLL_TSIdentificationClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  TSIdentificationCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PTSIdentificationCClassDataStructure = ^TSIdentificationCClassDataStructure;

var
  SOMD_DLL_TSIdentificationCClassData: PTSIdentificationCClassDataStructure = nil;

function TSIdentificationCClassData: PTSIdentificationCClassDataStructure;
begin
  if Assigned(SOMD_DLL_TSIdentificationCClassData) then
    Result := SOMD_DLL_TSIdentificationCClassData
  else
  begin
    SOMD_DLL_Load_Variable(SOMD_DLL_TSIdentificationCClassData, 'TSIdentificationCClassData');
    Result := SOMD_DLL_TSIdentificationCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_sender
 *)
type
  somTD_TSIdentification__get_sender = function(somSelf: SOMObjectBase{TSIdentification}; ev: PEnvironment): TSPortability_Sender; stdcall;

function TSIdentification._get_sender: TSPortability_Sender; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PTSIdentificationClassDataStructure;
  LocalEnv: Environment;
begin
  cd := TSIdentificationClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_TSIdentification__get_sender
   (SOM_Resolve(Self, cd.classObject, cd._get_sender))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _get_receiver
 *)
type
  somTD_TSIdentification__get_receiver = function(somSelf: SOMObjectBase{TSIdentification}; ev: PEnvironment): TSPortability_Receiver; stdcall;

function TSIdentification._get_receiver: TSPortability_Receiver; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PTSIdentificationClassDataStructure;
  LocalEnv: Environment;
begin
  cd := TSIdentificationClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_TSIdentification__get_receiver
   (SOM_Resolve(Self, cd.classObject, cd._get_receiver))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function TSIdentification.Create: TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := TSIdentification(SOMClass(NewClass).somNew);
end;

class function TSIdentification.InitInstance(Instance: Pointer): TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := TSIdentification(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function TSIdentification.ClassType: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMMSingleInstance(SOMObject(Self).somGetClass);
end;

class function TSIdentification.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function TSIdentification.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function TSIdentification.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function TSIdentification.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function TSIdentification.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function TSIdentification.NewInstance: TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := TSIdentification(SOMClass(NewClass).somNewNoInit);
end;

function TSIdentification.Clone: TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := TSIdentification(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

(*
 * New Method: identify_sender
 *)
type
  somTD_TSIdentification_identify_sender = procedure(somSelf: SOMObjectBase{TSIdentification}; ev: PEnvironment; sender: TSPortability_Sender); stdcall;

procedure TSIdentification.identify_sender(sender: TSPortability_Sender); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PTSIdentificationClassDataStructure;
  LocalEnv: Environment;
begin
  cd := TSIdentificationClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_TSIdentification_identify_sender
   (SOM_Resolve(Self, cd.classObject, cd.identify_sender))
     (Self, @LocalEnv, sender);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: identify_receiver
 *)
type
  somTD_TSIdentification_identify_receiver = procedure(somSelf: SOMObjectBase{TSIdentification}; ev: PEnvironment; receiver: TSPortability_Receiver); stdcall;

procedure TSIdentification.identify_receiver(receiver: TSPortability_Receiver); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PTSIdentificationClassDataStructure;
  LocalEnv: Environment;
begin
  cd := TSIdentificationClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_TSIdentification_identify_receiver
   (SOM_Resolve(Self, cd.classObject, cd.identify_receiver))
     (Self, @LocalEnv, receiver);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure TSIdentification.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TSIdentification.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TSIdentification.somDefaultCopyInit(var ctrl: Pointer; fromObj: TSIdentification); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somDefaultAssign(var ctrl: Pointer; fromObj: TSIdentification): TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := TSIdentification(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TSIdentification.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: TSIdentification); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TSIdentification.somDefaultVCopyInit(var ctrl: Pointer; fromObj: TSIdentification); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TSIdentification.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: TSIdentification); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somDefaultConstAssign(var ctrl: Pointer; fromObj: TSIdentification): TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := TSIdentification(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somDefaultVAssign(var ctrl: Pointer; fromObj: TSIdentification): TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := TSIdentification(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somDefaultConstVAssign(var ctrl: Pointer; fromObj: TSIdentification): TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := TSIdentification(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TSIdentification.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TSIdentification.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TSIdentification.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somGetClass: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMMSingleInstance(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TSIdentification.somPrintSelf: TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := TSIdentification(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TSIdentification.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TSIdentification.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function TSIdentification.ClassObject: SOMMSingleInstance; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = TSIdentification then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(TSIdentificationClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

class function TSIdentification.NewClass: SOMMSingleInstance;
begin
  if Self = TSIdentification then { invoked on class name literal }
  begin
    Result := SOMMSingleInstance(TSIdentificationClassData.classObject);
    if not Assigned(Result) then Result := SOMMSingleInstance(TSIdentificationNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMMSingleInstance(PPointer(Self)^);
  end
end;

function TSIdentification.As_TSIdentification: TSIdentification; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function TSIdentification.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function TSIdentification.Supports(Instance: SOMObjectBase; out Obj: TSIdentification): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := TSIdentification(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  TypeDef_MajorVersion = 2;
  TypeDef_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function TypeDefNewClass(
  somtmajorVersion: integer4 = TypeDef_MajorVersion;
  somtminorVersion: integer4 = TypeDef_MinorVersion):
  SOMClass; stdcall; external SOMIR_DLL_Name name 'TypeDefNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  TypeDefClassDataStructure = packed record
    classObject: SOMClass;
    _get_type,
    _set_type: somMToken;
  end;
  PTypeDefClassDataStructure = ^TypeDefClassDataStructure;

var
  SOMIR_DLL_TypeDefClassData: PTypeDefClassDataStructure = nil;

function TypeDefClassData: PTypeDefClassDataStructure;
begin
  if Assigned(SOMIR_DLL_TypeDefClassData) then
    Result := SOMIR_DLL_TypeDefClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_TypeDefClassData, 'TypeDefClassData');
    Result := SOMIR_DLL_TypeDefClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  TypeDefCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PTypeDefCClassDataStructure = ^TypeDefCClassDataStructure;

var
  SOMIR_DLL_TypeDefCClassData: PTypeDefCClassDataStructure = nil;

function TypeDefCClassData: PTypeDefCClassDataStructure;
begin
  if Assigned(SOMIR_DLL_TypeDefCClassData) then
    Result := SOMIR_DLL_TypeDefCClassData
  else
  begin
    SOMIR_DLL_Load_Variable(SOMIR_DLL_TypeDefCClassData, 'TypeDefCClassData');
    Result := SOMIR_DLL_TypeDefCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

(*
 * New Method: _get_type
 *)
type
  somTD_TypeDef__get_type = function(somSelf: SOMObjectBase{TypeDef}; ev: PEnvironment): TypeCode; stdcall;

function TypeDef._get_type: TypeCode; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PTypeDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := TypeDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_TypeDef__get_type
   (SOM_Resolve(Self, cd.classObject, cd._get_type))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

(*
 * New Method: _set_type
 *)
type
  somTD_TypeDef__set_type = procedure(somSelf: SOMObjectBase{TypeDef}; ev: PEnvironment; SOM_type: {caller_owns} TypeCode); stdcall;

procedure TypeDef._set_type(SOM_type: {caller_owns} TypeCode); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PTypeDefClassDataStructure;
  LocalEnv: Environment;
begin
  cd := TypeDefClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_TypeDef__set_type
   (SOM_Resolve(Self, cd.classObject, cd._set_type))
     (Self, @LocalEnv, SOM_type);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeDef._get_name: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_name
   (SOM_Resolve(Self, cd.classObject, cd._get_name))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure TypeDef._set_name(name: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_name
   (SOM_Resolve(Self, cd.classObject, cd._set_name))
     (Self, @LocalEnv, name);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeDef._get_id: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_id
   (SOM_Resolve(Self, cd.classObject, cd._get_id))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure TypeDef._set_id(id: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_id
   (SOM_Resolve(Self, cd.classObject, cd._set_id))
     (Self, @LocalEnv, id);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeDef._get_defined_in: CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._get_defined_in))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure TypeDef._set_defined_in(defined_in: {caller_owns} CORBAString); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_defined_in
   (SOM_Resolve(Self, cd.classObject, cd._set_defined_in))
     (Self, @LocalEnv, defined_in);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeDef._get_somModifiers: _IDL_Sequence_somModifier; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained__get_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._get_somModifiers))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure TypeDef._set_somModifiers(const somModifiers: {caller_owns} _IDL_Sequence_somModifier); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_Contained__set_somModifiers
   (SOM_Resolve(Self, cd.classObject, cd._set_somModifiers))
     (Self, @LocalEnv, somModifiers);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

class function TypeDef.Create: TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := TypeDef(SOMClass(NewClass).somNew);
end;

class function TypeDef.InitInstance(Instance: Pointer): TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := TypeDef(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function TypeDef.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function TypeDef.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function TypeDef.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function TypeDef.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function TypeDef.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function TypeDef.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function TypeDef.NewInstance: TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := TypeDef(SOMClass(NewClass).somNewNoInit);
end;

function TypeDef.Clone: TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := TypeDef(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function TypeDef.within: _IDL_Sequence_Container; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_within
   (SOM_Resolve(Self, cd.classObject, cd.within))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function TypeDef.describe: Contained_Description; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PContainedClassDataStructure;
  LocalEnv: Environment;
begin
  cd := ContainedClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_Contained_describe
   (SOM_Resolve(Self, cd.classObject, cd.describe))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure TypeDef.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TypeDef.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TypeDef.somDefaultCopyInit(var ctrl: Pointer; fromObj: TypeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somDefaultAssign(var ctrl: Pointer; fromObj: TypeDef): TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := TypeDef(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TypeDef.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: TypeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TypeDef.somDefaultVCopyInit(var ctrl: Pointer; fromObj: TypeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TypeDef.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: TypeDef); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somDefaultConstAssign(var ctrl: Pointer; fromObj: TypeDef): TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := TypeDef(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somDefaultVAssign(var ctrl: Pointer; fromObj: TypeDef): TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := TypeDef(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somDefaultConstVAssign(var ctrl: Pointer; fromObj: TypeDef): TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := TypeDef(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TypeDef.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TypeDef.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TypeDef.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function TypeDef.somPrintSelf: TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := TypeDef(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TypeDef.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure TypeDef.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function TypeDef.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = TypeDef then { invoked on class name literal }
  begin
    Result := SOMClass(TypeDefClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function TypeDef.NewClass: SOMClass;
begin
  if Self = TypeDef then { invoked on class name literal }
  begin
    Result := SOMClass(TypeDefClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(TypeDefNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function TypeDef.As_Contained: Contained; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Contained(Self);
end;

function TypeDef.As_TypeDef: TypeDef; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function TypeDef.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function TypeDef.Supports(Instance: SOMObjectBase; out Obj: TypeDef): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := TypeDef(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

const
  SOMEWorkProcEvent_MajorVersion = 2;
  SOMEWorkProcEvent_MinorVersion = 1;

(*
 * Declare the class creation procedure
 *)
function SOMEWorkProcEventNewClass(
  somtmajorVersion: integer4 = SOMEWorkProcEvent_MajorVersion;
  somtminorVersion: integer4 = SOMEWorkProcEvent_MinorVersion):
  SOMClass; stdcall; external SOMEM_DLL_Name name 'SOMEWorkProcEventNewClass';

(*
 * Declare the ABI 2 ClassData structure
 *)
type
  SOMEWorkProcEventClassDataStructure = packed record
    classObject: SOMClass;
  end;
  PSOMEWorkProcEventClassDataStructure = ^SOMEWorkProcEventClassDataStructure;

var
  SOMEM_DLL_SOMEWorkProcEventClassData: PSOMEWorkProcEventClassDataStructure = nil;

function SOMEWorkProcEventClassData: PSOMEWorkProcEventClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMEWorkProcEventClassData) then
    Result := SOMEM_DLL_SOMEWorkProcEventClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMEWorkProcEventClassData, 'SOMEWorkProcEventClassData');
    Result := SOMEM_DLL_SOMEWorkProcEventClassData;
  end;
end;

(*
 * Declare the ABI 2 CClassData structure
 *)
type
  SOMEWorkProcEventCClassDataStructure = packed record
    parentMtab: somMethodTabs;
    instanceDataToken: somDToken;
  end;
  PSOMEWorkProcEventCClassDataStructure = ^SOMEWorkProcEventCClassDataStructure;

var
  SOMEM_DLL_SOMEWorkProcEventCClassData: PSOMEWorkProcEventCClassDataStructure = nil;

function SOMEWorkProcEventCClassData: PSOMEWorkProcEventCClassDataStructure;
begin
  if Assigned(SOMEM_DLL_SOMEWorkProcEventCClassData) then
    Result := SOMEM_DLL_SOMEWorkProcEventCClassData
  else
  begin
    SOMEM_DLL_Load_Variable(SOMEM_DLL_SOMEWorkProcEventCClassData, 'SOMEWorkProcEventCClassData');
    Result := SOMEM_DLL_SOMEWorkProcEventCClassData;
  end;
end;

(*
 * Class Object and Method Token Macros
 *)

class function SOMEWorkProcEvent.Create: SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEWorkProcEvent(SOMClass(NewClass).somNew);
end;

class function SOMEWorkProcEvent.InitInstance(Instance: Pointer): SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEWorkProcEvent(SOMClass(NewClass).somRenewNoInit(Instance));
end;

function SOMEWorkProcEvent.ClassType: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(SOMObject(Self).somGetClass);
end;

class function SOMEWorkProcEvent.ClassName: string;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName);
end;

class function SOMEWorkProcEvent.ClassNameIs(const Name: string): Boolean;
begin
  Result := AnsiString(SOMClass(NewClass).somGetName) = Name;
end;

class function SOMEWorkProcEvent.InstanceSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somGetInstanceSize;
end;

class function SOMEWorkProcEvent.InheritsFrom(AClass: SOMClass): Boolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMClass(NewClass).somDescendedFrom(AClass);
end;

class function SOMEWorkProcEvent.MethodAddress(const Name: string): Pointer;
var
  NameAsAnsiString: AnsiString;
  NameAsSomId: somId;
begin
  NameAsAnsiString := AnsiString(Name);
  NameAsSomId := somIdFromString(PAnsiChar(NameAsAnsiString));
  try
    SOMClass(NewClass).somFindMethod(NameAsSomId, Result);
  finally
    SOMMemFree(NameAsSomId);
  end;
end;

class function SOMEWorkProcEvent.NewInstance: SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEWorkProcEvent(SOMClass(NewClass).somNewNoInit);
end;

function SOMEWorkProcEvent.Clone: SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEWorkProcEvent(SOMClass(somGetClass).somNewNoInit);
  SOMObject(Result).somDefaultCopyInit(somInitCtrl(nil^), SOMObject(Self));
end;

function SOMEWorkProcEvent.somevGetEventTime: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEvent_somevGetEventTime
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventTime))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

function SOMEWorkProcEvent.somevGetEventType: LongWord; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  Result :=
  somTD_SOMEEvent_somevGetEventType
   (SOM_Resolve(Self, cd.classObject, cd.somevGetEventType))
     (Self, @LocalEnv);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMEWorkProcEvent.somevSetEventTime(time: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEvent_somevSetEventTime
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventTime))
     (Self, @LocalEnv, time);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMEWorkProcEvent.somevSetEventType(SOM_type: LongWord); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMEEventClassDataStructure;
  LocalEnv: Environment;
begin
  cd := SOMEEventClassData;
  SOM_InitEnvironment(@LocalEnv);
  somTD_SOMEEvent_somevSetEventType
   (SOM_Resolve(Self, cd.classObject, cd.somevSetEventType))
     (Self, @LocalEnv, SOM_type);
  SOM_UninitEnvironmentOrRaise(@LocalEnv);
end;

procedure SOMEWorkProcEvent.somDefaultInit(var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultInit))
     (Self, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEWorkProcEvent.somDestruct(doFree: Byte; var ctrl: Pointer); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDestruct
   (SOM_Resolve(Self, cd.classObject, cd.somDestruct))
     (Self, doFree, ctrl);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEWorkProcEvent.somDefaultCopyInit(var ctrl: Pointer; fromObj: SOMEWorkProcEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somDefaultAssign(var ctrl: Pointer; fromObj: SOMEWorkProcEvent): SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEWorkProcEvent(
  somTD_SOMObject_somDefaultAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEWorkProcEvent.somDefaultConstCopyInit(var ctrl: Pointer; fromObj: SOMEWorkProcEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEWorkProcEvent.somDefaultVCopyInit(var ctrl: Pointer; fromObj: SOMEWorkProcEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEWorkProcEvent.somDefaultConstVCopyInit(var ctrl: Pointer; fromObj: SOMEWorkProcEvent); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDefaultConstVCopyInit
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVCopyInit))
     (Self, ctrl, fromObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somDefaultConstAssign(var ctrl: Pointer; fromObj: SOMEWorkProcEvent): SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEWorkProcEvent(
  somTD_SOMObject_somDefaultConstAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somDefaultVAssign(var ctrl: Pointer; fromObj: SOMEWorkProcEvent): SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEWorkProcEvent(
  somTD_SOMObject_somDefaultVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somDefaultConstVAssign(var ctrl: Pointer; fromObj: SOMEWorkProcEvent): SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEWorkProcEvent(
  somTD_SOMObject_somDefaultConstVAssign
   (SOM_Resolve(Self, cd.classObject, cd.somDefaultConstVAssign))
     (Self, ctrl, fromObj));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEWorkProcEvent.somInit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somInit
   (SOM_Resolve(Self, cd.classObject, cd.somInit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEWorkProcEvent.somFree; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somFree
   (SOM_Resolve(Self, cd.classObject, cd.somFree))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEWorkProcEvent.somUninit; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somUninit
   (SOM_Resolve(Self, cd.classObject, cd.somUninit))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somGetClass: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMClass(
  somTD_SOMObject_somGetClass
   (SOM_Resolve(Self, cd.classObject, cd.somGetClass))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somGetClassName: {dual_owned} CORBAString; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetClassName
   (SOM_Resolve(Self, cd.classObject, cd.somGetClassName))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somGetSize: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somGetSize
   (SOM_Resolve(Self, cd.classObject, cd.somGetSize))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somIsA(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsA
   (SOM_Resolve(Self, cd.classObject, cd.somIsA))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somIsInstanceOf(aClassObj: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somIsInstanceOf
   (SOM_Resolve(Self, cd.classObject, cd.somIsInstanceOf))
     (Self, aClassObj);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somRespondsTo(mId: somId): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somRespondsTo
   (SOM_Resolve(Self, cd.classObject, cd.somRespondsTo))
     (Self, mId);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somDispatch(out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somDispatch))
     (Self, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somClassDispatch(clsObj: SOMClass; out retValue: Pointer; methodId: somId; ap: va_list): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somClassDispatch
   (SOM_Resolve(Self, cd.classObject, cd.somClassDispatch))
     (Self, clsObj, retValue, methodId, ap);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somCastObj(cls: SOMClass): CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somCastObj
   (SOM_Resolve(Self, cd.classObject, cd.somCastObj))
     (Self, cls);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somResetObj: CORBABoolean; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result :=
  somTD_SOMObject_somResetObj
   (SOM_Resolve(Self, cd.classObject, cd.somResetObj))
     (Self);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

function SOMEWorkProcEvent.somPrintSelf: SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  Result := SOMEWorkProcEvent(
  somTD_SOMObject_somPrintSelf
   (SOM_Resolve(Self, cd.classObject, cd.somPrintSelf))
     (Self));
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEWorkProcEvent.somDumpSelf(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelf
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelf))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

procedure SOMEWorkProcEvent.somDumpSelfInt(level: LongInt); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
var
  cd: PSOMObjectClassDataStructure;
begin
  cd := SOMObjectClassData;
  somTD_SOMObject_somDumpSelfInt
   (SOM_Resolve(Self, cd.classObject, cd.somDumpSelfInt))
     (Self, level);
  SOM_UninitEnvironmentOrRaise(somGetGlobalEnvironment);
end;

class function SOMEWorkProcEvent.ClassObject: SOMClass; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if Self = SOMEWorkProcEvent then { invoked on class name literal }
  begin
    Result := SOMClass(SOMEWorkProcEventClassData.classObject);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

class function SOMEWorkProcEvent.NewClass: SOMClass;
begin
  if Self = SOMEWorkProcEvent then { invoked on class name literal }
  begin
    Result := SOMClass(SOMEWorkProcEventClassData.classObject);
    if not Assigned(Result) then Result := SOMClass(SOMEWorkProcEventNewClass);
  end
  else { invoked on SOM object }
  begin
    Result := SOMClass(PPointer(Self)^);
  end
end;

function SOMEWorkProcEvent.As_SOMEEvent: SOMEEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := SOMEEvent(Self);
end;

function SOMEWorkProcEvent.As_SOMEWorkProcEvent: SOMEWorkProcEvent; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Self;
end;

class function SOMEWorkProcEvent.Supports(Instance: SOMObjectBase): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
    end
    else
    begin
      Result := SOMObject(Instance).somIsA(cls);
    end;
  end;
end;

class function SOMEWorkProcEvent.Supports(Instance: SOMObjectBase; out Obj: SOMEWorkProcEvent): Boolean;
var
  cls: SOMClass;
begin
  if not Assigned(Instance) then
  begin
    Result := False;
    Obj := nil;
  end
  else
  begin
    cls := SOMClass(ClassObject);
    if not Assigned(cls) then
    begin
      Result := False;
      Obj := nil;
    end
    else if SOMObject(Instance).somIsA(cls) then
    begin
      Result := True;
      Obj := SOMEWorkProcEvent(Instance);
    end
    else
    begin
      Result := False;
      Obj := nil;
    end;
  end;
end;

function somresolve_(obj: SOMObjectBase; mToken: somMToken): somMethodProc; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := somMethodProc(mToken);
end;

function SOM_Resolve(o: SOMObjectBase; oc: SOMObjectBase{SOMClass}; m: somMToken;
  fileName: PAnsiChar = nil; lineNum: Integer = 0): somMethodProc; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if not Assigned(fileName) then fileName := Unknown_Source;
  SOM_TestCls(o, oc, fileName, lineNum);
  Result := m;
end;

function SOM_ResolveNoCheck(o: SOMObjectBase; oc: SOMObjectBase{SOMClass}; m: somMToken): somMethodProc; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := m;
end;

var
  SOM_MainProgram_Invoked : Boolean = False;

function SOM_MainProgram: SOMClassMgr; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  SOM_MainProgram_Invoked := True;
  Result := somMainProgram;
end;

function SOM_TestCls(obj: SOMObjectBase; cls: SOMObjectBase{SOMClass};
  fileName: PAnsiChar = nil; lineNum: Integer = 0): SOMObjectBase; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if not Assigned(fileName) then fileName := Unknown_Source;
  Result := somTestCls(obj, cls, fileName, lineNum);
end;

function somExceptionId; external SOM_DLL_Name;
function somExceptionValue; external SOM_DLL_Name;
procedure somExceptionFree; external SOM_DLL_Name;
procedure somSetException; external SOM_DLL_Name;
function somGetGlobalEnvironment; external SOM_DLL_Name;
function exception_id; external SOM_DLL_Name name 'somExceptionId';
function exception_value; external SOM_DLL_Name name 'somExceptionValue';
procedure exception_free; external SOM_DLL_Name name 'somExceptionFree';

function SOM_CreateLocalEnvironment: PEnvironment; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := PEnvironment(SOMCalloc(1, SizeOf(Environment)));
end;

procedure SOM_DestroyLocalEnvironment(ev: PEnvironment); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  somExceptionFree(ev);
  if somGetGlobalEnvironment <> ev then
    SOMFree(ev);
end;

procedure SOM_InitEnvironment(ev: PEnvironment); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if somGetGlobalEnvironment <> ev then
  begin
    FillChar(ev^, SizeOf(Environment), 0);
  end;
end;

procedure SOM_UninitEnvironment(ev: PEnvironment); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  somExceptionFree(ev);
end;

// #include <somapi.h>

var
  SOM_DLL_SOM_MajorVersion: PLongInt = nil;

function Replaceable_SOM_MajorVersion: PLongInt;
begin
  if Assigned(SOM_DLL_SOM_MajorVersion) then
    Result := SOM_DLL_SOM_MajorVersion
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOM_MajorVersion, 'SOM_MajorVersion');
    Result := SOM_DLL_SOM_MajorVersion;
  end;
end;

function SOM_MajorVersion: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Replaceable_SOM_MajorVersion^;
end;

var
  SOM_DLL_SOM_MinorVersion: PLongInt = nil;

function Replaceable_SOM_MinorVersion: PLongInt;
begin
  if Assigned(SOM_DLL_SOM_MinorVersion) then
    Result := SOM_DLL_SOM_MinorVersion
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOM_MinorVersion, 'SOM_MinorVersion');
    Result := SOM_DLL_SOM_MinorVersion;
  end;
end;

function SOM_MinorVersion: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Replaceable_SOM_MinorVersion^;
end;

var
  SOM_DLL_SOM_MaxThreads: PLongInt = nil;

function Replaceable_SOM_MaxThreads: PLongInt;
begin
  if Assigned(SOM_DLL_SOM_MaxThreads) then
    Result := SOM_DLL_SOM_MaxThreads
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOM_MaxThreads, 'SOM_MaxThreads');
    Result := SOM_DLL_SOM_MaxThreads;
  end;
end;

function SOM_MaxThreads: LongInt; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Replaceable_SOM_MaxThreads^;
end;

function somEnvironmentNew; external SOM_DLL_Name;
procedure somEnvironmentEnd; external SOM_DLL_Name;
function somMainProgram; external SOM_DLL_Name name 'somEnvironmentNew'; // SOM 3.0 Windows DLL has somMainProgram, SOM 2.1 from VAC 3.5.9 has not
function somAbnormalEnd; external SOM_DLL_Name;

var
  SOM_DLL_SOMCalloc: PsomTD_SOMCalloc = nil;

function Replaceable_SOMCalloc: PsomTD_SOMCalloc;
begin
  if Assigned(SOM_DLL_SOMCalloc) then
    Result := SOM_DLL_SOMCalloc
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOMCalloc, 'SOMCalloc');
    Result := SOM_DLL_SOMCalloc;
  end;
end;

function SOMCalloc(element_count, element_size: UIntPtr): somToken; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Replaceable_SOMCalloc^(element_count, element_size);
end;

var
  SOM_DLL_SOMFree: PsomTD_SOMFree = nil;

function Replaceable_SOMFree: PsomTD_SOMFree;
begin
  if Assigned(SOM_DLL_SOMFree) then
    Result := SOM_DLL_SOMFree
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOMFree, 'SOMFree');
    Result := SOM_DLL_SOMFree;
  end;
end;

procedure SOMFree(memory: somToken); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Replaceable_SOMFree^(memory);
end;

procedure SOMMemFree(memory: somToken); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Replaceable_SOMFree^(memory);
end;

var
  SOM_DLL_SOMMalloc: PsomTD_SOMMalloc = nil;

function Replaceable_SOMMalloc: PsomTD_SOMMalloc;
begin
  if Assigned(SOM_DLL_SOMMalloc) then
    Result := SOM_DLL_SOMMalloc
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOMMalloc, 'SOMMalloc');
    Result := SOM_DLL_SOMMalloc;
  end;
end;

function SOMMalloc(nbytes: UIntPtr): somToken; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Replaceable_SOMMalloc^(nbytes);
end;

var
  SOM_DLL_SOMRealloc: PsomTD_SOMRealloc = nil;

function Replaceable_SOMRealloc: PsomTD_SOMRealloc;
begin
  if Assigned(SOM_DLL_SOMRealloc) then
    Result := SOM_DLL_SOMRealloc
  else
  begin
    SOM_DLL_Load_Variable(SOM_DLL_SOMRealloc, 'SOMRealloc');
    Result := SOM_DLL_SOMRealloc;
  end;
end;

function SOMRealloc(memory: somToken; nbytes: UIntPtr): somToken; {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  Result := Replaceable_SOMRealloc^(memory, nbytes);
end;

function somTestCls; external SOM_DLL_Name;
function somGetClassFromMToken; external SOM_DLL_Name;
function somRegisterId; external SOM_DLL_Name;
function somCheckId; external SOM_DLL_Name;
function somIdFromString; external SOM_DLL_Name;
function somStringFromId; external SOM_DLL_Name;
function somCompareIds; external SOM_DLL_Name;
function somTotalRegIds; external SOM_DLL_Name;
procedure somSetExpectedIds; external SOM_DLL_Name;
function somUniqueKey; external SOM_DLL_Name;
procedure somBeginPersistentIds; external SOM_DLL_Name;
procedure somEndPersistentIds; external SOM_DLL_Name;
function somVaBuf_create; external SOMTC_DLL_Name;
procedure somVaBuf_get_valist; external SOMTC_DLL_Name;
procedure somVaBuf_destroy; external SOMTC_DLL_Name;
function somVaBuf_add; external SOMTC_DLL_Name;
function somvalistGetTarget; external SOMTC_DLL_Name;
procedure somvalistSetTarget; external SOMTC_DLL_Name;

// not in SOM headers

procedure SOM_RaiseEnvironment(ev: PEnvironment);
begin
  // TODO raise proper Delphi exception using info from ev
  ESOMException.Create(ev);
end;

procedure SOM_UninitEnvironmentOrRaise(ev: PEnvironment); {$IFDEF DELPHI_HAS_INLINE} inline; {$ENDIF}
begin
  if ev._major <> NO_EXCEPTION then
  begin
    SOM_RaiseEnvironment(ev);
  end
  else
  begin
    somExceptionFree(ev);
  end;
end;

procedure SOMFreeAndNil(var Obj);
begin
  if Assigned(SOMObject(Obj)) then
  begin
    SOMObject(Obj).somFree;
    SOMObject(Obj) := nil;
  end;
end;

procedure AddStringToVaBuf(var Buf: somVaBuf; var StringBuf: TAnsiStringArray; const NewStr: AnsiString);
var
  I: Integer;
  NewPointer: PAnsiChar;
begin
  I := Length(StringBuf);
  SetLength(StringBuf, I + 1);
  StringBuf[I] := NewStr;
  NewPointer := PAnsiChar(StringBuf[I]);
  somVaBuf_add(Buf, PAnsiChar(@NewPointer), tk_pointer);
end;

function ArrayOfConstToVaList(var Buf: somVaBuf; var StringBuf: TAnsiStringArray; const Arguments: array of const; AppendNil: Boolean): va_list;
var
  I: Integer;
  Temp: Single;
  Temp2: Pointer;
begin
  if not Assigned(Buf) then
  begin
    Buf := somVaBuf_create(nil, 0);
  end;
  for I := 0 to Length(Arguments) - 1 do
  begin
    case Arguments[I].VType of
      vtInteger: somVaBuf_add(Buf, PAnsiChar(Pointer(@Arguments[I].VInteger)), tk_long);
      vtBoolean: somVaBuf_add(Buf, PAnsiChar(Pointer(@Arguments[I].VBoolean)), tk_boolean);
      vtChar: AddStringToVaBuf(Buf, StringBuf, AnsiString(Arguments[I].VChar));
      vtExtended: begin Temp := Arguments[I].VExtended^; somVaBuf_add(Buf, PAnsiChar(Pointer(@Temp)), tk_float); end;
      vtString: AddStringToVaBuf(Buf, StringBuf, AnsiString(Arguments[I].VString^));
      vtPChar: AddStringToVaBuf(Buf, StringBuf, AnsiString(Arguments[I].VPChar));
      vtObject: somVaBuf_add(Buf, PAnsiChar(Pointer(@Arguments[I].VObject)), tk_pointer);
      vtClass: somVaBuf_add(Buf, PAnsiChar(Pointer(@Arguments[I].VClass)), tk_pointer); // TODO maybe convert Delphi 2 SOM here
      vtWideChar: AddStringToVaBuf(Buf, StringBuf, AnsiString(Arguments[I].VWideChar));
      vtPWideChar: AddStringToVaBuf(Buf, StringBuf, AnsiString(Arguments[I].VPWideChar));
      vtAnsiString: AddStringToVaBuf(Buf, StringBuf, AnsiString(Arguments[I].VAnsiString));
      vtCurrency: begin { not supported Arguments[I].VCurrency^ } end;
      vtVariant: begin { not supported Arguments[I].VVariant^ } end;
      vtInterface: begin { not supported IUnknown(Arguments[I].VInterface) } end;
      vtWideString: AddStringToVaBuf(Buf, StringBuf, AnsiString(WideString(Arguments[I].VWideString)));
      vtInt64: begin { not supported Arguments[I].VInt64^ } end;
      vtPointer: somVaBuf_add(Buf, PAnsiChar(Pointer(@Arguments[I].VPointer)), tk_pointer);
      {$IFDEF DELPHI_IS_UNICODE}
      vtUnicodeString: AddStringToVaBuf(Buf, StringBuf, AnsiString(UnicodeString(Arguments[I].VUnicodeString)));
      {$ENDIF}
    end;
  end;
  if AppendNil then
  begin
    Temp2 := nil;
    somVaBuf_add(Buf, PAnsiChar(Pointer(@Temp)), tk_pointer);
  end;
  somVaBuf_get_valist(Buf, Result);
end;

initialization
  Windows.InitializeCriticalSection(DLLLoad_CriticalSection);
finalization
  if SOM_DLL <> 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOM_DLL <> 0 then
    begin
      FreeLibrary(SOM_DLL);
    end;
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOMD_DLL <> 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOMD_DLL <> 0 then
    begin
      FreeLibrary(SOMD_DLL);
    end;
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOME_DLL <> 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOME_DLL <> 0 then
    begin
      FreeLibrary(SOME_DLL);
    end;
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOMEM_DLL <> 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOMEM_DLL <> 0 then
    begin
      FreeLibrary(SOMEM_DLL);
    end;
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOMIR_DLL <> 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOMIR_DLL <> 0 then
    begin
      FreeLibrary(SOMIR_DLL);
    end;
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOMS_DLL <> 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOMS_DLL <> 0 then
    begin
      FreeLibrary(SOMS_DLL);
    end;
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOMTC_DLL <> 0 then
  begin
    Windows.EnterCriticalSection(DLLLoad_CriticalSection);
    if SOMTC_DLL <> 0 then
    begin
      FreeLibrary(SOMTC_DLL);
    end;
    Windows.LeaveCriticalSection(DLLLoad_CriticalSection);
  end;
  if SOM_MainProgram_Invoked then
  begin
    somEnvironmentEnd;
  end;
  Windows.DeleteCriticalSection(DLLLoad_CriticalSection);
end.
